(class extends odaAction {
    static get properties() {
        return {
            allowAccess: 'w',
            icon: 'icons:content-copy',
            label: 'Подшить копию'
        }
    }

    async execute($object) {
        try {
            const cls = this.$item.TypeClass;

            const prom = this.$item.templates.split('|').map(async (id) => await this.$item.$class.findItem(id));
            const templates = await Promise.all(prom);
            let tmpObj;
            if (templates && templates.length && templates.length === 1) {
                tmpObj = templates[0];
            } else {
                const selector = await ODA.createComponent('/web/lib/lists/listbox/listbox.html');
                selector.items = templates;                

                const dialog = {
                    title: 'Select template',
                    icon: 'image:center-focus-strong',
                    ok: {
                        show: true,
                        disable: false
                    }
                };
                const dialogResult = await ODA.showDialog(selector, dialog);
                if (dialogResult) {
                    tmpObj = selector.focusedItem;
                }
            }

            // TODO Get context object
            if (tmpObj) {
                let dstCls = await tmpObj.$base.findItem(tmpObj.Root.$Bind[0].DstClass);
                if (dstCls.hasChildren) {
                    const component = await ODA.createComponent('/web/lib/dialogs/select-class/select-class.html',
                        { contextItem: dstCls, allowFilter: false, showWalker: false, itemKey: '$class' });
                    const result = await ODA.showDialog(component, { title: 'Select Class', icon: 'odant:class' });

                    if (result && result.item) dstCls = result.item;
                    else return;
                }
                
                const bindResult = await ODANT.API.post(tmpObj.url,
                    { execute: 'methods/auto-fill', restart: 'true', srcObj: $object.fullId, dstCls: dstCls.fullId });

                const bindObj = await this.$item.TypeClass.findItem(bindResult);
                if (!ODANT.getBool(tmpObj.Root.HiddenBind)) {
                    bindObj.show();
                }
                return bindObj;
            }
        } catch (e) {
            console.error(e);
        }

        return null;
    }
}).register();