(class extends odaAction {
    static get properties() {
        return {
            allowAccess: 'w',
            icon: 'icons:exit-to-app',
            label: 'Связать с существующим'
        }
    }

    async execute($object) {
        try {
            const cls = this.$item.TypeClass;

            const prom = this.$item.templates.split('|').map(async (id) => await this.$item.$class.findItem(id));
            const templates = await Promise.all(prom);
            let tmpObj;
            if (templates && templates.length && templates.length === 1) {
                tmpObj = templates[0];
            } else {
                const selector = await ODA.createComponent('/web/lib/lists/listbox/listbox.html');
                selector.items = templates;                

                const dialog = {
                    title: 'Select template',
                    icon: 'image:center-focus-strong',
                    ok: {
                        show: true,
                        disable: false
                    }
                };
                const dialogResult = await ODA.showDialog(selector, dialog);
                if (dialogResult) {
                    tmpObj = selector.focusedItem;
                }
            }

            if (tmpObj) {
                const dstCls = await cls.findItem(tmpObj.Root.$Bind[0].DstClass);

                const action = await dstCls.getViewAction('select-link');
                const control = await action._control;

                const form = await ODA.createComponent(dstCls.formUrl);
                form.allowButtons = action.allowButtons;
                form.hideViews = action.hideViews;
                form.actionSource = dstCls;
                form.control = control;
                form.contextItem = dstCls;
                const val = await form.showDialog();

                return await control.focusedItem;
            }
        } catch (e) {
            console.error(e);
        }

        return null;
    }
}).register();