(class extends odaAction {
    async execute(params) {
        const srcObj = await this.$owner.$base.findItem(params.srcObj);
        let dstCls = await this.$owner.$base.findItem(this.$owner.Root.$Bind[0].DstClass);
        if (dstCls.hasChildren) {
            const component = await ODA.createComponent('/web/lib/dialogs/select-class/select-class.html',
                { contextItem: dstCls, allowFilter: false, showWalker: false, itemKey: '$class' });
            const result = await ODA.showDialog(component, { title: 'Select Class', icon: 'odant:class' });

            if (result && result.item) dstCls = result.item;
            else return;
        }

        const bindResult = await ODANT.API.post(this.$owner.url,
            { execute: 'methods/auto-fill', restart: 'true', srcObj: srcObj.fullId, dstCls: dstCls.fullId});

        // if (this.$owner.Root.HiddenSource
        //     && (this.$owner.Root.HiddenSource.toLowerCase() === "true")) {
        // }

        if (!this.$owner.Root.HiddenBind
            || (this.$owner.Root.HiddenBind.toLowerCase() !== "true")) {

            if (Array.isArray(bindResult)) {
                const promises = bindResult.map((url) => srcObj.$class.findItem(url));
                return Promise.all(promises).then((bindObjs) => bindObjs.map((obj) => obj.show()));
            }

            return srcObj.$class.findItem(bindResult).then(bindObj => bindObj.show());
        }
    }
}).register();