(class extends odaAction {
    async execute(params) {
        console.log('Start Filling');
        console.log(`$owner.id: ${this.$owner.fullId}`);
        console.log(`Params: ${params}`);
        console.log('Start getting source object');

        const srcObj = await this.$owner.$class.findItem(params.srcObj);
        console.log(`SourceObject: ${srcObj}`);

        const dstCls = await this.$owner.$class.findItem(params.dstCls);
        console.log(`DstClass: ${dstCls}`);

        const attr = this.$owner.Root.DoNotBind;
        const doNotBind = (attr && attr.toLowerCase() === 'true') ? true : false;
        console.log(`DoNotBind: ${doNotBind}`);

        return this.updateObject(srcObj, this.$owner, dstCls, doNotBind);
    }

    async updateObject(srcObj, tmpObj, dstCls, doNotBind) {
        console.log('Start updateObject');
        console.log(`SourceObject: ${srcObj}`);
        console.log(`TemplateObject: ${tmpObj}`);
        console.log(`DoNotBind: ${doNotBind}`);

        let cls;
        if (dstCls) {
            cls = dstCls;
        } else {
            const id = tmpObj.Root.$Bind[0].DstClass;
            console.log("DstClass.id: " + id);

            cls = await srcObj.$base.findItem(id);
            console.log("DstClass: " + cls);
        }

        const notNeedAttrs = await ODANT.API.post(tmpObj.url, { method: 'xquery' },
            'attribute a { OBJECT/Bind/LINK/string(@path) }');
        console.log(`NotNeedAttrs: ${notNeedAttrs}`);
        // TODO. From table
        var tbl = tmpObj.Root.$Bind[0].SrcTable;
        console.log(`SrcTable: ${tbl}`);
        if (tbl) {
            console.log('From table');
            if (tbl.startsWith('@')) {
                tbl = tbl.substr(1);
            }
            console.log(`SrcTable: ${tbl}`);
            const srcXml = await ODANT.API.post(srcObj.url, { method: 'xquery', format: 'xml' },
                `element a { for $a in OBJECT/${tbl} return ($a, <br/>) }`);
            console.log(`SourceObject.XML: ${srcXml}`);

            srcXml = srcXml.substr(3, srcXml.length - 7);
            if (srcXml.endsWith('<br/>')) {
                srcXml = srcXml.substr(0, srcXml.length - 5);
            }

            console.log(`SourceObject.XML: ${srcXml}`);

            var promises = srcXml.split('<br/>')
                .map(tblXml => {
                    console.log(`Table.XML: ${tblXml}`);
                    this.createDstObj(cls, notNeedAttrs, tblXml, tmpObj, doNotBind, srcObj)
                });
            return Promise.all(promises);
        } else {
            console.log('From root');
            const srcXml = await ODANT.API.post(srcObj.url, { method: 'xquery', format: 'xml' }, 'OBJECT');
            console.log(`SourceObject.XML: ${srcXml}`);
            return this.createDstObj(cls, notNeedAttrs, srcXml, tmpObj, doNotBind, srcObj);
        }
    }

    async createDstObj(cls, notNeedAttrs, srcXml, tmpObj, doNotBind, srcObj) {
        console.log('Start createDstObj');
        console.log(`Class: ${cls}`);
        console.log(`notNeedAttrs: ${notNeedAttrs}`);
        console.log(`srcXml: ${srcXml}`);
        console.log(`tmpObj: ${tmpObj}`);
        console.log(`doNotBind: ${doNotBind}`);
        console.log(`srcObj: ${srcObj}`);

        const dstObj = await cls.createObject();
        console.log(`dstObj: ${dstObj}`);

        let dstXml = await ODANT.API.post(dstObj.url, { method: 'xquery', format: 'xml' },
            `element OBJECT { OBJECT/@*[not(contains('${notNeedAttrs.$A[0].a}', name()))] }`)
        console.log(`dstXml: ${dstXml}`);

        dstXml = dstXml.substr(0, dstXml.length - 2) + ' ';

        //console.log("dstXml: " + dstXml);
        const attrs = await this.getAttrs(srcXml, tmpObj, srcObj.name)
        console.log(`attrs: ${attrs}`);
        dstXml += attrs;
        dstXml += '>';
        //console.log("dstXml: " + dstXml);

        const elems = await this.getElems(srcXml, tmpObj, srcObj.name, dstObj.getRelativeId(srcObj))
        console.log(`elems: ${elems}`);

        dstXml += elems;
        //console.log("dstXml: " + dstXml);

        if (!doNotBind) {
            dstXml += this.getBind(srcObj, dstObj);
        }

        dstXml += '</OBJECT>';
        console.log(`dstXml: ${dstXml}`);

        //const r = dstObj.save(dstXml);
	    const r = dstObj.API.POST(undefined, undefined, dstXml);
        console.log(`save result: ${r}`);
        // const r = await ODANT.API.post(dstObj.$class.url, { method: 'save_objects' },
        //     `<OBJECTS>${dstXml}</OBJECTS>`)
        // console.log(`save_objects result: ${r}`);

        if (doNotBind) {
            console.log('oNotBind');
            if (tmpObj.Root.DeleteSource
                && (tmpObj.Root.DeleteSource.toLowerCase() == 'true')) {
                console.log('DeleteSource');
                srcObj.remove();
            }
        } else {
            console.log('Bind');
            this.bind(srcObj, dstObj, true);
            srcObj.save();
        }

        return dstObj.fullId;
    }

    async getAttrs(srcXml, tmpObj, name) {
        var xq = `declare namespace my = "http://odant.org/";
declare function my:cut-attr-name(
    $str as xs:string? ) as xs:string? {

        tokenize($str, '@')[last()]
        
};

declare function my:get-attrs(
    $tmp as element()* ,
    $src as element()* ) as item()* {

    for $a in $tmp/LINK[not(LINK/@src)]
    return attribute { my:cut-attr-name($a/@path) } {
        if ($a/@src = 'this')
        then (
            (:Ссылка:)
            '[#name#]'
        )
        else (
            (:Атрибут:)
            oda:eval($a/string(@src), $src[1])
        )
    }
};

let $src := ${srcXml}
return my:get-attrs(OBJECT/Bind, $src)`.replace('[#name#]', name);


        console.log(`getAttrs.xq: ${xq}`);
        const xml = await ODANT.API.post(tmpObj.url, { method: 'xquery', format: 'xml' }, xq);
        return xml ? xml.substr(28, xml.length - 36) : '';
    };

    async getElems(srcXml, tmpObj, name, id) {
        var xq = `declare namespace my = "http://odant.org/";
declare function my:cut-attr-name(
    $str as xs:string? ) as xs:string? {

        tokenize($str, '@')[last()]
        
};

declare function my:get-attrs(
    $tmp as element()* ,
    $src as element()* ) as item()* {

    for $a in $tmp/LINK[not(LINK)]
    return attribute { my:cut-attr-name($a/@path) } {
        if ($a/@src = 'this')
        then (
            (:Ссылка:)
            '[#name#]'
        )
        else (
            (:Атрибут:)
            oda:eval($a/string(@src), $src[1])
        )
    }
};

declare function my:get-elems(
    $tmp as element()* ,
    $src as element()* ) as item()* {
    
    
    for $a in $tmp/LINK
    return 
        if ($a/@src = 'this')
        then (
            (:Ссылка:)			
            element { my:cut-attr-name($a/@path) } {
                attribute link { '[#id#]' }			
            }
        )
        else (
            (:Таблица:)
            for $e in oda:eval(my:cut-attr-name($a/@src), $src)
            return element { my:cut-attr-name($a/@path) } {
                if ($a/LINK/@src)
                then
                (
                    $e/@id,
                    my:get-attrs($a, $e),
                    my:get-elems($a, $e)
                )
                else
                    $e/(@*, *)
            }
        )

};

let $src := ${srcXml}
return element x { my:get-elems(OBJECT/Bind, $src) }`.replace('[#name#]', name).replace('[#id#]', id);;

        console.log(`getElems.xq: ${xq}`);
        const xml = await ODANT.API.post(tmpObj.url, { method: 'xquery', format: 'xml' }, xq);
        return xml ? xml.substr(3, xml.length - 7) : '';
    }

    getBind(srcObj, dstObj) {
        return `<SERVICES><BIND><DOC Name="${srcObj.name}" isSrc="False"><link link="${dstObj.getRelativeId(srcObj)}"/></DOC></BIND></SERVICES>`;
    }

    bind(hostObj, linkObj, isSrc) {
        console.log('Start bind');
        console.log(`hostObj: ${hostObj}`);
        console.log(`linkObj: ${linkObj}`);
        console.log(`isSrc: ${isSrc}`);
        // if (hostObj.access.none)
        //     return;

        const readOnly = hostObj.Root && hostObj.Root.ro && hostObj.Root.ro.toString();
        console.log(`readOnly: ${readOnly}`);
        if (readOnly && readOnly.toLowerCase() === 'true') {
            console.log('ro');
            hostObj.Root.ro = 'False';
        }

        if (!hostObj.Root.$SERVICES || (hostObj.Root.$SERVICES.count < 1)) {
            console.log('SERVICES');
            hostObj.Root.$SERVICES = [];
            hostObj.Root.$SERVICES.push({});
        }

        const srv = hostObj.Root.$SERVICES[0];
        console.log(`srv: ${srv && JSON.stringify(srv)}`);

        if (!srv)
            return;

        if (!srv.$BIND || (srv.$BIND.count < 1)) {
            console.log('BIND');
            srv.$BIND = [];
            srv.$BIND.push({});
        }

        const bind = srv.$BIND[0];
        console.log(`bind: ${bind && JSON.stringify(bind)}`);

        if (bind == null)
            return;

        let doc;
        if (!bind.$DOC) {
            console.log('DOC');
            bind.$DOC = [];
        } else if (bind.$DOC.count > 0) {
            console.log('Search DOC');
            doc = bind.$DOC.filter((d) => d.$link && (d.$link.length > 0) && d.$link[0].link.includes(linkObj.id));
        }

        if (!doc) {
            console.log('Null DOC');
            bind.$DOC.push({});
            doc = bind.$DOC[bind.$DOC.length - 1];
        }

        doc.$link = [];
        doc.$link.push({});
        doc.$link[0].link = hostObj.getRelativeId(linkObj);
        doc.name = linkObj.name;
        doc.isSrc = isSrc;
        console.log(`doc: ${doc}`);
        if (readOnly && readOnly.toLowerCase() === 'true') {
            console.log('ro');
            hostObj.Root.ro = 'True';
        }
    }
}).register();