(class extends odaService {
    static get properties(){
        return {
            label: 'Telegram settings',
            allowAccess: 'R',
            allowUse: true,
            isActive: true,
        }
    }

    execute() {
        return ODA.showDialog({
            caption: this.label, value: `Create for class: '${this.$owner.name}'`,
            buttons: [
                {label: 'Event: on-enter', icon: 'image:flash-on'},
                {label: 'Event: on-exit', icon: 'image:flash-on'},
                {label: 'Class method', icon: 'icons:settings'},
                {label: 'Object method', icon: 'icons:settings'},
                {label: 'Views', icon: 'image:view-compact'},
            ]
        }).then(buttonName => {
            switch (buttonName) {
                case 'Event: on-enter':
                    this.sourceItem.getFolder('~/server/bot-events/on-enter').then(f => {
                        this.$owner.executeAction('_methods/create-action', f).then(_folder => {
                            this.$owner.executeAction('_methods/edit-action', {actionFolder: _folder})
                        })
                    });
                    break;
                case 'Class method':
                    this.sourceItem.getFolder('~/web/class/server/bot-methods').then(f => {
                        this.$owner.executeAction('_methods/create-action', f).then(_folder => {
                            this.$owner.executeAction('_methods/edit-action', {actionFolder: _folder})
                        })
                    });
                    break;
                case 'Object method':
                    this.sourceItem.getFolder('~/web/object/server/bot-methods').then(f => {
                        this.$owner.executeAction('_methods/create-action', f).then(_folder => {
                            this.$owner.executeAction('_methods/edit-action', {actionFolder: _folder})
                        })
                    });
                    break;
                default:
                    break;
            }
        }).catch(() => {
            ODA.notify('Cancel');
        });
    }
}).register();