#insert#

(:
let $oids := '1D31D9F396B1140 1D3216257CAF210 1D325568F9EF1D0'
let $host := 'H:1D03A3F3B5863BB'
let $base := 'B:1D32708618BFC30'
let $jurModuleId := '1CF566ABBA54AE8'
let $docClassId := H:1D03A3F3B5863BB/P:WORK/B:1D1E71E24EDDC98/C:1D1E71D5F9323AC
:)


let $allObjects := oda:select(doc(concat($docClassId, '/I:PACK'))/PACK/OBJECT, 'oid', $oids)
let $color := /OBJECT/@clr

for $accEntry in //regs
    let $objects := if($accEntry/@filter) then $allObjects[oda:eval($accEntry/@filter)] else $allObjects
    let $len := count($objects)
    let $oidsKT := oda:gen-oids($host, $len)
    let $oidsDT := oda:gen-oids($host, $len)
    let $oidsReg := oda:gen-oids($host, $len)
    let $dt := $accEntry/dt/acc/@link
    let $ct := $accEntry/ct/acc/@link
    let $cidDT := substring($dt, oda:num(string-length($dt) - 14), 15)
    let $cidKT := substring($ct, oda:num(string-length($ct) - 14), 15)
    let $isDTAnls := not(empty($accEntry/dt)) and (count($accEntry/dt/anls/@*) > 0 or not(empty($accEntry/dt/@count)))
    let $isCTAnls := not(empty($accEntry/ct)) and (count($accEntry/ct/anls/@*) > 0 or not(empty($accEntry/ct/@count)))

    let $DTClsName := string(doc(concat('oda:/', $host, '/', $base, '/', $jurModuleId, '/C:', $cidDT))/CLASS/@Name)
    let $CTClsName := string(doc(concat('oda:/', $host, '/', $base, '/', $jurModuleId, '/C:', $cidKT))/CLASS/@Name)

    let $operations :=
    <OBJECTS>
    {
        for $ob at $i in $objects
            let $docLink := concat('D:', $ob/@bid ,'/C:', $ob/@cid, '/O:', $ob/@oid)
            let $operLink := concat('C:', /OBJECT/@cid, '/O:', /OBJECT/@oid)

            let $regDate := $ob/oda:eval($accEntry/@date)
            let $note := $ob/oda:eval($accEntry/@note)
            let $sum := sum($ob/oda:eval(if ( empty($accEntry/@context) ) then $accEntry/@sum else concat($accEntry/@context, '/', $accEntry/@sum)))
            let $sumI := sum($ob/oda:eval(if ( empty($accEntry/@context) ) then $accEntry/dt/@count else concat($accEntry/@context, '/', $accEntry/dt/@count)))
            let $sumO := sum($ob/oda:eval(if ( empty($accEntry/@context) ) then $accEntry/ct/@count else concat($accEntry/@context, '/', $accEntry/ct/@count)))

            return (
                if($accEntry/dt) then element OBJECT
                {
                    attribute oda-new {$oidsDT[$i]},
                    attribute clr {$color},
                    attribute ro {'True'},
                    attribute typeAcc {'DT'},
                    attribute reg_date {$regDate},
                    attribute reg_id {$oidsReg[$i]},
                    attribute note {$note},
                    attribute cnm {$DTClsName},
                    attribute cid {$cidDT},
                    (:todo костыль:)
                    attribute bid {$ob/@bid},
                    attribute doc {$ob/@name},
                    attribute oper {./@name},
                    attribute d {$sum},
                    attribute i {$sumI},

                    element doc
                    {
                        attribute link {$docLink},
                        attribute oid {$ob/@oid}
                    },

                    element oper
                    {
                        attribute link {$operLink}
                    },

                    element corr
                    {
                        attribute link {concat($ct, '/O:', $oidsKT[$i])}
                    },

                    for $b in $ob/oda:eval($accEntry/@context)
                    return
                        if($isDTAnls)
                            then
                                element anls
                                {
                                    attribute i {$b/oda:eval($accEntry/dt/@count)},
                                    attribute d {$b/oda:eval($accEntry/@sum)},

                                    for $a in $accEntry/dt/anls/@*
                                        return attribute {$a/name()} {$b/oda:eval($a)}
                                }
                        else nil
                }
                else nil,

                if($accEntry/ct) then element OBJECT
                {
                    attribute oda-new {$oidsKT[$i]},
                                         attribute clr {$color},
                                         attribute ro {'True'},
                                         attribute typeAcc {'CT'},
                                         attribute reg_date {$regDate},
                                         attribute reg_id {$oidsReg[$i]},
                                         attribute note {$note},
                                         attribute cnm {$CTClsName},
                                         attribute cid {$cidKT},
                                         (:todo костыль:)
                                         attribute bid {$ob/@bid},
                                         attribute doc {$ob/@name},
                                         attribute oper {./@name},
                                         attribute c {$sum},
                                         attribute o {$sumO},

                                         element doc
                                         {
                        attribute link {$docLink},
                        attribute oid {$ob/@oid}
                    },

                    element oper
                    {
                        attribute link {$operLink}
                    },

                    element corr
                    {
                        attribute link {concat($dt,'/O:',$oidsDT[$i])}
                    },

                    for $b in $ob/oda:eval($accEntry/@context)
                    return
                        if($isCTAnls)
                            then
                                element anls
                                {
                                    attribute o {$b/oda:eval($accEntry/ct/@count)},
                                    attribute c {$b/oda:eval($accEntry/@sum)},

                                    for $a in $accEntry/ct/anls/@*
                                        return attribute {$a/name()} {$b/oda:eval($a)}
                                }
                    else nil
                    }
                else nil,

            element newOBJECT
            {
                $ob/@*[name() != 'ro' and name() != 'clr'],
                attribute ro {'True'},
                attribute clr {$color},

                $ob/*[not(name() = 'SERVICES')]

                ,

                if($ob/SERVICES) then
                (
                    for $node in $ob/SERVICES
                    return
                        element SERVICES
                        {
                            $node/@*,
                            $node/*[not(name() = 'REGISTER')],

                            element REGISTER
                            {
                                element OPERATION
                                {
                                    attribute name {./@name},
                                    attribute id {$oidsReg[$i]},

                                    element REG
                                    {
                                        attribute link {concat('C:', $cidDT, '/O:', $oidsDT[$i])},
                                        attribute cid {$cidDT},
                                        attribute type {'DT'},
                                        attribute reg_date {$regDate}
                                    }

                                    ,

                                    element REG
                                    {
                                        attribute link {concat('C:', $cidKT ,'/O:', $oidsKT[$i])},
                                        attribute cid {$cidKT},
                                        attribute type {'CT'},
                                        attribute reg_date {$regDate}
                                    }

                                }
                            }
                        }
                    )
                    else
                    (
                        element SERVICES
                        {
                            element REGISTER
                            {
                                element OPERATION
                                {
                                    attribute name {./@name},
                                    attribute id {$oidsReg[$i]},

                                    element REG
                                    {
                                        attribute link {concat('C:', $cidDT, '/O:', $oidsDT[$i])},
                                        attribute cid {$cidDT},
                                        attribute type {'DT'},
                                        attribute reg_date {$regDate}
                                    }

                                    ,

                                    element REG
                                    {
                                        attribute link {concat('C:', $cidKT ,'/O:', $oidsKT[$i])},
                                        attribute cid {$cidKT},
                                        attribute type {'CT'},
                                        attribute reg_date {$regDate}
                                    }

                                }
                            }
                        }
                    )
                }
            )
    }
    </OBJECTS>

	 let $op :=
        for $jur in $operations/OBJECT
            (:let $bid := $jur/@bid:)
            let $cid := $jur/@cid
            group by $cid

            let $objects :=
            <OBJECTS>
            {
                $jur
            }
            </OBJECTS>

            let $res := oda:command(concat('save_objects?id=', $host, '/', $base, '/', $jurModuleId, '/C:', $cid[1]), oda:xml($objects))
            return $res

 	 let $newObjects :=
                        <OBJECTS>
                        {
							for $obj in $operations/newOBJECT
							return
								element OBJECT
								{
									$obj/@*,
									$obj/*
								}
                        }
                        </OBJECTS>

	let $saveDocs := oda:command(concat('save_objects?id=', $docClassId), oda:xml($newObjects))




return  ($saveDocs, $op)