(class extends odaService {

    static get properties(){  return {
            label: 'Register',
            allowArrayContext: true,
            isActive: true,
            allowAccess: 'C'
        }}

    execute(params) {
        let header = `
              let $oids := '${params.Items}'
              let $host := 'H:${this.$item.$host.id}'
              let $base := 'B:${this.$item.$base.id}'
              let $jurModuleId := 'M:${this.ActionSource.$class.$owner.id}'
              let $docClassId := '${params.ClassFullId}' 
            `;

        return this._runAction(this.$item.$class, 'unreg.xq', header)
        .then(() => this._runAction(this.$item, 'reg.xq', header))
    }

    _runAction(item, fileName, header) {
        return this.ActionSource
        .getFile(fileName)
        .then(file => file.load())
        .then(xq => item.API.POST('xquery', {format: 'json'}, xq.replace(/#insert#/g, header)))
    }

}).register();