var odant = require('../../../../../../../core/odant')
var fs = require('fs')
odant.then(odant => {

  global.require = require
  ODANT.ssid = '9877FC5A350E717FA54E0B1B7CF4202D'

  Promise.all(
    [
      ODANT.findItem('H:1D03A3F3B5863BB/P:WORK/B:1D1E71E24EDDC98/C:1CF56703E3EEEEA/O:1D1E73508FFDBAF'),
      ODANT.findItem('H:1D03A3F3B5863BB/P:WORK/B:1D1E71E24EDDC98/M:1CF566ABBA54AE8/C:1CF56703E3EEEEA')
    ]
  ).then(res => {
    context = {}

    context.$item = res[0]
    context.ActionSource = res[1]

    console.time('Time execute action')

    execute.call(context, {
      regSettingsOID: `1D1E73508FFDBAF`,
      Items: ['1D3216257CAF210', '1D31D9F396B1140']
    }).then(() => {
      console.timeEnd('Time execute action')
    })
  })

  function execute (params) {
    return this.ActionSource
      .getObjectList(params.regSettingsOID)
      .then(
        templateReg => {
          this.ActionSource
            .getFile('reg.xq')
            .then(file => file.load())
            .then(
              xq => {
                let header = `
                let $oids := '${params.Items.join(' ')}' 
                let $host := 'H:${this.$item.$host.id}' 
                let $jurModuleId := 'M:${this.ActionSource.$owner.id}' `;
                let _xq = xq.replace(/#insert#/g, header);


                // fs.writeFile("d:/q.q", _xq, function(err) {
                //   if(err) {
                //     return console.log(err);
                //   }
                //
                //   console.log("The file was saved!");
                // });

                return this.$item.API.POST('xquery', {format: 'json'}, _xq)
              }
            )
        }
      )
  }

  function runRegister (registerTemplates) {

    const ids = generateOID.call(this, 3)

    if (registerTemplates) {
      this.createRegister.call(this, registerTemplates)
    } else {
      this.updateRegister()
    }

  }

  function createRegister (registerTemplates) {
    if (!registerTemplates) {
      return Promise.reject('Register template not exist')
    }

    this.convertTemplateObject(registerTemplates)
      .then(this.deleteRegister.bind(this))
      .then(this.getMinRegDate.bind(this))
      .then(this.registerOperations.bind(this))
  }

  function updateRegister () {

  }

  function getMinRegDate (registerTemplates) {
    return Promise.resolve({
      minreg: '564363',
      registerTemplates
    })
  }

  function registerOperations (params) {
    const registerColor = `'${params.registerTemplates.Root['clr']}'`

    params.registerTemplates.Root['$Проводка']
      .map(registerTemplate => this.createRegisterOperation.call(this, {
        registerTemplate,
        registerColor
      }))
  }

  function createRegisterOperation (param) {
    const registerTemplate = param.registerTemplate;

    const debit = registerTemplate['$ДТ'];
    const credit = registerTemplate['$КТ'];

    Promise.all([
      this.$item.$base.findItem(debit[0].$Счет[0].link),
      this.$item.$base.findItem(credit[0].$Счет[0].link)
    ])
      .then(res => {
        //TODO GET LOCK DATE

        this.createXQuery(param);
        console.log(res)

      })
      .catch(e => console.log(e));

    return Promise.resolve()
    //
    // operationTemplate.fields
    //     .then(field => {
    //         console.log(field);
    //     });

    // const journal = _docClass.FindLinkedItem(oper.SelectElement("Журнал"), odaItem.Types.odaClass, true) as Class;
    // const debitJournal = _docClass.FindLinkedItem(debit.SelectElement("Счет"), odaItem.Types.odaClass, true) as Class;
  }

  function deleteRegister (registerTemplate) {
    return Promise.resolve(registerTemplate)
  }

  function generateOID (count) {
    return this.$item.$host.API.GET('generate_id', {count})
      .then(res => res.result.split(' '))
  }

  function convertTemplateObject (registerTemplate) {

    // if (registerTemplate.Root['corrected']) {
    //     return Promise.reject();
    // }

    registerTemplate.Root['$Проводка'].forEach(reg => {
        let DT = reg['ДТ']
        let acc = reg['СчетДт'] && reg['СчетДт'].trim()

        if (acc) {
          DT['Счет'] = acc
          reg['СчетДт'] = undefined
        }

        let KT = reg['КТ']

        acc = reg['СчетКт'] && reg['СчетКт'].trim()
        if (acc) {
          KT['Счет'] = acc
          reg['СчетКт'] = undefined
        }

        let qtt = reg['Количество'] && reg['Количество'].trim()

        if (qtt) {
          DT['КолВо'] = qtt
          KT['КолВо'] = qtt
          reg['Количество'] = undefined
        }

      }
    )

    // registerTemplate.Root['corrected'] = true;

    return Promise.resolve(registerTemplate)
  }

  function deleteRegister (param) {
    return Promise.resolve(param)
  }

  function addAccountXQ (typeAcc, currentOperation) {
    const account = currentOperation[typeAcc]['Счет']

    //Add validation

    return (account.indexOf('@') !== -1)
      ? `substring-before($reg[1]/(concat("${acc_val}, ' ')), ' ')`
      : `$reg[1]/('${account.split(' ')[0]}')`

  }

  function createXQuery (param) {
  }

})
console.log('Start')