(:let $oids := '1D31D9F396B1140 1D3216257CAF210 1D325568F9EF1D0':)
(:let $host := 'H:1D03A3F3B5863BB':)
(:let $base := 'M:1D32708618BFC30':)
(:let $jurModuleId := 'M:1CF566ABBA54AE8':)
(:let $docClassId := 'H:1D03A3F3B5863BB/P:WORK/B:1D1E71E24EDDC98/C:1D1E71D5F9323AC':)

#insert#

let $objects := oda:select(doc(concat($docClassId, '/I:PACK'))/PACK/OBJECT, 'oid', $oids)

let $idx := string-length($docClassId) - 14
let $cid := substring($docClassId, $idx, 15)

let $regOids := string-join(
                      for $o in $objects/SERVICES/REGISTER/OPERATION/REG
                          let $len := string-length($o/@link)
                          let $idx := oda:num($len - 14)
                          let $oid := substring($o/@link, $idx, 15)
                          return $oid, ' ')

                  let $newObjects :=
    <OBJECTS>
    {
        for $obj in $objects
        return
            element OBJECT
            {
				$obj/@*[name() != 'ro' and name() != 'clr'],
				$obj/*[not(name() = 'SERVICES')]

				,

				for $node in $obj/SERVICES
				return
					element SERVICES
					{
						$node/@*,
						$node/*[not(name() = 'REGISTER')]
					}
            }
    }
    </OBJECTS>

let $delReg := oda:command(concat('delete_object?id=', $host, '/', $base, '/', $jurModuleId, '/' , /OBJECT/cls/@link, '&amp;force=true&amp;async=false'), $regOids)
let $updateObj := oda:command(concat('save_objects?id=', $host, '/', $base, '/C:' , $cid, '&amp;force=true&amp;async=false'), oda:xml($newObjects))

return ($delReg, $updateObj)