(class extends odaClass {
    getXQ(start, code) {
        let filter = '';
        if (start) {
            if (code)
                filter = "[oda:left(@CODE," + start + ") = oda:left('" + code + "'," + start + ")]";
            else
                return {
                    $O: []
                };
        }
        let xq = "for $a in x/O" + filter +
            " order by $a/@name" +
            " return $a";
        return xq;
    }
    getObjects(code, start) {
        return this.XQuery(this.getXQ(start, code)).then(res => {
            let p = res.$O.map(i => {
                return this.getObject(i.oid);
            })
            return Promise.all(p).then(res => {
                return res;
            });
        })
    }
    get ShortBaseClass() {
        return this.$('ShortBaseClass', () => {
            return this.findItem('sokrbase');
        })
    }
    AdrItems(name, kladrName) {
        return this.$(name, async () => {
            const adrItems = await this.findItem(kladrName);
            return adrItems;
        })
    }
    findRegions(code) {
        return this.AdrItems('Regions', 'subjects').then(cls => {
            return cls.getObjects();
        })
    }
    findDistricts(code) {
        return this.AdrItems('Districts', 'raions').then(cls => {
            return cls.getObjects(code, 2);
        })
    }
    findCities(code) {
        return this.AdrItems('Cities', 'towns').then(cls => {
            return cls.findItem('C:T'+code.substring(0,2)).then(cls=>{
                return cls.getObjects(code, 5);
            });
        })
    }
    findStreets(code) {
        return this.AdrItems('Streets', 'streets').then(cls => {
            return cls.findItem('C:S'+code.substring(0,2)).then(cls=> {
                return cls.getObjects(code, 8);
            })
        })
    }
    findHouses(code) {
        return this.AdrItems('Houses', 'houses').then(cls => {
            return cls.findItem('C:H' + code.substring(0, 2)).then(cls => {
                return cls.getObjects(code, 11);
            })
        })
    }  
}).register();