(class extends odaAction {

    static get properties() {
        return {
            label: 'Add article ',
            allowAccess: 'C',
            subIcon: 'plus',
            allowUse: true
        }
    }

    async execute() {
        try {
            await ODANT.loadScript('/web/ext/transliteration/lib/browser/transliteration.js');
            const label = await ODA.inputText({title: 'New article', value: 'New article'});
            const name = slugify(label + ' ' + ODANT.getGuid());
            const structure = await this.$item.Structure;
            const folder = await  structure.getFolderLang();
            const file = await folder.getFile(name + '.html', this.$item.DefaultContent);
            await  structure.addFilToStructure(this.$item.name, file.name, label);
            this.$item.fire('create', file, true);
            ODA.push("Article added", {
                tag: "create-file",
                body: `Article "${label}" was added`,
                icon: this.icon
            });
        } catch (err) {
            console.error(err);
            ODA.push("Article added", {
                tag: "Error",
                body: `failed to add file ${label}`,
                icon: this.icon
            });
        }
    }
}).register();