(class extends odaAction {
    
    static get properties() {return {
            label: 'Add article',
            allowAccess:  'C',
            subIcon: 'plus'
        }}
    async execute() {
        try {
            await ODANT.loadScript('/web/ext/transliteration/lib/browser/transliteration.js');
            const label = await ODA.inputText({title: 'Create new article', value: 'New article'});
            const name = slugify(label + ' ' + ODANT.getGuid());
            const folder = await this.$item.FolderLang;
            const file = await folder.getFile(name + '.html', this.$item.DefaultContent);
            const structure = await  this.$item.Structure;
            await structure.addFilToStructure('book', file.name, label);
            ODA.push("Chapter added", {
                tag: "create-file",
                body: `Chapter "${label}" has been added`,
                icon: this.icon
            });
            this.$item.fire('create', file, true);
        } catch (err) {
            console.error(err);
            ODA.push("Chapter added", {
                tag: "Error",
                body: `failed to add file ${label}`,
                icon: this.icon
            });
        }
    }
    
}).register();