(class extends odaObject {
    static get properties() {
        return {
            itemTypeLabel: 'chapter',
            defaultViewName: 'documentation',
            defaultRootFileName: 'book',
            icon: 'book',
            label: {
                get() {
                    if (this._label)
                        return this._label;
                    return this.getLabel().then(label => {
                        this._label = label;
                        this.fireChanged();
                        return label;
                    })
                },
                set(v) {
                    this.Structure.then(structure => {
                        structure.setLabel('book', v).then(label => {
                            this._label = label;
                            this.fireChanged();
                        })
                    })
                }
            },
            async Structure() {
                return this.$('structure', async () => {
                    if (this._structure) {
                        return this._structure;
                    }
                    // let root = {
                    //     label: this.name,
                    //     name: 'book',
                    //     locale: ODANT.language,
                    //     author: this.userId,
                    //     items: [],
                    //     locals: [
                    //         {
                    //             language: ODANT.language,
                    //             label: this.name,
                    //             author: this.userId,
                    //         }
                    //     ]
                    // };
                    try {
                        const folder = await  this.BookFolder;
                        // const structure = await folder.getFile('structure.json', JSON.stringify(root));
                        const structure = await folder.getFile('structure.json');
                        this._structure = structure;
                        await structure.Json;
                        return structure;
                    }catch (error) {
                        console.error(error);
                    }
                });
            },
            BookFolder() {
                return this.$('book-folder', () => this.$folder.getFolder('book'));
            },
            FolderLang() {
                return this.BookFolder.then(bookFolder => {
                    return this.$('folder-lang', () => bookFolder.getFolder(ODANT.language, true));
                })
            },
            async docItems() {
                try {
                    return await this.Files;
                } catch (e) {
                    return []
                }
            },
            async Files() {
                const structure = await this.Structure;
                return structure.loadFiles();
            },
            DefaultContent() {
                let html = document.implementation.createHTMLDocument();
                let meta = html.createElement('meta');
                meta.setAttribute("charset", "UTF-8");
                html.head.appendChild(meta);
                return html.documentElement.outerHTML;
            },
            async BookFile() {
                return this.$('book-file', async() =>{
                    const structure = await this.Structure;
                    return structure.loadRootFile();
                })
            }
        }
    }

    async nextItem(item, recurs) {
        try {
            let items = await this.Files;
            if (items.length > 0) {
                if (!item) {
                    return {
                        parent: this,
                        item: items[0]
                    }
                } else {
                    let idx = items.findIndex(i => i.id === item.id);
                    if(items[idx + 1]) {
                        return {
                            parent: this,
                            item: items[idx + 1]
                        };
                    }
                }
            }
            if(!recurs) {
                return null;
            }
            let parent = await this.getParentItem();
            return parent.nextItem(this, true)
        } catch (e) {
            return null
        }
    }

    async getLabel() {
        const structure = await this.Structure;
        const label = await structure.getFileLabel('book');
        return label ? label : this.name;
    }

    async getParentItem() {
        return this.$class
    }

    async hasDocChildren() {
        const structure = await this.Structure;
        const rootFile = await this.BookFile;
        return await structure.hasDocChildren(rootFile);
    }

    async execute() {
        const file = await this.BookFile;
        file.show('docs-editor');
    }

}).register();