(class extends odaAction {
    static get properties() { return {
        label: "Register card",
        allowExport: true,
        isActive: true
    }}

    _createPrimaryQuery(passed, TestType, TestResult) {
        //RegistrationDocument
        let rdDTType = '';
        switch (this._objReroot.DocumentType) {
            case 'Свидетельство о регистрации ТС':
                rdDTType = 'RegTalon';
                break;
            case 'Паспорт транспортного средства':
                rdDTType = 'PTS';
                break;
        }

        let rdDocumentType = `<tem:DocumentType>${rdDTType}</tem:DocumentType>`;
        let rdSeries = `<tem:Series>${this._objReroot.DocSeries}</tem:Series>`;
        let rdNumber = `<tem:Number>${this._objReroot.DocNumber}</tem:Number>`;
        let rdOrganization = `<tem:Organization>${this._objReroot.DocOrganization}</tem:Organization>`;
        this._objReroot.DocDate = this._objReroot.DocDate.replace('Z', '');
        let rdDate = `<tem:Date>${this._objReroot.DocDate}</tem:Date>`;

        //FORM
        let formComment = '';
        let formDuplicate = '';
        let formValidity = '';
        let dateOfRetest = '';

        if (passed) {
            formComment = this._objReroot.Comment ? `<tem:Comment>${this._objReroot.Comment}</tem:Comment>` : '';
            formDuplicate = `<tem:Duplicate>false</tem:Duplicate>`;
            this._objReroot.Validity = this._objReroot.Validity.replace('Z', '');
            formValidity = `<tem:Validity>${this._objReroot.Validity}</tem:Validity>`;
        } else {
            if (this._objReroot.DateOfRetest) {
                this._objReroot.DateOfRetest = this._objReroot.DateOfRetest.replace('Z', '');
                dateOfRetest = `<tec:DateOfRetest>${this._objReroot.DateOfRetest}</tec:DateOfRetest>`;
            }
        }

        //Vehicle
        let vMake = `<tec:Make>${this._objReroot.Make}</tec:Make>`;
        let vModel = `<tec:Model>${this._objReroot.Model}</tec:Model>`;

        //vehicle owner
        let FName = `<tec:FName>${this._objReroot.OwnerFam}</tec:FName>`;
        let Name = `<tec:Name>${this._objReroot.OwnerNam}</tec:Name>`;
        let MName = this._objReroot.OwnerOtch ? `<tec:MName>${this._objReroot.OwnerOtch}</tec:MName>` : '';
        let rdFType = '';

        if (this._objReroot.Foreign) {
            if (this._objReroot.Foreign === 'True')
                rdFType = 'Y';
            else
                rdFType = 'N';
        }
        else
            rdFType = 'NULL';

        let rdForeign = `<tem:Foreign>${rdFType}</tem:Foreign>`;

        //root
        let bodyNumber = this._objReroot.BodyNumber ? `<tec:BodyNumber>${this._objReroot.BodyNumber}</tec:BodyNumber>` : '';
        this._objReroot.DateOfDiagnosis = this._objReroot.DateOfDiagnosis.replace('Z', '');
        let dateOfDiagnosis = `<tec:DateOfDiagnosis>${this._objReroot.DateOfDiagnosis}</tec:DateOfDiagnosis>`;
        let VechicleCategory = `<tec:VehicleCategory>${this._objReroot.VechicleCategory}</tec:VehicleCategory>`;
        let VechicleCategory2 = `<tec:VehicleCategory2>${this._objReroot.VechicleCategory2}</tec:VehicleCategory2>`;
        let Vin = this._objReroot.VIN ? `<tec:Vin>${this._objReroot.VIN}</tec:Vin>` : '';
        let Year = `<tec:Year>${this._objReroot.Year}</tec:Year>`;
        let FrameNumber = this._objReroot.FrameNumber ? `<tem:FrameNumber>${this._objReroot.FrameNumber}</tem:FrameNumber>` : '';
        let EmptyMass = `<tem:EmptyMass>${this._objReroot.EmptyMass}</tem:EmptyMass>`;
        let MaxMass = `<tem:MaxMass>${this._objReroot.MaxMass}</tem:MaxMass>`;

        let FuelType = '';
        switch (this._objReroot.Fuel) {
            case 'Бензин':
                FuelType = 'Petrol';
                break;
            case 'Дизельное топливо':
                FuelType = 'Diesel';
                break;
            case 'Сжиженный газ':
                FuelType = 'LiquefiedGas';
                break;
            case 'Сжатый газ':
                FuelType = 'PressureGas';
                break;
            case 'Без топлива':
                FuelType = 'None';
                break;
        }

        let Fuel = this._objReroot.Fuel ? `<tem:Fuel>${FuelType}</tem:Fuel>` : '';

        let BSType = '';
        switch (this._objReroot.BrakingSystem) {
            case 'Механический':
                BSType = 'Mechanical';
                break;
            case 'Гидравлический':
                BSType = 'Hydraulic';
                break;
            case 'Пневматический':
                BSType = 'Pneumatic';
                break;
            case 'Комбинированный':
                BSType = 'Combined';
                break;
            case 'Без тормозной системы':
                BSType = 'None';
                break;
        }

        let BrakingSystem = `<tem:BrakingSystem>${BSType}</tem:BrakingSystem>`;
        let Tyres = `<tem:Tyres>${this._objReroot.Tyres}</tem:Tyres>`;
        let Killometrage;

        if (this._objReroot.Killometrage)
            Killometrage = `<tem:Killometrage>${this._objReroot.Killometrage}</tem:Killometrage>`;
        else
            Killometrage = `<tem:Killometrage>0</tem:Killometrage>`;
        let Note = this._objReroot.Note ? `<tec:Note>${this._objReroot.Note}</tec:Note>` : '';
        let RegistrationNumber = this._objReroot.RegistrationNumber ? `<tec:RegistrationNumber>${this._objReroot.RegistrationNumber}</tec:RegistrationNumber>` : '';

        //values
        let values = '<tec:Values>';
        this._objReroot.$Values.forEach(value => {
            if (value.Прим === 'Х') {
                values += `<tec:CardItemValue><tec:Code>${value.Code}</tec:Code><tec:TestResult>${value.TestResult && value.TestResult === 'True' ? '0' : '1'}</tec:TestResult></tec:CardItemValue>`;
            }
        });
        values += '</tec:Values>';

        return `${bodyNumber}${dateOfDiagnosis}<tem:Form>${formComment}${formDuplicate}${formValidity}</tem:Form>${Name}${FName}${MName}${Note}${RegistrationNumber}${TestResult}${TestType}${values}${dateOfRetest}<tec:Vehicle>${vMake}${vModel}</tec:Vehicle>${VechicleCategory}${VechicleCategory2}${Vin}${Year}${FrameNumber}${EmptyMass}${MaxMass}${Fuel}${BrakingSystem}${Tyres}${Killometrage}<tem:RegistrationDocument>${rdDocumentType}${rdSeries}${rdNumber}${rdOrganization}${rdDate}${rdForeign}</tem:RegistrationDocument>`;
    }

    _createSecondaryQuery(passed) {
        //root
        let cardIsSecondaryFor = this._objReroot.Nomer ? `<tec:CardIsSecondaryFor>${this._objReroot.Nomer}</tec:CardIsSecondaryFor>` : '';

        //FORM
        let formQuery = `<tem:Form>`;
        formQuery += this._objReroot.Comment ? `<tem:Comment>${this._objReroot.Comment}</tem:Comment>` : '';
        formQuery += `<tem:Duplicate>false</tem:Duplicate>`;
        this._objReroot.Validity = this._objReroot.Validity.replace('Z', '');
        formQuery += `<tem:Validity>${this._objReroot.Validity}</tem:Validity>`;
        formQuery += `</tem:Form>`;

        //values
        let values = '';

        if (!passed) {
            values = '<tec:Values>';
            this._objReroot.$Values.forEach(value => {
                if (value.Прим === 'Х') {
                    values += `<tec:CardItemValue><tec:Code>${value.Code}</tec:Code><tec:TestResult>${value.TestResult && value.TestResult === 'True' ? '0' : '1'}</tec:TestResult></tec:CardItemValue>`;
                }
            });
            values += '</tec:Values>';
        }

        return `${cardIsSecondaryFor}${formQuery}${values}`;
    }

    _createDuplicateQuery() {
        //root
        let cardIsDuplicateFor = this._objReroot.Nomer ? `<tec:CardIsDublicateFor>${this._objReroot.Nomer}</tec:CardIsDublicateFor>` : '';

        //FORM
        let formQuery = '<tem:Form>';
        formQuery += this._objReroot.Comment ? `<tem:Comment>${this._objReroot.Comment}</tem:Comment>` : '';
        formQuery += `<tem:Duplicate>true</tem:Duplicate>`;
        this._objReroot.Validity = this._objReroot.Validity.replace('Z', '');
        formQuery += `<tem:Validity>${this._objReroot.Validity}</tem:Validity>`;
        formQuery += `</tem:Form>`;

        return `${cardIsDuplicateFor}${formQuery}`;
    }

    execute(param) {
        if (this.contextItem) {
            return this.contextItem.API.GET().then(json => {
                this._objReroot = json.$OBJECT[0];

                if (!this._objReroot.$Expert || this._objReroot.$Expert.length < 1)
                    return `Error: Can't find Expert in class ${this.contextItem.url}`;

                let user = this._objReroot.$Expert[0];

                if (user) {
                    let query = '';

                    //user
                    let userLogin = `<tec:Name>${user.Login}</tec:Name>`;
                    let userPassword = `<tec:Password>${user.Password}</tec:Password>`;
                    let userIS = user.IS ? `<tec:ExtSystem>${user.IS}</tec:ExtSystem>` : '';

                    //expert
                    let userFName = `<tem:FName>${user.Фамил}</tem:FName>`;
                    let userName = `<tem:Name>${user.Имя}</tem:Name>`;
                    let userMName = `<tem:MName>${user.Отчес}</tem:MName>`;

                    let isDuplicate = this._objReroot.Duplicate === "True";

                    if (!isDuplicate) {
                        let isPrimary = false;
                        let isPassed = false;
                        let TTType = '';

                        switch (this._objReroot.TestType) {
                            case 'Первичная проверка':
                                TTType = 'Primary';
                                isPrimary = true;
                                break;
                            case 'Вторичная проверка':
                                TTType = 'Secondary';
                                break;
                        }

                        let TestType = `<tec:TestType>${TTType}</tec:TestType>`;
                        let TRType = '';

                        switch (this._objReroot.TestResult) {
                            case 'Проверка пройдена':
                                TRType = 'Passed';
                                isPassed = true;
                                break;
                            case 'Проверка не пройдена':
                                TRType = 'NotPassed';
                                break;
                        }

                        let TestResult = `<tec:TestResult>${TRType}</tec:TestResult>`;

                        if (isPrimary) {
                            query = this._createPrimaryQuery(isPassed, TestType, TestResult);
                        }
                        else {
                            query = this._createSecondaryQuery(isPassed);
                        }
                    }
                    else {
                        query = this._createDuplicateQuery();
                    }

                    let request = `<?xml version='1.0' encoding='UTF-8'?><soapenv:Envelope xmlns:tec='http://schemas.datacontract.org/2004/07/TechInspection.Domain.DataContracts' xmlns:tem='http://tempuri.org/' xmlns:soapenv='http://schemas.xmlsoap.org/soap/envelope/'><soapenv:Header/><soapenv:Body><tem:RegisterCard><tem:user>${userLogin}${userPassword}${userIS}</tem:user><tem:card>${query}<tem:Expert>${userName}${userFName}${userMName}</tem:Expert></tem:card></tem:RegisterCard></soapenv:Body></soapenv:Envelope>`;
                    console.log("\r\n" + new Date().toLocaleString() + ' EAISTO LOG START.\r\n');
                    console.log("\r\n" + new Date().toLocaleString() + ' : ' + "METHOD NAME: RegisterCard" + "\r\n");
                    console.log("\r\n" + new Date().toLocaleString() + ' XML: ' + request + "\r\n");
                    return fetch('http://eaisto.gibdd.ru/common/ws/arm_expert.php?wsdl', {
                        method: "post",
                        headers: {
                            "Content-type": "text/soap+xml; charset=UTF-8",
                            "SOAPAction": "http://tempuri.org/IInspection/RegisterCard"
                        },
                        body: request
                    }).then((response) => {
                        return response.text()
                        .then((text) => {
                            let converter = require('xml-js');
                            console.log("\r\n" + new Date().toLocaleString() + ' RESPONSE TEXT: ' + text);
                            if (converter) {
                                let root = JSON.parse(converter.xml2json(text, {compact: true, spaces: 4}));

                                if (root) {
                                    let env = root["SOAP-ENV:Envelope"];

                                    if (env) {
                                        let body = env["SOAP-ENV:Body"];

                                        if (body) {
                                            let regResponse = body["ns1:RegisterCardResponse"];

                                            if (regResponse) {
                                                let res = regResponse["ns1:RegisterCardResult"];

                                                if (res) {
                                                    let newId = res["_text"];

                                                    if (newId) {
                                                        this._objReroot.RegisterCardResult = newId;
                                                        res = regResponse["ns1:Nomer"];

                                                        if (res) {
                                                            newId = res["_text"];

                                                            if (newId) {
                                                                this._objReroot.Nomer = newId;

                                                                return this.$item.save(JSON.stringify(json)).then(() => {
                                                                    return "Registering completed!";
                                                                });
                                                            }
                                                        }
                                                    }
                                                }
                                                else {
                                                    return "Error: Node 'Envelope->Body->RegisterCardResponse->Nomer' doesn't exist";
                                                }
                                            }

                                            let fault = body["SOAP-ENV:Fault"];

                                            if (fault) {
                                                let fText = fault["faultstring"]["_text"];

                                                if (fText)
                                                    return "Error: " + fText;

                                                return "Error: fText undefined";
                                            }
                                            else {
                                                return "Error: Node 'Envelope->Body->Fault' doesn't exist";
                                            }
                                        }
                                        else {
                                            return "Error: Node 'Envelope->Body' doesn't exist";
                                        }
                                    }
                                    else {
                                        return "Error: Node 'Envelope' doesn't exist";
                                    }
                                }
                                else {
                                    return "Error: Can't convert response to json";
                                }
                            }
                            else {
                                return "Error: Can't require xml-js";
                            }
                        });
                    });
                }
                else {
                    return `Error: Field 'Users' not found in ${obj.Url}`;
                }
            });
        }
        else {
            return `Error: Context is not set ${this.ActionSource.Url}`;
        }
    }
}).register();