(class extends odaService {

    static get properties(){
        return {
            label: 'html2pdf',
            allowArrayContext: true,
            isActive: true,
            allowAccess: 'R'
        }
    }

    execute(params) {
        console.log(JSON.stringify(params));

        const htmlPdf = require('html-pdf-chrome');
        return this.ActionSource.$STATIC.$object
        .then(staticObj =>
            this.ActionSource.$STATIC.fields
            .then(fields => fields
            .find(f => f.name === 'port')
            .getValue(staticObj))
            .then(port => {
                if (port) {
                    return htmlPdf.create(params.HTML, {port})
                    .then(pdf => {
                        return this.ActionSource.createObject()
                        .then(obj => obj.fields
                            .then(fields =>
                                Promise.all([
                                        fields
                                        .find(f => f.name === 'Html')
                                        .setValue(obj, params.HTML),
                                        fields
                                        .find(f => f.name === 'Pdf')
                                        .setValue(obj, new File({
                                            name: `${Date.now()}.pdf`,
                                            type: `application/pdf`,
                                            buffer: pdf.toBuffer()
                                        }))
                                    ]
                                )
                            )
                            .then(res => {
                                const _file = res[1];
                                return obj.save()
                                .then(res =>  _file.fullId)
                            })
                        )
                    })
                }

                return 'Headless chrome port not specified';
            })
        )
    }
}).register();