(() => {
    'use strict';

    let csvExportToJSON = class extends odaAction {
        static get properties(){
            return {
                isActive: true,
                allowAccess: 'C'
            }
        }

        execute(param) {
            const parse = require('csv-parse');

            return params.source.load()
                .then(res => new Promise((resolve, reject) => {
                    const opt = {
                        comment: '#',
                        columns: param.headers
                            ? true
                            : row => row
                                .map((v, idx) => `col${idx}`)
                    };

                    parse(res, opt, (err, out) => {
                        const meta = [];
                        if (out.length > 0){
                            for (let key in out[0]){
                                meta.push({
                                    name: key
                                });
                            }
                        }

                        const result = {
                            'ROOT': {
                                '$DATASET': [
                                    {
                                        'DATA': {
                                            $R: out
                                        },
                                        'METADATA': {
                                            $FIELD: meta
                                        }
                                    }
                                ]

                            }
                        };

                        return obj.fields
                            .then(fields => {
                               const sourceField = fields.find(f => f.name === 'source');

                               return sourceField.setValue(object, new File({
                                   name: `import.json`,
                                   buffer: new Buffer.from(JSON.stringify(result))
                               }))
                            });
                    });
                }))
        }
    };

    csvExportToJSON.register();
})();
