(() => {
    'use strict';

    let excelSource = class extends odaAction {
        static get properties(){
            return {
                isActive: true,
                allowAccess: 'C'
            }
        }

        execute(params) {
            console.log(`method source csv executed ${JSON.stringify(params)}`);

            if (params && params.fullId) {
                return ODANT.findItem(params.fullId)
                    .then(obj => {
                        return obj.fields
                            .then(fields => fields
                                .find(f => f.name === 'file')
                                .getValue(obj))
                    })
            } else {
                return Promise.reject(new Error('fullId not specified'))
            }
        }
    };

    excelSource.register();
})();
