(() => {
    'use strict';

    let action = class extends odaAction {
        static get properties(){
            return {
                isActive: true,
                allowAccess: 'C'
            }
        }

        execute(params) {
            console.log(`method source executed ${JSON.stringify(params)}`);

            if (params && params.source) {
                return ODANT.findItem(params.source)
                    .then(obj => {
                        return obj.fields
                            .then(fields => fields
                                .find(f => f.name === 'file')
                                .getValue(obj)
                                .then(file => file.fullId))

                    })
            } else {
                return Promise.reject(new Error('Source not specified'))
            }
        }
    };

    action.register();
    //For testing
    if (typeof module !== 'undefined' && typeof module.exports !== 'undefined'){
        module.exports = action;
    }
})();