(class extends odaService {
    static get properties() {
        return {
            label: 'Import',
            isActive: true,
            allowArrayContext: true,
            allowAccess: 'C'
        }
    }

    execute() {
        return this.$item.$class.$STATIC.$object.then(staticObj => {
            return this.$item.$class.$STATIC.fields.then(fields => {
                let fieldConnector = fields.find(f => f.name === `connector`);

                return Promise.resolve(fieldConnector.getValue(staticObj))
            })
            .then(connector => {
                console.log('start methods/methods/source');
                return ODANT.executeAction(connector.fullId, 'methods/source', {
                    source: this.$item.fullId
                })
                .then(sourceResult => {
                    console.log('start methods/convert');
                    console.log(`connector.fullId: ${connector.fullId}`);

                    return ODANT.executeAction(connector.fullId, 'methods/convert', {
                        target: this.$item.fullId,
                        source: $item,
                    })
                    .then((sourceResult) => {
                        console.log('start methods/save-import-objects');
                        return ODANT.executeAction(this.$item.fullId, 'methods/save-import-objects', {
                            source: sourceResult
                        })
                    })
                });
            })
        })
    }
}).register();