(class extends odaAction {
    static get properties() {
        return {
            allowAccess: 'A',
            icon: 'icons:add',
            label: 'Add device',
            category: 'admin',
        };
    }
    async execute() {
        const control = await ODA.createComponent(this.resolveUrl('add-device-dialog.html'));
        const { name, label, icon } = await ODA.showDialog(control, { title: 'Add new device' });
        const cls = await this.$item._createClass(name);
        if (cls) {
            this._pushNote(cls);
        }
    }
    _pushNote(item) {
        ODA.push(
            `A ${item.itemTypeLabel} named "${item.label}" was created`,
            {
                tag: `create-device-${item.fullId}`,
                body: `A new device "${item.label}" was created in the ${item.$owner.itemTypeLabel} "${item.$owner.label}".`,
                icon: item.icon
            }
        );
    }
}).register();