(class extends odaAction {
    execute(params) {
        let p = JSON.parse(params);

        let root = {root: p};
        let buffer = Buffer.from(JSON.stringify(root), 'utf8');
        let now = new Date('1970-01-01T00:00:00').addSeconds(p.timestamp);
        let fileName = this.getFileName(now);

        return this.$item.save()
        .then(result => {
            return this.$item.getFolder(now.getFullYear().toString(), true)
            .then((folder) => {
                let month = (now.getMonth() + 1).toString();

                if (month.length === 1) {
                    month = '0' + month;
                }

                return folder.getFolder(month, true)
                .then(folder => {
                    let day = now.getDate().toString();

                    if (day.length === 1) {
                        day = '0' + day;
                    }

                    return folder.getFolder(day, true)
                    .then(folder => {
                        return folder.saveFile(buffer, fileName)
                        .then(file => {
                            return this.$item.API.POST('xquery', {format: 'xml'}, '*')
                            .then(objXml => {
                                return this.$item.$class.$STATIC.$object.then(staticObj => {
                                    let xq = staticObj.Root.LogXQ.replace("[#OBJXML#]", objXml);

                                    return file.API.POST('xquery', {format: 'xml'}, xq)
                                    .then(xml => this.$item.save(xml));
                                });
                            });
                        });
                    });
                });
            });
        });
    }

    getFileName(now) {
        let hour = now.getHours().toString();
        let min = now.getMinutes().toString();
        let sec = now.getHours().toString();

        if (hour.length === 1) {
            hour = '0' + hour;
        }

        if (min.length === 1) {
            min = '0' + min;
        }

        if (sec.length === 1) {
            sec = '0' + sec;
        }
        return hour + '.' + min + '.' + sec + '.json';
    }

}).register();