(class extends odaField {
    static get properties() {
        return {
            _input: 'file-lib',
            _complex: '',
            extentions: {
                label: 'Расширения',
                get() {
                    return this.getAttr('extentions', '*.*');
                },
                set(v) {
                    this.setAttr('extentions', v);
                }
            },
            absolutePath: {
                label: 'Полный путь',
                type: Boolean,
                get() {
                    return this.getBoolAttr('AbsolutePath', false);
                },
                set(v) {
                    this.setBoolAttr('AbsolutePath', v);
                }
            },
            _isLink: {
                get() {
                    return false;
                }
            },
            maxSize: {
                category: 'File settings'
            }
        }
    }
    async getFieldFileFromLibraryObject(libObj) {
        const fields = await libObj.fields;
        const imgFldArr = fields.filter((f) => f.name === 'file');
        if (imgFldArr && imgFldArr.length > 0) {
            return imgFldArr[0];
        }

        return null;
    }
    async getFormattedValue($object, root) {
        if ($object) {
            const libObj = await this.getValue($object, root);
            if (libObj && libObj.Root) {
                return libObj.Root.file;
                // const imgFld = await this.getFieldIconFromLibraryObject(libObj);
                // if (imgFld) {
                //     return await imgFld.getValue(libObj, libObj.Root);
                // }
            }
        }

        return '';
    }
}).register();