(class extends odaField {
    static get properties() {
        return {
            _input: 'image-lib',
            _complex: '',
            extentions: {
                label: 'Расширения',
                get() {
                    return this.getAttr('extentions', '*.png, *.jpg, *.jpeg, *.gif, *.csv, *.bmp')
                },
                set(v) {
                    this.setAttr('extentions', v);
                }
            },
            Format: {
                type: Number,
                get() {
                    return this.getNumAttr('Format', 64);
                },
                set(v) {
                    this.setNumAttr('Format', v);
                }
            },
            absolutePath: {
                label: 'Полный путь',
                type: Boolean,
                get() {
                    return this.getBoolAttr('AbsolutePath', false);
                },
                set(v) {
                    this.setBoolAttr('AbsolutePath', v);
                }
            },
            _isLink: {
                get() {
                    return false;
                }
            },
            defaultViewer: '/web/lib/type-previewers/image/odant-image-viewer.html',
            defaultEditor: '/web/lib/type-editors/image/odant-image-editor.html'
        }
    }
    async getFieldIconFromLibraryObject(libObj) {
        const fields = await libObj.fields;
        const imgFldArr = fields && fields.filter((f) => f.name === 'icon');
        if (imgFldArr && imgFldArr.length > 0) {
            return imgFldArr[0];
        }

        return null;
    }
    async getFormattedValue($object, root, format) {
        if ($object) {
            const libObj = await this.getValue($object, root);
            if (libObj) {
                const imgFld = await this.getFieldIconFromLibraryObject(libObj);
                if (imgFld) {
                    const $file = await imgFld.getValue(libObj, libObj.Root);
                    format = format || this.Format;
                    if ($file && $file.url)
                        return $file.url + (format ? '?mode=preview' + format : '');
                }
            }
        }
        
        return '';
    }
}).register();