(class extends odaService {

    static get properties() {
        return {
            allowAccess: 'C',
            allowExport: true,
            allowSave: true,
            label: "Post Data"
        }
    }

    async execute(args) {
        console.log((new Date()).toISOString() + " - PostData Start");
        console.log("args = " + args);
        console.log("item = " + this.$item + "; fullId = " + this.$item.fullId);
        let staticObj = await ODANT.API.request(this.$item.url + '/O:' + this.$item.id);//$item.getObject($item.id);
        console.log("staticObj = " + JSON.stringify(staticObj));

        if (staticObj == null) {
            console.log("ERROR staticObj == null");
            return "ERROR staticObj == null";
        }

        let xq = `let $postData := doc('${JSON.stringify(args)}') return $postData/(${staticObj.$STATIC[0].$xq[0].$CDATA$})`;
        console.log("Get new objects XQuery = " + xq);

        let toSave = await this.$item.XQuery(xq, {format: 'xml-standart'});//{ format: 'xml' }
        console.log("XML to save = " + toSave);

        if ((toSave == null) || (toSave.length <= 0)) {
            console.log("ERROR Nothing to save");
            return "ERROR Nothing to save";
        }

        let result = await this.$item.API.POST('save_objects', {format: 'xml-standart'}, toSave);
        console.log("result = " + result);

        console.log((new Date()).toISOString() + " - PostData End");
        return result;
    }
}).register()
