(class extends odaService{
    static get properties() {
        return {
            allowAccess: 'R',
            allowArrayContext: true,
            isActive: true,
            label: "Printing"
        }
    }
    async execute (params) {
        let url = this.resolveUrl('template-selector/print-template-selector.html');
        let selector = await ODA.createComponent(url);

        selector.contextItem = this.$item;
        const actionSource = (this.ActionSource.id === '142779122248358')
                             ? this.ActionSource
                             : await this.$item.$base.findItem('M:1CD85229B0F580E/C:142779122248358');
        selector.printClass = actionSource;

        const buttons = (actionSource.access.allowDelete)
                        ? [
                            { label: 'New',      icon: 'icons:add'     , special: 'add'},
                            { label: 'Remove',   icon: 'icons:remove'  , special: 'del'},
                            { label: 'Settings', icon: 'icons:settings', special: 'set'},
                            { label: 'OK',                               special: 'ok'}
                        ]
                        : [{ label: 'OK', special: 'ok'}]

        let dialog = {
            title: 'Select template',
            icon: 'image:center-focus-strong',
            dblclick: true,
            ok: {
                show: true,
                disable: false
            },
            buttons: buttons
        };

        let dialogResult = await ODA.showDialog(selector, dialog);

        if (!dialogResult.button) {
            if (!dialogResult.focusedItem || !dialogResult.focusedItem.item)
                return;

            let id = (this.$item instanceof odaItemList)
                     ? "owner=" + this.$item.$owner.fullId + "&item=" + this.$item.items[0].fullId + "&items=" + this.$item.items.join('|')
                     : "data=" + this.$item.fullId;
            // todo неправильный вызов
            return window.open(dialogResult.focusedItem.item.url + "/~/client/form/index.html?" + id + "&view=print-viewer", "_blank");

            // let viewerUrl = this.resolveUrl("../print-viewer/print-viewer.html");
            // let viewer = await ODA.createComponent(viewerUrl);
            // viewer.contextItem = dialogResult.focusedItem.item;
            // viewer.data = this.$item;
            // return ODA.showModal(viewer);
        } else {
            switch (dialogResult.button.special) {
                case 'add':
                    let newTmpObj = await actionSource.createObject();
                    let name      = await ODA.inputText({caption: 'Input template name', value: ''});

                    await newTmpObj.setValue('name', name, newTmpObj.Root);
                    await newTmpObj.setValue('source', this.$item.$class, newTmpObj.Root);

                    await newTmpObj.save();
                    window.open(newTmpObj.url + "/~/client/form/index.html?view=print-designer", "_blank");
                    //newTmpObj.show("print-designer");
                    break;
                case 'del':
                    if (dialogResult.control.focusedItem && dialogResult.control.focusedItem.item) {
                        if (await ODA.confirm('Are you sure?')) {
                            dialogResult.control.focusedItem.item.remove();
                        }
                    }
                    break;
                case 'set':
                    if (dialogResult.control.focusedItem && dialogResult.control.focusedItem.item) {
                        //dialogResult.control.focusedItem.item.show("print-designer");
                        window.open(dialogResult.control.focusedItem.item.url + "/~/client/form/index.html?view=print-designer", "_blank");
                    }
                    break;
                case 'ok':
                    let id = (this.$item instanceof odaItemList)
                             ? "owner=" + this.$item.$owner.fullId
                               + "&item=" + this.$item.$class.fullId
                               + "&items=" + this.$item.items.reduce((previousValue, currentValue) => (previousValue)
                                                                                                       ? previousValue + '|' + currentValue.oid
                                                                                                       : currentValue.oid,
                                                                      "")
                             : "data=" + this.$item.fullId;
                    // todo неправильный вызов
                    return window.open(dialogResult.control.focusedItem.item.url + "/~/client/form/index.html?" + id + "&view=print-viewer", "_blank");
                default:
                    alert( 'Я таких значений не знаю' );
            }
        }
    };
}).register();