(class extends odaService {

    static get properties(){
        return {
            allowAccess: 'W',
            allowSave: true,
            label: "Report"
        }
    }

    execute(params) {
        console.log("Start GetReportResult");
        let paramType = typeof params;
        console.log("params.Type = " + paramType);
        console.log("Item.fullId = " + this.$item.fullId);
        if (params && (paramType == 'object')) {
            console.log("params = " + JSON.stringify(params));
        }

        return this.$item.API.POST('get_object', {id: this.$item.fullId}).then(obj => {
            let sourcePath = obj.$OBJECT[0].$XQ[0].SourcePath;
            if (sourcePath) {
                console.log("SourcePath = " + sourcePath);
                let i = sourcePath.indexOf('|');
                if (i > 0) {
                    sourcePath = sourcePath.substr(0, i);
                    console.log("SourcePath = " + sourcePath);
                }
                return this.$item.findItem(sourcePath)
                .then(sourceItem => {
                    return this.reportXQ(sourceItem, obj, params)
                });
            }

            console.log("No SourcePath");
            return this.reportXQ(this.$item, this.$item, params)
        });
    }

    reportXQ(sourceItem, settings, params = {}) {
        console.log("reportXQ");
        let xq = Object
        .keys(params.queries)
        .reduce((xq, key) => {
            console.log("key = " + key);
            if (key == 'execute') {
                return xq;
            }

            let param = key;
            if (param.startsWith('[#') && param.endsWith('#]')) {
                param = param
                .replace('[', '\\[')
                .replace(']', '\\]');
            } else {
                param = '\\[#' + param + '#\\]';
            }

            return xq.replace(new RegExp(param, 'g'), params.queries[key]);
        }, settings.$OBJECT[0].$XQ[0].$CDATA$);

        console.log("xq = " + xq);
        xq = this.removeEmptyParams(settings, xq);

        return ODANT.API.post(sourceItem.url, { method: 'xquery', format: 'xml'}, xq).then((xml) => {
            return xml
        })
    }

    removeEmptyParams(settings, xq) {
        console.log("removeEmptyParams");
        for (let i = 0; i < settings.$OBJECT[0].$Params.length; i++) {
            let param = settings.$OBJECT[0].$Params[i].n;
            if (param.startsWith('[#') && param.endsWith('#]')) {
                param = param
                .replace('[', '\\[')
                .replace(']', '\\]');
            } else {
                param = '\\[#' + param + '#\\]';
            }

            xq = xq.replace(new RegExp(param, 'g'), '');
        }
        return xq;
    }
}).register();