(class extends odaAction {
    rootId = '1D6447623C2BD05'
    static get properties() {
        return {
            rootType(){
                if (this.$item.id === this.rootId)
                    return 'root';
                if (this.$item.$owner && !this.$item.$owner.type.endsWith(this.rootId))
                    return 'journal';
                if (this.$item.type.endsWith(this.rootId))
                    return 'storage';
            },
            allowAccess: 'A',
            icon: 'icons:add',
            label() {
                switch (this.rootType) {
                    case 'root': return 'Add journal';
                    case 'journal': return 'Add storage';
                    case 'storage': return 'Add sub storage';
                }
            },
            category: 'developer',
            zIndex: 100,
        };
    }
    async execute() {
        let place, name, label, type, number, control, dialogResult;
        switch (this.rootType) {
            case 'root':
                switch (this.$item.$owner.itemTypeLabel) {
                    case 'module':
                    default:
                        place = this.$item.$base;
                        break;
                    case 'base':
                        place = this.$item;
                        break;
                }
                const items = await place['Classes'];
                const count = items && items.length || 0;
                control = await ODA.createComponent('/web/lib/dialogs/label-to-name/label-to-name.html');
                control.label = `Journal${count ? ` ${String(count + 1)}` : ''}`;
                dialogResult = await ODA.showDialog(control, { title: 'Set name and label', icon: 'icons:build' });
                if (!dialogResult) return;
                name = dialogResult.name;
                label = dialogResult.label;
                type = place.getRelativeId(this.$item);
                break;
            case 'journal':
            case 'storage':
                place = this.$item;
                control = await ODA.createComponent(this.resolveUrl('label-and-number.html'));
                control.label = 'Sub storage';
                dialogResult = await ODA.showDialog(control, { title: 'Set storage label and number', icon: 'icons:build' });
                if (!dialogResult) return;
                label = dialogResult.label;
                name = `S${dialogResult.number}`;
                number = dialogResult.number;
                break;            
        }
        
        const root = {
            $CLASS: [{
                Name: name,
                Label: label,
                Type: type,
                Category: 'Register',
                number: number
            }]
        }
        place._createClass(name, JSON.stringify(root));
    }
}).register();
