(class extends odaService {

	static get properties() {
		return {
			allowAccess: 'W',
			allowExport: true,
			allowSave: true,
			label: "WSDL"
		}
	}

	execute() {
		console.log(`this.$item: ${this.$item.fullId}`);
		console.log(`this.$owner: ${this.$owner.fullId}`);

		const getWsdlElementFromFieldRoot = (accumulator, fieldRoot) => {
			console.log(`fieldRoot: ${fieldRoot}`);
			if (fieldRoot == null)
				return accumulator;

			return accumulator + `<s:element minOccurs="0" maxOccurs="1" name="${fieldRoot.Name}" type="s:string"/>`;
		};

		let fields = this.$item.ATTRS.reduce(getWsdlElementFromFieldRoot, '');
		console.log(`fields: ${fields}`);

		return `<wsdl:definitions xmlns:tm="http://microsoft.com/wsdl/mime/textMatching/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/" xmlns:tns="http://eai.azurewebsites.net" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:s="http://www.w3.org/2001/XMLSchema" xmlns:soap12="http://schemas.xmlsoap.org/wsdl/soap12/" xmlns:http="http://schemas.xmlsoap.org/wsdl/http/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" targetNamespace="http://eai.azurewebsites.net">
	<wsdl:types>
		<s:schema elementFormDefault="qualified" targetNamespace="http://eai.azurewebsites.net">
			<s:element name="ping">
				<s:complexType/>
			</s:element>
			<s:element name="pingResponse">
				<s:complexType>
					<s:sequence>
						<s:element minOccurs="0" maxOccurs="1" name="pingResult" type="s:string"/>
					</s:sequence>
				</s:complexType>
			</s:element>
			<s:element name="SaveObjects">
				<s:complexType>
					<s:sequence>
						<s:element minOccurs="0" maxOccurs="1" name="transportguid" type="s:string"/>
						<s:element minOccurs="0" maxOccurs="1" name="dt" type="tns:SaveRecord"/>
					</s:sequence>
				</s:complexType>
			</s:element>
			<s:complexType name="SaveRecord">
				<s:sequence>
					<s:element minOccurs="0" maxOccurs="1" name="oid" type="s:string"/>
					${fields}
				</s:sequence>
			</s:complexType>
			<s:element name="SaveObjectsResponse">
				<s:complexType>
					<s:sequence>
						<s:element minOccurs="0" maxOccurs="1" name="transportguid" type="s:string"/>
						<s:element minOccurs="0" maxOccurs="1" name="SaveObjectsResponse" type="s:string"/>
					</s:sequence>
				</s:complexType>
			</s:element>
			<s:element name="GetObjects">
				<s:complexType>
					<s:sequence>
						<s:element minOccurs="0" maxOccurs="1" name="transportguid" type="s:string"/>
						<s:element name="dt">
							<s:complexType>
								<s:sequence>
									<s:element minOccurs="0" maxOccurs="1" name="oid" type="s:string"/>
								</s:sequence>
							</s:complexType>
						</s:element>
					</s:sequence>
				</s:complexType>
			</s:element>
			<s:element name="GetObjectsResponse">
				<s:complexType>
					<s:sequence>
						<s:element minOccurs="0" maxOccurs="1" name="transportguid" type="s:string"/>
						<s:element minOccurs="0" maxOccurs="1" name="GetObjectsResult" type="s:string"/>
					</s:sequence>
				</s:complexType>
			</s:element>
			<s:element name="DeleteObjects">
				<s:complexType>
					<s:sequence>
						<s:element minOccurs="0" maxOccurs="1" name="transportguid" type="s:string"/>
						<s:element name="dt">
							<s:complexType>
								<s:sequence>
									<s:element minOccurs="0" maxOccurs="1" name="oid" type="s:string"/>
								</s:sequence>
							</s:complexType>
						</s:element>
					</s:sequence>
				</s:complexType>
			</s:element>
			<s:element name="DeleteObjectsResponse">
				<s:complexType>
					<s:sequence>
						<s:element minOccurs="0" maxOccurs="1" name="transportguid" type="s:string"/>
						<s:element minOccurs="0" maxOccurs="1" name="DeleteObjectsResult" type="s:string"/>
					</s:sequence>
				</s:complexType>
			</s:element>
		</s:schema>
	</wsdl:types>
	<wsdl:message name="pingSoapIn">
		<wsdl:part name="parameters" element="tns:ping"/>
	</wsdl:message>
	<wsdl:message name="pingSoapOut">
		<wsdl:part name="parameters" element="tns:pingResponse"/>
	</wsdl:message>
	<wsdl:message name="SaveObjectsSoapIn">
		<wsdl:part name="parameters" element="tns:SaveObjects"/>
	</wsdl:message>
	<wsdl:message name="SaveObjectsSoapOut">
		<wsdl:part name="parameters" element="tns:SaveObjectsResponse"/>
	</wsdl:message>
	<wsdl:message name="GetObjectsSoapIn">
		<wsdl:part name="parameters" element="tns:GetObjects"/>
	</wsdl:message>
	<wsdl:message name="GetObjectsSoapOut">
		<wsdl:part name="parameters" element="tns:GetObjectsResponse"/>
	</wsdl:message>
	<wsdl:message name="DeleteObjectsSoapIn">
		<wsdl:part name="parameters" element="tns:DeleteObjects"/>
	</wsdl:message>
	<wsdl:message name="DeleteObjectsSoapOut">
		<wsdl:part name="parameters" element="tns:DeleteObjectsResponse"/>
	</wsdl:message>
	<wsdl:portType name="backendSoap">
		<wsdl:operation name="ping">
			<wsdl:input message="tns:pingSoapIn"/>
			<wsdl:output message="tns:pingSoapOut"/>
		</wsdl:operation>
		<wsdl:operation name="SaveObjects">
			<wsdl:input message="tns:SaveObjectsSoapIn"/>
			<wsdl:output message="tns:SaveObjectsSoapOut"/>
		</wsdl:operation>
		<wsdl:operation name="GetObjects">
			<wsdl:input message="tns:GetObjectsSoapIn"/>
			<wsdl:output message="tns:GetObjectsSoapOut"/>
		</wsdl:operation>
		<wsdl:operation name="DeleteObjects">
			<wsdl:input message="tns:DeleteObjectsSoapIn"/>
			<wsdl:output message="tns:DeleteObjectsSoapIn"/>
		</wsdl:operation>
	</wsdl:portType>
	<wsdl:binding name="backendSoap" type="tns:backendSoap">
		<soap:binding transport="http://schemas.xmlsoap.org/soap/http"/>
		<wsdl:operation name="ping">
			<soap:operation soapAction="http://eai.azurewebsites.net/ping" style="document"/>
			<wsdl:input>
				<soap:body use="literal"/>
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal"/>
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name="SaveObjects">
			<soap:operation soapAction="http://eai.azurewebsites.net/SaveObjects" style="document"/>
			<wsdl:input>
				<soap:body use="literal"/>
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal"/>
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name="GetObjects">
			<soap:operation soapAction="http://eai.azurewebsites.net/GetObjects" style="document"/>
			<wsdl:input>
				<soap:body use="literal"/>
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal"/>
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name="DeleteObjects">
			<soap:operation soapAction="http://eai.azurewebsites.net/DeleteObjects" style="document"/>
			<wsdl:input>
				<soap:body use="literal"/>
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal"/>
			</wsdl:output>
		</wsdl:operation>
	</wsdl:binding>
	<wsdl:binding name="backendSoap12" type="tns:backendSoap">
		<soap12:binding transport="http://schemas.xmlsoap.org/soap/http"/>
		<wsdl:operation name="ping">
			<soap12:operation soapAction="http://eai.azurewebsites.net/ping" style="document"/>
			<wsdl:input>
				<soap12:body use="literal"/>
			</wsdl:input>
			<wsdl:output>
				<soap12:body use="literal"/>
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name="SaveObjects">
			<soap12:operation soapAction="http://eai.azurewebsites.net/SaveObjects" style="document"/>
			<wsdl:input>
				<soap12:body use="literal"/>
			</wsdl:input>
			<wsdl:output>
				<soap12:body use="literal"/>
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name="GetObjects">
			<soap12:operation soapAction="http://eai.azurewebsites.net/GetObjects" style="document"/>
			<wsdl:input>
				<soap12:body use="literal"/>
			</wsdl:input>
			<wsdl:output>
				<soap12:body use="literal"/>
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name="DeleteObjects">
			<soap12:operation soapAction="http://eai.azurewebsites.net/DeleteObjects" style="document"/>
			<wsdl:input>
				<soap12:body use="literal"/>
			</wsdl:input>
			<wsdl:output>
				<soap12:body use="literal"/>
			</wsdl:output>
		</wsdl:operation>
	</wsdl:binding>
	<wsdl:service name="backend">
		<wsdl:port name="backendSoap" binding="tns:backendSoap">
			<soap:address location="${this.contextItem.externalUrl}?execute=methods/backend"/>
		</wsdl:port>
		<wsdl:port name="backendSoap12" binding="tns:backendSoap12">
			<soap12:address location="${this.contextItem.externalUrl}?execute=methods/backend"/>
		</wsdl:port>
	</wsdl:service>
</wsdl:definitions>`;

		//         return `<wsdl:definitions xmlns:tm="http://microsoft.com/wsdl/mime/textMatching/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/" xmlns:tns="http://eai.azurewebsites.net" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:s="http://www.w3.org/2001/XMLSchema" xmlns:soap12="http://schemas.xmlsoap.org/wsdl/soap12/" xmlns:http="http://schemas.xmlsoap.org/wsdl/http/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" targetNamespace="http://eai.azurewebsites.net">
		// <wsdl:types>
		// <s:schema elementFormDefault="qualified" targetNamespace="http://eai.azurewebsites.net">
		// <s:element name="ping">
		// <s:complexType/>
		// </s:element>
		// <s:element name="pingResponse">
		// <s:complexType>
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="pingResult" type="s:string"/>
		// </s:sequence>
		// </s:complexType>
		// </s:element>
		// <s:element name="SetStaticData">
		// <s:complexType>
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="dt" type="tns:StaticRecord"/>
		// </s:sequence>
		// </s:complexType>
		// </s:element>
		// <s:complexType name="StaticRecord">
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="branch" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="subsidiary" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="type" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="internal_id" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="name" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="attributes" type="tns:ArrayOfStaticRecordAttribute"/>
		// </s:sequence>
		// </s:complexType>
		// <s:complexType name="ArrayOfStaticRecordAttribute">
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="unbounded" name="attribute" nillable="true" type="tns:StaticRecordAttribute"/>
		// </s:sequence>
		// </s:complexType>
		// <s:complexType name="StaticRecordAttribute">
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="id" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="value" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="valid_since" type="s:string"/>
		// </s:sequence>
		// </s:complexType>
		// <s:element name="SetStaticDataResponse">
		// <s:complexType>
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="SetStaticDataResult" type="s:string"/>
		// </s:sequence>
		// </s:complexType>
		// </s:element>
		// <s:element name="SetDynamicData">
		// <s:complexType>
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="dt" type="tns:DynamicRecord"/>
		// </s:sequence>
		// </s:complexType>
		// </s:element>
		// <s:complexType name="DynamicRecord">
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="branch" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="subsidiary" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="period_type" type="s:string"/>
		// <s:element minOccurs="1" maxOccurs="1" name="period_start" type="s:dateTime"/>
		// <s:element minOccurs="1" maxOccurs="1" name="period_end" type="s:dateTime"/>
		// <s:element minOccurs="0" maxOccurs="1" name="type" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="internal_id" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="name" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="attributes" type="tns:ArrayOfDynamicRecordAttribute"/>
		// </s:sequence>
		// </s:complexType>
		// <s:complexType name="ArrayOfDynamicRecordAttribute">
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="unbounded" name="attribute" nillable="true" type="tns:DynamicRecordAttribute"/>
		// </s:sequence>
		// </s:complexType>
		// <s:complexType name="DynamicRecordAttribute">
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="id" type="s:string"/>
		// <s:element minOccurs="0" maxOccurs="1" name="value" type="s:string"/>
		// </s:sequence>
		// </s:complexType>
		// <s:element name="SetDynamicDataResponse">
		// <s:complexType>
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="SetDynamicDataResult" type="s:string"/>
		// </s:sequence>
		// </s:complexType>
		// </s:element>
		// <s:element name="DeleteStaticData">
		// <s:complexType>
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="internal_id" type="s:string"/>
		// </s:sequence>
		// </s:complexType>
		// </s:element>
		// <s:element name="DeleteStaticDataResponse">
		// <s:complexType>
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="DeleteStaticDataResult" type="s:string"/>
		// </s:sequence>
		// </s:complexType>
		// </s:element>
		// <s:element name="DeleteDynamicData">
		// <s:complexType>
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="internal_id" type="s:string"/>
		// </s:sequence>
		// </s:complexType>
		// </s:element>
		// <s:element name="DeleteDynamicDataResponse">
		// <s:complexType>
		// <s:sequence>
		// <s:element minOccurs="0" maxOccurs="1" name="DeleteDynamicDataResult" type="s:string"/>
		// </s:sequence>
		// </s:complexType>
		// </s:element>
		// </s:schema>
		// </wsdl:types>
		// <wsdl:message name="pingSoapIn">
		// <wsdl:part name="parameters" element="tns:ping"/>
		// </wsdl:message>
		// <wsdl:message name="pingSoapOut">
		// <wsdl:part name="parameters" element="tns:pingResponse"/>
		// </wsdl:message>
		// <wsdl:message name="SetStaticDataSoapIn">
		// <wsdl:part name="parameters" element="tns:SetStaticData"/>
		// </wsdl:message>
		// <wsdl:message name="SetStaticDataSoapOut">
		// <wsdl:part name="parameters" element="tns:SetStaticDataResponse"/>
		// </wsdl:message>
		// <wsdl:message name="SetDynamicDataSoapIn">
		// <wsdl:part name="parameters" element="tns:SetDynamicData"/>
		// </wsdl:message>
		// <wsdl:message name="SetDynamicDataSoapOut">
		// <wsdl:part name="parameters" element="tns:SetDynamicDataResponse"/>
		// </wsdl:message>
		// <wsdl:message name="DeleteStaticDataSoapIn">
		// <wsdl:part name="parameters" element="tns:DeleteStaticData"/>
		// </wsdl:message>
		// <wsdl:message name="DeleteStaticDataSoapOut">
		// <wsdl:part name="parameters" element="tns:DeleteStaticDataResponse"/>
		// </wsdl:message>
		// <wsdl:message name="DeleteDynamicDataSoapIn">
		// <wsdl:part name="parameters" element="tns:DeleteDynamicData"/>
		// </wsdl:message>
		// <wsdl:message name="DeleteDynamicDataSoapOut">
		// <wsdl:part name="parameters" element="tns:DeleteDynamicDataResponse"/>
		// </wsdl:message>
		// <wsdl:portType name="backendSoap">
		// <wsdl:operation name="ping">
		// <wsdl:input message="tns:pingSoapIn"/>
		// <wsdl:output message="tns:pingSoapOut"/>
		// </wsdl:operation>
		// <wsdl:operation name="SetStaticData">
		// <wsdl:input message="tns:SetStaticDataSoapIn"/>
		// <wsdl:output message="tns:SetStaticDataSoapOut"/>
		// </wsdl:operation>
		// <wsdl:operation name="SetDynamicData">
		// <wsdl:input message="tns:SetDynamicDataSoapIn"/>
		// <wsdl:output message="tns:SetDynamicDataSoapOut"/>
		// </wsdl:operation>
		// <wsdl:operation name="DeleteStaticData">
		// <wsdl:input message="tns:DeleteStaticDataSoapIn"/>
		// <wsdl:output message="tns:DeleteStaticDataSoapOut"/>
		// </wsdl:operation>
		// <wsdl:operation name="DeleteDynamicData">
		// <wsdl:input message="tns:DeleteDynamicDataSoapIn"/>
		// <wsdl:output message="tns:DeleteDynamicDataSoapOut"/>
		// </wsdl:operation>
		// </wsdl:portType>
		// <wsdl:binding name="backendSoap" type="tns:backendSoap">
		// <soap:binding transport="http://schemas.xmlsoap.org/soap/http"/>
		// <wsdl:operation name="ping">
		// <soap:operation soapAction="http://eai.azurewebsites.net/ping" style="document"/>
		// <wsdl:input>
		// <soap:body use="literal"/>
		// </wsdl:input>
		// <wsdl:output>
		// <soap:body use="literal"/>
		// </wsdl:output>
		// </wsdl:operation>
		// <wsdl:operation name="SetStaticData">
		// <soap:operation soapAction="http://eai.azurewebsites.net/SetStaticData" style="document"/>
		// <wsdl:input>
		// <soap:body use="literal"/>
		// </wsdl:input>
		// <wsdl:output>
		// <soap:body use="literal"/>
		// </wsdl:output>
		// </wsdl:operation>
		// <wsdl:operation name="SetDynamicData">
		// <soap:operation soapAction="http://eai.azurewebsites.net/SetDynamicData" style="document"/>
		// <wsdl:input>
		// <soap:body use="literal"/>
		// </wsdl:input>
		// <wsdl:output>
		// <soap:body use="literal"/>
		// </wsdl:output>
		// </wsdl:operation>
		// <wsdl:operation name="DeleteStaticData">
		// <soap:operation soapAction="http://eai.azurewebsites.net/DeleteStaticData" style="document"/>
		// <wsdl:input>
		// <soap:body use="literal"/>
		// </wsdl:input>
		// <wsdl:output>
		// <soap:body use="literal"/>
		// </wsdl:output>
		// </wsdl:operation>
		// <wsdl:operation name="DeleteDynamicData">
		// <soap:operation soapAction="http://eai.azurewebsites.net/DeleteDynamicData" style="document"/>
		// <wsdl:input>
		// <soap:body use="literal"/>
		// </wsdl:input>
		// <wsdl:output>
		// <soap:body use="literal"/>
		// </wsdl:output>
		// </wsdl:operation>
		// </wsdl:binding>
		// <wsdl:binding name="backendSoap12" type="tns:backendSoap">
		// <soap12:binding transport="http://schemas.xmlsoap.org/soap/http"/>
		// <wsdl:operation name="ping">
		// <soap12:operation soapAction="http://eai.azurewebsites.net/ping" style="document"/>
		// <wsdl:input>
		// <soap12:body use="literal"/>
		// </wsdl:input>
		// <wsdl:output>
		// <soap12:body use="literal"/>
		// </wsdl:output>
		// </wsdl:operation>
		// <wsdl:operation name="SetStaticData">
		// <soap12:operation soapAction="http://eai.azurewebsites.net/SetStaticData" style="document"/>
		// <wsdl:input>
		// <soap12:body use="literal"/>
		// </wsdl:input>
		// <wsdl:output>
		// <soap12:body use="literal"/>
		// </wsdl:output>
		// </wsdl:operation>
		// <wsdl:operation name="SetDynamicData">
		// <soap12:operation soapAction="http://eai.azurewebsites.net/SetDynamicData" style="document"/>
		// <wsdl:input>
		// <soap12:body use="literal"/>
		// </wsdl:input>
		// <wsdl:output>
		// <soap12:body use="literal"/>
		// </wsdl:output>
		// </wsdl:operation>
		// <wsdl:operation name="DeleteStaticData">
		// <soap12:operation soapAction="http://eai.azurewebsites.net/DeleteStaticData" style="document"/>
		// <wsdl:input>
		// <soap12:body use="literal"/>
		// </wsdl:input>
		// <wsdl:output>
		// <soap12:body use="literal"/>
		// </wsdl:output>
		// </wsdl:operation>
		// <wsdl:operation name="DeleteDynamicData">
		// <soap12:operation soapAction="http://eai.azurewebsites.net/DeleteDynamicData" style="document"/>
		// <wsdl:input>
		// <soap12:body use="literal"/>
		// </wsdl:input>
		// <wsdl:output>
		// <soap12:body use="literal"/>
		// </wsdl:output>
		// </wsdl:operation>
		// </wsdl:binding>
		// <wsdl:service name="backend">
		// <wsdl:port name="backendSoap" binding="tns:backendSoap">
		// <soap:address location="${this.contextItem.externalUrl}?execute=methods/backend"/>
		// </wsdl:port>
		// <wsdl:port name="backendSoap12" binding="tns:backendSoap12">
		// <soap12:address location="${this.contextItem.externalUrl}?execute=methods/backend"/>
		// </wsdl:port>
		// </wsdl:service>
		// </wsdl:definitions>`;
	}
}).register()