(class extends odaField {
    static get properties(){ return {
        linkMode:{
            enum: [
                'journal class',
                'account class',
                'saldo value',
                'oborot value',
                'price value',
                'balance'
            ]
        },
        LinkFields:{
            category: 'Link',
            type: String,
            // type_editor: TE_XQ,
            get: function(){
                return this.getAttr('LinkFields', '*');
            },
            set: function(value){
                this.setAttr('LinkFields', value);
            }
        },
        ValueListFilter:{
            category: 'Link',
            type: String,
            // type_editor: TE_XQ,
            get: function(){
                return this.getAttr('meta:ValueListFilter');
            },
            set: function(value){
                return this.setAttr('meta:ValueListFilter', value);
            }
        },
        _isLink:{
            get: function(){
                return !this.isTable && this.TypeClass.ATTRS.length > 0 && !this.TypeClass.isAbstract;
            }
        },
        _isStructure:{
            get: function(){
                return !this.isTable && this.TypeClass.ATTRS.length > 0 && this.TypeClass.isAbstract;
            }
        },
        defaultViewName: function(){
            if(this._isLink)
                return 'link';
            return this.super('defaultViewName');
        },
        extendedViewName: function(){
            if(this._isLink)
                return 'extended-link';
            if (this._isStructure)
                return 'extended';
            return  this.super('extendedViewName');
        }
    }}

    getValue(odaObject, dataRoot) {
        return super.getValue(odaObject, dataRoot);
    }
    setValue(odaObject, value, dataRoot) {
        if (this._isLink){
            if (value && !(value instanceof odaItem) && value.oid){
                return this.TypeClass.getObject(value.oid).then(obj =>{
                    return super.setValue(odaObject, obj, dataRoot);
                })
            }
        }
        return super.setValue(odaObject, value, dataRoot);
    }
    getValueList(odaObject, dataRoot){
        if (this._isLink){
            let filter = dataRoot[this.name] || '';
            if (filter){
                filter = '[contains(@name, "'+filter+'")]';
            }
            if (this.ValueListFilter){
                let f1 = this.getMetadata('ValueListFilter', odaObject, dataRoot, 0);
                if (f1){
                    filter += `[${f1}]`;
                }
            }
            let xq = 'for $a in */*'+filter+' return element item{ $a/(@oid, @icon), attribute value{$a/@name}}';
            return this.TypeClass.XQuery(xq, {index: 'table'}).then(res=>{
                return res.$item;
            });
        }
        return super.getValueList(odaObject, dataRoot);
    }

}).register();