(:
let $oids := '1D3E85DAEFA3CC3 1D3E85DAEFA3CBF'
let $host := 'H:1D03A3F3B5863BB'
let $base := 'B:1D3D5663D779540'
let $jurModuleId := 'M:1D3D31F5FB61620'
let $docClassId := 'H:1D03A3F3B5863BB/D:WORK/D:1D3D5663D779540/C:1D1E7184DDF2C25'
:)

#insert#

let $objects := oda:select(doc(concat($docClassId, '/I:PACK'))/PACK/OBJECT[SERVICES/REGISTER] , 'oid', $oids)


let $objectsGroup :=
	<bg>{
            for $bid in distinct-values($objects/@bid)
			let $bidObjects := $objects[@bid = $bid]
			return element g{
				for $cid in distinct-values($objects/@cid)
 					let $cidObjects := $bidObjects[@cid = $cid]
					return element OBJECTS{
						attribute bid {$bid},
						attribute cid {$cid},
						$cidObjects
					}
			}
		}
	</bg>

let $regOids :=
		for $bg in $objectsGroup
			for $bidObjects in $bg/g/OBJECTS
				return element gr{
					let $regs := $bidObjects/OBJECT/SERVICES/REGISTER/OPERATIONS/REG
					for $cid in distinct-values($regs/@cid)
						return element x{
							attribute bid {$bidObjects/@bid},
							attribute cid {$bidObjects/$cid},
							attribute oids {string-join(oda:right($regs[@cid = $cid]/@link, 15), ' ')}
						}
				}

let $docsGroups :=
	<bg>
		{
			for $bg in $objectsGroup
				for $bidObjects in $bg/g/OBJECTS
					return element OBJECTS{
							attribute bid {$bidObjects/@bid},
							attribute cid {$bidObjects/@cid },

						for $obj in $bidObjects/OBJECT
 							return
						            element OBJECT
						            {
										$obj/@*[name() != 'ro' and name() != 'clr'],
										$obj/*[not(name() = 'SERVICES')]
										,
										for $node in $obj/SERVICES[count(*) > count(REGISTER)]
										return
											element SERVICES
											{
												$node/@*,
												$node/*[not(name() = 'REGISTER')]
											}
						            }
					}
		}
	</bg>

let $deleteRegisterOperations :=
		for $regGroup in $regOids/x
	 	return oda:command(concat('delete_object?id=', $host, '/B:',$regGroup/@bid, '/', $jurModuleId, '/',$regGroup/@path, '&amp;force=true&amp;async=true'), $regGroup/@oids)

let $docsUpdateResult :=
		for $docgr in $docsGroups/OBJECTS
	 		return oda:command(concat('save_objects?id=', $host, '/B:',$docgr/@bid ,'/C:' , $docgr/@bid, '&amp;force=true&amp;async=true'), oda:xml($docgr))

let $results := ($docsUpdateResult, $deleteRegisterOperations)

return <result>
{
	($docsUpdateResult,$deleteRegisterOperations)
}
</result>