#insert#

(:
let $oids := '1D3E60288F97810 1D3E6A9E6531370'
let $host := 'H:1D03A3F3B5863BB'
let $base := 'B:1D3D5663D779540'
let $jurModuleId := 'M:1D3D31F5FB61620'
let $docClassId := 'H:1D03A3F3B5863BB/D:WORK/D:1D3D5663D779540/C:1D1E7184DDF2C25'
:)

let $templateId := concat('C:', /OBJECT/@cid, '/O:', /OBJECT/@oid)
let $path := concat('oda:/', $host, '/', $base, '/', $jurModuleId)
let $templateCid := /OBJECT/@cid
let $allObjects := oda:select(doc(concat($docClassId, '/I:PACK'))/PACK/OBJECT, 'oid', $oids)
let $color := /OBJECT/@clr

let $result :=
for $accEntry in //regs
    let $objects := if($accEntry/@context) then $allObjects[oda:eval($accEntry/@context)] else $allObjects
	let $entryName := ./@name


	let $len := count($objects)

	let $oidsKT := oda:gen-oids($host, $len)
    let $oidsDT := oda:gen-oids($host, $len)
    let $oidsReg := oda:gen-oids($host, $len)


	let $dt := $accEntry/correspondence/dt
    let $dtLink := $dt/acc/@link

    let $ct := $accEntry/correspondence/ct
    let $ctLink := $ct/acc/@link

	let $cidDT := substring($dtLink, oda:num(string-length($dtLink) - 14), 15)
    let $cidKT := substring($ctLink, oda:num(string-length($ctLink) - 14), 15)

	let $dtCls := doc(concat($path, '/C:', $cidDT))
	let $ctCls := doc(concat($path, '/C:', $cidKT))

    let $DTClsName := string($dtCls/CLASS/@Name)
    let $CTClsName := string($ctCls/CLASS/@Name)

	let $dtAnl := $dtCls/CLASS/METADATA/ATTR[@Name="regs"]/ATTR[@Name="anl"]/ATTR
	let $ctAnl := $ctCls/CLASS/METADATA/ATTR[@Name="regs"]/ATTR[@Name="anl"]/ATTR

	let $isDTAnls := not(empty($dt)) and (count($dtCls/CLASS/METADATA/ATTR[@Name="regs"]/ATTR[@Name="anl"]/*) > 0 or not(empty($dt/@count)))
    let $isCTAnls := not(empty($ct)) and (count($ctCls/CLASS/METADATA/ATTR[@Name="regs"]/ATTR[@Name="anl"]/*) > 0 or not(empty($ct/@count)))

	let $contextIsEmpty := empty($accEntry/@context)

	let $sumpath  := if ( $contextIsEmpty ) then $accEntry/@sum else concat($accEntry/@context, '/', $accEntry/@sum)
	let $sumIpath := if ( $contextIsEmpty ) then $dt/@count else concat($accEntry/@context, '/', $dt/@count)
	let $sumOpath := if ( $contextIsEmpty ) then $ct/@count else concat($accEntry/@context, '/', $ct/@count)

    let $operations :=
    <OBJECTS>
       {
   		attribute name {$accEntry/@name},
		for $ob at $i in $objects
        	let $docLink := concat('B:', $ob/@bid ,'/C:', $ob/@cid, '/O:', $ob/@oid)
			let $regDate := $ob/oda:eval($accEntry/@date)
            let $note := $ob/oda:eval($accEntry/@note)
            let $sum := sum($ob/oda:eval($sumpath))
            let $sumI := sum($ob/oda:eval($sumIpath))
            let $sumO := sum($ob/oda:eval($sumOpath))
			let $regId := $oidsReg[$i]
			let $dtId := $oidsDT[$i]
			let $ctId := $oidsKT[$i]

		 	return (
                   if ($dt) then
				   	element OBJECT {
						attribute oda-new {$dtId},
				   		attribute clr {$color},
						attribute ro {'True'},
						attribute typeAcc {'DT'},
					    attribute reg_date {$regDate},
						attribute reg_id {$regId},
						attribute note {$note},
						attribute cnm {$DTClsName},
						attribute cid {$cidDT},
						attribute bid {$ob/@bid},
						attribute doc {$ob/@name},
						attribute oper {$entryName},
						attribute d {$sum},
						attribute i {$sumI},

						element doc {
                           attribute link {$docLink},
                           attribute oid {$ob/@oid}
                        },

						element oper {
                           attribute link {$templateId}
                       },

						element corr {
							attribute link {concat($ct, '/O:', $ctId)}
						},

						for $b in $ob/oda:eval($accEntry/@context)
   							let $anls := element anl {
   								for $anl in $dtAnl
   								return attribute {$anl/@Name} {$b/oda:eval(concat('@', $anl/@Name))}
   							}

							let $anlsHash := if (count($anls/@*) > 0) then oda:hash64(string-join((
	 										for $b in $anls/@*
	 										let $n := $b/name()
	 										order by $n
	 										return concat($n, ':',$b)
	 									),'|'))	else nil

							 return if($isDTAnls) then
	                                   element regs {
	                                       attribute i {$b/oda:eval($dt/@count)},
	                                       attribute d {$b/oda:eval($accEntry/@sum)},
	   									   attribute anl {$anlsHash},
	   									   $anls
	                                   }
	                           else nil
				   } else nil,
                   if($ct) then element OBJECT
                   {
                       attribute oda-new {$ctId},
                       attribute clr {$color},
                       attribute ro {'True'},
                       attribute typeAcc {'CT'},
                       attribute reg_date {$regDate},
                       attribute reg_id {$regId},
                       attribute note {$note},
                       attribute cnm {$CTClsName},
                       attribute cid {$cidKT},
                       attribute bid {$ob/@bid},
                       attribute doc {$ob/@name},
                       attribute oper {$entryName},
                       attribute c {$sum},
                       attribute o {$sumO},
                                         element doc
                                            {
                           attribute link {$docLink},
                           attribute oid {$ob/@oid}
                       },

                       element oper
                       {
                           attribute link {$templateId}
                       },

                       element corr
                       {
                           attribute link {concat($dt,'/O:',$dtId)}
                       },

                       for $b in $ob/oda:eval($accEntry/@context)

   					let $anls := element anl {
   									for $anl in $ctAnl
   									return attribute {$anl/@Name} {$b/oda:eval(concat('@', $anl/@Name))}
   								}
   					let $anlsHash := if (count($anls/@*) > 0) then oda:hash64(string-join((
   										for $b in $anls/@*
   										let $n := $b/name()
   										order by $n
   										return concat($n, ':',$b)
   									),'|')) else nil

                       return
                           if($isCTAnls)
                               then
                                   element regs
                                   {
                                       attribute o {$b/oda:eval($ct/@count)},
                                       attribute c {$b/oda:eval($accEntry/@sum)},
   									   attribute anl {$anlsHash},
   									   $anls
                                   }
                       else nil
                       }
                   else nil,

					element newOBJECT{

					}
               )
       }
       </OBJECTS>
	return $operations

let $journalsSaveObjects :=
	for $jur in $result/OBJECT
	         let $cid := $jur/@cid
	         group by $cid

	         let $journalObjects := <OBJECTS>{$jur}</OBJECTS>
			 let $command := concat('save_objects?id=', $host, '/', 'P:WORK/', $base, '/', $jurModuleId, '/C:', $cid[1])
			 let $res := oda:command($command, oda:xml($journalObjects))
			 return $res


let $services :=
   <OBJECTS>
   {
        for $serv at $idx in $result/OBJECT
		let $oid := $serv/doc/@oid
		group by $oid
		return element OBJECT{
				for $s in $serv
	 				group by $s/@reg_id
					return element OPERATIONS{
						attribute name {$s[1]/../@name},
						for $reg in $s
						return element REG{
						    attribute cid {$reg/@cid},
							attribute link {concat('C:', $reg/@cid ,'/O:',$reg/@oda-new)},
							attribute type {$reg/@typeAcc},
                            attribute reg_date {$reg/@reg_date}
						}
					}
		}
   }
   </OBJECTS>

let $docs :=
	<OBJECTS>{
		for $obj at $idx in $allObjects
		let $serv := $services/OBJECT[$idx]/OPERATIONS
		return element OBJECT{
		        attribute ro {'True'},
                attribute clr {$color},
			    $obj/@*[name() != 'ro' and name() != 'clr'],
                $obj/*[not(name() = 'SERVICES')],
				if ($obj/SERVICES) then
                (
                    for $node in $obj/SERVICES
 					return
                        element SERVICES
                        {
                            $node/@*,
                            $node/*[not(name() = 'REGISTER')],
							element REGISTER
                            {
                                attribute tid {$templateId},
								$serv
							}
						}
				) else (
                        element SERVICES
                        {
                            element REGISTER
                            {
                                attribute tid {$templateId},
								$serv
							}
				})

		}
	}</OBJECTS>

let $docsSaveObjects := oda:command(concat('save_objects?id=', $docClassId), oda:xml($docs))

return ($journalsSaveObjects, $docsSaveObjects)