(class extends odaService {

    static get properties() {
        return {
            label: 'Register',
            allowArrayContext: true,
            isActive: true,
            allowAccess: 'C'
        }
    }

    execute(params) {
        const arr = this._groupArr(params.items.split(' '), 5000);
        const hrstart = process.hrtime();

        return Promise.all(arr.map(gr => this._reg(gr.join(' '), params)))
            .then(() => ({
                'time': process.hrtime(hrstart)
            }))
            .catch((err) => ({
                'time': process.hrtime(hrstart),
                'err': err
            }))
    }

    _reg(oids, params){
        let header = `
              let $oids := '${oids}'
              let $host := 'H:${this.$item.$host.id}'
              let $base := 'B:${this.$item.$base.id}'
              let $jurModuleId := 'M:${this.ActionSource.$class.$owner.id}'
              let $docClassId := '${params.clsId}' 
            `;

        return this._runAction(this.$item.$class, 'unreg.xq', header)
            .then(() => this._runAction(this.$item, 'reg.xq', header))
            .catch((err) => console.log(err));
    }

    _runAction(item, fileName, header) {
        return item.getFile(fileName)
            .then(file => file.load())
            .then(xq => item.API.POST('xquery', {format: 'json'}, xq.replace(/#insert#/g, header)))
            .catch((err) => {
                console.log(err);
            })
    }

    _groupArr(arr, chunkSize) {
        const groups = [];

        for (let i = 0; i < arr.length; i += chunkSize) {
            groups.push(arr.slice(i, i + chunkSize));
        }

        return groups;
    }

}).register();