const odant = require('../../../../../../../core/odant.js');
const fs = require('fs');

odant.then(odant => {
    ODANT.ssid = '4AE5D182106C077DA08F610F0BABD5AD';

    return ODANT.findItem('H:1D03A3F3B5863BB/P:WORK/B:1D3D5663D779540/M:1D3D31F5FB61620/C:1D3D56687BDFCC0/O:1D3DB15C8949060')
        .then((template) => {
            const params = {
                "clsId":"H:1D03A3F3B5863BB/P:WORK/B:1D3D5663D779540/C:1D1E7184DDF2C25",
                "items":"1D3E60288F97810"
            };

            const header = `
                let $oids := '${params.items}'
                let $host := 'H:${template.$host.id}'
                let $base := 'B:${template.$base.id}'
                let $jurModuleId := 'M:${template.$class.$owner.id}'
                let $docClassId := '${params.clsId}' 
            `;

            return template.getFile('reg.xq')
                .then(file => file.load())
                .then(xq => {
                    const xqq = xq.replace(/#insert#/g, header)
                    fs.writeFileSync('D:\\xqq.xq', xqq);

                    return template.API.POST('xquery', {format: 'json'}, xqq)
                        .then((result) => {
                            console.log(result);
                        })
                        .catch((err) => {
                            console.log(err);
                        })
                })

        });
});




