(class extends odaService {
    static get properties() {
        return {
            allowAccess: 'C',
            allowUse: true,
            isActive: true,
            label() {
                return this.$item.itemType === odaItem.Types.odaClass ? "Import in class" : "Import in base";
            }
        }
    }
    async execute(params) {
        //const inBase = this.$item.itemType !== odaItem.Types.odaClass;
        const url = this.resolveUrl('vdmc-selector/vdmc-selector.html');
        const selector = await ODA.createComponent(url);
        selector.contextItem = this.$owner;

        const dialog = {
            title: 'Select template',
            icon: 'image:center-focus-strong',
            ok: {
                show: true,
                disable: false
            },
            buttons: [
                { label: 'New', icon: 'icons:add', special: 'add' },
                { label: 'Remove', icon: 'icons:remove', special: 'del' },
                { label: 'OK', special: 'ok' }
            ]
        };
        const dialogResult = await ODA.showDialog(selector, dialog).catch(e => console.log(e));
        if (!dialogResult) return;
        
        if (!dialogResult.button) {
            if (dialogResult.focusedItem && dialogResult.focusedItem.item) {
                dialogResult.focusedItem.item.show();
            }
        } else {
            switch (dialogResult.button.special) {
                case 'add':
                    const importClsPath = "M:1D3E2AEF095FAD9/C:1D3E2AF035C58B6";
                    const importCls = await this.$owner.$base.findItem(importClsPath);
                    const newTmpObj = await importCls.createObject();

                    if (newTmpObj.Root) {
                        const contextCls = await this.$owner.$base.findItem('M:1D3E2AEF095FAD9/C:1D3E2C3A3971BED');
                        const component = await ODA.createComponent('/web/lib/dialogs/select-class/select-class.html',
                            { contextItem: contextCls, allowFilter: false, showWalker: false, itemKey: '$class' });
                        const result = await ODA.showDialog(component, { title: 'Select Class', icon: 'odant:class' });
                        if (result && result.item) {
                            newTmpObj.Root.source = this.$owner.label
                            newTmpObj.Root.$source = [{
                                link: importCls.getRelativeId(this.$owner)
                            }];

                            newTmpObj.Root.type = result.item.label;
                            newTmpObj.Root.$type = [{
                                link: importCls.getRelativeId(result.item)
                            }];

                            newTmpObj.show();
                        }
                    }
                    break;
                case 'del':
                    if (dialogResult.control.focusedItem && dialogResult.control.focusedItem.item) {
                        if (await ODA.confirm('Are you sure?')) {
                            dialogResult.control.focusedItem.item.remove();
                        }
                    }
                    break;
                case 'ok':
                    if (dialogResult.control.focusedItem && dialogResult.control.focusedItem.item) {
                        dialogResult.control.focusedItem.item.show();
                    }
                    break;
                default:
                    alert('Я таких значений не знаю');
            }
        }
    }
}).register();