(class extends odaService {

    static get properties() {
        return {
            allowAccess: 'R',
            label: 'Add session'
        }
    }

    async execute(params) {
        console.log('Start Attaching');
        if (!this.$item)
            return;

        console.log('Item.fullId = ' + this.$item.fullId);
        console.log('params = ' + JSON.stringify(params));

        // Session rows without link on object
        let emptySessionTbl = this.$item.Root.$sesTbl.filter((v, i) => {
            if (!v.session)
                return v;
        });

        if (emptySessionTbl.length <= 0)
            return;

        let sessionsCls = await this.$item.$base.findItem('C:1D5831F3690C2B9');
        if (!sessionsCls)
            return;
            
        console.log('SessionsClass.fullId = ' + sessionsCls.fullId);

        emptySessionTbl.array.forEach((sessionRow) => {
            let newSession = await sessionsCls.createObject();
            if (!newSession)
                return;
            
            newSession.save();

            // Set the link
            let link = this.$item.getRelativeId(newSession);
            console.log('RelativeId = ' + link);
            
            // Object.keys(params).forEach((attr) => {
            //     newSession.Root[attr] = params[attr];
            // });

            //Object.assign(newSession.Root, params);
            // newSession.Root = {...newSession.Root, ...params};

            sessionRow.session = newSession.name;
            sessionRow.$session = [{ name: newSession.name, link: link }];

            // Generate URL
            let url = `${newSession.Url}?execute=methods/generate-page&id=${this.$item.id}`;
            sessionRow.url = url;
        });

        this.$item.save();

        console.log('End Attaching');
    }
}).register();