(class extends odaService {

    static get properties(){
        return {
            allowAccess: 'R',
            label: "Generate page"
        }
    }

    async execute(params) {
        console.log('Start HTML generation');
        if (!this.$item)
            return;

        console.log('Item.fullId = ' + this.$item.fullId);
        console.log('params = ' + JSON.stringify(params));

        const htmlPage = `<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <style type="text/css">
    html { height: 100%; }
    body { height: 100%; margin: 0; background: #111; text-align: center; }
    #remoteVideo { height: 70%; margin-top: 5%; background: #000; }
    #localVideo { width: 20%; position: absolute; right: 1.1em; bottom: 1em; border: 1px solid #333; background: #000; }
    #callButton { position: absolute; display: none; left: 50%; font-size: 2em; bottom: 5%; border-radius: 1em; }
    </style>
</head>

<video id="localVideo" autoplay muted></video>
<video id="remoteVideo" autoplay></video>
<button id="callButton">вњ†</button>

<script>
    const PeerConnection = window.mozRTCPeerConnection || window.RTCPeerConnection;
    const IceCandidate = window.mozRTCIceCandidate || window.RTCIceCandidate;
    const SessionDescription = window.mozRTCSessionDescription || window.RTCSessionDescription;
    navigator.getUserMedia = navigator.getUserMedia || navigator.mozGetUserMedia || navigator.webkitGetUserMedia;

    let pc; // PeerConnection

    let callButton = document.getElementById("callButton");
    let localVideo = document.getElementById("localVideo");
    let remoteVideo = document.getElementById("remoteVideo")
    // Step 1. getUserMedia
    navigator.getUserMedia(
        { audio: true, video: true }, 
        gotStream, 
        function(error) { console.log(error) }
    );

    function gotStream(stream) {
        callButton.style.display = 'inline-block';
        localVideo.srcObject = stream;
        localVideo.onloadedmetadata = function(e) {
            localVideo.play();
        };

        pc = new PeerConnection(null);
        for (let track in stream.allTrack()) {
            pc.addTrack(track);
        }
        pc.onicecandidate = gotIceCandidate;
        pc.onaddstream = gotRemoteStream;
    }
</script>
</html>`;

        console.log('End HTML generation');
        return htmlPage;
    }
}).register();