    'use strict';
    function ExecuteTrigger(action) {
        return action.$class.$STATIC.$object.then((obj) => {
            if (obj) {
                let staticObj = obj._data.$STATIC[0];

                if (staticObj) {
                    let triggers = staticObj.$Triggers;

                    if (triggers) {
                        return action.$item.API.POST('xquery', {format: 'json'}, _createQuery(triggers))
                            .then((response) => {
                                let pair = response[0];

                                if (pair) {
                                    let separatedArr = pair.split('/', 2);

                                    return action.$item.API.GET(separatedArr[1], {to: separatedArr[0]}).then((res) => {
                                        return `Trigger '${separatedArr[1]}' was executed. The new object id is: ${res.result}`;
                                    });
                                }
                                else
                                    return `XQuery returns empty string in static object: ${obj.url}`;
                            });
                    }
                    else {
                        return `Field 'Triggers' not found in static object: ${obj.url}`;
                    }
                }
                else {
                    return `Static object not found in class: ${obj.$class.url}`;
                }
            }
        });
    }

    function _createQuery(triggers) {
        let request = "OBJECT/(";
        let lastIdx = triggers.length - 1;

        triggers.every((element, index) => {
            if (index === lastIdx) {
                request += "if (" + element.Expression + ") then '" + element.Target + "' else '')";
            }
            else {
                request += "if (" + element.Expression + ") then '" + element.Target + "' else ";
            }

            return true;
        });

        return request;
    }