(class extends odaService {
    static get properties() {return {
        label: 'Show on map',
        allowArrayContext: true,
        isActive () {
            function getKeys(obj, val) {
                let objects = [];

                for (let i in obj) {
                    if (!obj.hasOwnProperty(i)) continue;

                    if (typeof obj[i] === 'object') {
                        objects = objects.concat(getKeys(obj[i], val));
                    } else if (obj[i] === val) {
                        objects.push(i);
                    }
                }
                return objects;
            }

            return (getKeys(this.$item.$class.METADATA, 'map').length > 0);
        },
        allowExport: true,
    }}

    async execute() {
        const xq = await this.$class.API.POST('xquery',{ format: 'JSON'},
            `
        declare function local:path($n as node()) as xs:string 
                {
                  let $p := $n/..
                  
                  return
                      if($p and not($p/name() = 'METADATA')) 
                          then concat(local:path($p), '/',$n/@Name)
                          else $n/string(@Name)
                  }; 
                  
                  let $fieldsPathsString := for $a in //*[@Type='map' or @Type='C:1D3B5060B6EAC30'] 
                                                return local:path($a)
                      
                   let $concatmapFields := string-join(
                                                for $a in $fieldsPathsString
                                                return $a, ','
                                            )
                      
                  return string(concat('
                    element x {
                        for $o in //PACK/OBJECT
                            return element o { 
	                            attribute y0 {min($o/(', $concatmapFields, ')/(shape, Mark)/point/@latitude)},
								attribute y1 {max($o/(', $concatmapFields, ')/(shape, Mark)/point/@latitude)},	
								attribute x0 {min($o/(', $concatmapFields, ')/(shape, Mark)/point/@longitude)},
								attribute x1 {max($o/(', $concatmapFields, ')/(shape, Mark)/point/@longitude)},	
								attribute name {if ($o/@name) then $o/@name else $o/@oid},
                                $o/@oid, 
                                element m {
                  ',
                    string-join(for $a in //*[@Type='map' or @Type='C:1D3B5060B6EAC30'] 
                      return concat('$o/', local:path($a)), ',')
                      ,
                      
                      '}
                      }
                    }'
                  ))  
            `);

        const oids = (this.$item instanceof odaObject) ? this.$item.id : this.$item.items.join(' ');

        const filterXQ = `
                        let $selectionObject := oda:select(x/o, 'oid', '${oids}')        

                        return element x {
                            element items{		
                            for $a in $selectionObject      	
                                return $a 
                            }     
                        }
                    `;

        const index = await this.$class.getIndex('geo-grid', xq[0]);
        const indexRes = await index.POST('xquery_index', {
            format: 'json',
            async: false,
        }, filterXQ);
        const viewer = await ODA.createComponent(this.resolveUrl('odant-map.html'));
        viewer.cls = this.$class;
        viewer.items = indexRes.$x[0].$items[0].$o;
        return ODA.showDialog({control: viewer, title: this.$class.label || this.$class.name, icon: 'enterprise:map-location'});

    }
}).register();
