(class extends odaAction {

    async execute(params) {
        console.log('Run Recalc');

        console.log(`params = ${params}`);

        const xq = this.generateXQuery(this.$owner);
        console.log(`xq = ${xq}`);
        const cls = await this.$owner.$base.findItem(this.$owner.Root.cls[0].link);

        console.log(`cls.url = ${cls.url}`);
        return ODANT.API.post(cls.url, { method: 'update_objects'}, { oids: params.replace(' ', '|'), xq: xq });
    }

    generateXQuery(template) {
        let contextMap = {};
        let xqBuilder = `for $OBJECT at $count in //OBJECT 
return
(`;
        for (let el of template.Root.$CALC) {

            let context = (el.Context) ? el.Context.trim() : '';
            const to = el.ToField.trim();
            const mode = el.Mode;

            if (mode != "Удалить") {

                // TODO reduce
                const toArr = to.split('/');
                context = toArr.reduce((context, part) => {
                    if (!part.startsWith("@")) {
                        if (context) {
                            context += "/";
                        }

                        if (part) {
                            context += part;
                        }
                    }

                    return context;
                }, context);
                // for (let s of toArr) {
                //     if (s.startsWith("@"))
                //         break;

                //     if (context) {
                //         context += "/";
                //     }

                //     if (s) {
                //         context += s;
                //     }
                // }
            }

            if (!context) {
                context = ".";
            }

            if (!contextMap[context]) {
                contextMap[context] = [];
            }

            contextMap[context].push(el);
        }

        let i = 1;
        for (let contexts in contextMap) {

            const modeMap = {};
            for (let val of contextMap[contexts]) {

                const mode = val.Mode;
                if (!modeMap[mode]) {
                    modeMap[mode] = [];
                }

                modeMap[mode].push(val);
            }

            let v = 'context' + i.toString();
            xqBuilder += `
    for $${v} in $OBJECT/${contexts} 
    return 
    (`;
            for (let modes in modeMap) {

                switch (modes) {

                    case 'Value':
                    case 'Поменять значение':
                        xqBuilder += `
        insert nodes 
        (`;
                        for (let el of modeMap[modes]) {

                            let to = el.ToField;
                            to = "attribute " + to.substr(to.indexOf('@') + 1);
                            let xq = el.XQuery;
                            if (xq.startsWith(contexts + '/'))
                                xq = xq.replace(contexts + '/', '');

                            xqBuilder += `
            ${to}{$${v}/(${xq})},`;
                        }
                        xqBuilder += `
            ()
        ) 
        into $` + v;
                        break;
                    case 'Rename':
                    case 'Переименовать':
                        break;
                    case 'Delete':
                    case 'Удалить':
                        xqBuilder += `
        delete nodes 
        (`;
                        for (let el in modeMap[modes]) {
                            let xq = el.ToField;
                            if (!xq) {
                                xq = el.XQuery;
                            }

                            if (!xq)
                                continue;

                            if (xq === contexts) {
                                xq = '';
                            } else if (xq.startsWith(contexts + '/')) {
                                xq = xq.replace(contexts + '/', '');
                            }

                            if (!xq) {
                                xqBuilder += `
            $${v},`;
                            } else {
                                xqBuilder += `
            $${v}/(${xq}),`;
                            }
                        }

                        xqBuilder += `
            ()
        )`;
                        break;
                    default:
                        break;
                }
            }
            xqBuilder += `
    ),`;
            ++i;
        }

        xqBuilder += `
    ()
    )`;
        return xqBuilder;
    }
}).register();