(class extends odaField {
    static get properties() {
        return {
            _input: 'date-time',
            Format: {
                category: 'DateTime properties',
                label: 'Format - Формат (отображение)',
                type: String,
                get() {
                    return this.getAttr('Format');
                },
                set(v) {
                    this.setAttr('Format', v);
                },
                enum: [
                    'date',
                    'full',
                    'fulltime',
                    'short',
                    'month',
                    'time',
                    'D',
                    'm',
                    's',
                    'S',
                    'ShortDate',
                    'FullDateTimeMs',
                    'GeneralDateTime',
                    'LongDate',
                    'ShortTime',
                    'LongTime',
                    'FullDateTime',
                    'MonthDay',
                    'YearMonth',
                    'MonthYear',
                    'SortableDateTime',
                    'UniversalDateTime',
                    'isoDate',
                    'isoTime',
                    'isoDateTime',
                    'isoUtcDateTime',
                    'dddd, dd mmmm yyyy г.',
                    'dd.mm.yyyy hh:MM:ss.lll',
                    'dd.mm.yyyy hh:MM:ss',
                    'dd.mm.yyyy hh:MM',
                    'yyyy-mm-dd hh:MM:ss',
                    'dd.mm.yyyy',
                    'dd / mm / yyyy',
                    'yyyy-mm-dd',
                    'mm.yyyy',
                    'hh:MM:ss',
                    'hh:MM'
                ]
            },
            Mask: {
                category: 'DateTime properties',
                label: 'Mask - Маска (редактирование)',
                type: String,
                get() {
                    return this.getAttr('Mask');
                },
                set(v) {
                    this.setAttr('Mask', v);
                },
                enum: [
                    'dd.mm.yyyy hh:MM:ss.lll',
                    'dd.mm.yyyy hh:MM:ss',
                    'dd.mm.yyyy hh:MM',
                    'yyyy-mm-dd hh:MM:ss',
                    'dd.mm.yyyy',
                    'dd / mm / yyyy',
                    'yyyy-mm-dd',
                    'mm.yyyy',
                    'hh:MM:ss',
                    'hh:MM'
                ]
            },
            Locale: {
                category: 'DateTime properties',
                label: 'Locale - Локаль',
                type: String,
                get() {
                    return this.getAttr('Locale');
                },
                set(v) {
                    this.setAttr('Locale', v);
                },
                enum: ['ru-RU', 'en-US', 'ua-UA', 'ar-EG', 'zh-Hans-CN-u-nu-hanidec', 'th-TH-u-nu-thai'],
            },
            testFormat: {
                label: 'Тест',
                type: Date,
                get() {
                    let date = new Date();
                    return date.getFormattedValue(this.getArgs());
                }
            },
            _labelTop: true
        };
    }

    getArgs() {
        return {
            format: this.Format,
            mask: this.Mask,
            locale: this.Locale,
            placeholder: this.placeholder,
            title: this.description
        };
    }

    getValue($object, root) {
        const value = super.getValue($object, root);
        if (value && value.then){
            return value.then(value=>{
                return value && new Date(Date.parse(value)) || undefined;
            })
        }
        return value && new Date(Date.parse(value)) || undefined;
    }

    getFormattedValue($object, root, format) {
        format = format || this.getArgs();
        const value = this.getValue($object, root);
        if (value && value.then){
            return value.then(value =>{
                return value ? value.getFormattedValue(format) : value;
            })
        }
        return value ? value.getFormattedValue(format) : value;
    }

    async setValue($object, value, root) {
        if ($object) {
            super.setValue($object, (value && value.toISOString()) || null, root);
        }
    }
}).register();