(class extends odaField {
    static get properties() {
        return {
            _input: 'hyper-link',
            searchMode: {
                label: 'Режим поиска',
                type: String,
                get() {
                    return this.getAttr('SearchMode');
                },
                set(v) {
                    this.setAttr('SearchMode', v);
                },
                enum: ['Google', 'Wiki', 'Yandex', 'GoogleMaps', 'YandexMaps', 'GoogleImage', 'YandexImage', 'WikiODA']
            },
        };
    }
    getUrl(url, mode = this.searchMode) {
        url = url.trim();
        switch (mode) {
            case 'WikiODA':
                return "http://wiki.oda.su/index.php?Search&search=" + url;
            case 'Google':
                return "http://www.google.ru/search?q=" + url.replace(' ', '+');
            case 'Wiki':
                return "http://ru.wikipedia.org/wiki/" + url;
            case 'Yandex':
                return "http://yandex.ru/yandsearch?text=" + url.replace(' ', '+');
            case 'GoogleMaps':
                return "http://maps.google.com/maps?q=" + url.replace(' ', '+');
            case 'YandexMaps':
                return "http://maps.yandex.ru/?text=" + url;
            case 'GoogleImage':
                return "http://images.google.com/images?q=" + url.replace(' ', '+');
            case 'YandexImage':
                return "http://images.yandex.ru/yandsearch?text=" + url.replace(' ', '+');
            default:
                return "http://www.google.ru/search?q=" + url.replace(' ', '+');
        }
    }
}).register();