import '/web/oda/components/inputs/string/string.js';
import '/web/core/class/fields/inputs/default/default.js';
import '/web/oda/components/buttons/radio-group/radio-group.js';

ODA({
    is: 'oda-string',
    extends: 'oda-string-input, odant-field-input',
    template: /*html*/`
    <style>
        :host {
            flex: auto;
        }
    </style>
    <oda-radio-group ~if="_showAlternativeValueList()" :multi-select="_multiSelect($field)" :list="valueList"
        :value="_getGroupValue(value)" @value-changed.stop="_groupValueChanged"></oda-radio-group>
    `,
    props: {
        value: String,
        $field: Object,
        $object: Object,
        valueList: Array
    },
    observers: [
        async function _fieldObjectDataRootChanged($field, $object, dataRoot) {
            if ($field && $object && dataRoot) {
                const list = await $field.getValueList($object, dataRoot);
                if (list) {
                    this.valueList = (Array.isArray(list)) ? list.map(i => i.value) : [list];
                }
            }
        }
    ],
    _showInput() {
        if (!this.$field || !this.$object) {
            return true;
        }

        return !this.$field.view || (this.$field.view === 'Строка');
    },
    _showDropDown(value) {
        if (!this.$object) {
            return false;
        }

        if (!this.$field) {
            return this.$super('oda-field-base', '_showDropDown', value);
        }

        return !this.$field.view || (this.$field.view === 'Строка')
            ? this.$super('oda-field-base', '_showDropDown', value)
            : false;
    },
    _showAlternativeValueList() {
        if (!this.$field || !this.$object) {
            return false;
        }

        return this.$field.view && (this.$field.view !== 'Строка');
    },
    _multiSelect($field = this.$field) {
        if (!$field || !this.$object) {
            return false;
        }
        return $field.view && ($field.view === 'CheckBox');
    },
    _getGroupValue(value = this.value) {
        return value;
    },
    _groupValueChanged(e) {
        const value = this.dataRoot[this.$field.name];
        const newVal = (Array.isArray(e.target.value) ? e.target.value : e.target.value.split(',')).join(';');
        if (newVal !== this.value && !value === !this.value)
            this.value = newVal;
    }
})