(class extends odaField {
    static get properties() {
        return {
            _input: 'sign-file',
            _isStructure: null,
            _complex: null,
            extentions: {
                label: 'Расширения',
                get() {
                    return this.getAttr('extentions', '*.*');
                },
                set(v) {
                    this.setAttr('extentions', v);
                }
            },
            maxSize: {
                category: 'File settings'
            }
        }
    }
    getFormattedValue($object, root) {
        return root && root[this.name] || '';
    }
    async _getFile() {
        return (await this.fields).find($field => $field.name === 'file');
    }
    async _getSignTable() {
        return (await this.fields).find($field => $field.name === 'signTable');
    }
    async _getSign() {
        return (await (await this._getSignTable()).fields).find($field => $field.name === 'sign');
    }
    async _getUserIdField() {
        return (await (await this._getSignTable()).fields).find($field => $field.name === 'userId');
    }
    async _getCertName() {
        return (await (await this._getSignTable()).fields).find($field => $field.name === 'name');
    }
    async _getCertLabel() {
        return (await (await this._getSignTable()).fields).find($field => $field.name === 'label');
    }
    async _getCertIssuerName() {
        return (await (await this._getSignTable()).fields).find($field => $field.name === 'issuerName');
    }
    async _getCertSubjectName() {
        return (await (await this._getSignTable()).fields).find($field => $field.name === 'subjectName');
    }
    async _getCertThumbprint() {
        return (await (await this._getSignTable()).fields).find($field => $field.name === 'thumbprint');
    }
    async _getCertValidFrom() {
        return (await (await this._getSignTable()).fields).find($field => $field.name === 'validFrom');
    }
    async _getCertValidTo() {
        return (await (await this._getSignTable()).fields).find($field => $field.name === 'validTo');
    }
}).register();