import ODA3 from '../../oda3/oda.js';
ODA3({
    is: 'oda-editor-new',
    template: `
    <style>
            :host{
                @apply --flex;
                @apply --vertical;
                border: 1px solid red;
                overflow: hidden;
                text-overflow: ellipsis;
                min-height: 32px;
            }
            input, div{
                @apply --flex;
                overflow: hidden;
                text-overflow: ellipsis;
            }
            div{
                @apply --horizontal;
                align-items: center;
            }
            div > *{
                @apply --flex;
                width: 100%;
                overflow: hidden;
                text-overflow: ellipsis;
            }
        </style>
        <input type="number" :value="item?.num" @input="item && (item.num = $event.target.value)">
        <input type="text" :value="item?.str" @input="item && (item.str = $event.target.value)">
        <div style="padding: 4px; border: 1px solid gray;">
            <input ~for="i, idx in arrOfStr" type="text" :value="arrOfStr[idx]" @input="arrOfStr[idx] = $event.target.value">
        </div>`,
    props: {
        arrOfStr: {
            type: Array,
            default: []
        },
        item: {
            type: Object,
            set(n) {
                if (n && n.arrOfStr)
                    this.arrOfStr = n.arrOfStr;
            }
        }
    }
})
// Двусторонний биндинг не хочет работать