import ODA3 from '../../oda3/oda.js';
ODA3({
    is: 'oda-viewer-new',
    template: `
    <style>
            :host{
                @apply --flex;
                @apply --vertical;
                border: 1px solid red;
                overflow: hidden;
                text-overflow: ellipsis;
                min-height: 32px;
                background-color: whitesmoke;
            }
            input, div{
                @apply --flex;
                overflow: hidden;
                text-overflow: ellipsis;
            }
            div{
                @apply --horizontal;
                align-items: center;
            }
            div > *{
                @apply --flex;
                width: 100%;
                overflow: hidden;
                text-overflow: ellipsis;
            }
        </style>
        <div>
            <span>{{item && item.num}}</span>
        </div>
        <div>
            <span>{{item && item.str}}</span>
        </div>
        <div style="padding: 4px; border: 1px solid gray;">
            <div ~for="i in arrOfStr">
                <span>{{i}}</span>
            </div>
        </div>`,
    props: {
        arrOfStr: {
            type: Array,
            default: []
        },
        item: {
            type: Object,
            set(n) {
                if (n && n.arrOfStr)
                    this.arrOfStr = n.arrOfStr;
            }
        }
    }
})
// Двусторонний биндинг не хочет работать