'use strict';
const TelegramBot = require('node-telegram-bot-api');
const token = '261963836:AAGDSCM_gLH2V1kQ3yL503cGIgEPf7CdZX0'; //OdantAutoBot
const bot = new TelegramBot(token, {polling: true});

const context = 'http://odant.org/api/H:1D03A3F3B5863BB/P:WORK/B:1D223970C7FB7BA';

// const context = 'http://89.108.87.196:8380/api/H:1D1BA4552C89E3B/P:WORK/B:1D22148BB126012';

var sessions = new Map();
var ContextItem;

require('../../core/odant.js').then(odant => {
    return odant.findItem(context);
}).then(item =>{
    ContextItem = item;
    global.ContextItem = ContextItem;
    console.log('ODANT is Ready', ContextItem.displayLabel);

    var getBotSession = function(from){
        return new Promise(resolve =>{
            // if (!sessions.has(from.id)){
            //     sessions.set(from.id,  new UserSession(from));
            // }
            var session = sessions.get(from.id);
            if (session)
                session.updateTimer();
            resolve(session);
        })
    };

    bot.on('callback_query', function(msg) {
        getBotSession(msg.from).then(function(session) {
            var command = msg.data.split(' ')[0];
            var val = msg.data.replace(command+' ', '');
            session.messageId = msg.message.message_id;
            switch(command){
                case '/back':
                    session.back();
                    break;
                case '/step':
                    session.ContextItem.findItem(val).then(item =>{
                        session.ContextItem = item;
                    });
                    break;
                default:{
                    val = val.replaceAll('_', '-');
                    session.ContextItem.executeMethod(val).then(result =>{
                        console.log(result);
                    })
                }break;
            }

        }.bind(msg));
    });

    bot.on("message", function(msg){
        console.log(msg.text);
        getBotSession(msg.from).then(session => {
            if (msg.entities) {
                var command = msg.text.toLowerCase();
                switch (command) {
                    case '/start':
                        if (session)
                            session.closeSession();
                        sessions.set(msg.from.id,  new UserSession(msg.from));
                        break;
                    case '/back':
                        if (session)
                            session.back();
                        break;
                }
            }
            else{
                var item;
                if (session.Structure) {
                    item = session.Structure.find(i => {
                        return i[0].text == msg.text;
                    })
                }
                if (item) {
                    session.ContextItem.findItem(item[0].callback_data).then(next => {
                        if (next instanceof odaObject) {
                            //next.formsRun();
                        } else
                            session.ContextItem = next;
                    });
                }
            }

        })
    });

});

class UserSession{
    constructor(profile) {
        this.id = profile.id;
        this.profile = profile;
        this.FirstName = profile.first_name;
        this.sendMessage('Hi, ' + this.FirstName +'.').then(()=>{
            this.ContextItem = ContextItem;
        });

    }
    updateTimer(){
        if(this.Timer)
            clearTimeout(this.Timer);
        this.Timer = setTimeout(()=>{
            this.sendMessage('💋 Goodbye, '+this.FirstName+'...');
            this.closeSession();
        }, 180000)
    }
    closeSession(){
        //this.sendMessage(this.id, 'Session closed', {reply_markup: JSON.stringify({[]}});
        if(this.Timer)
            clearTimeout(this.Timer);
        sessions.delete(this.id);
        delete this;
    }

    sendMessage(message, options){
        return bot.sendMessage(this.id, message, options);
    }
    get ContextItem(){
        return this._context_item || ContextItem;
    }
    set ContextItem(item){
        this._context_item = item;
        this.ActionsMenu.then(text => {
            var caption = "Вы в разделе (/"+item.itemTypeLabel+"):\r\n"+this.icon+" <a href='"+ item.url+"/~/client/navigator/index.html'>"+ item.labelPath+"</a> " + text;
            if (item !== ContextItem)
                caption += "\n\nВернуться (/back)";
            this.StructureMenu.then(menu => {
                bot.sendMessage(this.id, caption, menu);
            })
        });
    }

    set Structure(structure) {
        this._structure = structure;
    }

    get Structure(){
        return this._structure;
    }

    getIcon(prefix){
        switch (prefix){
            case 'B':
                return '🏨';
            case 'C':
                return '🗃';
            case 'S':
                return '👥';
        }
        return '';
    }

    get icon(){
        return this.getIcon(this.ContextItem.prefix);
    }

    get StructureMenu(){
        this.Structure = null;
        return new Promise(resolve => {
            this.ContextItem.Items.then(items => {
                let structure = [];
                if (items.length > 0) {
                    let classes = [];
                    let promises = [];
                    items.forEach(item => {
                        let link = item.fullId.substring(item.fullId.lastIndexOf("/") + 1);
                        let count = item.objectCount > 0 ? " (" + item.objectCount + ")" : "";
                        let label = (item.label || item.Name) + count;
                        if (item.hasChildren) {
                            label = '➕ ' + label;
                        }
                        label += ' ' + this.getIcon(item.prefix);
                        classes.push({label: label, link: link, id: item.Id});
                        promises.push(item.Methods);

                        // item.Methods.then(methods => {
                        //     var text = "";
                        //     if (methods.length > 0){
                        //         text = "\n\nВыполнить действие: ";
                        //         methods.forEach(m =>{
                        //             text += "\n▶️ "+m.Label+" (/" + m.Name.replaceAll('-', '_')+")";
                        //         });
                        //     }
                        //     resolve(text);
                        // });
                    });
                    Promise.all(promises).then(methods => {
                        let map = new Map();
                        methods.forEach(methodsCls => {
                            if (methodsCls.length > 0)
                                map.set(methodsCls[0].Owner.Id, methodsCls[0]);
                            // methodsCls.forEach(method => {
                            //     map.set(method.Owner.Id, method);
                            // })
                        });
                        classes.forEach(cls => {
                            var text = "";
                            var data = "";
                            if (map.has(cls.id)){
                                var m = map.get(cls.id);
                                text = "▶️ " + m.label;
                                data = "/" + m.Name;
                            }
                            structure.push([{text: cls.label, callback_data: cls.link}, {text: text, callback_data: data}]);
                        });
                        this.Structure = structure;
                        resolve({
                            parse_mode: 'HTML',
                            disable_web_page_preview: false,
                            force_reply: true,
                            reply_markup: JSON.stringify({keyboard: structure}),
                            resize_keyboard: true
                        });
                    });
                } else if (this.ContextItem.objectCount > 0) {
                    this.ObjectsMenu.then(structure => {
                        this.Structure = structure;
                        resolve({
                            parse_mode: 'HTML',
                            disable_web_page_preview: false,
                            force_reply: true,
                            reply_markup: JSON.stringify({keyboard: structure}),
                            resize_keyboard: true
                        });
                    });
                }
            });
        })
    }

    get ObjectsMenu(){
        return new Promise(resolve => {
            this.ContextItem.getIndex("objectView", "element X { for $o in //OBJECT return element O { $o/@oid, $o/@name }}").then(index => {
                index.XQuery("*", "*", "json").then(res => {
                    var arr = [];
                    res.$X[0].$O.forEach(obj => {
                        arr.push([{
                            text: (obj.name || obj.oid),
                            url: this.ContextItem.url + '/O:' + obj.oid + '/~/views/editor/index.html',
                            callback_data: 'O:' + obj.oid
                        }])
                    });
                    resolve(arr);
                })
            })
        })
    }

    get ActionsMenu(){
        return new Promise(resolve => {
            this.ContextItem.Methods.then(methods => {
                var text = "";
                if (methods.length > 0){
                    text = "\n\nВыполнить действие: ";
                    methods.forEach(m =>{
                        text += "\n▶️ "+m.label+" (/" + m.Name.replaceAll('-', '_')+")";
                    });
                }
                resolve(text);
            })
        })
    }

    back(){
        if (this.ContextItem != global.ContextItem)
            this.ContextItem = this.ContextItem.Owner;
    }
}
