class BotMenu{
    createMenu(item){
        return new Promise(resolve => {
            item.Items.then(items => {
                var structure = [];
                var menu = function (str) {
                    return {
                        parse_mode: 'HTML',
                        disable_web_page_preview: false,
                        force_reply: true,
                        reply_markup: JSON.stringify({keyboard: str}),
                        resize_keyboard: true
                    };
                };
                if (items.length > 0) {
                    items.forEach(item => {
                        let link = item.fullId.substring(item.fullId.lastIndexOf("/") + 1);
                        let count = item.objectCount > 0 ? " (" + item.objectCount + ")" : "";
                        let label = (item.label || item.Name) + count;
                        if (item.hasChildren) {
                            label = '➕ ' + label;
                        }
                        label += ' ' + this.getIcon(item.prefix);
                        structure.push([{text: label, callback_data: link}]);
                    });
                    resolve(menu(structure));
                } else if (item.objectCount > 0) {
                    this.ObjectsMenu(item).then(structure => {
                        resolve(menu(structure));
                    });
                } else {
                    structure.push([{text: "Вернуться", callback_data: "/back"}]);
                    resolve(menu(structure));
                }
            })
        })
    }

    ObjectsMenu(item){
        return new Promise(resolve => {
            item.getIndex("objectView", "element X { for $o in //OBJECT return element O { $o/@oid, $o/@name }}").then(index => {
                index.XQuery("*", "*", "json").then(res => {
                    let arr = [];
                    res.$X[0].$O.forEach(obj => {
                        arr.push([{
                            text: (obj.name || obj.oid),
                            url: item.url + '/O:' + obj.oid + '/~/views/editor/index.html',
                            callback_data: 'O:' + obj.oid
                        }])
                    });
                    resolve(arr);
                })
            })
        })
    }

    getIcon(prefix){
        switch (prefix){
            case 'B':
                return '🏨';
            case 'C':
                return '🗃';
            case 'S':
                return '👥';
            case 'Y':
                return 'g';
        }
        return '';
    }
}

module.exports = BotMenu;