const UserSessionList = require('./user-session-list');
const TelegramBot = require('node-telegram-bot-api');
const BotMenu = require('./bot-menu');
const BotLogger = require('./bot-logger');

const token = '192266089:AAGFuGIjjXcTcZn11XAeGLHoHNzXFSLqUYY';
const context = 'http://odant.org/api/H:1D03A3F3B5863BB/P:WORK/B:1D223970C7FB7BA';

const bot = new TelegramBot(token, {polling: true});
const userSessionList = new UserSessionList();
const botMenu = new BotMenu();
const botLogger = new BotLogger(context);

userSessionList.on('sessionStart', _onSessionStart);
userSessionList.on('sessionClose', _onSessionClose);
userSessionList.on('sessionContextItemChanged', _onSessionContextItemChanged);

function _onSessionStart(session){
    sendMessage(session, 'Hi, ' + session.FirstName +'.');
    botMenu.createMenu(session.MainContextItem).then(menu => {
        session.Structure =  JSON.parse(menu.reply_markup).keyboard;
        let caption = "Вы в разделе (/"+session.MainContextItem.itemType+"):\r\n"+" <a href='"+ session.MainContextItem.url+"/~/pages/navigator/index.html'>"+ session.MainContextItem.labelPath+"</a> ";
        sendMessage(session, caption, menu);
    })
}

function _onSessionClose(session){
    sendMessage(session, '💋 Goodbye, ' + session.FirstName + '...');
}

function _onSessionContextItemChanged(session) {
    botMenu.createMenu(session.ContextItem).then(menu => {
        session.Structure =  JSON.parse(menu.reply_markup).keyboard;
        let caption = "Вы в разделе (/"+session.ContextItem.itemTypeLabel+"):\r\n"+" <a href='"+ session.ContextItem.url+"/~/client/navigator/index.html'>"+ session.ContextItem.labelPath+"</a> ";
        if (session.ContextItem != session.MainContextItem)
            caption += "\n\nВернуться (/back)";
        sendMessage(session, caption, menu);
    })
}

function sendMessage(session, caption, menu) {
    bot.sendMessage(session.id, caption, menu);
    botLogger.log(session, 'out');
}

function hideKeyboard(messageId) {
    let menu = {
        parse_mode: 'HTML',
        disable_web_page_preview: false,
        force_reply: true,
        reply_markup: {'hide_keyboard': true},
        resize_keyboard: true
    };
    bot.sendMessage(messageId, "<b>remove</b>", menu);
}

require('../../core/odant.js').then(odant => {
    return odant.findItem(context);
}).then(contextItem =>{
    bot.on("message", (msg)=>{
        if (msg.entities){
            const command = msg.text.toLowerCase();
            switch (command) {
                case '/start':
                    userSessionList.add(msg.from, contextItem);
                    break;
                case '/back':
                    let contextItm = userSessionList.getSessionContext(msg.from);
                    if (contextItm != userSessionList.getSessionMainContext(msg.from)) {
                        userSessionList.setSessionContext(msg.from, contextItm.Owner)
                    }
                    break;
            }
        } else {
            let item;
            let structure = userSessionList.getSessionStructure(msg.from);
            if(structure) {
                item = structure.find(i => i[0].text == msg.text);
            }
            if (item) {
                if (item[0].callback_data == "/back") {
                    let contextItm = userSessionList.getSessionContext(msg.from);
                    if (contextItm != userSessionList.getSessionMainContext(msg.from)) {
                        userSessionList.setSessionContext(msg.from, contextItm.Owner)
                    }
                } else {
                    let contextItem = userSessionList.getSessionContext(msg.from);
                    contextItem.findItem(item[0].callback_data).then(next => {
                        if (next instanceof odaObject) {
                            hideKeyboard(msg.from.id);
                            bot.sendPhoto(msg.from.id, next.url + "http://odant.org/api/H:1D03A3F3B5863BB/P:WORK/B:1D223970C7FB7BA/C:1D2262A6BF817CE/~/views/grid/icon.png").then(e => {
                                let arr = [[{text: "Открыть " + next.label, url: next.url + "/~/client/pages/form/index.html"}],[{text: "Вернуться", callback_data: "/back"}]];
                                let menu = {
                                    parse_mode: 'HTML',
                                    disable_web_page_preview: false,
                                    force_reply: true,
                                    reply_markup: JSON.stringify({inline_keyboard: arr}),
                                    resize_keyboard: true
                                };
                                bot.sendMessage(msg.from.id, "Действия", menu);
                            });
                        } else
                            userSessionList.setSessionContext(msg.from, next);
                    });
                }
            }
        }
    });

    bot.on('callback_query', function(msg) {
        getBotSession(msg.from).then(function(session) {
            var command = msg.data.split(' ')[0];
            var val = msg.data.replace(command+' ', '');
            session.messageId = msg.message.message_id;
            switch(command){
                case '/back':
                    session.back();
                    break;
                case '/step':
                    session.ContextItem.findItem(val).then(item =>{
                        session.ContextItem = item;
                    });
                    break;
                default:{
                    val = val.replaceAll('_', '-');
                    session.ContextItem.executeMethod(val).then(result =>{
                        console.log(result);
                    })
                }break;
            }

        }.bind(msg));
    });
});