const EventEmitter = require("events").EventEmitter;

var TIMEOUT = 180000;
class UserSession extends EventEmitter{
    constructor(profile) {
        super();
        this.id = profile.id;
        this.profile = profile;
        this.FirstName = profile.first_name;
        this.updateTimer();
    }
    updateTimer(){
        if(this.Timer)
            clearTimeout(this.Timer);
        this.Timer = setTimeout(()=>{
            this.emit("sessionExpired");
        }, TIMEOUT)
    }
    get MainContextItem(){
        return this._main_context_item;
    }
    set MainContextItem(contextItem){
        this._main_context_item = contextItem;
    }

    get ContextItem(){
        return this._context_item || this._main_context_item;
    }
    set ContextItem(item){
        this._context_item = item;
        this.emit("contextItemChanged");
    }

    get Structure(){
        return this._structure;
    }
    set Structure(structure) {
        this._structure = structure;
    }
}

module.exports = UserSession;