// const TE_SERVER_TRIGGER = '/web/core/class/client/configurator/editors/xquery-property-editor.html';
'use strict';
globalThis.odaClass = globalThis.odaClass || class odaClass extends odaStructureItem {
    destroy() {
        this.$connection.unlisten(this, this.eventHandler_);
    }
    constructor(p){
        super(p);
        this.eventHandler_ = this.eventHandler.bind(this);
        this.$connection.listen(this, this.eventHandler_);
    }

    get $class(){
        // if (this.$owner && !(this.$owner instanceof odaDomain))
        //     return this.$owner;
        return this;
    }
    get $items(){
        return this._getItems('C');
    }

    get $classes(){
        return this._getItems('C');
    }

    async eventHandler(event){
        if (event.type === 'object') {
            if (event.$additional) {
                this.reset('objectCount');
                event.$additional.forEach(u => {
                    if (u.$E) {
                        u.$E.forEach(e => {
                            if (e.$P) {
                                e.$P.forEach(async (p) => {
                                    if (p.$U) {
                                        let list = this._objects.filter(i =>{
                                            return p.$U.find(p =>{
                                                return p.o === i.id
                                            });
                                        });
                                        if (list.length){
                                            list = list.map(i=>{
                                                return i.reload();
                                            });
                                            await Promise.all(list);
                                            this.fire('update', this);
                                        }
                                        list = p.$U.filter(p => {
                                            return !this._objects.some(o => o.id === p.o);
                                        });
                                        if (list.length) {
                                            this.fire('create-objects', list.map(p => p.o));
                                        }
                                    }
                                    if(p.$D){
                                        this.fire('delete-objects', p.$D);
                                    }
                                })
                            }
                        })
                    }
                    if (u.$C) {
                        u.$C.forEach(async (c) => {
                            const cls = await this.findItem('C:' + c.i);
                            let fid = cls.fullId;
                            if (!this.config.$C)
                                this.config.$C = [];
                            this.config.$C.push(c);
                            this.reset('Children Config Classes');
                            cls.reset();
                            fid = cls.fullId;
                            this.fire('create', cls, true);
                        })
                    }
                });
                this.fireChanged();
            }
        }
        else if (event.type === 'class') {
            switch (event.operation) {
                case 'delete': {
                    this.$owner.reset();
                    this.fire('deleted', this);
                } break;
                case 'update': {
                    await this.load();
                } break;
                case 'create': {
                    this.reset();
                    this.fire('update');
                } break;
                case 'pack create': {
                    this.fire('pack-create', event.$additional);
                } break;
                case 'pack delete': {
                    this.fire('pack-delete', event.$additional);
                } break;
            }
        }
    }
    get $indexes(){
        return this.$('$indexes', async ()=>{
            let res = await this.API.GET('get_class_indexes');
            res = res.result.split('|');
            res = res.map(i=>this.getIndex(i));
            return await Promise.all(res);
        })
    }
    static get properties() {return {
        prefix: 'C',
        zIndex: 10,
        icon() {
            if (this.config && this.config.ico) {
                if (this.config.ico.includes(':'))
                    return this.config.ico;
                return this.url + '/~/' + this.config.ico;
            }
            if (this.isAbstract || this.hasChildren) {
                return 'odant:abstract-class';
            }
            return 'odant:class';
        },
        // subIcon() {
        //     if (this.hasChildren)
        //         return 'odant:class';
        //     return null;
        // },
        _actionsPath(){
            return ODANT.webMode ?'client' : 'server';
        },
        defaultIcon: 'odant:class',
        _allowSave() {
            return this.access.admin;
        },
        cover() {
            return this.url + '/~/cover.png';
        },
        itemTypeLabel: "class",
        isAbstract: {
            type: Boolean,
            get() {
                return this.getBoolAttr('Abstract') || this.ATTRS.length === 0;
            },
            set(v){
                this.setBoolAttr('Abstract', v);
            }
        },
        Category: {
            get (){
                return this.getAttr('Category');
            },
            set (v){
                this.setAttr('Category', v);
            }
        },
        Note: {
            get (){
                return this.getAttr('Note', 'This class is designed to work with your data...');
            },
            set (v){
                this.setAttr('Note', v);
            }
        },
        type: {
            // type_editor: TE_TYPE_SELECTOR,
            editor: '/web/core/structure/lib/type-editor/type-editor.html',
            get (){
                return this.getAttr('Type');
            },
            set(value) {
                this.reset('fields');
                this.setAttr('Type', value);
            }
        },
        label:{
            get() {
                return this.getAttr('Label', (this.config && (this.config.l || this.config.n)) || '');
            },
            set(value) {
                this.setAttr('Label', value);
            }
        },
        XName: {
            category: 'Expressions',
            label: 'Выражение для имен объектов',
            editor: '/web/lib/inputs/expression/expression.html',
            get (){
                return this.getAttr('XName');
            },
            set (v){
                this.setAttr('XName', v);
            }
        },
        objectHint:{
            category: 'Data',
            editor: '/web/lib/inputs/expression/expression.html',
            get (){
                return this.getAttr('ObjectHint');
            },
            set (v){
                this.setAttr('ObjectHint', v);
            }
        },
        backup: {
            type: Boolean,
            category: 'Data',
            get(){
                return this.getBoolAttr('Backup');
            },
            set (v){
                this.setBoolAttr('Backup', v);
            }
        },
        defaultViewName: {
            category: 'Views',
            // editor: '/web/core/structure/lib/action-editor/action-editor.html',
            get() {
                if (this.isAbstract) {
                    if (this.access.allowAdmin)
                        return 'configurator';
                    return 'qr-code';
                }
                return this.getAttr('default-class-view', 'grid');
            },
            set (v){
                this.setAttr('default-class-view', v);
            }
        },
        defaultObjectLinkViewName: {
            category: 'Views',
            // editor: '/web/core/structure/lib/action-editor/action-editor.html',
            label: 'Представление объекта по ссылке',
            get() {
                return this.getAttr('defaultObjectLinkViewName', 'editor');
            },
            set(v) {
                this.setAttr('defaultObjectLinkViewName', v);
            }
        },
        selectLinkViewName: {
            category: 'Views',
            label: 'Представление выбора ссылки',
            get() {
                return this.getAttr('select-link-view', 'select-link');
            },
            set (v){
                this.setAttr('select-link-view', v);
            },
            enum: ['select-link', 'select-in-tree']
        },
        defaultPage: {
            category: 'Views',
            get (){
                return this.getAttr('default-page', 'navigator');
            },
            set (v){
                this.setAttr('default-app', v);
            }
        },
        defaultForm: {
            category: 'Views',
            get (){
                return this.getAttr('default-form', 'form');
            },
            set (v){
                this.setAttr('default-class-form', v);
            }
        },
        defaultObjectForm: {
            category: 'Views',
            get (){
                return this.getAttr('default-object-form', 'form');
            },
            set (v){
                this.setAttr('default-object-form', v);
            }
        },
        defaultObjectView:{
            category: 'Views',
            // editor: '/web/core/structure/lib/action-editor/action-editor.html',
            get (){
                return this.getAttr('default-object-view', 'editor');
            },
            set (v){
                this.setAttr('default-object-view', v);
            }
        },
        defaultObjectpage:{
            category: 'Views',
            get (){
                return this.getAttr('default-object-page', 'form');
            },
            set (v){
                this.setAttr('default-object-page', v);
            }
        },
        _objects () {
            return this.$('_objects', [])
        },
        _indexes () {
            return this.$('_indexes', [])
        },
        beforeCreate:{
            category: "server-triggers",
            // type_editor: TE_SERVER_TRIGGER,
        },
        afterCreate:{
            category: "server-triggers",
            // type_editor: TE_SERVER_TRIGGER,
        },
        beforeUpdate:{
            category: "server-triggers",
            // type_editor: TE_SERVER_TRIGGER,
        },
        afterUpdate:{
            category: "server-triggers",
            // type_editor: TE_SERVER_TRIGGER,
        },
        beforeDelete:{
            category: "server-triggers",
            // type_editor: TE_SERVER_TRIGGER,
        },
        afterDelete:{
            category: "server-triggers",
            // type_editor: TE_SERVER_TRIGGER,
        },
        onStart:{
            category: "server-tasks",
            // type_editor: TE_SERVER_TRIGGER,
        },
        onTimer:{
            category: "server-tasks",
            // type_editor: TE_SERVER_TRIGGER,
        },
        interBaseDataMode:{
            category: 'Data',
            get (){
                return this.getAttr('InterbaseDataMode', 'Aggregation');
            },
            set (v){
                this.setAttr('InterbaseDataMode', v);
            },
            enum:[
                'None',
                'Aggregation',
                'Inheritance',
                'Mixed'
            ]
        },
        _copyRules: {
            category: 'rules',
            value: [
                {from: '//B, //B/C, //B/C//C', to: '//B, //B/C, //B/C//C'}
            ]
        },
        _moveRules: {
            category: 'rules',
            value: [
                {from: '//B, //B/C, //B/C//C', to: '//B, //B/C, //B/C//C'}
            ]
        },
        byUser: {
            label: 'По пользователям',
            get() {
                return this.getBoolAttr('ByUser');
            },
            set(v) {
                this.setBoolAttr('ByUser', v);
            }
        },
        hide(){
            return ODANT.getBool(this.config && this.config.hide);
        },
    }}

    get hasPacks(){
        return this.getElements('Pack').length>0;
    }

    async copyTo(to){
        if (this._checkRule('copy', to)){
            try {
                return to.API.POST('create_class_by_xml', {format: 'json'} , '{"$CLASS":[' + JSON.stringify(this.Root) + ']}')
            } catch(e){
                console.log(e);
            }
        }
    }

    showSettings(){
        return this.show('configurator');
    }

    async searchObjects(filter, mask) {
        if (!filter)
            return [];
        try {
            const res = await this.API.POST('search_oids', {mask: mask || '*'}, filter);
            const p = res.result.split(' ').map(i => {
                return this.getObject(i);
            });
            return Promise.all(p);
        } catch(e) {
            return [];
        }
    }


    async _recalcObject(obj, metadata) {
        if (obj instanceof odaObject) {
            obj = obj.body;
        }
        // Temporarily. To delete this and  the "async" function's prefix when it will by realized on the server-side: the object recalculating for workplace's class
        if (this.$owner instanceof odaWorkPlace) {
            const stat = await (await fetch(`/api${this.fullId}/O:${this.id}`)).json();
            Object.assign(obj, stat);
        }
        ///////////////
        return this.API.POST('recalc', { meta: metadata }, JSON.stringify(obj));
    }

    removeObjects(oids) {
        this.API.POST('delete_object', {}, oids);
    }

    getObjectList(list) {
        if (Array.isArray(list))
            list = list.join(' ');
        return this.API.POST('get_objects_list', { format: 'json' }, list);
    }
    get $objects(){
        if (this.hasChildren)
            return [];
        return this.getIndex('table').then(idx=>{
            return idx.XQuery('for $a in //O[not(@parent)] return element O {$a/@oid}').then(list=>{
                const p = ((list && list.$O) || []).map(el => this.getObject(el.oid));
                return Promise.all(p);
            });
        });
    }
    get $users() {
        const xq = `for $a in //OBJECT return element U { $a/(@oid) }`;
        return this.getIndex('pack').then((i) => {
            return i.XQuery(xq).then((ls) => {
                return Promise.all(((ls && ls.$U) || []).map((el) => this.getObject(el.oid)));
            });
        });
    }
    get $assignedUsers() {
        const xq = `for $a in //*[roles/@role='${this.$base.id}'] return element U { $a/(@oid) }`;
        return this.getIndex('pack').then((i) => {
            return i.XQuery(xq).then((ls) => {
                return Promise.all(((ls && ls.$U) || []).map((el) => this.getObject(el.oid)));
            });
        });
    }
    async getObjects(filter) {
        try{
            const res = await this.XQuery(`for $a in //O${filter ? `[${filter}]` : ''} return element O {$a/@oid}`);
            const p = (res.$O || []).map(el => this.getObject(el.oid));
            return Promise.all(p);
        }
        catch (e) {
            return [];
        }
    }

    get Objects(){
        return this.getObjects();
    }

    get $$draftObjects(){
        return (async ()=>{
            try{
                const idx = await this.getIndex('names');
                const dataSet = await idx.getDataSet();
                const data = await dataSet.Items;
                return  data.map(el => new odaObject({$owner: this, Root: el}));
            }
            catch (e) {
                return [];
            }
        })();
    }


    save(data) {
        data = data || this.data || '{"$CLASS":[' + JSON.stringify(this.Root) + ']}';
        return super.save(data);
    }

    get Packets() {
        return (async()=>{
            const json = await this.API.GET('get_pack_list');
            const p = json.$FOLDER[0].$FILE ? json.$FOLDER[0].$FILE.reduce((res, v)=>{
                const names = v.Name.split('#');
                const name = names.shift();
                let p = res.find(i => i.name === name);
                if (!p){
                    p = {name: name, count: 0, items: []};
                    res.push(p);
                }
                p.count += +v.Count;
                if (names.length)
                    p.items.push({count: v.Count, names:names});
                return res;
            }, []).map(i=>{
                return new odaPack({$owner: this, Root:i})
            }) : [];
            return p;
            // return json.$FOLDER[0].$FILE;
        })();

    }
    get METADATA() {
        return this.getElement('$METADATA');
    }

    get $STATIC() {
        return this.$('STATIC', ()=>{
            return new odaStatic({$owner: this})
        });
    }
    get $DETAILS() {
        return this.$('DETAILS', ()=>{
            return new odaDetails({$owner: this.$base})
        });
    }
    get $FIELDS() {
        return this.$('FIELDS', ()=>{
            return new odaExtFields({$owner: this})
        });
    }

    get METHODS() {
        return this.getElement('$METHODS');
    }


    get hasFields() {
        return this.getElements('$METADATA/$ATTR').length > 0;
    }

    get ATTRS() {
        return this.getElements('$METADATA/$ATTR');
    }


    async _createClass(name, body) {
        const res = await this.API.POST('create_class', {name: name || 'New class'}, body);
        const cfg = await this.$base.getConfig();
        this.$base.$set('config', cfg);
        this.reset();
        const cid = res.result.slice(res.result.lastIndexOf(':') + 1);
        const cls = await this.getClass(cid);
        this.fire('create', cls);
        return cls;

    }

    static async findField(path = '') {
        if (!path)
            throw new Error('Empty path');

        const fields = await this.fields;
        if (fields.length > 0) {
            const parts = path.split('/');
            const step = parts.shift();
            const field = fields.find(f => f.name === step);

            if (field) {
                if (parts.length === 0)
                    return field;
                return field.findField.call(field, parts.join('/'));
            }
        }
        throw new Error('Field not found');
    }

    findField(path) {
        return odaClass.findField.call(this, path);
    }

    async createField(attrs) {
        if (!attrs)
            throw new Error('No attrs for create field');
        if (!attrs.Name)
            throw new Error('No attrs.Name for create field');
        if (this.ATTRS.find(i => i.Name === attrs.Name))
            throw new Error('Field named ' + attrs.Name + ' already exists');
        this.ATTRS.push(attrs);
        const field = await  odaField.create(this, attrs);
        this.fireChanged();
        return field;
    }

    static async _getFields(source) {
        let attrs = this.getElements(source) || [];
        if (this.TypeClass) {
            for (const attr of this.TypeClass.ATTRS){
                const a = attrs.find(a=>a.Name === attr.Name);
                if (!a){
                    attrs.push(attr);
                }
                else{
                    for (const i in attr){
                        a[i] = a[i] || attr[i];
                    }
                }
            }
        }
        attrs = attrs.filter(attr => {
            return !ODANT.getBool(attr.Hide);
        });
        const p = attrs.map(attr => {
            return odaField.create(this, attr);
        });
        return Promise.all(p);
    }
    get fields() {
        return this.$FIELDS.fields;
        // return this.$('fields', () => {
        //     return odaClass._getFields.call(this, '$METADATA/$ATTR');
        // })
    }

    getMetadata(p) {
        return this.API.GET(null, p);
    }

    getObject(id, params = {meta: true, recalc: false}) {
        return this.$O(id, async () => {
            let cls = this;
            const body = await ODANT.API.request(this.url + '/O:' + id, params);
            const root = body.$OBJECT || body.$STATIC || body.$DETAILS;
            if (this.id !== root[0].cid) {
                try{
                    cls = (await this.findItem(root[0].cid)) || this;
                }
                catch (e) {
                    cls = this;
                }
            }
            this._objectScript = this._objectScript || await ODANT.loadScript(cls.url + '/~/web/object/object.js');
            return odaItem.factory.create(this._objectScript.src, {$owner: cls, body: body});
        })
    }

    $O(key, callback) {
        this._$O = this._$O || {};
        this._$O[key] = this._$O[key] || callback();
        return this._$O[key];
    }

    async getObjectCount(pack) {
        const json = await this.API.GET('get_class_objects_count', { format: 'json', mask: pack || '*' });
        return parseInt(json.result) || 0;
    }

    get objectCount() {
        return this.$('objectCount', () => {
            return this.getObjectCount();
        });
    }
    getIndex(name, XQ, type) {
        return this.$('Index:' + name, async () => {
            if (XQ) {
                const param = { name: name };
                if (type) param.type = type;
                await this.API.POST('create_index', param, XQ);
            }
            return new odaIndex({ id: name, $owner: this, XQ: XQ });
        })
    }

    async XQuery(xq, params = {}) {
        const idx = await this.getIndex(params.index || 'table', params.XQ);
        params.index = null;
        params.XQ = null;
        return idx.XQuery(xq, params);
    }
    async createObject(src) {
        if (src && typeof src === 'object')
            src = JSON.stringify(src);
        const json =  await this.API.POST('create_object', {recalc: true, meta: true}, src);
        const script = await ODANT.loadScript(this.url + '/~/web/object/object.js');
        const obj = odaItem.factory.create(script.src, {$owner: this, body: json});
        obj.currentState = 'new object';
        this.fire('create', obj);
        return obj;

    }

    async getBackupsInfo(mask, types) {
        return await this.$(`BackupsInfo:${mask}:${types}`, async () => await this.API.POST('get_backups_info', { mask: mask, types: types }));
    }

    async getBackupClass(dir, id) {
        return await this.$(`BackupClass:${dir}:${id}`, async () => await this.API.POST('get_backup_class', { d: dir, i: id }));
    }

    async getBackupDeletedObject(dir, id) {
        return await this.$(`BackupDeletedObject:${dir}:${id}`, async () => await this.API.POST('get_backup_deleted_object', { d: dir, i: id }));
    }

    async getBackupUpdateObject(dir, id) {
        return await this.$(`BackupUpdateObject:${dir}:${id}`, async () => await this.API.POST('get_backup_update_object', { d: dir, i: id }));
    }
};
odaClass.register();


globalThis.odaGroup = globalThis.odaGroup || class odaGroup extends odaStructureItem {
    constructor(params) {
        super();
        this.noContextMenu = true;
        this.noFocus = true;
        this.noSelect = true;
        this._name = params.name;
        this._owner = params.owner;
        this._type = params.type;
    }
    get $owner() {
        return this._owner;
    }
    static get properties(){ return {
        prefix: 'G',
        icon: 'odant:folder',
        // subIcon: 'class',
        itemTypeLabel: "odaGroup",
        // url: null,
        isRef: false,
        url() {
            return this.$owner.url;
        },
        zIndex: 0,
        id() {
            return this.$owner.id + '_G_' + this.name;
        },
        access() {
            return this.$owner.access;
        },
        name() {
            return this._name;
        },
        type() {
            return this._type || 'CATEGORY';
        },
        label() {
            switch (this.type.toLowerCase()) {
                case 'module': return 'Modules';
                case 'workplace': return 'Workplaces';
                case 'group':
                case 'category': return this._name;
                default: return 'black'
            }
        },
        fill() {
            switch (this.type.toLowerCase()) {
                case 'module': return 'magenta';
                case 'workplace': return 'darkblue';
                case 'group':
                case 'category': return 'orange';
                default: return 'black'
            }
        }
    }}
    
    get config() {
        return this.$('config', async () => {
            return this.getConfig();
        });
    }

    async getConfig(xq) {
        return this.$(`get-config:${xq ? xq : 'none'}`, async ()=>{
            const cfg = await this.$owner.getConfig(xq, true, this.$owner.access.allowAdmin);
            return cfg.$G ? cfg.$G.find(item => item.name === this.name && item.type === this._type) : null;
        });
    }

    async getItem(id, prefix) {
        return this.$owner.getItem(id, prefix);
    }

    async findItem(path) {
        return this.$owner.findItem(path);
    }

    getActionFolderName() {
        return '_categories';
    }
    async findAction(action) {
        action = await this.$owner.$class.findAction(action);
        action.$set('$owner', this);
        return action;
    }
    async getActions(type) {
        const actions = await this.$base.getActions(this.getActionFolderName() + (type === '*' ? '' : '/' + type), this);
        return actions.map(i => {
            let m = Object.create(i);
            m._owner = this;
            return m;
        });
    }
    getCategories() {
        return [];
    }
};

globalThis.odaModuleGroup =  globalThis.odaModuleGroup ||  class odaModuleGroup extends odaGroup {
    static get properties(){
        return {
            id: 'Modules',
            itemTypeLabel: "modules",
            prefix: 'M',
            icon: 'folders/folder-magenta-open',
            zIndex: 30
        }
    }
    get config() {
        return this.$('config',{
                    i: this.id,
                    n: this.id,
                    $M: this.$owner.config.$M
        });
    }


    async _buildStructure(structure) {
        await this.$base._createStructure(structure);
        const cfg = await this.$base.getConfig();
        this.$base.reset();
        this.$base.$set('config', cfg);
        this.reset();
        this.fire('reset');

        return this;
    }

    getActionFolderName() {
        return '_modules';
    }

    async findAction(action) {
        const a = await this.$owner.findAction(action);
        a.$set('$owner', this);
        return a;
    }
}

'use strict';

globalThis.odaClassItem =  globalThis.odaClassItem ||  class odaClassItem extends odaItem {
    static get properties(){
        return {
            _color(){
                return this.inherit.color;
            },
            $dataOwner(){
                return this.$('$dataOwner', ()=>{
                    let item = this.$owner;
                    while(item && item instanceof odaClassItem)
                        item = item.$owner;
                    return item;
                })
            }
        }
    }
    getActions(type = '*', context) {
        return this.$dataOwner.getActions(type, context || this);
    }
    get fields() {
        return this.$class.fields;
    }
}

odaClassItem.register();

globalThis.odaPack =  globalThis.odaPack ||  class odaPack extends odaClassItem {

    static get properties() {
        return {
            icon: 'av:library-books',
            itemTypeLabel: 'pack',
            id () {
                return this.getAttr('Label', this.name);
            },
            mask(){
                const prefix = this.$owner.mask;
                return (prefix?prefix+'/':'') + this.name;
            },
            name () {
                return this.getAttr('name', '');
            },
            url () {
                return '';
            },
            objectCount () {
                return this.getAttr('count');
            }
        }
    }

    get $$draftObjects() {
        return this.$('draft-objects', async () => {
            const idx = await this.$class.getIndex('names');
            const dataSet = await idx.getDataSet(this.mask);
            const data = await dataSet.Items;
            return  data.map(el => new odaObject({$owner: this, Root: el}));
        })
    }
    get hasPacks(){
        return this.Packets.length>0;
    }
    get Packets() {
        return this.$('packets', ()=>{
            let p = this.Root.items.reduce((res, v)=>{
                const names = v.names;
                const name = names.shift();
                let p = res.find(i => i.name === name);
                if (!p){
                    p = {name: name, count: 0, items: []};
                    res.push(p);
                }
                p.count += +v.count;
                if (names.length)
                    p.items.push({count: v.count, names: names});
                return res;
            }, []);
            p = p.map(i=>{
                return new odaPack({$owner: this, Root:i})
            });
            return p;
        })

    }
}
odaPack.register();
