'use strict';
globalThis.odaHost = globalThis.odaHost || class odaHost extends odaStructureItem {
    static get properties(){ return {
        supportUrl(){
            return this.$('supportUrl', () => {
                return `${this.$connection.url}/H:${this.config.s}`;
            })
        },
        isSystem: true,
        prefix: 'H',
        defaultViewName: 'desktop',
        config () {
            return this.$('config');
        },
        icon: 'odant:host',
        _actionsPath: 'client',
        _fullPath:{
            get () {
                return this.$('_fullPath', () => {
                    return this.prefix+':'+this.id;
                })
            }
        }
    }}
    get hasChildren() {
        return true;
    }
    get $folder(){
        return this.$connection.$folder;
    }
    get Work(){
        return this.getDomain('work', 'p');
    }
    get $system() {
        return this.$('$system', () => {
            return this.findItem('P:SYSTEM');
        })
    }

    get $security() {
        return this.$('$security', async () => {
            const sys = await this.$system;
            return sys.findItem('C:000000000000020');
        })
    }
};
odaHost.register();