(class extends odaCreateItemAction {
    static get properties() {
        return {
            prefix: 'B',
            label: 'Add base',
            icon: 'base'
        }
    }

    async execute(params) {
        const childBases = await this.$item.Bases;
        let component = await ODA.createComponent('/web/lib/listbox/odant-list-box.html', {items: [this.$item, ...childBases]});
        component.addEventListener('focused-item-changed', (e) => {
            component.fire('modal-result', e.detail.value);
        });

        const result = await ODA.showDialog({
            title: 'Select Base for deploy',
            control: component,
            buttons: [
                {label: 'New base', icon: 'icons:add', special: 'add'},
            ]
        });
        if (!result)
            throw new Error('cancelled');

        const name = await ODA.inputText({
            title: 'New base name',
            value: "Base " + (childBases.length + 1)
        });
        if (result.button) {
            const base = await this.$item._createDomain(name, 'B');
            ODA.push("Action add base", {
                tag: "add-base",
                body: '"' + name + '" was created',
                icon: this.$item.icon
            });

            return base;
        }
        component =  await this.createComponent('odant-add-base.html');
        component.contextItem = result;
        component = await ODA.showDialog(component);
        const base = await this.$item._createDomain(name, 'B');
        const structure = await this.buildStructure(this._getTemplateForBuild(component.$$('odant-tree').nodes));
        try{
            return await base._buildStructure(structure);
        }
        catch (e) {
            ODA.push(
                'Failed',
                {
                    tag: 'add-base',
                    body: e,
                    icon: this.$item.icon
                }
            );

            return e;
        }
    }
}).register();