export default odaPage({
    props: {
        label: 'Site in Core',
        allowAccess: 'r',
        icon: 'odant:object'
    }
})

// import '/web/oda/components/layouts/app-layout/app-layout.js';
// import '/web/oda/tools/containers/dropdown/dropdown.js';
// import '/web/oda/components/grids/tree/tree.js';
// import '/web/core/item/lib/context/context.js';

// ODA({ is: 'site-tempale',template: '<link rel="stylesheet" href="/themplate/testThems/dop.css">'})

ODANT({
    is: 'odant-site',
    hostAttributes: {
        //             'right.icon': 'icons:warning',
        //             'left.splitter.hidden': true
        // <link rel="stylesheet" href="/themplate/testThems/testThemes/aos.css"> // лишний стиль
    },
    
    props: {
      sitebg:"background-image: url('/themplate/testThems/testThemes/img_5.jpg'); background-position: 50% 0px;",
      //sitebg:{get() {return "background-image: url('" + this.siteInfo.sitefoto + "'); background-position: 50% 0px;";} },
 
      photos:Array,
      siteblges:Array,
      sitepages:Array,

      menulist:[{"name":"Фото", "href":"section-photos"},{"name":"Блог", "href":"section-blog"}], 

      contextItem: {
          type: Object,
          async set(n) {
              this.items = await n.$$items;

              let siteInfoPath = myPath ( this.items.find(i => i.name=="site-base").path );          
              this.siteInfo = (await fetch(siteInfoPath).then((r) => r.json())).$rows[0] ;

              let photosPath = myPath ( this.items.find(i => i.name=="Photos").path );
              this.photos = (await fetch(photosPath).then((r) => r.json())).$rows.filter(c => c.publ);

              let blogesPath = myPath ( this.items.find(i => i.name=="blog").path );
              this.siteblges = (await fetch(blogesPath).then((r) => r.json())).$rows.filter(c => c.publ);

              let sitepagesPath = myPath ( this.items.find(i => i.name=="main_mrnu_pages").path );
              this.sitepages = (await fetch(sitepagesPath).then((r) => r.json())).$rows.filter(c => c.publ);

              //let reOb = ob => {return {"name":ob.name, "href":ob.oid} };
              this.sitepages.map(ob => {this.menulist.push({"name":ob.name, "href":ob.oid}) });


              //console.log(this.menulist );
              
     
              


          }
      },
      siteInfo:Object,
      items: Array,
      titleLabel: {
          get() {
              return this.contextItem.label;
          }
      },
      _mmenuClick (e) {
        console.log("ok");
        console.log(e);
        // console.log(d);
      }
    },


  


    template: `
<link rel="stylesheet" href="/themplate/testThems/dop.css">

  <div class="site-wrap">

  <div class="site-mobile-menu site-navbar-target">
    <div class="site-mobile-menu-header">
      <div class="site-mobile-menu-close mt-3">
        <span class="icon-close2 js-menu-toggle"></span>
      </div>
    </div>
    <div class="site-mobile-menu-body">

</div>
  </div>

  <header class="header-bar d-flex d-lg-block align-items-center site-navbar-target aos-init aos-animate" data-aos="fade-right">
    <div class="site-logo">
      <a href="#">{{siteInfo?.sitename}}</a>
    </div>
    
    <div class="d-inline-block d-lg-none ml-md-0 ml-auto py-3" style="position: relative; top: 3px;"><a href="#" class="site-menu-toggle js-menu-toggle text-white"><span class="icon-menu h3"></span></a></div>

    <div class="main-menu"> 
      <ul class="js-clone-nav">
        <li ~for="menulist"><em :elem="item?.href" @down="_mmenuClick" class="nav-link scroll-to" :class="item?.href">{{item?.name}}</em></li>        
      </ul>
    </div>
  </header> 

  <main class="main-content">

    <section class="site-section-hero bg-image" :style="sitebg" id="section-home">
        <div class="row justify-content-center align-items-center">
          <div class="col-md-7 text-center">
            <h1 @tap="_mmenuClick('111')" class="text-white heading text-uppercase aos-init aos-animate" data-aos="fade-up">{{siteInfo?.sitename}}</h1>
            <p class="lead text-white mb-5 aos-init aos-animate" data-aos="fade-up" data-aos-delay="100">{{siteInfo?.siteslogan}}</p>

          </div>
        </div>
      </section>

    <div class="container-fluid">   

      <section class="row align-items-stretch photos" id="section-photos">
        <div class="col-12">
          <div class="row align-items-stretch">        
            <div ~for="photos" class="col-6 col-md-6 col-lg-4 aos-init img-cont" data-aos="fade-up">
              <img :src="item?.img" class="img-fluid">            
            </div>
          </div>        
        </div>
      </section> <!-- #section-photos -->



      <section class="site-section" id="section-blog">
        <div class="container">
          <div class="row justify-content-center">
            <div class="col-md-8">
              <div class="row">
                <h2 class="heading text-uppercase text-white aos-init" data-aos="fade-up">Blog</h2>
                
                <div ~for="siteblges" class="col-md-12 mb-4 aos-init" data-aos="fade-up">
                  <div class="d-md-flex d-block blog-entry align-items-start">
                    <div class="mr-0 mr-md-5 mb-3 img-wrap"><a href="#"><img :src="item?.picture" alt="Image" class="img-fluid"></a></div>
                    <div>
                      <h2 class="mt-0 mb-2"><a href="#">{{item?.name}}</a></h2>
                      <div class="meta mb-3">Опубликовано: <a href="#"> {{item?.data}}</a></div>
                      <div ~html='item?.body' > </div>
                    </div>
                  </div>
                </div>

                
              </div>
            </div>
          </div>
        </div>
      </section>
      
      <section ~for="sitepages" class="site-section darken-bg" :id="item?.oid">
        <div class="container">
          <div class="row justify-content-center">
            <div class="col-md-8">
              <h2 class="heading text-uppercase text-white">{{item?.name}}</h2>
              <figure class="mb-5 aos-init" data-aos="fade-up"><img :src="item?.picture" :alt="item?.name" class="img-fluid w-50 rounded"></figure>
              <div ~html='item?.body' data-aos="fade-up" data-aos-delay="100" class="aos-init"></div> 
            </div>
          </div>
        </div>
      </section>

      <div class="row justify-content-center">
        <div class="col-md-12 text-center py-5">
          <p ~html='siteInfo?.copyrite' ></p>
        </div>
      </div>
    </div>
  </main>

</div> <!-- .site-wrap --> 
        `,


});

let myPath = sP => "http://127.0.0.1:8080/api/" + sP + "/I:table?get_dataset";

// let async  mygetObject = (list, name) => {
//   let p = myPath ( list.find(i => i.name==name).path );
//   let rez = (await fetch(p).then((r) => r.json())).$rows;
//   return rez };