(class extends odaClass{
    static get properties(){
        return {}
    }
}).register();

(class extends odaField {
    getValue(odaObject, dataRoot) {
        return super.getValue(odaObject, dataRoot);
    }
    setValue(odaObject, value, dataRoot) {
        if (this._isLink){
            if (value && !(value instanceof odaItem) && value.oid){
                return this.TypeClass.getObject(value.oid).then(obj =>{
                    return super.setValue(odaObject, obj, dataRoot);
                })
            }
        }
        return super.setValue(odaObject, value, dataRoot);
    }
    async getValueList(odaObject, dataRoot){
        if (this._isLink){
            let filter = dataRoot[this.name] || '';
            if (filter){
                filter = '[contains(@name, "'+filter+'")]';
            }
            if (this.ValueListFilter){
                let f1 = this.getMetadata('ValueListFilter', odaObject, dataRoot, 0);
                if (f1){
                    filter += `[${f1}]`;
                }
            }
            let xq = 'for $a in */*'+filter+' return element item{ $a/(@oid, @icon), attribute value{$a/@name}}';
            const res = await  this.TypeClass.XQuery(xq, {index: 'table'});
            return res ? res.$item : [];
        }
        return super.getValueList(odaObject, dataRoot);
    }


    static get properties(){
        return {

            LinkFields:{
                category: 'Link',
                type: String,
                // type_editor: TE_XQ,
                get: function(){
                    return this.getAttr('LinkFields', '*');
                },
                set: function(v){
                    this.setAttr('LinkFields', v);
                }
            },
            ValueListFilter:{
                category: 'Link',
                type: String,
                // type_editor: TE_XQ,
                get: function(){
                    return this.getAttr('meta:ValueListFilter');
                },
                set: function(v){
                    return this.setAttr('meta:ValueListFilter', v);
                }
            },
            _isLink:{
                get: function(){
                    return !this.isTable && this.TypeClass.ATTRS.length > 0 && !this.TypeClass.isAbstract;
                }
            },
            _isStructure:{
                get: function(){
                    return !this.isTable && this.TypeClass.ATTRS.length > 0 && this.TypeClass.isAbstract;
                }
            },
            defaultViewName: function(){
                if(this._isLink)
                    return 'link';
                return this.super('defaultViewName');
            },
            extendedViewName: function(){
                if(this._isLink)
                    return 'extended-link';
                if (this._isStructure)
                    return 'extended';
                return  this.super('extendedViewName');
            }
        }
    }
}).register();