(class extends odaButton {
    static get properties() {return {
        label: 'Create object',
        allowAccess: 'C',
        icon: 'icons:note-add',
        zIndex: -1,
        allowUse:  function () {
            return this.contextItem.itemType === odaItem.Types.odaClass && !this.contextItem.isAbstract;
        }
    }}

    async execute(params = {}) {
        const classes = await this.$class.Items;

        if (classes.length === 1)
            return classes[0].executeAction('create-object', params);
        if (classes.length > 0) {
            let tree = await ODA.createComponent('/web/core/structure/lib/structure-tree/structure-tree.html');
            tree.contextItem =this.$item;
            tree.allowFocus = true;
            tree.focusedItem = params.class;
            // tree.hideRoot = true;
            // tree.addEventListener('dblclick', e => {
            //     e.currentTarget.fire('modal-result', e.currentTarget.focusedItem);
            // });

            const dialog = await ODA.showDialog(tree, { dblclick: true }); // <- after select simple class recall this action again from new context
            return tree.focusedItem.executeAction('create-object', params);
        }
        const fields = await this.$class.fields;
        const linkField = fields.find(i => {
            return i.name === 'name' && i.TypeClass && !i.TypeClass.isAbstract;
        });
        if (linkField) {
            const actions = await linkField.getActions('links');
            const linkAction = actions.find(a=>{
                return a.name === $field.linkMethod;
            });

            let obj = await linkAction.execute();
            if (!(obj instanceof odaObject)) {
                obj = await linkField.TypeClass.executeAction('create-object', { default: { name: control.value } });
                await obj.save();
            }
            params = {default: {name: obj}};
        }
        return this.createObject(params);
    }

    async createObject(params) {
        const obj = await this.$class.createObject();
        if (params && typeof params.default === 'object'){
            for (let i in params.default) {
                obj.setValue(i, params.default[i]);
            }
        }
        // const fields = await obj.fields;
        // let required = fields.filter(fields => fields.required);
        // if (required.length > 0) {
        //     const control = await ODA.createComponent(this.resolveUrl('odant-required-editor.html'));
        //     control.contextItem = obj;
        //     await ODA.showDialog(control);
        //     await obj.save();
        // }
        return obj.show();
    }
}).register();