export default odaButton({
    props: {
        allowAccess: 'C',
        icon: 'icons:note-add',
        label: 'New Object',
        active() {
            return this.$source.typeName !== 'part';
        }
    },
    async execute(params = {}) {
        const classes = await this.$class.$$classes;

        if (classes.length === 1)
            return classes[0].executeAction('create-object', params);

        if (classes.length > 0) {
            await import('/web/core/structure/lib/structure-tree/structure-tree.js');

            const dialog = await ODA.showDialog('odant-structure-tree', { contextItem: this.$owner.$class, allowFocus: true, focusedItem: params.class }, { title: 'Select simple class', rdblclick: true });
            return dialog.focusedItem.executeAction('create-object', params);
        }

        // TODO realise odaClass.isAbstract
        // const fields = await this.$class.$$fields;
        // const linkField = fields.find(i => {
        //     return (i.name === 'name') && i.$typeClass && !i.$typeClass.isAbstract;
        // });

        // if (linkField) {
        //     const actions = await linkField.getActions('links');
        //     const linkAction = actions.find(a => {
        //         return a.name === $field.linkMethod;
        //     });

        //     let obj = await linkAction.execute();
        //     if (!(obj instanceof odaObject)) {
        //         obj = await linkField.$typeClass.executeAction('create-object', { default: { name: control.value } });
        //         await obj.save();
        //     }
        //     params = { default: { name: obj } };
        // }
        return this.createObject(params);
    },
    async createObject(params) {
        const obj = await this.$class.createObject();
        if (params && typeof params.default === 'object') {
            for (let i in params.default) {
                obj.setValue(i, params.default[i]);
            }
        }
        return obj.show();
    }
})