(class extends odaField {
    static get properties(){
        return {
            linkMethod:{
                category: 'link',
                type: String,
                get: function(){
                    return this.getAttr('link-method', 'select-link');
                },
                set: function(v){
                    this.setAttr('link-method', v);
                },
                enum: ['select-link', 'create-and-link']
            },
            LinkFields:{
                category: 'link',
                type: String,
                label: 'Доступные поля',
                editor: '/web/lib/inputs/expression/expression.html',
                get: function(){
                    return this.getAttr('LinkFields', '');
                },
                set: function(v){
                    this.setAttr('LinkFields', v);
                }
            },
            ValueListFilter:{
                category: 'link',
                type: String,
                // type_editor: TE_XQ,
                get: function(){
                    return this.getAttr('meta:ValueListFilter');
                },
                set: function(v){
                    return this.setAttr('meta:ValueListFilter', v);
                }
            },
            defaultViewName: {
                category: 'link',
                type: String,
                label: 'Представление по умолчанию',
                get: function () {
                    return this.getAttr('defaultViewName');
                },
                set: function (v) {
                    return this.setAttr('defaultViewName', v);
                }
            },
            MoreLink: {
                category: 'link',
                editor: '/web/core/structure/lib/item-list-editor/item-list-editor.html',
                type: String,
                label: 'Дополнительные источники',
                get: function () {
                    if (!this.Root.$MoreLink) return '';

                    return this.Root.$MoreLink.reduce((acc, val) => {
                        if (!val || !val.link) return acc;
                        if (acc.length > 0) {
                            acc += '|';
                        }

                        return acc + val.link;
                    }, '');
                },
                set: function (v) {
                    const newVal = (v) ? v.split('|').map((s) => ({link: s})) : '';
                    this.Root.$MoreLink =  newVal;
                    this.fireChanged();
                }
            }
        }
    }
}).register();