(class extends odaAction {
    static get properties() {
        return {
            allowAccess: 'w',
            icon: 'icons:more-horiz'
        }
    }

    async execute(multiSelection) {
        let cls = this.$item.TypeClass;

        if (this.$item.MoreLink) {
            const prom = await this.$item.MoreLink.split('|').map(async (link) => await this.$item.$base.findItem(link));
            const classes = [cls, ...await Promise.all(prom)];

            const listbox = await ODA.createComponent('/web/lib/lists/listbox/listbox.html');
            listbox.items = classes;
            listbox.focusedItem = classes[0];
            const dialog = await ODA.showDialog(listbox, { dblclick: true }).catch((e) => { });
            if (!dialog) return null;
            cls = listbox.focusedItem;
        }

        const action = await cls.getViewAction(cls.selectLinkViewName);
        const control = await action._control;

        if (multiSelection) {
            control.multiSelection = multiSelection;
            control.allowSelection = true;
        }

        const form = await ODA.createComponent(cls.formUrl);
        form.allowButtons = action.allowButtons;
        form.hideViews = action.hideViews;
        form.actionSource = cls;
        form.control = control;
        form.size = 'max';
        form.hideMin = true;
        form.hideMax = true;
        const val = await form.showDialog();//await ODA.showDialog(form, { dblclick: true }).catch((e) => { });

        return await control.focusedItem;
    }
}).register();