ODANT({
    is: 'odant-table-grid',
    imports: [ '@oda/table' ],
    extends: 'oda-table',
    props: {
        screen: {
            set(v) {
                this.fire('screen-changed', v);
            }
        },
        preFooter: {
            type: Object
        },
        footer: {
            type: Object,
            get() {
                if (this.preFooter) return this.preFooter;
                const obj = {};
                this.cols.forEach(c => {
                    if (c.treeMode) {
                        let d = this.size;
                        const i = this.size;
                        if (i > d) {
                            d = d.toLocaleString() + ' / ' + i.toLocaleString();
                        } else {
                            d = d.toLocaleString();
                        }

                        if (this.screen) {
                            let to = this.screen.from + this.screen.length;
                            if (to > d)
                                to = d;
                            if (d)
                                d += '  [ ' + (this.screen.from).toLocaleString() + ' ... ' + to.toLocaleString() + ' ]';
                        }
                        obj[c.name] = d || '';
                    }

                    switch (c.summary) {
                        case 'count': {
                            obj[c.name] = this.size;
                        } break;
                        case 'sum': {
                            obj[c.name] = this.dataSet.reduce((res, r) => {
                                const v = r[c.name];
                                if (v)
                                    res += parseFloat(v);
                                return res;
                            }, 0);
                        } break;
                    }
                });
                return obj;
            }
        },
    },
})