import ODA from '../../../../oda/oda.js';
import '../../../../oda/components/grids/tree/tree.js';
import '../../../item/lib/item-node/item-node.js';
ODA({
    is: 'odant-parent-tree',
    extends: 'oda-tree',
    props: {
        allowFocus: true,
        defaultTemplate: 'odant-parent-tree-cell',
        contextItem: {
            type: Object,
            async set(contextItem) {
                const classes = [];
                let p = contextItem;
                let last;
                while (p && p.itemType === odaItem.Types.odaClass) {
                    if (!last) {
                        last = { $item: p, items: [] };
                        this.focusedItem = last;
                    } else {
                        const obj = { $item: p, items: [last] , $expanded: true};
                        last = obj;
                    }
                    p = p.$owner;
                }
                this.dataSet = [last];
            }
        }
    },
})

ODA({
    is: 'odant-parent-tree-cell',
    extends: 'odant-item-node, oda-table-cell-base',
    props: {
        hidePrefix: true,
        hideSuffix: true,
        item:{
            type: Object,
            async set(item){
                if (item && item.$item.fullId) {
                    this.contextItem = await ODANT.findItem(item.$item.fullId);
                }
            }
        }
    }
})