const imgExts = [
    'bmp',
    'cod',
    'gif',
    'ief',
    'jpe',
    'jpeg',
    'jpg',
    'jfif',
    'svg',
    'tif',
    'tiff',
    'ras',
    'cmx',
    'ico',
    'png',
    'pnm',
    'pbm',
    'pgm',
    'ppm',
    'rgb',
    'xbm',
    'xpm',
    'xwd'
];

export default odaView({
    props: {
        label: 'Image preview',
        allowAccess: 'R',
        allowUse() {
            return this.$owner.ext && imgExts.some(e => e === this.$owner.ext.toLowerCase());
        },
        icon() {
            return this.$owner.icon;
        }
    }
})

ODANT({
    is: 'image-preview',
    imports: [
        '@oda/image-viewer'
    ],
    template: /*html*/`
        <style>
            :host{
                @apply --content;
                @apply --horizontal;
                flex: 1;
                justify-content: stretch;
            }
        </style>
        <oda-image-viewer :src="path"></oda-image-viewer>
    `,
    props: {
        openable: false,
        contextItem: {
            type: Object,
            set(contextItem) {
                let path;
                if (contextItem) {
                    path = contextItem.url;
                    this.openable = true;
                } else {
                    path = '/web/res/images/no-image.svg';
                    this.openable = false;
                }
                this.path = path;
            }
        },
        path: ''
    },
})

