(class extends odaAction {
    static get properties() {
        return {
            icon: 'icons:add-box',
            allowAccess: 'A',
            allowUse() {
                return this.$item.name === 'lib';
            }
        }
    }
    async execute(params = {}) {
        let { name, inherit } = params;
        if (!name) {
            ({ name } = await ODA.inputText({ title: 'New component name' }));
        }
        if (!name) {
            throw new Error('It is impossible to create an action, not enough data.');
        }
        return this._createComponent(name);
    }
    async _createComponent(name) {
        const actionFolder = await this.$item.createFolder(name);
        const htmlBody = this._getHTMLBody(name);
        await actionFolder.saveFile(htmlBody, name + '.html');
    }
    _getHTMLBody(name, inherit) {
        return `<script src="/web/core/oda.js"></script>
<oda-module id="oda-${name}">
    <template>
        <style>
            
        </style>
        
    </template>
    <script>
        ODA({
            is: 'oda-${name}',${inherit ? `\nextends: '${inherit}',` : ''}
            properties: {
                
            },
        })
    </script>
</oda-module>`
    }
}).register();