(class extends odaAction {
    static get properties() {
        return {
            icon() {
                return 'icons:create-new-folder';
            },
            label() {
                return `Create ` + (this.labelCreation || 'folder');
            },
            allowAccess() {
                return this.labelCreation ? 'A' : 'C';
            },
        }
    }
    execute(params) {
        if (this.labelCreation) {
            this.$item.executeAction('create-action');
        }
        else {
            return ODA.inputText({ title: 'Create new folder', value: 'folder name' }).then(name => {
                return this.$item.createFolder(name);
            })
        }
    }
    get labelCreation() {
        return this.labels[this.$item.path];
    }
    get labels() {
        return {
            '~/client': 'client action',
            '~/server': 'server action',

            '~/server/methods': 'server method',
            '~/lib': 'visual component',
            // '~/fields': 'field component',
            // '~/fields/inputs': 'field input control',
            // '~/fields/complex': 'field complex control',
            // '~/fields/lib': 'field visual component',
            // '~/fields/admin': 'field admin method',
            // '~/fields/links': 'field link method',

            '~/server/tasks': 'server task',
            '~/server/tasks/on-start': 'server on-start task',
            '~/server/tasks/on-timer': 'server on-timer task',

            '~/server/triggers': 'server trigger',
            '~/server/triggers/after-create': 'server after-create trigger',
            '~/server/triggers/after-delete': 'server after-delete trigger',
            '~/server/triggers/after-update': 'server after-update trigger',
            '~/server/triggers/before-create': 'server before-create trigger',
            '~/server/triggers/before-delete': 'server before-delete trigger',
            '~/server/triggers/before-update': 'server before-update trigger',

            '~/web/object/client': 'client action',
            '~/web/object/lib': 'visual component',
            '~/web/object/server': 'server action',
            '~/web/object/server/methods': 'server method',

            '~/web/object/server/triggers': 'server trigger',
            '~/web/object/server/triggers/after-create': 'server after-create trigger',
            '~/web/object/server/triggers/after-delete': 'server after-delete trigger',
            '~/web/object/server/triggers/after-update': 'server after-update trigger',
            '~/web/object/server/triggers/before-create': 'server before-create trigger',
            '~/web/object/server/triggers/before-delete': 'server before-delete trigger',
            '~/web/object/server/triggers/before-update': 'server before-update trigger',
        }
    }
}).register();