(class extends odaAction {
    async execute() {
        const text = `It will be deleted<br>${this.$item.itemTypeLabel}: <b style="font-size: 120%;">${this.$item.label}</b><br>Continue?`;
        await ODA.confirm(text);
        return this.$item.remove();
    }
    static get properties() {
        return {
            shortcut: 'del',
            icon: 'icons:delete',
            category: 'admin',
            allowArrayContext: true,
            label() {
                if (this.labelCreation) {
                    return `Clear ${this.labelCreation}s`;
                }
                return `Delete folder "${this.$item.label}"`;
                // return 'Delete ' + this.$item.itemTypeLabel;
            },
            allowAccess: 'A',
            allowUse() {
                if (this.labelCreation && this.$item.inherit.isSelf) {
                    return true;
                }
                return !this.$item.isSystem || this.$item.inherit.isSelf;
            }
        }
    }
    get labelCreation() {
        return this.labels[this.$item.path];
    }
    get labels() {
        return {
            '~/client': 'client action',
            '~/server': 'server action',

            '~/server/methods': 'server method',
            '~/lib': 'visual component',
            '~/fields': 'field component',
            '~/fields/inputs': 'field input control',
            '~/fields/complex': 'field complex control',
            '~/fields/lib': 'field visual component',
            '~/fields/admin': 'field admin method',
            '~/fields/links': 'field link method',

            '~/server/tasks': 'server task',
            '~/server/tasks/on-start': 'server on-start task',
            '~/server/tasks/on-timer': 'server on-timer task',

            '~/server/triggers': 'server trigger',
            '~/server/triggers/after-create': 'server after-create trigger',
            '~/server/triggers/after-delete': 'server after-delete trigger',
            '~/server/triggers/after-update': 'server after-update trigger',
            '~/server/triggers/before-create': 'server before-create trigger',
            '~/server/triggers/before-delete': 'server before-delete trigger',
            '~/server/triggers/before-update': 'server before-update trigger',

            '~/web/object': 'object action',
            '~/web/object/client': 'client action',
        }
    }
}).register();