(class extends odaAction {
    static get properties() {
        return {
            label: 'Upload file',
            allowAccess: 'A',
            icon: "icons:file-upload"
        }
    }
    async execute(params) {
        const fileDialog = await ODA.showFileDialog('Select files to upload', true);
        const control = await ODA.createComponent(this.resolveUrl('file-names.html'));
        const files = Array.from(fileDialog).map(f => {
            let n = f.name;
            let i = n.lastIndexOf('/');
            if (i > 0)
                n = n.substring(i + 1);
            i = n.lastIndexOf('.');
            if (i > 0) {
                f.label = n.substring(0, i);
                f.ext = n.substring(i + 1, 100);
            }
            return f;
        });
        control.items = files;
        await ODA.showDialog(control);
        let p = Array.from(files).map(f => this.$item.saveFile(f, f.label + '.' + f.ext));
        try {
            const res = await Promise.all(p);
            ODA.notify(res);
            return res;
        } catch (err) {
            ODA.notify(err);
        }
    }
}).register();
