ODANT({
    is: 'oda-file-conflict-dialog',
    imports: [
        '@oda/radio-group'
    ],
    template: /* html */`
    <style>
        :host {
            overflow: auto;
        }
        .container {
            min-width: 300px;
            @apply --content;
            @apply --shadow;
            width: 400px;
            max-width: 100%;
            padding: 20px;
        }
    </style>

    <div class="container">
        An item named <b>{{lastFile && lastFile.label}}</b> already exists in the
        <b>{{dropItem && (dropItem.path || '~')}}</b> directory.
        <oda-radio-group ::value="_value" :list="_actions"></oda-radio-group>
    </div>`,
    props: {
        lastFile: {
            type: [File, Object],
            default: null,
        },
        isMultipleFiles: {
            default: false,
            watch(v) {
                if (v) {
                    this._buttons = Object.values(this.buttons);
                } else {
                    this._buttons = this._buttons.filter(b => b !== this.buttons.forAllNext);
                }
            },
        },
        dropItem: Object,
        action: {
            type: String,
            enum: ['save', 'rename', 'replace', 'none'],
            default: 'none',
            watch(act) {
                this._buttons = act === 'rename' || !this.isMultipleFiles ? ['OK'] : Object.values(this.buttons);
            },
        },
        _value: {
            default: 'Do nothing',
            watch(val) {
                this.action = this._actionsLegend[val];
            },
        },
        _actions: {
            default: [
                'Do nothing',
                'Replace',
                'Save both',
                'Rename a new file',
            ],
        },
        _actionsLegend: {
            type: Object,
            default: {
                'Do nothing': 'none',
                'Replace': 'replace',
                'Save both': 'save',
                'Rename a new file': 'rename',
            },
        },
        _buttons: {
            default: [],
            watch(btns) {
                if (!this.isMultipleFiles) btns = btns.filter(b => b !== this.buttons.forAllNext);
                this.domHost.buttons = btns;
            },
        },
        buttons: {
            type: Object,
            default: {
                forAllNext: 'For all next',
                ok: 'OK',
            },
        },
    },
    attached() {
        const { domHost } = this;
        domHost.title = 'What to do?';
        domHost.icon = 'icons:help';
        this._buttons = Object.values(this.buttons);
    },
});