ODANT({
    is: 'odant-file-new-name-dialog',
    imports: [
        '@oda/button',
        '@oda/radio-group'
    ],
    template: /* html */`
    <style>
        :host {
            overflow: auto;
        }
        .container {
            min-width: 300px;
            @apply --content;
            @apply --shadow;
            width: 400px;
            max-width: 100%;
            padding: 20px;
        }
        input {
            padding: 2px 4px;
            min-height: 24px;
            width: 100%;
        }
        .error {
            @apply --error;
            border-color: var(--error-color);
        }
    </style>

    <div class="container">
        Enter new name:<br>
        <input type="text" ::newName="newName" :class="{ error: !_isLegalName(newName) }">
    </div>`,
    properties: {
        fileName: {
            default: '',
            watch(name) {
                const formatMatch = name.match(/[.][a-z0-9]+$/i);
                const format = formatMatch && formatMatch[0] || '';
                name = name.substring(0, name.length - format.length);
                const match = name.match(/_-?\d+$/);
                const isNumbered = match !== null;
                let n = 1;
                if (isNumbered) {
                    name = name.substring(0, name.length - match[0].length);
                    n = +match[0].match(/-?\d+/)[0] + 1;
                }
                let newName;
                const setName = () => {
                    newName = `${name}_${n}${format}`;
                };
                setName();

                while (this.illegalNames.reduce((res, n) => res || n.toLowerCase() === newName.toLowerCase(), false)) {
                    n++;
                    setName();
                }

                this.newName = newName;
            },
        },
        newName: {
            default: '',
            watch(name) {
                if (this.domHost) this.domHost.ok.disabled = !this._isLegalName(name);
            },
        },
        illegalNames: [],
    },
    attached() {
        const { domHost } = this;
        domHost.title = 'Rename new file';
        domHost.icon = 'icons:create';
    },
    _isLegalName(name) {
        const isExistIllegalSymbol = !!name.match(/[\\/?:*"><|]/);
        const isEmpty = !name.trim().length;
        const isDuplicateName = this.illegalNames.reduce((res, n) => res || n.toLowerCase() === name.toLowerCase(), false);

        return !(isExistIllegalSymbol || isEmpty || isDuplicateName);
    },
});