// import ODA from '../../../../oda/oda.js';
// import '../file-tree/file-tree.js';
// import '../../../../oda/components/grids/tile/tile.js';
ODANT({
    imports: [
        // '@lib/file-tree',
        '/web/core/folder/lib/file-tree/file-tree.js',
        '@oda/tile'
    ],
    is: 'odant-file-tile', extends: 'oda-tile, odant-file-tree',
    props: {
        focusedItem: Object,
        defaultTemplate: 'odant-item-node',
        showFiles: true
    },

    observers: [
        function _setTemplates(viewModes) {
            if (viewModes) {
                viewModes.find(mode => mode.name === 'table').template = 'odant-file-tile-table-item';
                viewModes.find(mode => mode.name === 'icons').template = 'odant-file-tile-icons-item';
            }
        }
    ],

    async updateContext(node) {
        if (!node) return;
        if (node.$item instanceof odaFolder) {
            const items = await this._beforeExpand(node);
            if (items) {
                this.dataSet = items;
                if (this.contextItem !== node) {
                    this._contextItem = node;
                    this.contextItem = node;
                }
            }
        } else if (node.$item instanceof odaFile) {
            const result = await node.$item.show();
        }
    }
});

import '/web/oda/components/grids/tile/tile.js'
ODA({
    // imports: '@oda/tile',
    is: 'odant-file-tile-table-item', extends: 'oda-tile-table-item',
    props: {
        _template: 'odant-item-node',
        _item: {
            get() {
                if (!this.item || !this.item.$item) return null;
                return Object.assign({}, {$item: this.item.$item, type: this.item.$item.type, size: this.item.$item.sizeText, time: this.transformTime(this.item.$item.time)});
            }
        }
    },
    transformTime(t, zone = 'ru') {
        if (t) return (new Date(t)).toLocaleString(zone);
        return ''
    }
});

ODA({
    // imports: '@oda/tile',
    is: 'odant-file-tile-icons-item',  extends: 'oda-tile-icon-item',
    props: {
        _item: {
            get() {
                return this.item.$item;
            }
        }
    },
});