class Handlers {
    add(eventType, callback) {
        this[eventType] = this[eventType] || [];
        this[eventType].push(callback);
    }
    remove(eventType, callback) {
        if (this[eventType]) {
            const idx = this[eventType].indexOf(callback);
            if (!idx) this[eventType].splice(idx, 1);
        }
    }
}
const handlers = new Handlers;
export default class Transmitter {
    on(eventType, callback) {
        handlers.add(eventType, callback);
    };
    once(eventType, callback) {
        const w = (...args) => {
            removeListener(eventType, w)
            callback(...args);
        }
        handlers.add({ eventType, w });
    };
    addListener = this.on;
    removeListener(eventType, callback) {
        handlers.remove(eventType, callback);
    };
    send(type, data, origins = '*') {
        if (this.target) {
            this.target.postMessage({ type, data }, origins);
        }
    }
    constructor(target = window.opener) {
        this.target = target;
        window.addEventListener('message', (event) => {
            const _handlers = handlers[event.data.type];
            if (_handlers) {
                for (const h of _handlers) {
                    h(event);
                }
            }
        });
    }
}