let auth_method, auth_method_name, controller;
const url = new URL(location.toString());
auth_method = url.searchParams.get('auth_method') || 'pap';
const Transmitter = import('./Transmitter.js').then(module => {
    const transmitter = new module.default();

    // автологин
    const storage = new odantLocalStorage('security');
    const login = storage.getValue('login');
    const ticket = storage.getValue('ticket');
    if (ticket) {
        transmitter.send('authorize', { login, ticket });
        window.close;
        return;
    }

    transmitter.on('close', () => window.close());
});
setTimeout(async () => {
    if (ODANT && ODANT.frameworkReady) load();
    else {
        await loadCore();
        load();
    }
}, 100);
async function load(m = { type: auth_method }) {
    auth_method = m.type;
    auth_method_name = m.name;
    controller = (await import(`./${auth_method}.js`)).default;
    controller.init(m);
    loadOtherMethods();
    const form = document.getElementById('form');
    form && (form.style.removeProperty('opacity')); //если не сделать форму вначале прозрачной будет видно как появляются oda- компоненты
}
async function loadOtherMethods() {
    const otherMethodsBlock = document.getElementById('otherMethodsBlock');
    otherMethodsBlock.innerHTML = '';
    try {
        const methods_src = await ODANT.API.request(ODANT.origin + '/api', { method: 'get_methods', version: '3.0' });

        const methods = typeof methods_src[0] === 'string'
            ? methods_src.map(type => ({ type }))
            : [...methods_src];

        if (methods && methods.length > 1) {
            for (const m of methods) {
                const b = document.createElement('oda-button');
                b.label = m.label ?? m.name ?? m.type;
                if (m.name !== auth_method_name) {
                    b.addEventListener('click', async () => {
                        controller.destroy();
                        load(m);
                    });
                } else {
                    b.toggled = true;
                }
                otherMethodsBlock.appendChild(b);
            }
            otherMethodsBlock.style.removeProperty('opacity');
        } else {
            otherMethodsBlock.style.setProperty('opacity', '0');
        }
    } catch (err) {
        otherMethodsBlock.style.setProperty('opacity', '0');
        console.warn(err);
    }
}