import Base from './auth-base.js';
class LdapAuthenticate extends Base {
    constructor() {
        super();
        this.validate = () => { };
        this.submit = async (e) => {
            e && e.preventDefault();
            const { login, password } = this;
            if (this.form.checkValidity()) {
                const params = { method: 'authentication', login: login, };
                if (this._name) params.name = this._name;
                else params.type = 'ldap';
                const ticket = await ODANT.API.request(ODANT.origin + '/api', params, password);
                if (login && ticket) {
                    const storage = new odantLocalStorage('security');
                    const res = await odaConnection._authorize(ticket);
                    storage.setValue('login', login);
                    this.transmitter.send('authorize', { login, ticket });
                    this.destroy();
                    window.close();
                }
            }
        }
    }
    init(...args) {
        super.init(...args);
        this.registerBtn.hidden = true;
        this.forgotBtn.hidden = true;
    }
}
export default new LdapAuthenticate();