(async () => {
    const Transmitter_module = await import('../Transmitter.js');
    const transmitter = new Transmitter_module.default();
    transmitter.on('close', () => window.close());

    const url = new URL(location.toString());

    const storage = new odantLocalStorage('security');
    const auth_name = storage.getValue('auth_name');
    const params = {};
    for (const key of url.searchParams.keys()) {
        params[key] = url.searchParams.get(key);
    }
    try {
        const ticket = await ODANT.API.request(ODANT.origin + '/api', { method: 'authentication', type: auth_name }, JSON.stringify({ params }));
        if (ticket) {
            await odaConnection._authorize(ticket);
            storage.setValue('ticket', ticket);
            transmitter.send('authorize', { ticket });
            window.close();
        }
    } catch (err) {
        const message = document.createElement('h3');
        message.textContent = err.toString();
        document.documentElement.innerHTML = '';
        document.body.appendChild(message);
    }

})()