import Base from './auth-base.js';
class PapAuthenticate extends Base {
    constructor() {
        super();
        this.register = async (e) => {
            if (!this.login) {
                this.loginInput.setCustomValidity('заполните это поле');
                this.loginInput.reportValidity();
                this.loginInput.focus();
                return;
            }
            const res = await this.findAccount();
            if (res) {
                this.loginInput.setCustomValidity('логин занят');
                this.loginInput.reportValidity();
                this.loginInput.focus();
                return;
            } else {
                this.loginInput.disabled = true;
                if (!this.password) {
                    this.passInput.setCustomValidity('заполните это поле');
                    this.passInput.reportValidity();
                    return;
                }
                const { login, password } = this;
                const passHash = Sha256.hash(password);
                await ODANT.API.request(ODANT.origin + '/api', { method: 'registration', login: login, type: 'email', referrer: document.URL }, passHash);
                this._setPinMode(true);
                this.passInput.focus();
                const fn = async () => {
                    if (this.password.length > 4) {
                        this.passInput.value = this.passInput.value.slice(0, 4);
                        return;
                    }
                    if (this.password.length === 4) {
                        try {
                            this.submit();
                            this.passInput.removeEventListener('input', fn);
                        } catch (err) {
                            this.passInput.setCustomValidity('неверный код');
                            this.passInput.reportValidity();
                            this.passInput.value = '';
                        }
                    }
                }
                this.passInput.addEventListener('input', fn);
            }
        };
        this.submit = async (e) => {
            e && e.preventDefault();
            const { login, password } = this;
            const res = await this.findAccount();
            if (res) {
                const passHash = Sha256.hash(password);
                try {
                    const ticket = await ODANT.API.request(ODANT.origin + '/api', { method: 'authentication', login: login }, passHash);
                    if (login && ticket) {
                        this.passInput.setCustomValidity('');
                        const storage = new odantLocalStorage('security');
                        await odaConnection._authorize(ticket);
                        storage.setValue('login', login);
                        storage.setValue('ticket', ticket);
                        this.transmitter.send('authorize', { login, ticket });
                        this.destroy();
                        window.close();
                    }
                } catch (err) {
                    this.passInput.setCustomValidity('неверный пароль');
                    this.passInput.reportValidity();
                }
            } else {
                this.loginInput.setCustomValidity('такого пользователя не существует');
                this.loginInput.reportValidity();
            }
        }
    };
    init(...args) {
        super.init(...args);
        this.registerBtn.addEventListener('click', this.register);
    };
    destroy() {
        super.destroy();
        this.registerBtn.removeEventListener('click', this.register);
    }
}
export default new PapAuthenticate();