import ODA from '../../../../oda/oda.js';

ODA({
    is: 'odant-index',
    props: {
        name: 'table',
        mask: String,
        filter: '',
        contextItem: Object,
        dataSet: {
            type: Object,
            notify: true,
        },
        size: {
            default: 0,
            notify: true
        },
        screen: Object,
        fields: {
            type: Array,
            notify: true
        },
        rows: {
            default: [],
            notify: true
        },
        index: {
            type: Object,
            set(n, o) {
                if (o) {
                    //this.unlisten(o, 'changed', this.changeHandler);
                }
                if (n) {
                    this.changeHandler = e => {
                        if (this.screen) {
                            this.screen = Object.assign({}, this.screen);
                        }
                        else {
                            this._setDataSet(this.index, this.filter, this.mask, true);
                        }
                    };
                    //this.listen(n,  'changed', this.changeHandler );
                }
            }
        }
    },
    observers: [
        async function setIndex(contextItem, name) {
            if (contextItem && contextItem.typeName === 'class' && name) {
                const index = await contextItem.getIndex(name);
                this.fields = await index.$$fields;
                this.index = index;
            }
        },
        async function loadRows(index, screen, mask, filter) {
            //this.debounce('loadRows', async () => {
                if (index && screen) {
                    screen.post.globalFilter = filter;
                    const data = await index.getRows(mask, screen.from, screen.length, screen.post);
                    this.size = data.count;
                    this.rows = data.$rows;
                    //this.set(this, 'rows', data.$rows);
                }
            //}, 100);
        },
        '_setDataSet(index, filter, mask)'
    ],
    _setDataSet(index, filter, mask = this.mask, clear) {
        if (index && this.mask && !this.screen) {
            if (clear) index.reset?.()
            this.dataSet = new odaIndexDataSet({$index: index, mask, filter});
        }
    }
})