/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

'use strict';

class CodeEditorDocument {
	
	constructor(domDocument, type) {
		this._getType = () => {
			return type;
		};
		
		this._getDocument = () => {
			return domDocument;
		};
	}
	
	get type() {
		return this._getType();
	}
	
	get document() {
		return this._getDocument();
	}
}

class CodeEditorDomModule extends CodeEditorDocument {
	constructor(domDocument) {
		super(domDocument, 'dom-module');
	}
	
	get imports() {
		this.document.querySelector('head');
	}
	
	get hearchery() {
		this.document.querySelector('template');
	}
	
	stringify() {
		return this.document.querySelector('head').innerHTML + this.document.querySelector('body').innerHTML;
	}
}

class CodeEditorHTMLDocument extends CodeEditorDocument {
	constructor(domDocument) {
		super(domDocument, 'html-document');
	}
	
	get imports() {
		this.document.querySelector('head');
	}
	
	get hearchery() {
		this.document.querySelector('body');
	}
	
	stringify() {
		return (new XMLSerializer()).serializeToString(this.document.doctype) + "\n" + this.document.querySelector('html').outerHTML;
	}
}

class CodeEditorParser {
	
	parse(text) {
		var _document = (new DOMParser).parseFromString(text, "text/html");
		
		if (_document.querySelector('dom-module')) { //(_document.doctype)
			return new CodeEditorDomModule(_document);
		} else {
			return new CodeEditorHTMLDocument(_document);
		}
	}
}