export default odaPage({
    props: {
        label: 'Open',
        allowAccess: 'r'
    }
})
ODANT({
    imports: [
        '@oda/app-layout',
        '@lib/action-bar',
        '@lib/item-node',
        '@lib/item-menu',
        '@oda/button',
        // '/web/oda/components/layouts/app-layout/app-layout.js',
        // '/web/core/item/lib/action-bar/action-bar.js',
        // '/web/core/item/lib/item-node/item-node.js',
        // '/web/core/item/lib/item-menu/item-menu.js',
        // '/web/oda/components/buttons/button/button.js'
    ],
    is: 'form',
    extends: 'odant-context, oda-app-layout',
    template: /*html*/`
    <style>
        :host([modal]){
            animation: zoom-in .2s;
            position: absolute;
            z-index: 1;
        }
        :host([modal][closing]){
            animation: zoom-out .25s;
        }
    </style>
<!--    <div slot="title" class="horizontal bold flex" style="justify-content: center; align-self: center; padding: 2px;">-->
        
<!--    </div>-->
    <div slot="top-left" class="horizontal between" ~style="{ minHeight: _iconSize + 'px', maxHeight: _iconSize * 2 + 'px' }" style="align-items: flex-end; overflow: hidden;" @contextmenu="_topContextMenu">
        <odant-item-node hide-prefix allow-expand class="no-flex font-150" :context-item="contextItem"></odant-item-node>
        <odant-action-bar ~show="allowButtons || (view && view.allowButtons)" :icon-size groups="button" :context-item="contextItem || actionSource"></odant-action-bar>
        <odant-action-bar ~show="focusedItem && (allowButtons || (view && view.allowButtons))" :icon-size groups="button" :context-item="focusedItem"  style="border-left: 1px solid gray;"></odant-action-bar>
    </div>
    <oda-button icon-pos="right" :label="view?.label || ''" ref="viewsBtn" slot="top-right" ~show="_getShowViews(hideViews, view)" ref="viewBtn" allow-toggle ::toggled="menuOpened" icon="icons:apps" :title="_buttonViewsTitle" :icon-size></oda-button>
<!--    <odant-item-menu ref="menu" ::opened="menuOpened" title="Select view..." groups="odaView" :context-item="contextItem || actionSource" :parent="$refs.viewBtn"></odant-item-menu>-->
<!--    <div class="flex vertical" slot="main" style="overflow: hidden; height: 0px;">-->
<!--        <slot name="body"></slot>-->
<!--        <slot></slot>-->
<!--    </div>-->
    <div slot="bottom" class="horizontal header between bottom">
        <div class="horizontal flex">
            <odant-action-bar ~show="view && view.allowServices" ref="serviceBar" allow-labels :icon-size groups="service" :context-item="focusedItem || contextItem || actionSource" class="raised"></odant-action-bar>
            <div class="horizontal flex service-bar" style="align-items: center; z-index: 10;">
                <slot name="service-bar"></slot>
            </div>
        </div>
        <div class="no-flex horizontal modal">
            <oda-button ~show="view && view.allowSave" :disabled="_disableSave || !contextItem || !contextItem.isChanged || !contextItem.access.allowWrite" style="background-color: green; color: white" :icon-size label="Apply" @down.stop="_save"></oda-button>
            <oda-button ~show="modal" class="raised bold" :icon-size label="OK" @tap="_ok"></oda-button>
        </div>
    </div>`,
    // <div :is="view?.defaultViewName || 'div'" ref="ctrl" :slot="control ? 'main' : '?'"></div>
    props: {
        closing: {
            type: Boolean,
            reflectToAttribute: true
        },
        icon: {
            get() {
                return this.contextItem && this.contextItem.icon;
            }
        },
        iconSize: {
            default: 24,
            shared: true
        },
        _iconSize: {
            type: Number,
            get() {
                return this.iconSize + 8;
            }
        },
        menuOpened: {
            default: false,
            async set(n) {
                if (n) {
                    await this.contextItem.import('lib/item-menu/item-menu.js');
                    await ODA.showDropdown('odant-item-menu', { contextItem: this.contextItem, groups: 'view' }, { parent: this.$refs.viewsBtn });
                    this.menuOpened = false;
                }
            }
        },
        allowClose: false,
        viewName: '',
        titleLabel: {
            get() {
                return this.contextItem && this.contextItem.labelPath;
            }
        },
        hideToolbar: {
            type: Boolean,
            reflectToAttribute: true,
            default: false
        },
        _disableSave: false,
        contextItem: {
            type: Object,
            async watch(n, o) {
                this.debounce('contextItemChanged', async () => {//временное решение
                    if (o) {
                        this.unlisten('message', '_onmessage', {target: window});
                    }
                    if (n) {
                        this.listen('message', '_onmessage', { target: window });
                        const name = this.viewName || n.defaultViewName;
                        const actions = (await n.getActions()).filter(i=>i.typeName === 'view');
                        this.view = actions.find(i => i.name === name);
                        if(!this.view){
                            console.warn(`View "${name}" not found!`);
                            this.view = actions[0];
                        }
                    }
                }, 100);
            }
        },
        actionSource: {
            type: Object,
        },
        focusedItem: {
            type: Object,
        },
        modal: {
            type: Boolean,
            default: false,
            reflectToAttribute: true,
        },
        view: {
            type: Object,
            async watch(view, o) {
                if (o && this.control) {
                    this.control.setProperty('slot', '?');
                    this.control.contextItem = null;
                    this.control.remove();
                    this.control = null;
                    this.focusedItem = null;
                }
                if (view) {
                    try {
                        this.hideToolbar = view.hideToolbar;
                        this.control = await view._control;
                        this.control.contextItem = this.contextItem;
                        this.control.setProperty('slot', 'main');
                        this.appendChild(this.control);
                        this.focusedItem = this.control.focusedItem;
                        this.fire('form-loaded', this);
                    }
                    catch (err) {
                        this.control = this.create('odant-error-view', { view: view });
                        console.warn(err);
                    }
                }
            },
        },
        _buttonViewsTitle: {
            type: String,
            get() {
                if (this.view && this.view.label) return `View selector (${this.view.label})`;

                return '';
            }
        },
        control: {
            type: HTMLElement,
            // notify: true,
            // watch(control, old) {
            //     if (old) {
            //         //this.unlisten(old, 'focused-item-changed', '_focused');
            //         this.removeChild(old);
            //     }
            //     if (control) {
            //         //this.listen(control, 'focused-item-changed', '_focused');
            //         this.async(() => {
            //             control.iconSize = this.iconSize;
            //             this.appendChild(control);
            //             control.render();
            //             this.render();
            //             this.async(() => {
            //                 if (control.leftDrawer) {
            //                     Object.keys(control.leftDrawer).forEach(k => {
            //                         this.set(this.left, k, control.leftDrawer[k]);
            //                     })
            //                 };
            //                 if (control.rightDrawer) {
            //                     Object.keys(control.rightDrawer).forEach(k => {
            //                         this.set(this.right, k, control.rightDrawer[k]);
            //                     })
            //                 };
            //                 this.left.opened = this.__read(`${this.settingsId}/left/opened`, this.left.opened);
            //                 this.right.opened = this.__read(`${this.settingsId}/right/opened`, this.right.opened);
            //                 this.left.width = this.__read(`${this.settingsId}/left/width`, this.left.width);
            //                 this.right.width = this.__read(`${this.settingsId}/right/width`, this.right.width);
            //             }, 100);
            //         }, 100)
            //     }
            // },
        },
        settingsId: {
            type: String,
            get() {
                if (this.contextItem && this.view)
                    return `${(this.contextItem.$class || this.contextItem).path.slice(1)}/${this.view.name}`;

                return this.localName;
            }
        },
        allowButtons: Boolean,
        hideViews: Boolean
    },
    _topContextMenu(e) {
        const menu = this.create('odant-item-menu', {
            contextItem: this.contextItem,
            groups: '*',
            collapseLimit: 3
        });
        menu.open({ hideTitle: false });
    },
    _beforeUnload(e) {
        if (this.contextItem && this.view && this.view.allowSave && this.contextItem.currentState && this.contextItem.isChanged) {
            if (e.type === 'beforeunload') {
                const confirmationMessage = "\o/";
                (e || window.event).returnValue = confirmationMessage;
                return confirmationMessage;
            } else {
                this._close();
            }
        }
    },
    async _onmessage(e) {
        const data = e.data;
        if (data.action && data.action === 'close' && data.src === location.href && data.id === this.contextItem.path) {
            e.stopPropagation();
            const dirtyForms = Array.prototype.filter.call(document.body.children, (c) => c.localName === 'odant-form' && c !== this && c.contextItem && c.contextItem.isChanged);
            if (dirtyForms.length) {
                try {
                    for (const df of dirtyForms) {
                        const res = await df._close();
                        if (!res) return;
                    }
                    window.parent !== window && window.parent.postMessage({ action: 'form-close', id: this.contextItem.path }, '*');
                } catch (e) {
                    this._close(undefined, undefined, true);
                }
            } else {
                this._close(undefined, undefined, true);
            }
        }
    },
    ___render() {
        this.render();
    },
    showView(view) {
        if (view) {
            if (view.$owner?.path && view.$owner?.path === this.contextItem?.path) {
                this.view = view;
            } else {
                let parent = this.domHost;
                while (parent && !parent.showView) {
                    parent = parent.domHost;
                }
                if (parent) {
                    parent.showView(view);
                } else {
                    if (window.parent !== window) {
                        window.parent.postMessage({ action: 'show-view', id: view.$owner.path, view: view.name }, '*');
                    }
                }
            }
        }
    },
    showItem(contextItem) {
        if (this.domHost && this.domHost.showItem) return this.domHost.showItem(contextItem);
        if (window.parent !== window) {
            window.parent.postMessage({ action: 'show-item', id: contextItem.path }, '*');
        } else {
            contextItem.show();
        }
    },
    _focused(e) {
        this.focusedItem = e.detail.value;
    },
    // _parent() {
    //     return this.$refs.viewBtn;
    // },
    _getContext(item, opened) {
        if (opened)
            return item;
    },
    _rightToggle(e) {
        this.$super('oda-app-layout', '_rightToggle', e);
        if (this.contextItem && this.view) {
            this.__write(`${this.settingsId}/right/opened`, this.right.opened);
        }
    },
    async ready() {
        this.params = new URLSearchParams(window.location.search);
        this.viewName = this.params.get('view') || this.viewName;
        //await this.$nextTick();
        // this.hideToolbar = ODANT.getBool(this.params.get('hideToolbar'));
    },
    attached() {
        if (this.parentElement === document.body && ODA.mainWindow === window && !this.contextItem instanceof odaObject) {
            this.showTitle = true;
        }
    },
    detached() {
        this.control = null;
    },
    _selectView(e, d) {
        this.$.layout._rightToggle();
        if (e.model && e.model.node)
            this.view = e.model.node.data;
        this._scrollTop = 0;
    },
    show(modal = false) {
        this.modal = true;
        document.body.appendChild(this);
        return new Promise((resolve, reject) => {
            this.resolve = resolve;
            this.reject = reject;
            this.addEventListener('modal-result', e => {
                e.stopPropagation();
                if (e.detail) {
                    resolve(this.control);
                    this._close();
                } else {
                    this.view.getModalResult(this.control).then(res => {
                        resolve(res);
                        this._close();
                    });
                }
            })
        })
    },
    showDialog() {
        return this.show(true);
    },
    async _close(e, d, externally = false) {
        const needMessage = externally && parent !== window;

        if (this.view && this.view.allowSave && this.contextItem.currentState && this.contextItem.isChanged) {
            try {
                const ctrl = this.create('odant-form-close-confirm');
                const buttons = [
                    {
                        label: 'Yes',
                        style: { 'color': 'var(--success-color)' },
                        left: true,
                        action: async () => {
                            await this._save();
                            needMessage && parent.postMessage({ action: 'form-close', id: this.contextItem.path }, '*');
                        }
                    },
                    {
                        label: 'No',
                        action: async () => {
                            this.contextItem.reset();
                            this.contextItem.reset(['body', 'Root']);
                            this.contextItem.reload && await this.contextItem.reload();
                            needMessage && top.postMessage({ action: 'form-close', id: this.contextItem.path }, '*');
                        }
                    }
                ];
                const title = this.contextItem.labelPath || this.contextItem.displayLabel;
                const subTitle = this.contextItem.name;
                const res = await ODA.showDialog(ctrl, { buttons, title, subTitle, fixWidth: true });
                await res.button.action();
            } catch (e) {
                return;
            }
        }
        this.closing = true;
        if (this.reject) {
            this.reject();
        }
        // this.async(() => {
            if (this.modal) {
                this.remove();
            } else if (this.parentElement === document.body) {
                if (window.parent === window) {
                    window.close();
                }
                else {
                    let myEvent = new CustomEvent("form-close", {
                        detail: this.contextItem,
                        bubbles: true,
                        cancelable: false
                    });
                    document.dispatchEvent(myEvent);
                    needMessage && parent.postMessage({ action: 'form-close', id: this.contextItem.path }, '*');
                }
            }
        // }, 200)
        return true;
    },
    async _save() {
        if (this.view && this.view.allowSave && this.contextItem && this.contextItem.isChanged) {
            return await new Promise(async (res, rej) => {
                try {
                    this._disableSave = true;
                    const callback = () => {
                        this.debounce('await save', () => {
                            this.unlisten(this.contextItem, 'saved', callback);
                            res(this.contextItem);
                        }, 300);
                    }
                    this.listen(this.contextItem, 'saved', callback);
                    await this.contextItem.save();
                } catch (err) {
                    const ctrl = this.create('odant-form-save-error');
                    ctrl.message = err.message;
                    await ODA.showDialog(ctrl, { title: err.name, icon: err.icon });
                    throw err;
                    rej(err);
                } finally {
                    this.async(() => {
                        this._disableSave = false;
                    }, 1000);

                }
            });
        }
    },
    async _ok() {
        await this._save();
        if (this.resolve) {
            this.resolve(this.control || this.focusedItem);
        }
        this._close();
    },
    _getShowViews(hideViews, view) {
        if (view && !hideViews) return !view.hideViews;
        return !hideViews;
    }
});

ODANT({
    is: 'error-view',
    template: /*html*/ `
    <div class="vertical flex" style="align-items: center; justify-content: center;">
        <span style="margin-bottom: 8px;">{{_getText()}}</span>
        <oda-button ~if="view" class="raised" icon="icons:build" label="fix it in app-studio" @tap="_tap"></oda-button>
    </div>`,
    props: {
        view: Object
    },
    _getText() {
        if (this.view)
            return 'Error ' + this.view.name+ ' in '// + this.view.$owner.displayLabel
    },
    _tap() {
        this.view.scriptFolder.open('app-studio');
    }
});

ODANT({
    is: 'form-close-confirm',
    template: /*html*/ `
    <style>
        :host{
            @apply --vertical;
            padding: 16px 8px;
        }
    </style>
    <span>Save before closing?</span>`,
});

ODANT({
    is: 'form-save-error',
    template: /*html*/ `
    <style>
        :host{
            @apply --vertical;
            padding: 16px 8px;
        }
    </style>
    <span>{{message}}</span>`,
    props: {
        message: 'Unhandled error'
    },
});