export default odaView({
    props: {
        category: 'developer',
        label: 'JSON editor',
        icon: 'files:json',
        allowSave: true,
        allowButtons: false,
        allowUse() {
            if (this.$owner instanceof odaClass || this.$owner instanceof odaBase || this.$owner instanceof odaWorkPlace || this.$owner instanceof odaObject)
                return true;
            return false;
        }
    }
})

ODANT({
    is: 'json-editor',
    imports: [
        '@oda/ace-editor',
        '@oda/button',
        '@oda/splitter'
    ],
    template: /*html*/`
        <script src="/web/core/item/client/views/json-editor/oda-editor.js"></script>
        <script src="/web/core/item/client/views/json-editor/sax-min.js"></script>
        <oda-button slot="top-right" :icon-size="iconSize" ::toggled="wrap" icon="editor:wrap-text" title="Wrap text" allow-toggle></oda-button>
        <oda-ace-editor ::wrap="wrap" :mode="mode" ::value="value" ref="editor"></oda-ace-editor>
    `,
    props: {
        iconSize: 24,
        wrap: true,
        contextItem: {
            type: Object,
            async set(item, old) {
                if (old) {
                    this.value = '';
                }
                if (item) {
                    //let data;
                    if (item.body) await item.body;
                    this.mode = 'json';
                    this.value = JSON.stringify(item.ROOT, null, '\t');
                }
            }
        },
        mode: '',
        value: {
            type: String,
            set(n) {
                if (this.contextItem) {
                    this.contextItem.data = n;
                }
            }
        },
    },
})