import '/web/oda/components/layouts/accordion/accordion.js';
import '/web/core/item/lib/item-tree/item-tree.js';
import '/web/core/folder/lib/file-tree/file-tree.js';

ODA({
    is: 'oda-xquery-sources',
    template: /*html*/`
            <style>
            :host {
                @apply --vertical;
                @apply --flex;
                overflow: hidden;
            }
        </style>
        <oda-item-node :size="iconSize * 1.5" :style="{borderBottom: contextItem === focusedItem?'2px solid blue':'2px solid transparent'}" class="left-header no-flex" :active="contextItem === focusedItem" :context-item @tap.stop="focusedItem = contextItem"></oda-item-node>
        <oda-accordion ::selected="selected">
            <!--<oda-accordion-item :label="[[contextItem.itemTypeLabel]]" icon="[[contextItem.icon]]" hidden$="[[contextSourceItems.length]]">-->
                <!--<odant-xquery-context-source context-item="[[contextItem]]" items="{{contextSourceItems}}" focused-item="{{focusedIndex}}"></odant-xquery-context-source>-->
            <!--</oda-accordion-item>-->

            <oda-accordion-item label="indexes" icon="av:library-books">
                <div class="vertical flex" style="overflow: hidden;">
                    <oda-item-tree item-source-names="$indexes" :context-item="contextItem" allow-focus ::focused-item="focusedItem"></oda-item-tree>
                </div>
            </oda-accordion-item>

            <!--<oda-accordion-item label="objects" icon="enterprise:contract" hidden$="[[!objects.length]]">-->
                <!--<odant-object-tree hide-root context-item="[[contextItem]]" focused-item="{{focusedObject}}" allow-classes allow-packets nodes="{{objects}}"></odant-object-tree>-->
            <!--</oda-accordion-item>-->

            <oda-accordion-item label="files" icon="editor:insert-drive-file">
                <div class="vertical flex" style="overflow: hidden;">
                    <oda-file-tree :context-item="contextItem" ::focused-item="focusedItem" show-files file-extensions="json,xml,oml,ocl"></oda-file-tree>
                </div>
            </oda-accordion-item>

        </oda-accordion>
    `,
    props: {
        iconSize: 24,
        indexes: [],
        contextItem: null,
        focusedItem: {
            default: null,
            notify: true
        },
        selected: -1
    }
})
