import '/web/oda/components/layouts/accordion/accordion.js';
import '/web/core/item/lib/xml-tree/xml-tree.js';
import '/web/core/item/lib/item-tree/item-tree.js';

ODA({
    is: 'oda-xquery-tools',
    template: /*html*/`
        <style>
            :host {
                @apply --vertical;
                @apply --flex;
            }
        </style>
        <oda-accordion ref="accord" selected="0">
            <oda-accordion-item label="XQuery functions" ~if="functions.length">
                <div>
                    <odant-item-tree hide-root allow-classes allow-packets itemsList='$$objects' :context-item="sourceItem" allow-drag :data-set="functions">
                    </odant-item-tree>
                </div>
            </oda-accordion-item>
            <oda-accordion-item label="Filed structure">
                <div>
                    <odant-item-tree itemsList='$$fields' :context-item="contextItem && contextItem.$class"></odant-item-tree>
                </div>
            </oda-accordion-item>
            <oda-accordion-item label="XML structure">
                <div>
                    <odant-xml-tree :context-item></odant-xml-tree>
                </div>
            </oda-accordion-item>
        </oda-accordion>
    `,
    props: {
        contextItem: Object,
        functions: []
    }
})
