ODANT({
    is: "odant-field-tree",
    imports: [
        '@lib/item-tree',
        '@lib/action-bar'
    ],
    extends: 'odant-item-tree',
    props: {
        allowActions: false,
        allowFocus: true,
        allowSelection: true,
        allowDrag: true,
        hideRoot: true,
        itemsList: '$$fields',
        // cols: {
        //     get() {
        //         const cols = [{ name: this.keyName, treeMode: true }];
        //         this.groups = [{ name: 'group' }];
        //         return cols;
        //     }
        // },
        // defaultTemplate: 'odant-field-tree-cell',
        // defaultGroupTemplate: 'odant-field-tree-group'
    },
});

ODANT({
    is: 'odant-field-tree-group',
    imports: '@oda/table',
    extends: 'oda-table-expand',
    template: /* html */`
    <style>
        :host{
            @apply --horizontal;
            @apply --flex;
            @apply --header;
            margin-bottom: 1px;
            min-height: 32px;
            flex: 1 1 !important;
        }
        oda-item-node{
            max-width: 120px;
            min-width: 120px;
            @apply --no-flex;
            padding: 2px;
            fill: white;
            width: 120px;

        }
        *{
            color: white;
        }
        .divider{
            margin: 8px;
            border: 1px solid gray;
            width: 0px;
            transform: rotate(15deg);
        }
        :host>div>div{
            align-items: center;
        }
    </style>
    <div class="vertical flex header">
        <div class="flex horizontal">
            <odant-item-node :size="iconSize" @tap.stop="_toggleExpand()" style="font-size: x-large" hide-prefix hide-suffix :context-item="contextItem" menu-groups="admin"></odant-item-node>
            <odant-action-bar ~show="_showActions(table && table.allowActions)" :size="iconSize/1.5" auto-hide class="header flex" groups="admin" class="content" :context-item="contextItem"></odant-action-bar>
        </div>
        <div ~show="_showActions(table && table.allowActions)" ~for="i in  fields" class="horizontal  flex" @down.stop="" style="align-items: center">
            <odant-item-node :size="iconSize" hide-prefix hide-suffix disabled :context-item="i"></odant-item-node>
            <odant-action-bar :size="iconSize/1.5" auto-hide class="header flex" groups="admin" class="content" :context-item="i"></odant-action-bar>
        </div>
    </div>`,
    props: {
        contextItem: {
            type: Object,
            get() {
                return this.item.items && this.item.items[0] && this.item.items[0].$item && this.item.items[0].$item.$group || {};
            }
        },
        selectedItem: {
            type: Object,
            watch(item, old) {
                const fields = [];
                if (item) {
                    let i = item;
                    while (i && i !== this.contextItem) {
                        fields.push(i);
                        i = i.$owner;
                    }
                    fields.reverse();
                }
                this.fields = fields;
            }
        },
        fields: {
            type: Array,
            value() {
                return []
            }
        }
    },
    observers: [
        function _tableItemChanged(table, item) {
            if (!table || !(table instanceof EventSource) || !item) return;

            this.listen(table, 'selection-changed', '_setSelectedItem');
            if (table.items.indexOf(item) === 0 && !item.$expanded) {
                this._toggleExpand();
            }
        }
    ],
    _showActions() {
        return this.table.allowActions && this.table.contextItem && this.table.contextItem.adminMode;
    },
    _setSelectedItem(e, d) {
        const array = e.detail.value.filter(i => {
            let item = i.$item;
            while (item) {
                if (item === this.contextItem)
                    break;
                item = item.$owner;
            }
            return !!item;
        }).map(i => i.$item);
        if (array.length) {
            this.selectedItem = ((array.length === 1) ? array[0] : new odaItemList({ items: array }));
        }
        else {
            this.selectedItem = null;
        }
    },
    detached() {
        this.unlisten(this.table, 'selection-changed', '_setSelectedItem');
    }
});

ODANT({
    is: 'odant-field-tree-cell',
    imports: [
        '@oda/table',
        '@lib/item-node'
    ],
    extends: 'oda-table-cell-base, odant-item-node',
    props: {
        showName: true,
        hidePrefix: true,
        allowAdmin: false,
    }
});