ODANT({
    is: 'odant-xml-tree',
    imports: [
        '@oda/tree'
    ],
    extends: 'oda-tree',
    props: {
        allowDrag: true,
        contextItem: {
            type: Object,
            async watch(item) {
                if (item) {
                    this.dataSet = this._createItems(await item.request('structure'));
                    this.expandAll();
                }
                else {
                    this.dataSet = null;
                }
            }
        },
        defaultTemplate: {
            type: String,
            default: 'odant-xml-tree-attribute'
        }
    },
    _createItems(json, parent = '/') {
        let items = [];
        if (json.$DOC) {
            return this._createItems(json.$DOC[0])
        }
        if (json.$A) {
            items = json.$A.map(a => ({
                path: parent + '@' + a.n,
                label: '@' + a.n
            }));
        }
        if (json.$E) {
            items.push(...json.$E.map((e) => ({
                path: parent + e.n,
                count: Number(e.c).toLocaleString(),
                label: '<' + e.n + '>',
                template: 'odant-xml-tree-element',
                items: this._createItems(e, parent + e.n + '/')
            }
            )));
        }
        return items.length ? items : undefined;
    }
});

ODA({
    is: 'odant-xml-tree-attribute',
    // extends: 'oda-table-cell',
    template: /*html*/`
        <style>
            :host{
                color: blue;
                font-size: 100%;
                font-family: 'Droid Sans Mono', monospace;
                @apply --no-flex;
                @apply --horizontal;
                align-items: center;
            }
        </style>
        <span>{{item?.label}}</span>`,
    props: { item: Object }
});

ODA({
    is: 'odant-xml-tree-element',
    extends: 'odant-xml-tree-attribute',
    template: /*html*/`
        <style>
            :host{
                color: brown;
            }
            .label{
                font-weight: bold;
                font-size: 100%;
                color: gray;
            }
        </style>
        <span class="label">{{item?.count}}</span>`
});