(class extends odaAction {
  execute(params = {}) {
    return new Promise((resolve, reject) => {
      try {
        let sax = require(this.resolveUrl('sax-lib.js'));
        // const parser = sax.parser(true);
        // parser.onerror = function (e) {
        //   // an error happened.
        // };
        // parser.ontext = function (t) {
        //   // got some text.  t is the string of text.
        // };
        // parser.onopentag = function (node) {
        //   // opened a tag.  node has "name" and "attributes"
        // };
        // parser.onattribute = function (attr) {
        //   // an attribute.  attr has "name" and "value"
        // };
        // parser.onend = function () {
        //   // parser stream is done, and ready to have more stuff written to it.
        //   resolve();
        // };
        let dataRow = '';
        let group = '';
        let streamDict = {};

        let saxStream = sax.createStream(true);
        saxStream.on("error", function (e) {
          // unhandled errors will throw, since this is a proper node
          // event emitter.
          console.error("error!", e)
          // clear the error
          this._parser.error = null
          this._parser.resume()
        });
        saxStream.on("text", function (t) {
          // got some text.  t is the string of text.
        });
        saxStream.on("opentag", function (node) {
          // opened a tag.  node has "name" and "attributes"
          if (node.name != params.dataNode) {
            return;
          }

          group = '';
          dataRow = '<OBJECT';
        });
        saxStream.on("closetag", function (node) {
          // closed a tag.  node has "name" and "attributes"
          if (dataRow.length > 0) {
            dataRow += '/>';

            let stream;
            for (let key in Object.keys(streamDict)) {
              if (key != group) {
                continue;
              }

              stream = streamDict[key];
              break;
            }

            if (stream == null) {
              stream = fs.createWriteStream(`D://Temp//${group}.xml`);
              streamDict[group] = stream;
            }

            stream.write(dataRow);
          }
        });
        saxStream.on("attribute", function (attr) {
          // an attribute.  attr has "name" and "value"
          if (dataRow.length > 0) {
            let value = attr.value.replace('<', '&lt;')
              .Replace('>', '&gt;')
              .Replace('&', '&amp;')
              .Replace('\'', '&apos;')
              .Replace('"', '&quot;');
            dataRow += ` ${attr.name}="${value}"`;

            if (attr.name == params.packAttr) {
              group = value.substr(0, 5);
            }
          }
        });
        saxStream.on("end", function () {
          // parser stream is done, and ready to have more stuff written to it.
          resolve(streamDict);
        });
        // pipe is supported, and it's readable/writable
        // same chunks coming in also go out.
        fs.createReadStream(params.filePath)
          .pipe(saxStream);

        return `выполнен метод SAX: ${JSON.stringify(params)} in ${this.$item}`;
      } catch (e) {
        reject(e);
      }
    });
  }
}).register();