(() => {
    'use strict';
    const YANDEX_TRANSLATE_KEY = 'trnsl.1.1.20170815T113812Z.3867b739e14a8066.c581f62184ab231363d6af49ad885cdbcd9d158c';
    const TRANSLATE_URL = 'https://translate.yandex.net/api/v1.5/tr.json/translate?key=' + YANDEX_TRANSLATE_KEY;
    (class extends odaAction {
        execute(params) {
            return this.translate(params.text, params.lang);
        }
        async translate(text, lang) {
            try {
                let url = encodeURI(TRANSLATE_URL + '&lang=' + (lang || 'en') + '&text=' + text);
                const request = await fetch(url);
                if (request.status === 200) {
                    const json = await request.json();
                    return json.text && json.text.length > 0 && json.text[0];
                } else {
                    const json = await request.json();
                    const message = `status: ${request.status}; code: ${json.code}; message: ${json.message}`;
                    console.error(message);
                    return message;
                }
            }
            catch (e) {
                console.error(e);
            }
        }
    }).register();
})();
