(class extends odaButton {
    static get properties() {
        return {
            label() {
                return 'Copy ' + this.contextItem.itemTypeLabel;
            },
            zIndex: -2,
            allowAccess: 'C',
            icon: 'icons:content-copy',
            allowArrayContext: true
        }
    }
    async execute() {
        let cls = this.$item.$class;
        while (cls && cls.$owner && !(cls.$owner instanceof odaDomain) && cls.$owner.access.allowCreate) {
            cls = cls.$owner;
        }

        const classes = await cls.Items;
        if (classes.length === 1) {
            cls = classes[0];
        } else if (classes.length > 1) {
            let tree = await ODA.createComponent('/web/core/structure/lib/structure-tree/structure-tree.html');
            tree.contextItem = cls;
            tree.allowFocus = true;
            tree.addEventListener('structure-tree-ready', () => {
                tree.expandItem = this.$item.$class;
            });

            try {
                await ODA.showDialog(tree, { dblclick: true });
                cls = tree.focusedItem;
            } catch (e) {
                return null;
            }
        }

        const obj = await cls.createObject(this.$item.body);
        return obj.show();
    }
}).register();