/**
 * Created by Roman Perepelkin on 01.10.2016.
 */
'use strict';

// const getGlobalThis = () => {
//     if (typeof self !== 'undefined') return self;
//     if (typeof window !== 'undefined') return window;
//     if (typeof global !== 'undefined') return global;
//     if (typeof this !== 'undefined') return this;
//     throw new Error('Unable to locate global `this`');
// };
// var globalThis = getGlobalThis();


if (typeof globalThis === 'undefined') {
    if (typeof window === 'undefined')
        global.globalThis = global;
    else
        window.globalThis = window;
}

if (globalThis.NODEPATH === undefined)
    globalThis.NODEPATH = '';

if (!globalThis.ODANT) {
    const getDescriptor = Object.getOwnPropertyDescriptor;
    // DATE ==================================================

    if (!Date.prototype.addDays) {
        Object.defineProperty(Date.prototype, 'addDays', {
            enumerable: false, value: function (num) {
                let value = this.valueOf();
                value += 86400000 * num;
                return new Date(value);
            }
        });
    }

    if (!Date.prototype.addSeconds) {
        Object.defineProperty(Date.prototype, 'addSeconds', {
            enumerable: false, value: function (num) {
                let value = this.valueOf();
                value += 1000 * num;
                return new Date(value);
            }
        });
    }

    if (!Date.prototype.addMinutes) {
        Object.defineProperty(Date.prototype, 'addMinutes', {
            enumerable: false, value: function (num) {
                let value = this.valueOf();
                value += 60000 * num;
                return new Date(value);
            }
        });
    }

    if (!Date.prototype.addHours) {
        Object.defineProperty(Date.prototype, 'addHours', {
            enumerable: false, value: function (num) {
                let value = this.valueOf();
                value += 3600000 * num;
                return new Date(value);
            }
        });
    }

    Date.isLeapYear = function (year) {
        return (((year % 4 === 0) && (year % 100 !== 0)) || (year % 400 === 0));
    };

    Date.getDaysInMonth = function (year, month) {
        return [31, (Date.isLeapYear(year) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month];
    };

    if (!Date.prototype.isLeapYear) {
        Object.defineProperty(Date.prototype, 'isLeapYear', {
            enumerable: false, value: function () {
                return Date.isLeapYear(this.getFullYear());
            }
        });
    }

    if (!Date.prototype.getDaysInMonth) {
        Object.defineProperty(Date.prototype, 'getDaysInMonth', {
            enumerable: false, value: function () {
                return Date.getDaysInMonth(this.getFullYear(), this.getMonth());
            }
        });
    }

    if (!Date.prototype.addMonths) {
        Object.defineProperty(Date.prototype, 'addMonths', {
            enumerable: false, value: function (num) {
                const n = this.getDate();
                this.setDate(1);
                this.setMonth(this.getMonth() + num);
                this.setDate(Math.min(n, this.getDaysInMonth()));
                return this;
            }
        });
    }
    globalThis.TimeSpan = globalThis.TimeSpan || class TimeSpan extends Date {
        toString() {
            let res = '';
            // const y = this.getFullYear();
            // if (y)
            //     res += y + ' years ';
            // const m = this.getMonth();
            // if (m)
            //     res += m + ' month ';
            // const d = this.getDay();
            // if (d)
            //     res += d + ' days ';
            const hh = this.getHours() + (this.getTimezoneOffset() / 60);
            if (hh)
                res += hh + ' hours ';
            const mm = this.getMinutes();
            if (mm)
                res += mm + ' min ';
            const ss = this.getSeconds();
            if (ss)
                res += ss + ' sec ';
            const ms = this.getMilliseconds();
            if (ms)
                res += ms + ' ms ';
            return res;
            // return (y?(y + ' years'):'' + m?(' ' + m + ' month'):'' + d?(' ' + d + ' days'):'' + hh?(' ' + hh +' hours'):'' + mm?(' ' + mm + ' min'):'' + ss?(' ' + ss +' sec'):'' + ms?(' ' + ms +' ms'):'');
        }
    };
    //
    // // NUMBER TYPE ===================================================
    //
    // Number.prototype.getFormattedValue = (format) =>{
    //     return format + ' отформатировано число ';
    // };
    //
    //
    // Object.defineProperty(Number, "formats", {
    //     get () {
    //         return ["Decimal", "Integer", "Percent", "Currency", "Text"]
    //     }
    // });

    // JSON ====================================

    JSON.selectNodes = function (json, path) {
        return [json];
    };

    JSON.selectSingleNode = function (json, path, force) {
        if (!path || !json)
            return json;
        path = path.split('/');
        let step = path.shift();
        if (step) {
            switch (step) {
                case 'CDATA()':
                    return json['$CDATA$'];
                case 'TEXT()':
                    return json['$TEXT$'];
                default: {
                    if (step[0] === '@') {
                        return json[step.substring(1)];
                    }
                    else {
                        json = json['$' + step];
                        if (json && Array.isArray(json) && json.length > 0) {
                            return JSON.selectSingleNode(json[0], path.join('/'));
                        }
                    }
                }
                    break;
            }
        }
        return undefined;
    };

    globalThis.RequestError = globalThis.RequestError || class RequestError extends Error {
        constructor(response, message) {
            super(message);

            this.errorCode = response.headers.get('odant-error-code');
            this.status = response.status;
            this.statusText = response.statusText;
            this.url = response.url;
        }
    };


    globalThis.loadCore = globalThis.loadCore || async function () {
        let path = ODANT.webMode ? '/web/core' : (ODANT.DEFAULTORIGIN + '/web/core');
        if (ODANT.serverSide) {
            if (!globalThis.OLD_SERVER) {
                const modules = [
                    { name: 'node-fetch', alias: 'fetch' },
                    { name: 'request' },
                    { name: 'node-fetch/lib/headers.js', alias: 'Headers' },
                    { name: 'websocket', alias: 'WebSocket', extract: module => module.default.w3cwebsocket },
                    { name: 'form-data', alias: 'FormData' },
                    { name: 'numeral' },
                    { name: 'node-html5-file', alias: 'File' },
                    { name: 'url', alias: 'URL' },
                    { name: 'util'},
                    { name: 'vm' },
                    { name: 'transliteration', alias: 'slugify', extract: module => module.default.slugify },
                    { name: 'transliteration', alias: 'transliteration', extract: module => module.default.transliterate },
                ];
                const ps = modules.map(async m => {
                    try {
                        return {
                            name: m.alias || m.name,
                            extract: m.extract,
                            module: await import(m.name)
                        }
                    } catch (err) {
                        console.error(err);
                    }
                });
                (await Promise.all(ps)).forEach(m => {
                    if (!(m.name in globalThis)) {
                        Object.defineProperty(globalThis, m.name, {
                            value: (m.extract && m.extract(m.module)) || m.module.default
                        });
                    }
                });
                globalThis.vmModuleLinker = globalThis.vmModuleLinker || async function (specifier, referencingModule) {
                    if (specifier.startsWith('http')) {
                        try {
                            const res = await fetch(specifier);
                            const src = await res.text();
                            const context = vm.createContext((referencingModule && referencingModule.context) || globalThis);
                            const m = new vm.SourceTextModule(src, { context, identifier: specifier });
                            await m.link(globalThis.vmModuleLinker);
                            await m.evaluate();
                            return m;
                        } catch (err) {
                            console.error(err);
                        }
                    } else {
                        let up;
                        if (referencingModule.initializeImportMeta) {
                            up = referencingModule.initializeImportMeta.meta.url;
                        } else if (referencingModule.identifier) {
                            up = referencingModule.identifier;
                        }
                        if (typeof up === 'string') {
                            const path = (await import('path')).default;
                            const { dir: root } = path.parse(up);
                            const { base: file } = path.parse(specifier);
                            const url = path.join(root, file).replace(/(?<=https?:)\/(?!\/)/, '//'); //path заменяет // после http: на /
                            if (url.startsWith('http')) {
                                return await globalThis.vmModuleLinker(url, referencingModule);
                            }
                        }
                    }
                    return import(specifier);
                }

                ODANT.loadScript = function (url) {
                    if (url.startsWith('/')) {
                        url = ODANT.DEFAULTORIGIN + url;
                    }
                    return ODANT.cache('load-script:' + url, async () => {
                        const response = await fetch(encodeURI(url));
                        if (response.status === 200) {
                            const code = await response.text();
                            globalThis.currentScript = url;
                            vm.runInThisContext(code, {
                                fileName: url,
                                importModuleDynamically: globalThis.vmModuleLinker
                            });
                            response.src = url;
                            return response
                        }
                        throw new Error(`error on load script: "${url}"`);
                    });
                };
            }
        }


        // if (!ODANT.webMode) {
        await Promise.all([
            ODANT.loadScript("/web/ext/crypto/sha256.js"),
            ODANT.loadScript(path + "/_items/item.js")
        ]);
        await Promise.all([
            ODANT.loadScript(path + "/_items/connection.js"),
            ODANT.loadScript(path + "/_items/structure.js")
        ]);
        await Promise.all([
            ODANT.loadScript(path + "/_items/host.js"),
            ODANT.loadScript(path + "/_items/class.js")
        ]);
        await ODANT.loadScript(path + "/_items/domain.js");
        await ODANT.loadScript(path + "/_items/action.js");
        await Promise.all([
            ODANT.loadScript(path + "/index/_index.js"),
            ODANT.loadScript(path + "/_items/field.js"),
            ODANT.loadScript(path + "/_items/object.js"),
            ODANT.loadScript(path + "/_items/file.js")

        ]);
        await Promise.all([
            ODANT.loadScript(path + "/user/_user.js"),
            ODANT.loadScript(path + "/_items/folder.js"),
        ]);
        // }
        return ODANT;
    };

    globalThis.ODANT = function (prototype) {
        const cls = (class extends (prototype.extends || Object) {
            static get properties() { return prototype.props }
        }).register();
        Object.getOwnPropertyNames(prototype).forEach(name => {
            const d = getDescriptor(prototype, name);
            if (typeof d.value === 'function') {
                cls.prototype[name] = function (...args) {
                    return d.value.call(cls, ...args);
                }
            }
        });
        return cls;
    }
    Object.defineProperty(ODANT, 'webMode', {
        get() {
            return (typeof window !== 'undefined');
        }
    });
    Object.defineProperty(ODANT, 'clientSide', {
        get() {
            return this.webMode;
        }
    });
    Object.defineProperty(ODANT, 'serverSide', {
        get() {
            return !this.clientSide;
        }
    });
    if (ODANT.serverSide) {
        Object.defineProperty(globalThis, 'OLD_SERVER', {
            value: process.argv.length <= 1
        });
        if(globalThis.OLD_SERVER){
            console.warn('OLD_SERVER !!!' );
        }
    }
    ODANT.API = {
        checkUrl(url) {
            return ODA.cache('check-url: ' + url, async () => {
                url = encodeURI(url);
                const res = await fetch(url, { method: 'HEAD' });
                if (!res.ok)
                    throw new Error('Error url');
                url = (ODANT.DEFAULTORIGIN !== window.location.origin) ? url : res.url;
                if (!url) throw new Error('Error url');
                return url;
            });
        },
        post(context, params, post_object, fetchParams) {
            if (ODANT.serverSide && params && params['stream']) {
                return this.readStream(context, params, post_object);
            }

            return this.request(context, params, post_object, fetchParams);
        },
        get(context, params, fetchParams) {
            if (ODANT.serverSide && params && params['stream']) {
                return this.readStream(context, params);
            }

            return this.request(context, params, undefined, fetchParams);
        },

        readStream(context, params, post_object) {
            const paramsString = Object
                .keys(params)
                .reduce((a, c) => {
                    if (typeof params[c] !== 'object' && params[c]) {
                        a.push(`${c}=${params[c]}`);
                    }

                    return a;
                }, [])
                .join('&');

            let url = (paramsString.length === 0) ? context.url : `${context.url}?${paramsString}`;

            if (ODANT.serverSide && ODANT.ssid) {
                url = ODANT.URL(url);
            }

            let baseOpt = {
                method: 'GET',
                uri: url,
            };

            if (post_object) {
                baseOpt = {
                    method: 'POST',
                    uri: url,
                    body: post_object
                };
            }

            const reqParam = Object.assign(baseOpt, params.stream, true);
            return Promise.resolve(request(reqParam));
        },

        saveFile(p) {
            const formData = new FormData();
            formData.append("file", p.file, p.name);
            return this.post(p.url, null, formData);
        },
        async request(context, params, post_object, fetchParams = {}) {
            let p = params || {};
            if (typeof p === 'string')
                p = { 'method': p };
            let url = this._buildUrl(context, p);

            p = {
                method: post_object ? 'POST' : 'GET',
                body: post_object,
                credentials: 'include'
            };
            Object.assign(p, fetchParams);
            try {
                globalThis.loader && globalThis.loader.on(2000);
                // const load = url.includes('load');
                //
                // if (load)
                //     console.time('load');
                const response = await fetch(encodeURI(url), p);
                // if (load)
                //     console.timeEnd('load');
                switch (response.status) {
                    case 200: {
                        let content_type_header = response.headers.get('Content-Type');
                        let res = content_type_header ? content_type_header.split(';')[0] : content_type_header;
                        switch (res) {
                            case 'application/x.odant.async':
                            case 'application/x.odant.async+json':
                            case 'text/x-json':
                            case 'application/json':
                                return response.json();
                            case 'text/cmd':
                            case 'text/css':
                            case 'text/csv':
                            case 'text/javascript':
                            case 'application/javascript':
                            case 'text/php':
                            case 'text/html':
                            case 'text/plain':
                            case 'text/xml':
                                return response.text();
                            case 'image/png':
                            case 'image/gif':
                            case 'image/jpg':
                            case 'image/jpeg':
                            case 'application/octet-stream':
                                return ODANT.webMode ? response.blob() : response.buffer();

                            default: {
                                throw new RequestError(response, 'Unresolved fetch mime-type: ' + res);
                            }
                        }
                    }
                    case 500: {
                        const text = await response.text();
                        throw new RequestError(response, text);
                    }
                    default: {
                        // throw new RequestError(response, response.statusText);
                    }
                }
            }
            finally {
                // if (!params || !params.async)
                globalThis.loader && globalThis.loader.off();
            }
        },
        _buildUrl(context = '', params = {}) {
            let url = context.url || context;
            let arr = [];
            for (let n in params) {
                let val = params[n];
                if (val)
                    arr.push(n + (val ? ('=' + val) : ''));
            }
            params = arr.join('&');
            if (params)
                url += (url.includes('?') ? '&' : '?') + arr.join('&');
            if (ODANT.serverSide && ODANT.ssid)
                url = ODANT.URL(url);
            return url;
        }
    }
    ODANT.getBool = function (v, def = false) {
        if (!v)
            return def;
        switch (typeof v) {
            case 'object':
                return true;
            case 'string':
                return v.toLowerCase() === 'true';
            case 'boolean':
                return v;
            case 'number':
                return v !== 0;
        }
        return false;
    }
    ODANT.mixin = function (from, to, deep = 0) {
        if (from && to) {
            for (let i in from) {
                if (!to[i])
                    to[i] = from[i];
                if (deep)
                    ODANT.mixin(from[i], to[i], deep - 1);
            }

            return to;
        }
    }


    ODANT.root = globalThis;

    if (!ODANT.webMode) {
        ODANT.pushMessage = function (param) {
            console.log(param);
        };
        ODANT.push = ODANT.pushMessage;
    }

    ODANT._cache = {};

    ODANT.cache = (key, callback) => {
        let result = ODANT._cache[key];
        if (result === undefined) {
            if (typeof callback === 'function')
                result = callback();
            else
                result = callback;
            ODANT._cache[key] = result
        }
        return result;
    };

    if (ODANT.webMode) {
        window.odantLocalStorage = window.odantLocalStorage || class odantLocalStorage {
            constructor(path, parent) {
                this._path = path;
                this._parent = parent;
                try {
                    if (this._parent) {
                        this._storage = this._parent.getValue(path) || {};
                    }
                    else {
                        this._storage = JSON.parse(localStorage.getItem(path)) || {};
                    }
                    if (typeof this._storage !== 'object')
                        this._storage = {};
                }
                catch (err) {
                    this._storage = {};
                }

            }
            setValue(key, value) {
                let path = key.split('/');
                let s = this._storage;
                while (typeof s === 'object' && path.length) {
                    let v = path.shift();
                    if (path.length) {
                        s = s[v || '*'] || {};
                    }
                    else {
                        if (value)
                            s[v || '*'] = value;
                        else if (s[v || '*'])
                            delete s[v || '*'];
                        break;
                    }
                }
                this.save();
            }
            getValue(key) {
                let path = key.split('/');
                let s = this._storage;
                while (typeof s === 'object' && path.length) {
                    let v = path.shift();
                    s = s[v || '*'];
                }
                return s;
            }
            clear() {
                this._storage = null;
                this.save();
                this._storage = {};

            }
            save() {
                if (this._parent)
                    this._parent.setValue(this._path, this._storage);
                else if (this._storage)
                    localStorage.setItem(this._path, JSON.stringify(this._storage));
                else
                    localStorage.removeItem(this._path);
            }
        };
    }

    Object.defineProperty(ODANT, 'language', {
        get: function () {
            if (!this._language) {
                this._language = window.navigator.language;
                this._language = this._language.split('-').pop().toLowerCase();
            }
            return this._language;

        },
        set: function (newValue) {
            this._language = newValue;
        },
        enumerable: true,
        configurable: true
    });

    ODANT.setSSID = function (ssid) {
        ODANT.ssid = ssid;
    };

    ODANT.getSSID = function (delimiter) {
        return (ODANT.ssid && (delimiter ? delimiter : '') + 'ssid=' + ODANT.ssid) || '';
    };
    ODANT.URL = function (url) {
        if (url) {
            if (url.indexOf('ssid') < 0) {
                if (url.indexOf('?') < 0)
                    url += ODANT.getSSID('?');
                else if (url.indexOf('ssid=') < 0)
                    url += ODANT.getSSID('&');
            }
        }
        return url;
    };



    // ODANT.factory = new odaModuleFactory();

    ODANT.getGuid = function () {
        function s4() {
            return Math.floor((1 + Math.random()) * 0x10000)
                .toString(16)
                .substring(1);
        }

        return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
            s4() + '-' + s4() + s4() + s4();
    };


    globalThis.NOTREADY = 'Not ready!';

    //todo убрать это дерьмо

    ODANT.DEFAULTORIGIN = ODANT.DEFAULTORIGIN || globalThis.DEFAULTORIGIN /*|| 'http://business.odant.ru' */ || 'https://current.odant.org';
    ODANT.origin = ODANT.DEFAULTORIGIN;

    // globalThis._scripts = new Map();
    ODANT.items = {};
    if (ODANT.webMode) {
        if (document.defaultView.location.origin.indexOf('localhost') < 0) {
            ODANT.DEFAULTORIGIN = document.defaultView.location.origin;
            ODANT.origin = ODANT.DEFAULTORIGIN;
        }
        ODANT.loadScript = async function (url) {
            return ODANT.cache('load-script:' + url, () => {
                return new Promise(function (resolve, reject) {
                    let script = document.createElement("script");
                    script.onload = function (e) {
                        globalThis.loader && globalThis.loader.off();
                        script.remove();
                        resolve(script);
                    };
                    script.onerror = function (e) {
                        globalThis.loader && globalThis.loader.off();
                        script.remove();
                        script = null;
                        reject(new Error('error on load script', url));
                    };
                    script.async = true;
                    script.type = "text/javascript";
                    script.src = encodeURI(url);
                    globalThis.loader && globalThis.loader.on(2000);
                    document.head.appendChild(script);
                });
            });
        };
    }
    else {
        if (globalThis.OLD_SERVER) {
            globalThis.promise = require(NODEPATH + 'promise');
            globalThis.fetch = require(NODEPATH + 'node-fetch');
            globalThis.request = require(NODEPATH + 'request');
            globalThis.Headers = require(NODEPATH + 'node-fetch/lib/headers');
            globalThis.WebSocket = require(NODEPATH + 'websocket').w3cwebsocket;
            globalThis.FormData = require(NODEPATH + 'form-data');
            globalThis.numeral = require(NODEPATH + 'numeral');
            globalThis.File = require(NODEPATH + 'node-html5-file');

            const transliteration = require(NODEPATH + 'transliteration');

            globalThis.slugify = transliteration.slugify;
            globalThis.transliteration = transliteration.transliterate;
            globalThis.require = require;

            ODANT.loadScript = function (url) {
                if (url.startsWith('/')) {
                    url = ODANT.DEFAULTORIGIN + url;
                }
                return ODANT.cache('load-script:' + url, async () => {
                    const response = await fetch(encodeURI(url));
                    if (response.status === 200) {
                        const code = await response.text();
                        globalThis.currentScript = url;
                        require('vm').runInThisContext(code, url);
                        response.src = url;
                        return response
                    }
                    throw new Error(`error on load script: "${url}"`);
                });
            };
        }
    }

    if (!String.prototype.replaceAll) {
        Object.defineProperty(String.prototype, 'replaceAll', {
            enumerable: false, value: function (search, replace) {
                return this.split(search).join(replace);
            }
        });
    }

    ODANT.counter = (start = 1, step = 1) => {
        return () => start += step;
    };

    ODANT.getArrayCount = function (obj, filter) {
        let res = 0;
        for (let i in obj) {
            if (filter && !i.startsWith(filter))
                continue;
            if (Array.isArray(obj[i]))
                res += obj[i].length;
            else
                res++;
        }
        return res;
    };
    if (!Array.prototype.contains) {
        Object.defineProperty(Array.prototype, 'contains', {
            enumerable: false, value: function (item) {
                if (this.includes(item))
                    return true;
                if (this.find(i => {
                    return i.items && i.items.contains(item);
                }))
                    return true;
                return false;
            }
        });
    }
    if (!Array.prototype.findDeep) {
        Object.defineProperty(Array.prototype, 'findDeep', {
            enumerable: false, value: function (callback, itemsName = 'items') {
                const res = this.find(callback) ||
                    this.find(i => {
                        const array = i[itemsName];
                        return Array.isArray(array) && array.findDeep(callback, itemsName)
                    });
                return res;
            }
        });
    }
    if (!Array.prototype.deleteItems) {
        Object.defineProperty(Array.prototype, 'deleteItems', {
            enumerable: false, value: function (items, itemsName) {
                items = Array.isArray(items) ? items : [items];
                items.forEach(item => {
                    const idx = this.indexOf(item);
                    if (idx > -1)
                        this.splice(idx, 1);
                });
                if (itemsName) {
                    this.forEach(i => {
                        const array = i[itemsName];
                        if (Array.isArray(array)) {
                            array.deleteItems(items, itemsName);
                        }
                    });
                }
            }
        });
    }
    if (!Array.prototype.delete) {
        Object.defineProperty(Array.prototype, 'delete', {
            enumerable: false, value: function (callback, itemsName) {
                this.deleteItems(this.filter(callback));
                if (itemsName) {
                    this.forEach(i => {
                        const array = i[itemsName];
                        if (Array.isArray(array)) {
                            array.delete(callback, itemsName);
                        }
                    });
                }
            }
        });
    }

    // JSON.find = function (json, id) {
    //     if (!json.items)
    //         return null;
    //     var res = json.items.find(i=>{
    //         return i.id == id || i.name == id || i.id == id || i.name == id;
    //     });
    //     if (!res){
    //         json.items.forEach(i=>{
    //             res = res || JSON.find(i, id);
    //         })
    //     }
    //     return res;
    // };

    JSON.find = function (json = {}, callback) {
        let res = callback(json);
        if (!res && Array.isArray(json.items)) {
            res = json.items.find(callback);
            return res || json.items.reduce((res, i) => {
                res = res || JSON.find(i, callback);
                return res;
            }, null)
        }
        return res;
    };


    JSON.update = function (json, source) {
        for (let i in source) {
            if (!json[i]) {
                json[i] = source[i]
            }
        }
    };

    ODANT.loadJSON = (path) => {
        return ODANT.API.request(path);
    };

    ODANT.getContextFromUrl = function (url) {
        if (url) {
            url = decodeURI(url);
            url = url.split('?')[0];
            url = url.split('#')[0];
            let i = url.indexOf('/api/');
            if (i < 0)
                return null;
            url = url.substring(i + 4);
            i = url.lastIndexOf('/~');
            if (i < 0) {
                url = url.split('/').filter(s => {
                    return s.indexOf(':') === 1;
                }).join('/');
            }
            else {
                url = url.substring(0, i);
            }

            return url;
        }
        return '';
    };

    ODANT.getArrayChildren = function (obj, filter) {
        let res = [];
        for (let i in obj) {
            if (filter && !i.startsWith(filter))
                continue;
            if (Array.isArray(obj[i])) {
                let localName = filter ? i.replace(filter, '') : i;
                obj[i].forEach(function (j) {
                    j.localName = localName;
                    res.push(j);
                })
            }
        }
        return res;
    };

    ODANT.executeAction = async (context, action, params) => {
        if (!(context instanceof odaItem))
            context = await ODANT.getItem(context);
        return context.executeAction(action, params);
    };

    if (!String.format) {
        String.format = function (format) {
            let args = Array.prototype.slice.call(arguments, 1);
            return format.replace(/{(\d+)}/g, function (match, number) {
                return typeof args[number] !== 'undefined'
                    ? args[number]
                    : match
                    ;
            });
        };
    }
    if (!String.prototype.hash) {
        Object.defineProperty(String.prototype, 'hash', {
            enumerable: false, value: function () {
                // if (Array.prototype.reduce){
                //     return this.split("").reduce(function(a,b){a=((a<<5)-a)+b.charCodeAt(0);return a&a},0);
                // }
                let hash = 0;
                if (this.length === 0) return hash;
                for (let i = 0; i < this.length; i++) {
                    let character = this.charCodeAt(i);
                    hash = ((hash << 5) - hash) + character;
                    hash = hash & hash; // Convert to 32bit integer
                }
                return hash;
            }
        });
    }


    if (!ODANT.webMode) {
        module.exports = loadCore();
    }
    else {
        loadCore().then((result) => {
            console.log('ODANT framework is ready.');
            Object.defineProperty(ODANT, 'frameworkReady', {
                value: true,
                readOnly: true
            });
        });
    }

    ODANT.translate = (text, language = ODANT.language) => {
        return text;
    };
    ODANT.numberFormat = (mask, value) => {
        const maskRegex = /[0-9\-+#()]/;
        const notMaskRegex = /[^\d#()]/g;
        const predefFormats = [
            {
                aliases: ['integer', 'целое'],
                method(mask, value) {
                    return (new Intl.NumberFormat(navigator.language)).format(value.toFixed(0));
                }
            }, {
                aliases: ['decimal', 'integer', 'целое'],
                method(mask, value) {
                    return (new Intl.NumberFormat(navigator.language)).format(value);
                }
            }, {
                aliases: ['percentage', 'процентное', 'процентный', 'процент', 'percent'],
                method(mask, value) {
                    return (new Intl.NumberFormat(navigator.language, { style: 'percent', minimumFractionDigits: 2, })).format(value);
                }
            }, {
                aliases: ['currency', 'денежное', 'деньги', 'финансовое', 'fiscal', 'financial'],
                method(mask, value) {
                    const currency = navigator.language.toLowerCase().includes('ru') ? 'RUB' : 'USD';
                    return (new Intl.NumberFormat(navigator.language, { style: 'currency', currency, currencyDisplay: 'symbol' })).format(value);
                }
            }, {
                aliases: ['bank', 'банковское', 'банк'],
                method(mask, value) {
                    return getFormatted('0-0000;(0-0000)', value);
                }
            }
        ];

        const predefFormat = predefFormats.find(f => f.aliases.includes(mask.toLowerCase()));
        if (!mask || !(predefFormat || maskRegex.test(mask))) return String(value);
        const method = predefFormat && predefFormat.method || getFormatted;
        return method(mask, value);

        function getFormatted(mask, value) {
            const masks = mask.split(';');
            if (masks[1]) {
                mask = String(value).startsWith('-') ? masks[1] : masks[0];
            }
            if (isNaN(Number(value)) || !value) {
                if (masks[2]) return masks[2];
                value = 0;
            }
            const maskObj = getMask(mask);
            const valObj = getValue(value, maskObj);
            if (valObj.sign === "(") {
                return maskObj.prefix + "(" + valObj.result + ")" + maskObj.suffix;
            }
            return maskObj.prefix + valObj.sign + valObj.result + maskObj.suffix;
        }


        function getIndex(mask) {
            return mask.search(maskRegex);
        }

        function setSeporators(maskObj) {
            const res = maskObj.mask.match(notMaskRegex);
            if (res) {
                switch (res.length) {
                    case 0:
                        maskObj.intGroupSep = "";
                        maskObj.decSep = "";
                        maskObj.fractGroupSep = "";
                        break;
                    case 1:
                        if (/[\.\,\-]/.test(res[0])) {
                            maskObj.intGroupSep = "";
                            maskObj.decSep = res[0];
                            maskObj.fractGroupSep = "";
                        } else {
                            maskObj.intGroupSep = res[0];
                            maskObj.decSep = "";
                            maskObj.fractGroupSep = "";
                        }
                        break;
                    case 2:
                        if (/[\.\,\-]/.test(res[0])) {
                            maskObj.intGroupSep = "";
                            maskObj.decSep = res[0];
                            maskObj.fractGroupSep = res[1];
                        } else {
                            maskObj.intGroupSep = res[0];
                            maskObj.decSep = res[1];
                            maskObj.fractGroupSep = "";
                        }
                        break;
                    case 3:
                    default:
                        maskObj.intGroupSep = res[0];
                        maskObj.decSep = res[1];
                        maskObj.fractGroupSep = res[2];
                        break;
                }
                return;
            }
            maskObj.intGroupSep = "";
            maskObj.decSep = "";
            maskObj.fractGroupSep = "";
        }

        function getMask(mask = "#.##") {
            const maskObj = {};
            const len = mask.length;
            const start = getIndex(mask);
            maskObj.prefix = start > 0 ? mask.substring(0, start) : "";

            const end = getIndex(
                Array.from(mask)
                    .reverse()
                    .join("")
            );
            const offset = len - end;
            const substr = mask.substring(offset, offset + 1);
            const indx = offset + (substr === "." || substr === ',' ? 1 : 0);
            maskObj.suffix = end > 0 ? mask.substring(indx, len) : '';

            maskObj.mask = mask.substring(start, indx);
            maskObj.maskHasNegativeSign = maskObj.mask.startsWith('(') || maskObj.mask.startsWith('-');
            maskObj.maskHasPositiveSign = maskObj.mask.startsWith('+');
            maskObj.negativeSign = maskObj.mask.startsWith('(') ? '(' : '-';
            if (maskObj.mask.startsWith('-')) {
                maskObj.mask = maskObj.mask.slice(1);
            } else if (maskObj.negativeSign === '(') {
                maskObj.mask = maskObj.mask.replace(/^\(|\)$/g, '');
            }

            setSeporators(maskObj);

            const res = maskObj.mask.split(maskObj.decSep);
            maskObj.integer = res[0];
            maskObj.fraction = res[1];
            return maskObj;
        }

        function getValue(value, maskObj) {
            let isNegative = false;
            const valObj = {
                value
            };
            if (value < 0) {
                isNegative = true;
                valObj.value = -valObj.value;
            }
            valObj.sign = isNegative ? maskObj.negativeSign : "";
            const fractMask = maskObj.fraction ? maskObj.fraction.replace(/\s/g, "") : '';
            const posTrailZero = maskObj.fraction && fractMask.lastIndexOf("0") + 1;

            valObj.value = Number(valObj.value).toFixed(fractMask.length);
            valObj.value = valObj.value.toString();

            let [valInteger = "0", valFraction = ""] = valObj.value.split(".");
            valFraction = valFraction.replace(/0*$/, "");
            if (valFraction && valFraction.length < posTrailZero) {
                valFraction = Number("0." + valFraction).toFixed(posTrailZero).replace("0.", "");
            }
            valObj.integer = valInteger;
            valObj.fraction = valFraction;
            addSeparators(valObj, maskObj);

            if (valObj.result === "0" || valObj.result === "") {
                isNegative = false;
                valObj.sign = "";
            }

            if (!isNegative && maskObj.maskHasPositiveSign) {
                valObj.sign = "+";
            } else if (isNegative && maskObj.maskHasNegativeSign) {
                valObj.sign = maskObj.negativeSign;
            }
            return valObj;
        }

        function reverseS(s) {
            return Array.from(s).reverse().join("");
        }

        function addSeparators(valObj, maskObj) {
            valObj.result = "";

            const singDigit = maskObj.integer.match(/0/g);
            const singDigitCount = (singDigit && singDigit.length) || 0;

            if (valObj.integer.length <= singDigitCount) {
                while (valObj.integer.length < singDigitCount) {
                    valObj.integer = "0" + valObj.integer;
                }
            } else if (Number(valObj.integer) === 0) {
                valObj.integer = "";
            }

            if (valObj.integer && maskObj.integer) {
                const sepPos = maskObj.integer.length - maskObj.integer.indexOf(maskObj.intGroupSep);
                const reg = new RegExp(`\\B(?=(\\d{${sepPos}})+(?!\\d))`, "g");
                valObj.result = valObj.integer.replace(reg, maskObj.intGroupSep);
            }
            if (valObj.fraction && maskObj.fraction) {
                const sepPos = maskObj.fraction.indexOf(maskObj.fractGroupSep);
                const reg = new RegExp(`\\B(?=(\\d{${sepPos}})+(?!\\d))`, "g");
                valObj.result += maskObj.decSep + reverseS(reverseS(valObj.fraction).replace(reg, maskObj.fractGroupSep));
            }
            return valObj;
        }
    };


}
