/**
 * Created by Роман on 26.12.2016.
 */
'use strict';
var MAX_AGE = 86400000;
var CACHE_NAME = 'v4';
self.addEventListener('install',  event => {
    console.log('install', event);
    function onInstall() {
        caches.open(CACHE_NAME).then(cache => {
            return cache.addAll(['odant.js', 'oda.js']);
        }).then(function() {
            return self.skipWaiting();
        }).catch(ex => {
            console.log('catch on caches.open onInstall', ex);
        })
    }
    event.waitUntil(onInstall());
    // event.waitUntil(self.skipWaiting());
});

self.addEventListener('activate', event => {
    // активация
    console.log('activate', event);
    event.waitUntil(self.clients.claim());
});

self.addEventListener('fetch', event => {
    // console.log('Handling fetch event for', event.request.url);

    function onFetch() {

    }
    event.respondWith( caches.match(event.request).then( response =>{
        if (response) {
            // console.log('Found response in cache:', response);

            return response;
        }
        // console.log('No response found in cache. About to fetch from network...');


        return fetch(event.request).then(response =>{

            // console.log('Response from network is:', response);
            if (response.url.includes('.html') || response.url.includes('.js')){
                return caches.open(CACHE_NAME).then(cache =>{
                    cache.put(event.request, response.clone());
                    return response;
                });
            }

            return response;

        }).catch(ex =>{
            console.error('Fetching failed:', ex);
            throw ex;
        });
    }));
});

self.addEventListener('beforeinstallprompt', e => {
    console.log(e.platforms);
    // beforeinstallprompt Event fired

    // e.userChoice will return a Promise.
    // For more details read: https://developers.google.com/web/fundamentals/getting-started/primers/promises
    e.userChoice.then(choiceResult => {

        console.log(choiceResult.outcome);

        if(choiceResult.outcome === 'dismissed') {
            console.log('User cancelled home screen install');
        }
        else {
            console.log('User added to home screen');
        }
    });
});