import '/web/oda/components/buttons/icon/icon.js';
//TODO
// import '/web/lib/dialogs/input/input.html';
// import '/web/core/structure/lib/action-finder/action-finder.html';
// import '/web/lib/dialogs/icon-select/icon-select.html';

ODANT({
    is: 'desktop-ext-shortcut',
    template: /*html*/ `
        <style>
            :host{
                --shortcut-font-size: 13px;
                --shortcut-line-height: 15px;
                --shortcut-label-lines-count: 3;
            }
            :host{
                @apply --vertical;
                @apply --content;
                transition: box-shadow 0.25s ease-in-out, opacity 0.25s ease-in;
                box-shadow: 0px 0px 1px rgba(0, 0, 0, 0.04),
                            0px 0px 2px rgba(0, 0, 0, 0.06),
                            0px 4px 8px rgba(0, 0, 0, 0.04),
                            0px 24px 32px rgba(0, 0, 0, 0.0);
                align-items: center;
                padding: 15px;
                padding-top: 20px;
                overflow: hidden;
                text-overflow: ellipsis;
                border-radius: 5px;
                position: relative;
                opacity: 0;
                pointer-events: none;
            }
            :host>*{
                user-select: none;
            }
            :host(:hover){
                box-shadow: 0px 0px 1px rgba(0, 0, 0, 0.04),
                            0px 4px 8px rgba(0, 0, 0, 0.04),
                            0px 16px 24px rgba(0, 0, 0, 0.04),
                            0px 24px 32px rgba(0, 0, 0, 0.04);
            }
            oda-icon{
                margin-bottom: 10px;
            }
            .shortcut-label{
                display: -webkit-box;
                white-space: normal;
                overflow: hidden;
                text-overflow: ellipsis;
                -webkit-box-orient: vertical;
                font-weight: 500;
                text-align: center;

                max-width: 88px;
                overflow-wrap: break-word;

                font-size: var(--shortcut-font-size);
                -webkit-line-clamp: var(--shortcut-label-lines-count);
                line-height: var(--shortcut-line-height);
                max-height: cac(var(--shortcut-line-height) * var(--shortcut-label-lines-count));
            }
        </style>
        <oda-icon :icon="icon" :icon-size="iconSize"></oda-icon>
        <oda-icon ~if="global" icon="office-set:global" :icon-size="iconSize/3" style="position: absolute; left: 10px; top: 10px; opacity: 0.25;"></oda-icon>
        <oda-icon ~if="remote" icon="icons:open-in-new" :icon-size="iconSize/3" style="position: absolute; right: 10px; top: 10px; opacity: 0.25;"></oda-icon>
        <oda-icon ~if="$action" :icon="$action.icon" :icon-size="iconSize/2" style="position: absolute; right: 30px; top: 45px;"></oda-icon>
        <div class="shortcut-label" :title="label" ~text="label"></div>`,
    props: {
        item: {
            type: Object,
            async set(item, old) {
                if (old) {
                    //this.set(this, '$item', null);
                    this.$item = null;
                    this.icon = '';
                    this.label = '';
                    this.$view = null;
                    this.$action = null;
                    this.style.setProperty('opacity', 0);
                    this.style.setProperty('pointer-events', 'none');
                    this.style.removeProperty('fill', 'red');
                }
                if (item) {
                    await this._load();
                    this.style.setProperty('opacity', 1);
                    this.style.setProperty('pointer-events', 'all');
                }
                this.hidden = !(this.allowAdmin || this.$item) || this.item && this.item.hidden;
            }
        },
        contextItem: Object,
        $item: Object,
        $action: Object,
        icon: String,
        label: String,
        remote: Boolean,
        global: {
            type: Boolean,
            get() {
                if (this.item) return this.item.global;
            }
        },
        iconSize: 48,
        hidden: {
            type: Boolean,
            reflectToAttribute: true
        },
        hostId: '',
        allowAdmin: false
    },
    listeners: {
        dragstart(e) {
            this.domHost.fire('drag-start', { item: this.item, sourceEvent: e });
        },
        contextmenu: '_contextMenu',
        tap: '_tap'
    },
    async _load(item = this.item) {
        try {
            const remote = this._checkRemote(item.id);
            const context = this.contextItem instanceof odaDomain || this.contextItem instanceof odaHost ? this.contextItem : this.contextItem.$base;
            const $item = remote ? item.$item : (await context.findItem(item.id)) || await CORE.host.findItem(item.id);
            if (!$item) throw 'no find item for shortcut';
            //this.set(this, '$item', $item);
            this.$item = $item;
            this.remote = remote;
            this.icon = this.$item?.icon || 'device:widgets';
            this.label = this.$item?.label || '-';
            if (item.view || item.action) this.$action = await this.$item.findAction(item.view || item.action);
            else this.$action = null;
        } catch (err) {
            console.warn(err);
            this.icon = 'icons:close';
            this.style.setProperty('fill', 'red');
            this.label = this.$item?.label || 'unavailable';
            this.$action = null;
        }
    },
    async _contextMenu(e) {
        e.preventDefault();
        e.stopPropagation();
        const items = [
            {
                icon: 'icons:menu',
                label: 'Item menu',
                action: async () => {
                    const menu = this.create('oda-item-menu', {
                        contextItem: this.$item,
                        groups: '*',
                        collapseLimit: 3
                    });
                    menu.open({ parent: this, hideTitle: false });
                },
                required: true
            },
            {
                icon: 'image:edit',
                label: 'Label',
                hidden: true,
                title: this.item.label || '',
                action: async () => {
                    await this._changeProp('label');
                }
            },
            {
                icon: 'image:edit',
                label: 'Icon',
                title: this.item.icon || '',
                action: async () => {
                    await this._changeProp('icon');
                }
            },
            {
                icon: 'image:edit',
                label: 'Method',
                title: this.item.action || '',
                action: async () => {
                    await this._changeProp('action');
                }
            },
            {
                icon: 'image:edit',
                label: 'View',
                title: this.item.view || '',
                action: async () => {
                    await this._changeProp('view');
                }
            },
            {
                icon: 'icons:autorenew',
                label: 'Reset',
                action: async () => {
                    const res = await ODA.confirm('Are you sure?', 'Reset shortcut');
                    this.domHost.fire('reset', { item: this.item });
                },
                required: true,
            },
            {
                icon: 'odant:delete',
                label: 'Delete',
                action: async () => {
                    const res = await ODA.confirm('Are you sure?', 'Delete shortcut');
                    this.domHost.fire('delete', { item: this.item });
                },
                required: true
            },
            {
                icon: 'social:share',
                label: 'Share',
                action: async () => {
                    const res = await ODA.confirm('Are you sure?', 'Share shortcut');
                    this.domHost.fire('share', { item: this.item });
                },
                required: true
            },
        ];
        if (!this.$item) {
            items.splice(0, items.length, ...items.filter(i => i.required));
        }
        if (this.global && !this.allowAdmin) {
            items.splice(0, items.length, ...items.filter(i => i.label !== 'Delete'));
        }
        if (this.global || !this.allowAdmin) {
            items.splice(0, items.length, ...items.filter(i => i.label !== 'Share'));
        }
        if (this.global && this.allowAdmin) {
            items.push({
                icon: 'odant:delete',
                label: 'Unshare',
                action: async () => {
                    const res = await ODA.confirm('Are you sure?', 'Unshare shortcut');
                    await this._changeProp('global');
                },
                required: true
            });
        }
        if (this.remote) {
            items.splice(0, items.length, ...items.filter(i => i.label !== 'Item menu'));
        }
        //TODO
        //const res = await ODA.showContextMenu({ title: 'Edit', icon: 'icons:menu', items, iconSize: 32, template: 'odant-desktop-ext-menu-item' });
        //res.action();

        // TODO
        await this.contextItem.import('web/core/item/lib/item-menu/item-menu.js');
        ODA.showDropdown('odant-item-menu', {contextItem: this.contextItem}, {parent: this});
    },
    async _changeProp(prop) {
        //TODO
        const dialogs = {
            label: { ctrl: 'oda-input-dialog', params: { value: this.item.label || this.$item.label }, get(ctrl) { return ctrl.value } },
            icon: { ctrl: 'oda-icon-select', params: {}, get(ctrl) { return ctrl.value } },
            action: { ctrl: 'oda-action-finder', params: { contextItem: this.$item, groups: ['odaaction', 'odabutton'] }, get(ctrl) { return ctrl.$action.name } },
            view: { ctrl: 'oda-action-finder', params: { contextItem: this.$item, groups: ['odaview'] }, get(ctrl) { return ctrl.$action.name } },
        };
        const control = this.create(dialogs[prop].ctrl);
        for (const k in dialogs[prop].params) {
            control[k] = dialogs[prop].params[k];
        }
        const params = {
            title: `Configure ${prop}`,
            buttons: [
                {
                    label: 'Reset', icon: 'icons:autorenew',
                    action: async () => {
                        const res = await ODA.confirm('Are you sure?', `Reset ${prop}?`);
                        this[prop] = this.$item[prop] || (prop === 'icon' ? 'device:widgets' : (prop === 'label' ? '-' : ''));
                        this.domHost.fire('reset', { item: this.item, prop });
                    }
                },
                {
                    label: 'Save', icon: 'icons:check',
                    action: async () => {
                        const value = dialogs[prop].get(control);
                        this[prop] = value;
                        this.domHost.fire('change-prop', { item: this.item, prop, value });
                    }
                },
            ]
        };
        const res = await ODA.showDialog(control, params);
        if (this.global && !this.allowAdmin) {
            await ODA.confirm('Override global shortcut?', 'Confirm');
            //this.set(this.item, 'global', false);
            this.$item.global = false;
        }
        await res.button.action();
        await this._load();
    },
    _checkRemote(id) {
        const match = id.match(/^\/?H:(.{15})\//i);
        return match ? thisId !== match[1] : false;
    },
    _tap(e) {
        if (this.remote) {
            window.open(`${this.item.url}/~/client/navigator/index.html`, '_blank');
            return;
        }

        if (this.$action) {
            this.$item.executeAction(this.$action.name);
        } else {
            let nav = this.domHost;
            while (nav && !nav.showItem) {
                nav = nav.domHost;
            }
            if (nav && this.$item) {
                nav.showItem(this.$item);
            }
        }
    }
})
        
ODA({
    is: 'odant-desktop-ext-menu-item',
    template: /*html*/ `
        <style>
            :host {
                @apply --label;
                @apply --horizontal;
                @apply --flex;
                align-items: center;
                max-width: 215px;
                overflow: hidden;
                text-overflow: ellipsis;
            }
            :host>*{
                padding: 4px;
                overflow: hidden;
                text-overflow: ellipsis;
            }
        </style>
        <span class="label" :title="item.title">{{item.label}}{{item.title ? '*' : ''}}</span>`,
    properties: {
        item: {},
    }
});