import ODA from '../../../../oda/oda.js';
import '../action-finder/action-finder.js';

ODA({
    is: 'odant-action-editor',
    template: `
    <style>
        :host{
            @apply --horizontal;
        }
        :host>oda-class-finder{
            @apply --flex;
        }
    </style>
    <odant-action-finder :context-item="contextItem" :$action="$action" :groups="['odaView']" @$action-changed="$action = $event.detail.value"></odant-action-finder>`,
    props: {
        value: {
            type: String,
            notify: true,
        },
        item: {
            type: Object,
            async watch(n) {
                if (n && n.owner) {
                    const context = n.owner;
                    switch (this.item.name) {
                        case 'defaultViewName': this.contextItem = context; break;
                        case 'defaultObjectView':
                            if (!context.isAbstract && context.createObject)
                                this.contextItem = await context.createObject();
                            break;
                        default: break;
                    }
                }
            }
        },
        contextItem: {
            type: Object,
            async watch(n) {
                this.$action = (await n.getActions()).find(a => a.name === this.item.io);
            }
        },
        $action: {
            type: Object,
            notify: true,
            watch(n) {
                this.focused = true;
                this.async(() => {
                    if (n) {
                        this.value = n.name || n.id;
                    } else {
                        this.value = undefined;
                    }
                    this.async(() => this.focused = false);
                });
            }
        },
        focused: false,
    }
});