import ODA from '../../../../oda/oda.js';
import '../../../../oda/components/grids/listbox/listbox.js';
ODA({
    is: 'odant-action-list',
    extends: 'oda-list-box',
    template: `
    <style>
        :host {
            min-width: 200px;
        }
    </style>`,
    props: {
        contextItem: {
            type: Object,
            default: {}
        },
        by: 'name',
        items: {
            type: Array,
            default: [],
            get() {
                if (this._actions && this._actions.length > 0) {
                    if (this.includes.length > 0) {
                        return this._actions.filter(a => this.includes.some(i => i.toLowerCase() === a[this.by].toLowerCase()));
                    }
                    if (this.excludes.length > 0) {
                        return this._actions.filter(a => !this.excludes.some(ex => ex.toLowerCase() === a[this.by].toLowerCase()));
                    }
                    return [...this._actions];
                }
                return [];
            }
        },
        includes: [],
        excludes: [],
        groups: [],
        actions: [],
        _actions: Array,
    },
    observers: [
        async function _setActions(actions, contextItem, groups) {
            if (actions && actions.length) return this._actions = [...actions];
            if (contextItem && contextItem.getActions) {
                if (groups && groups.length > 0) {
                    const items = [];
                    for (const g of groups) {
                        items.push(...(await contextItem.getActions(g)));
                    }
                    return this._actions = items;
                }
                return this._actions = await contextItem.getActions();
            }
            this._actions = [];
        }
    ],
})