import ODA from '../../../../oda/oda.js';
import '../action-list/action-list.js';
ODA({
    is: 'odant-select-action',
    template: `
    <style>
        :host{
            @apply --vertical;
            @apply --flex;
            @apply --content;
            padding: 4px;
            box-sizing: border-box;
            overflow: hidden;
        }
        [disabled]{
            @apply --disabled;
        }
    </style>
    <input ~if="showFilter" ref="input" :value="filter" @input="filter = $refs.input.value" style="padding: 4px 8px;">
    <odant-action-list ref="list" :by="by" include-context :filter="filterVal" :context-item="contextItem" :style="{maxWidth: parent ? (parent.host || parent).offsetWidth + 'px' : ''}" :actions="actions" :groups="groups" :includes="includes" :excludes="excludes" :focused-item="item" @result="item = $event.detail.value.focused"></odant-action-list>`,
    props: {
        contextItem: Object,
        showFilter: true,
        filter: {
            type: String,
            set(n) {
                this.debounce('set-filter', () => {
                    this.filterVal = n;
                }, 300);
            }
        },
        includes: [],
        excludes: [],
        groups: [],
        actions: [],
        by: 'name',
        filterVal: '',
        item: {
            type: Object,
            set(n) {
                if (n) {
                    this.fire('result');
                }
            }
        },
        _path: []
    },
})