import ODA from '../../../../oda/oda.js';
import '../class-tree/class-tree.js';
import '../item-walker/item-walker.js';

ODA({
    is: 'odant-select-class',
    template: `
    <style>
        :host{
            @apply --vertical;
            @apply --flex;
            @apply --content;
            padding: 4px;
            box-sizing: border-box;
            overflow: hidden;
        }
        [disabled]{
            @apply --disabled;
        }
    </style>
    <odant-item-walker :context-item="contextItem" ::current="current" item-key="$base"></odant-item-walker>
    <input ~if="showFilter" ref="input" :value="filter" @input="filter = $refs.input.value" style="padding: 4px 8px;">
    <odant-class-tree ref="tree" include-context :filter-val="filterVal" :context-item="current"
        :style="{maxWidth: parent ? (parent.host || parent).offsetWidth + 'px' : ''}" ::focused-node="node"></odant-class-tree>`,
    props: {
        contextItem: {
            type: Object,
        },
        startContext: Object,
        current: {
            type: Object,
            watch() {
                this.$refs.input.focus();
            }
        },
        showFilter: true,
        filter: {
            type: String,
            watch(n) {
                this.debounce('set-filter', () => {
                    this.filterVal = n;
                }, 300);
            }
        },
        filterVal: '',
        node: {
            type: Object,
            async watch(n) {
                if (n && n.fullId) {
                    this.item = await ODANT.findItem(n.fullId);
                }
            }
        },
        item: {
            type: Object,
            watch(n) {
                if (n) {
                    this.fire('result');
                }
            }
        },
        _path: []
    }
});