// import './item-search.js';
ODANT({
    imports: [
        '@lib/item-tree',
        // '/web/core/structure/lib/structure-tree/item-search.js',
        '@oda/search-input'
    ],
    is: 'odant-structure-tree',
    extends: 'this, odant-item-tree',
    template: /*html*/`
        <oda-search-input ~if="allowSearch" @search="_search" @search-changed="_searchChanged"></oda-search-input>
        <odant-item-node ~if="!hideItemNode" :context-item style="margin: 8px;"></odant-item-node>
    `,
    props: {
        itemsList: '_$$structure',
        hideRoot: true,
        hideItemNode: false,
        expandNames: 'Work',
        // preventExpanding: true,
        lazy: true,
        defaultTemplate: 'odant-structure-node',
        expandItem: Object,
        // focusedItem: {
        //     type: Object,
        //     get() {
        //         return this.focusedNode?.$item;
        //     }
        // },
        allowSearch: true,
        allowInherit: false,
        allowSelection: true,
        dragOperation: [
            { icon: 'icons:reply', label: 'Move', },
            { icon: 'icons:content-copy', label: 'Copy', },
            { icon: 'icons:link', label: 'Link', },
            { label: 'Inherit', }
        ],
        // templateLoading: { // for DELETION
        //     type: Object,
        //     get() {
        //         return { template: this.loadingTemplate };
        //     }
        // },
        // focusedNode: {
        //     type: Object,
        //     async watch(node) {
        //         if (node) {
        //             this._expandItemChanged(node.$item, node);
        //         }
        //     }
        // },
        // _readyToDataset: Boolean
    },
    observers: [
        '_expandItemChanged(expandItem)',
        // '_load(contextItem, allowInherit)',
        // function _setDataSet(contextItem, itemsList, _readyToDataset) {
        //     if (!_readyToDataset) return;
        //     this.refreshDataset(contextItem);
        // }
    ],
    _onDragStart(e) {
        const el = e.path.find(p => p.row);
        if (el && (this.allowDrag || el.row.drag)) {
            if (el.row.$item && el.row.$item.path) {
                e.dataTransfer.setData('odant/odaitem', JSON.stringify(el.row.$item.toJSON()));
                try {
                    const node = e.target.querySelector('oda-table-cell-tree').$core.shadowRoot.querySelector('odant-structure-node');
                    e.dataTransfer.setDragImage(node, 0, 0);
                } catch (err) {
                    e.dataTransfer.setDragImage(new Image(), 0, 0);
                }
            }
            ODA._draggableRows = this._draggableRows = this.selection.includes(el.row) ? this.selection : [el.row];
        }
    },
    // detached() {
    //     this.unlisten('event', '_onEvent', { target: this.contextItem });
    // },
    // async _load(item, inherit) {
    //     if (item) {
    //         const obj = { $item: item };
    //         if (inherit && item.typeName === 'class') {
    //             let items = await this._getInheritItems(item);
    //             obj.config = items['$' + item.$base.prefix][0];
    //             obj.$item = item.$base;
    //         }
    //         obj.items = await this._beforeExpand(obj);
    //         const node = obj.items.find(i => i.$expanded);
    //         if (node) {
    //             node.items = await this._beforeExpand(node);
    //         }
    //         this.dataSet = [obj];
    //         this.focusedNode = this.dataSet[0];
    //
    //         this.async(() => {
    //             this.fire('structure-tree-ready');
    //         }, 100);
    //     }
    // },
    // async _beforeExpand(node) {
    //     try {
    //         const allowAdmin = true;//node.$item.access === 6;
    //         const isGroup = node.$item?.constructor?.name === 'odaGroup' ? true : false;
    //         const config = await node?.$item?.getConfig();
    //         let p = [];
    //         if (config?.$P) {
    //             const idx = config.$P.findIndex(i => i.n === 'ROOT');
    //             if (~idx) config.$P.splice(idx, 1);
    //         }
    //         for (let key in config) {
    //             let group = config[key];
    //             if (Array.isArray(group)) {
    //                 let prefix = key[1];
    //                 p.push(...group.map(async item => {
    //                     const strItem = prefix === 'G'
    //                                     ? new odaGroup({ $owner: node.$item, name: item.name, config: item })
    //                                     : await node.$item.findItem(prefix + ':' + item.i);
    //                     // const strItem = prefix === 'D'
    //                     //                 ? (await (node.$item.findItem(prefix + ':' + item.i)))
    //                     //                 : prefix === 'G'
    //                     //                   ? new odaGroup({ $owner: node.$item, name: item.name, config: item })
    //                     //                   : isGroup
    //                     //                     ? await node.$item.findItem(node.$item.$owner.path + '/' + prefix + ':' + item.i)
    //                     //                     : await node.$item.findItem(node.$item.path + '/' + prefix + ':' + item.i);
    //                     const obj = { $item: strItem };
    //                     if (this.allowInherit) {
    //                         obj.config = item;
    //                         obj.$expanded = node.level === 0 && strItem instanceof odaBase;
    //                         obj.allowCheck = strItem instanceof odaBase;
    //                     }
    //                     if (item.ch === 'T' || prefix === 'G') {
    //                         // obj.items = [this.templateLoading];  // for DELETION
    //                         obj.items = [{}];
    //                     }
    //                     if (strItem.id === 'WORK') {
    //                         obj.$expanded = true;
    //                     }
    //                     return obj;
    //                 }))
    //             }
    //         }
    //         const items = (await Promise.all(p));
    //         return items.sort((a, b) => {
    //             return ((a.$item.zIndex < b.$item.zIndex)
    //             || (a.$item.zIndex === b.$item.zIndex && a.$item.label && b.$item.label && a.$item.label.toLowerCase() < b.$item.label.toLowerCase())) ? -1 : 1;
    //         });
    //     } catch (error) {
    //         // ODA.error(this, error.stack);
    //         return [{ template: 'oda-table-error', error }];
    //     }
    // },
    async _getInheritItems(item) {
        const xq = `declare function local:func($base as node(), $id as xs:string){
                        element B{
                        $base /@*,
                        $base/(C,C//C)[@i=$id],
                        for $b in $base/B
                        return local:func($b, $id)
                    }
                };
                local:func(B, '${item.id}')`;
        return CORE.API.post(item.$base.url + '/*', {
            method: 'xquery',
            prefix: 'true'
        }, xq);
    },
    // async _expandItemChanged(item, origin) {
    //     if (!this.contextItem) return;
    //     if (item) {
    //         let node = this.find(i => i.$item && i.$item.path === item.path);
    //         if (node) {
    //             let parentItem = node;
    //             while (parentItem && parentItem.$item.path !== this.contextItem.path) {
    //                 parentItem = this.find(i => i.items && i.items.find(j => j.$item?.path === parentItem.$item.path));
    //                 if (parentItem)
    //                     parentItem.$expanded = true;
    //             }
    //         } else {
    //             let owner = item;
    //             const path = [];
    //             while (owner && owner.path !== this.contextItem.path) {
    //                 path.push(owner);
    //                 owner = owner.$owner;
    //             }
    //             await this._expandPath(path);
    //         }
    //         node = this.find(i => i.$item?.path === item.path);
    //         if (node) {
    //             if (node === origin) {
    //                 origin.view = undefined;
    //             }
    //             if (origin) {
    //                 Object.assign(node, origin);
    //             }
    //             if (this.focusedNode !== node) {
    //                 this.focusedNode = node;
    //             }
    //             this._refresh();
    //         }
    //     }
    // },
    async _expandPath(paths) {
        if (paths.length) {
            const p = paths.pop();
            let node = this.find(i => i.$item?.path === p.path);
            if (node) {
                if (paths.length === 0) {
                    this.focusedNode = node;
                } else {
                    node.items = await this._beforeExpand(node);
                    node.$expanded = true;
                    await this._expandPath(paths);
                }
            }
        }
    },
    _onDragOver(e) {
        let dropEffect = this.$super('oda-tree', '_onDragOver', ...arguments);
        if (dropEffect !== 'none') {
            e.dataTransfer.dropEffect = this._dataTrasfer;
        }
    },
    _onDragEnter(e) {
        this.$super('oda-tree', '_onDragEnter', ...arguments);
        let type = 'none';
        const el = e.path.find(p => p.row);
        if (el.row) {
            if (el.row.drop !== false && (this.allowDrop !== 'none' || el.row.drop)) {
                for (let i = 0; i < this.dragOperation.length; i++) {
                    type = this._draggableRows[0].$item._checkRule(this.dragOperation[i].label.toLowerCase(), el.row.$item) ? 'move' : 'none';
                    if (type !== 'none') {
                        break
                    }
                }
            }
        }
        this._dataTrasfer = type;
    },
    // async _selectCopyItems(contextItem) {
    //     const res = await ODA.showDialog({
    //         title: `Select items`,
    //         component: this.create('odant-copy-sources-tree', { contextItem })
    //     }, 'loaded');
    //     if (res) {
    //         console.log('ok');
    //     }
    // },
    // async _onEvent(e, d) {
    //     if (true) {
    //         const node = this.find(i => {
    //             return i.$item === e.currentTarget;
    //         });
    //         if (node && !(d instanceof odaObject)) {
    //             switch (e.source) {
    //                 case 'update':
    //                     node.items = await this._beforeExpand(node) || [];
    //                     break;
    //                 case 'create':
    //                     node.items = await this._beforeExpand(node) || [];
    //                     node.$expanded = true;
    //                     d = node.items.find(i => i.$item.path === d.path);
    //                     this.async(() => {
    //                         this.focusedNode = d;
    //                     }, 100);
    //                     break;
    //                 case 'deleted':
    //                     if (d) {
    //                         this.deleteItems(i => i.$item?.path === d.path, true);
    //                     } else {
    //                         this.deleteItems(i => i.$item?.path === e.currentTarget.path, true);
    //                     }
    //                     break;
    //             }
    //             this._refresh();
    //         }
    //     }
    // },
    async _search(e) {
        const value = e.detail.value;
        if (value) {
            const regExp = /^\/?(?:(?:[HPBSWDMCO]:[0-9A-F]{15}|[P]:(?:WORK)|(?:ROOT)|(?:USER))\/?)*$/;
            if (regExp.test(value)) {
                this.expandItem = await CORE.findItem(value);
            } else {
                // const item = this.contextItem.$host;
                const item = this.contextItem;
                const view = await this.contextItem.findAction('search');
                // await item.getView('search');
                // const view = await item.getViewAction('search');
                this.focusedNode = { $item: item, view, tag: 'odant-search', param: value };
            }
        }

    },
    async _searchChanged(e) {
        const value = e.detail.value;
        console.log('_searchChanged: ' + value);
    }
});

ODANT({
    imports: '@lib/item-node',
    is: 'odant-structure-node',
    extends: 'odant-item-node',
    template: /*html*/`<style> :host { overflow: visible !important;} </style>`,
    props: {
        showAccess: true,
        showInherit: true,
    }
});