(class extends odaAction {

        execute(params = {}) {
            console.log('methods/copy', params);
            console.log(new Date(Date.now()));
            console.log('source: ', params.source);
            console.log('target: ', this.$item.fullId);

            if (!params.source) {
                throw new Error('Target missed');
            }

            console.log('ODANT.findItem(params.source)');
            return ODANT.findItem(params.source)
            .then((sourceItem) => {
                return this.$item.Items
                .then((children) => {
                    if (children.find(child => child.id === sourceItem.id)) {
                        throw new Error('Item allready exists');
                    }

                    const options = params.options || {};

                    return this.createItem(sourceItem)
                    .then((newItem) => {
                        if (options.copyFiles) {
                            return this.copyFiles(sourceItem, newItem, options)
                            .then(() => {
                                return newItem;
                            });
                        }

                        return newItem;
                    })
                    .then((newItem) => {
                        if (options.copyChildren) {
                            return this.copyChildren(sourceItem, newItem, options)
                            .then(() => {
                                return newItem;
                            })
                        }

                        return newItem;
                    })
                    .then((newItem) => {
                        return 'copy finished';
                    })
                    .catch((err) => {
                        console.dir(err);
                        console.trace();
                        return 'copy failed';
                    });
                });
            });
        }

        createItem(sourceItem) {
            console.log('createItem');

            const params = { name: sourceItem.name };

            let command = 'create_class';

            if (sourceItem.prefix !== 'C') {
                command = 'create_domain';
                params.type = this.$item._convertPrefixToType(sourceItem.prefix);
                params.prefix = true;
            }

            return this.$item.API.POST(command, params, '{"$CLASS":[' + JSON.stringify(sourceItem.Root) + ']}')
            .then((res) => {
                if (sourceItem.prefix === 'C') {
                    return this.$item.getClass(res.$C[0].i);
                }

                return this.$item.getDomain(res.i, sourceItem.prefix);
            })
            .catch((err) => err);
        }

        copyFiles(source, target, options) {
            console.log('copyFiles');

            return source.getFilesAndFolders()
            .then((children) => {
                const exclude = ['class.ocl']
                return children.filter(child => child.inherit.none && (exclude.findIndex(excl => excl === child.id)) === -1);
            })
            .then((children) => {
                return Promise.all(children.map((child) => {
                    return 'ok';
                }));
            });
        }

        copyChildren(sourceItem, target, options) {
            console.log('copyChildren');
            console.log('sourceItem', sourceItem.fullId);
            console.log('target', target.fullId);

            return sourceItem.Items
            .then((children) => {
                return children.filter((child) => child.id !== '000000000000000');
            })
            .then((children) => {
                console.log('copyChildren recursive');
                return Promise.all(children.map((child) => {
                    return ODANT.executeAction(target.fullId, 'methods/copy', { options, source: child.fullId, });
                }));
            });
        }

    }
).register();
