ODANT({
    is: 'user-panel',
    imports: [
        '@lib/item-icon',
    ],
    template: /*html*/`<style>
    :host {
        @apply --vertical;
        width: 200px;
        display: none;
        background-color: white;
    }
    :host(:not([box])) oda-item-icon {
        overflow: hidden;
        border-radius: 50%;
    }
    odant-item-icon {
        margin: 8px;
        @apply --shadow;
        align-self: center;
    }
    oda-icon {
        cursor: pointer;
    }
    oda-button {
        margin-top: 16px;
    }
    span {
        text-align: center;
        width: 100%;
    }
</style>
<div class="flex horizontal" style="justify-content: flex-end; padding: 4px">
    <oda-icon icon="icons:close" @tap="close"></oda-icon>
</div>
<odant-item-icon  @tap="_profile" size="128" :context-item="contextItem" class="success" default="icons:account-circle"></oda-item-icon>
<span class="bold" text="contextItem && contextItem.label"></span>
<span class="font-70" text="contextItem && contextItem.login"></span>
<oda-button class="flex header dark" size="48" icon="icons:power-settings-new" @tap="_logout" label="EXIT"></oda-button>`,
    props: {
        contextItem: Object,
        box: {
            type: Boolean,
            reflectToAttribute: true,
            value: false
        }
    },
    _logout() {
        this.close();
        this.contextItem.logout();
    },
    _profile() {
        this.close();
        this.contextItem.open();
    }
});