if (!Date.prototype.addDays) {
    Object.defineProperty(Date.prototype, 'addDays', { enumerable: false, value: function (num) {
            let value = this.valueOf();
            value += 86400000 * num;
            return new Date(value);
        }});
}

if (!Date.prototype.addSeconds) {
    Object.defineProperty(Date.prototype, 'addSeconds', { enumerable: false, value: function (num) {
            let value = this.valueOf();
            value += 1000 * num;
            return new Date(value);
        }});
}

if (!Date.prototype.addMinutes) {
    Object.defineProperty(Date.prototype, 'addMinutes', { enumerable: false, value: function (num) {
            let value = this.valueOf();
            value += 60000 * num;
            return new Date(value);
        }});
}

if (!Date.prototype.addHours) {
    Object.defineProperty(Date.prototype, 'addHours', { enumerable: false, value: function (num) {
            let value = this.valueOf();
            value += 3600000 * num;
            return new Date(value);
        }});
}

Date.isLeapYear = function (year) {
    return (((year % 4 === 0) && (year % 100 !== 0)) || (year % 400 === 0));
};

Date.getDaysInMonth = function (year, month) {
    return [31, (Date.isLeapYear(year) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month];
};

if (!Date.prototype.isLeapYear) {
    Object.defineProperty(Date.prototype, 'isLeapYear', { enumerable: false, value: function () {
            return Date.isLeapYear(this.getFullYear());
        }});
}

if (!Date.prototype.getDaysInMonth) {
    Object.defineProperty(Date.prototype, 'getDaysInMonth', { enumerable: false, value: function () {
            return Date.getDaysInMonth(this.getFullYear(), this.getMonth());
        }});
}

if (!Date.prototype.addMonths) {
    Object.defineProperty(Date.prototype, 'addMonths', { enumerable: false, value: function (num) {
            const n = this.getDate();
            this.setDate(1);
            this.setMonth(this.getMonth() + num);
            this.setDate(Math.min(n, this.getDaysInMonth()));
            return this;
        }});
}
globalThis.TimeSpan = globalThis.TimeSpan || class TimeSpan extends Date{
    toString(){
        let res = '';
        // const y = this.getFullYear();
        // if (y)
        //     res += y + ' years ';
        // const m = this.getMonth();
        // if (m)
        //     res += m + ' month ';
        // const d = this.getDay();
        // if (d)
        //     res += d + ' days ';
        const hh = this.getHours() + (this.getTimezoneOffset()/60);
        if (hh)
            res += hh + ' hours ';
        const mm = this.getMinutes();
        if (mm)
            res += mm + ' min ';
        const ss = this.getSeconds();
        if (ss)
            res += ss + ' sec ';
        const ms = this.getMilliseconds();
        if (ms)
            res += ms + ' ms ';
        return res;
        // return (y?(y + ' years'):'' + m?(' ' + m + ' month'):'' + d?(' ' + d + ' days'):'' + hh?(' ' + hh +' hours'):'' + mm?(' ' + mm + ' min'):'' + ss?(' ' + ss +' sec'):'' + ms?(' ' + ms +' ms'):'');
    }
};
//
// // NUMBER TYPE ===================================================
//
// Number.prototype.getFormattedValue = (format) =>{
//     return format + ' отформатировано число ';
// };
//
//
// Object.defineProperty(Number, "formats", {
//     get () {
//         return ["Decimal", "Integer", "Percent", "Currency", "Text"]
//     }
// });

// JSON ====================================

JSON.selectNodes = function (json, path) {
    return [json];
};

JSON.selectSingleNode = function (json, path, force) {
    if (!path || !json)
        return json;
    path = path.split('/');
    let step = path.shift();
    if (step) {
        switch (step) {
            case 'CDATA()':
                return json['$CDATA$'];
            case 'TEXT()':
                return json['$TEXT$'];
            default: {
                if (step[0] === '@') {
                    return json[step.substring(1)];
                }
                else {
                    json = json['$' + step];
                    if (json && Array.isArray(json) && json.length > 0) {
                        return JSON.selectSingleNode(json[0], path.join('/'));
                    }
                }
            }
                break;
        }
    }
    return undefined;
};
