window.globalThis = window.globalThis || window;
if (!window.ODA){
    window.ODA = function(prototype = {}) {
        const componentResizeObserver = new ResizeObserver(entries=>{
            for (let i = 0, l = entries.length; i<l;i++){
                entries[i].target.fire('resize');
            }
        });
        const core = {
            reflects: [],
            observers: {},
            listeners: {},
            prototype: prototype,
            root: { tag: '#document-fragment', id: 0, dirs: []},
            data: {},
            $refs: {}
        };
        const module = document.currentScript && document.currentScript.parentElement;

        function callHook (hook) {
            const h = prototype[hook];
            h && h.call(this);
        }
        function ComponentFactory () {
            class odaComponent extends HTMLElement {
                constructor () {
                    super();
                    this.__core__ = deepCopy(core);
                    this.__core__.renderer = render.bind(this);
                    this.__core__.Dep = new Dep1();
                    this.__core__.events = {};
                    this.__core__.data = {};
                    this.__core__.debounces = new Map();
                    for(let name in core.data){
                        let obj = deepCopy.call(this, this[name] || core.data[name]);
                        const d = makeReactive.call(this, this.__core__.data, name, obj, prototype.properties[name]);
                        Object.defineProperty(this, name, {
                            get: d.get,
                            set: d.set
                        });
                    }
                    this.properties = prototype.properties;

                    this.__core__.shadowRoot = (this.localName !== 'oda-module')?this.attachShadow({mode: 'closed'}):null;
                    if(this.localName === 'oda-slot' || prototype.test)
                        this.__core__.root = this.__core__.shadowRoot;
                    callHook.call(this, 'created');
                    ODA.telemetry.components[prototype.is].count++;
                    ODA.telemetry.components.count++;

                    if(this.__core__.shadowRoot){
                        componentResizeObserver.observe(this);
                        // this.__core__.renderer();
                        // this.render();
                        this.debounce('ready', ()=>{
                            Array.prototype.filter.call(this.__core__.shadowRoot.children, s => {
                                return s.attributes['slot'] !== undefined;
                            }).forEach(slot=>{
                                const name = slot.getAttribute('slot');
                                slot.removeAttribute('slot');
                                const el = document.createElement('oda-slot');
                                el.setAttribute('slot', name);
                                el.__core__.root.appendChild(slot);
                                Array.prototype.forEach.call(slot.querySelectorAll('slot'), s=>{
                                    Array.prototype.filter.call(this.children, el=>{
                                        return el.getAttribute('slot') === s.getAttribute('name');
                                    }).forEach(s =>{
                                        el.appendChild(s);
                                    })
                                });
                                el.__core__.root = null;
                                delete el.__core__.root;
                                let p = this;
                                while (p && p.__core__){
                                    if (p.__core__.prototype.slots && p.__core__.prototype.slots.includes(name)){
                                        p.appendChild(el);
                                        break;
                                    }
                                    p = p.domHost;
                                }
                            });
                            for (let i = 0, l = core.reflects.length; i<l; i++)
                                funcToAttribute.call(this, core.reflects[i]);
                            for (const obs in this.__core__.observers){
                                for(let h of this.__core__.observers[obs])
                                    h.call(this);
                            }

                            callHook.call(this, 'ready');
                            this.render();
                        });
                    }
                }
                connectedCallback () {
                    for (let event in prototype.listeners){
                        this.__core__.listeners[event] = (e)=>{
                            prototype.listeners[event].call(this, e, e.detail);
                        };
                        this.addEventListener(event, this.__core__.listeners[event]);
                    }
                    callHook.call(this, 'attached');
                }
                disconnectedCallback () {
                    for (let event in prototype.listeners)
                        this.removeEventListener(event, this.__core__.listeners[event])
                    callHook.call(this, 'detached');
                }
                static get observedAttributes(){
                    return Object.keys(prototype.properties).map(key=>prototype.properties[key].attrName);
                }
                attributeChangedCallback(name, o, n){
                    if (o === n) return;
                    this[name.toCamelCase()] = (n === '')?true:((o === '' && n === null)?false:n);
                }
                get host(){
                    return this;
                }
                updateStyles (styles = {}, old = {}){
                    Object.keys(Object.assign({}, styles, old)).forEach(name => {
                        this.style[name] = styles[name] || '';
                    });
                }
                notify(key){
                    const obs = this.__core__.observers[key];
                    if(!obs) return;
                    for(let i=0, l=obs.length; i<l; i++)
                        obs[i].call(this, key);
                }

                render(){
                    if(!this.__core__.shadowRoot || this.__core__.inRender) return;
                    this.__core__.inRender = true;
                    ODA.render(this.__core__.renderer);
                }
                resolveUrl(path){
                    return prototype.path + path;
                }
                delete (root, path){
                    this.set(root, path)
                }
                get (root, path) {
                    if(!root)
                        return undefined;
                    if(!path)
                        return root;
                    path = path.split('.');
                    const p = path.shift();
                    root = root[p];
                    if(path.length>0)
                        return this.get(root, path.join('.'));
                    return root;
                }
                set (context, path, value){
                    let root = context === this?this.__core__.data:context;
                    const steps = path.split('.');
                    const name = steps.pop();
                    for (let step of steps){
                        step = root[steps.shift()] || {};
                        observeObj.call(this, step);
                        root = step;
                    }
                    // if(!Object.getOwnPropertyDescriptor(root, name))
                        makeReactive.call(this, root, name);
                    root[name] = value;
                }
                fire (event, detail){
                    event =  new odaCustomEvent(event, {detail: {value: detail}, composed: true});
                    this.dispatchEvent(event);
                }
                listen(item, event='', callback){
                    if (item) {
                        if (typeof callback === 'string'){
                            callback = this.__core__.events[callback] = this.__core__.events[callback] || this[callback].bind(this);
                        }

                        event.split(',').forEach(i => {
                            item.addEventListener(i.trim(), callback)
                        });
                    }
                }
                unlisten (item, event='', callback){
                    if (item) {
                        if (typeof callback === 'string')
                            callback = this.__core__.events[callback];
                        if(callback) {
                            event.split(',').forEach(i => {
                                item.removeEventListener(i.trim(), callback)
                            });
                        }
                    }
                }
                create (tagName, props={}, inner){
                    const el = document.createElement(tagName);
                    for (let p in props)
                        el[p] = props[p];
                    if (inner) {
                        if (inner instanceof HTMLElement)
                            el.appendChild(inner);
                        else
                            el.textContent = inner;
                    }
                    return el;
                }
                debounce (key, handler, delay = 0){
                    let db = this.__core__.debounces.get(key);
                    if(db)
                        delay?clearTimeout(db):cancelAnimationFrame(db);
                    const fn = delay?setTimeout:requestAnimationFrame;
                    const t = fn(() => {
                        this.__core__.debounces.delete(key);
                        handler.call(this);
                    }, delay);
                    this.__core__.debounces.set(key, t)
                }
                get $refs() {
                    return this.__core__.$refs;
                }
                async (handler, delay = 0){
                    delay?setTimeout(handler, delay):requestAnimationFrame(handler)
                }
                __read (path, def){
                    this.setting  =  this.setting || JSON.parse(localStorage.getItem(prototype.is));
                    if(typeof this.setting !== 'object')
                        this.setting  = {};
                    path = path.split('/');
                    let s = this.setting;
                    while (path.length && s){
                        s = s[path.shift()];
                    }
                    return s || def;
                }
                __write (path, value){
                    this.setting  =  this.setting || JSON.parse(localStorage.getItem(prototype.is));
                    if(typeof this.setting !== 'object')
                        this.setting  = {};
                    path = path.split('/');
                    let s = this.setting;
                    if (s) {
                        while (path.length > 1) {
                            const p = path.shift();
                            s = s[p] = typeof s[p] === 'object' ? s[p] : {};
                        }
                        s[path.shift()] = value;
                        localStorage.setItem(prototype.is, JSON.stringify(this.setting));
                    }
                }
                $super  (name, ...args) {
                    const getIds = (p) => {
                        const res = [];
                        let id = p.extends;
                        if (id) {
                            const ids = id.split(/, */).filter(i => i !== 'this');
                            for (const id of ids) {
                                res.push(id);
                                res.push(...getIds(ODA.telemetry.components[id].prototype));
                            }
                        }
                        return res;
                    };
                    const curId = this.$parent.__core__.name;
                    const curMethod = ODA.telemetry.components[curId].prototype[name] || ODA.telemetry.components[curId].prototype[name];
                    const ids = getIds(ODA.telemetry.components[curId].prototype);
                    for (const id of ids) {
                        const proto = ODA.telemetry.components[id].prototype;
                        const method = proto.methods[name] || proto[name];
                        if (curMethod !== method && typeof method === 'function') {
                            return method.call(this, ...args);
                        }
                    }
                    throw new Error(`Not found super method: "${name}" `);
                };
                get domHost(){
                    return this.__core__.domHost ||  (()=>{
                        let p = this.parentNode;
                        while (p  && !p.__core__) {
                            if (p.constructor.name === 'ShadowRoot')
                                p = p.host;
                            else
                                p = p.parentNode;
                        }
                        this.__core__.domHost = p;
                        return p;
                    })();
                }
                set hidden(v){
                    this.style.visibility = v ? 'hidden' : 'visible';
                }
            }

            for (let name in prototype.properties) {
                const prop = prototype.properties[name];
                prop.name = name;
                prop.attrName = prop.attrName || name.toKebabCase();
                // if (prop.reflectToAttribute){
                //     core.reflects.push(name);
                //     core.observers[name] = core.observers[name] || [];
                //     core.observers[name].push(funcToAttribute);
                // }

                // Object.defineProperty(odaComponent.prototype, name, {
                //     get() {
                //         return this.__core__.data[name];
                //     },
                //     set(v) {
                //         this.__core__.data[name] = v;
                //     }
                // });
                let val = prop.default;
                if (typeof val === "function")
                    val = val.call(this);
                if (val && val.then)
                    val.then(val);
                core.data[name] = val;
            }
            core.root.children = prototype.template?parseJSX(prototype, prototype.template):[];
            for(let func of prototype.observers){
                let expr;
                if (typeof func === 'function') {
                    expr = func.toString();
                    expr = expr.substring(0, expr.indexOf('{')).replace('async', '').replace('function', '').replace(func.name, '');
                }
                else{
                    expr = func.substring(func.indexOf('('));
                }
                expr = expr.replace('(', '').replace(')', '').trim();
                const dd = Object.keys(core.data);
                const vars = expr.split(',').map(prop=>{
                    prop = prop.trim();
                    const idx = dd.indexOf(prop);
                    if (idx<0)
                        ODA.error(prototype.is, `No found propety by name "${prop} for observer ${func.toString()}"`);
                    return {prop, arg: 'v' + idx};
                });
                if (typeof func === 'string'){
                    const args = vars.map(i=>{
                        func = func.replace(i.prop, i.arg);
                        return i.arg;
                    }).join(',');
                    func = new Function(args, `with (this) {${func}}`);
                }
                function funcObserver(){
                    const params = vars.map(v=>{
                        return this[v.prop];
                    });
                    if (!params.includes(undefined))
                        func.call(this,  ...params);
                }
                for (const v of vars){
                    core.observers[v.prop] = core.observers[v.prop] || [];
                    core.observers[v.prop].push(funcObserver);
                }
            }
            Object.getOwnPropertyNames(prototype).forEach(name => {
                const d = Object.getOwnPropertyDescriptor(prototype, name);
                if (typeof d.value === 'function'){
                    odaComponent.prototype[name] = function (...args)  {
                        return d.value.call(this, ...args);
                    }
                }
            });
            return odaComponent
        }
        function parsePath (path) {
            if (/[^\w.$]/.test(path)) return;
            var segments = path.split('.');
            return function (obj) {
                for (var i = 0; i < segments.length; i++) {
                    if (!obj) { return }
                    obj = obj[segments[i]];
                }
                return obj
            }
        }
        function makeReactive(obj, key, val, prop){
            if (obj.__core__)
                obj = obj.__core__.data;
            let d = Object.getOwnPropertyDescriptor(obj, key);
            if(d && !d.configurable) return d;
            const dep = new Dep(this);
            const getter = d && d.get;
            const setter = d && d.set;
            let deps = [];
            const computed = prop && !!prop.computed;
            const DEP = this.__core__.Dep;
            if(computed){
                val = null;
                this.__core__.observers[key] = this.__core__.observers[key] || [];
                this.__core__.observers[key].add(()=>{
                    val = null;
                    deps = DEP.getValidDeps(deps, key);
                    DEP.notifyDeps.call(this,  deps, key)
                })
            }
            else if (!getter && val === undefined)
                val = obj[key];
            let childOb = observeObj.call(this, val, key);
            d = {
                enumerable: true,
                configurable: true,
                get: () => {
                    if (computed){
                        DEP.target && DEP.depend(deps, key);
                        DEP.target = key;
                        if (!val) {
                            DEP.subs[key] = [];
                            val = prop.computed.call(this);
                        }
                        DEP.target = null;
                        return val;
                    }
                    let value = getter?getter.call(obj):val;
                    if (DEP.target) {
                        DEP.depend(deps, key);
                        if (childOb) {
                            childOb.dep.depend();
                            if (Array.isArray(value))
                                dependArray(value);
                        }
                    }
                    return value;
                },
                set: (newVal) =>{
                    if (prop){
                        if (prop.type === Boolean)
                            newVal = (newVal === 'true') || !!newVal;
                        else if (prop.type === Number)
                            newVal = +newVal
                    }
                    const old = getter ? getter.call(obj) : val;
                    if (newVal === old) return;
                    setter?setter.call(obj, newVal):(val = newVal);
                    childOb = observeObj.call(this, newVal, key);
                    if (deps.length)
                        deps = DEP.getValidDeps(deps, key);
                    DEP.notifyDeps.call(this, deps, key);
                    this.notify(key);
                    if (prop){
                        if (prop.reflectToAttribute)
                            funcToAttribute.call(this, key);
                        if (prop.watch)
                            prop.watch.call(this, newVal, old);
                        if (prop.notify)
                            this.dispatchEvent(new CustomEvent(prop.attrName+'-changed', {detail: {value: val, src: this}, bubbles: true, cancelable: true}));
                    }
                }
            };
            Object.defineProperty(obj, key, d);
            return d;
        }

        class Observer{
            constructor (obj, host) {
                this.dep = new Dep(host);
                def(obj, '__ob__', this);
                if (Array.isArray(obj)) {
                    obj.__proto__ = arrayMethods;
                    this.observeArray.call(host, obj);
                } else {
                    this.walk.call(host, obj);
                }
            }
            walk (obj){
                if(!isPlainObject(obj)) return;
                for (let key in obj)
                    makeReactive.call(this, obj, key);
            }
            observeArray (items){
                for (let i = 0, l = items.length; i<l; i++)
                    observeObj.call(this, items[i]);
            }
        }
        const hop = Object.prototype.hasOwnProperty;
        function hasProperty(obj, key){
            return hop.call(obj, key)
        }
        function observeObj (obj) {
            if (!isObject(obj)) return;
            if (/*hasProperty(obj, '__ob__') && */obj.__ob__ instanceof Observer) return  obj.__ob__;
            if ((Array.isArray(obj) || isPlainObject(obj)) && Object.isExtensible(obj)) return new Observer(obj, this);
        }
        function dependArray (value) {
            for (let obj = undefined, i = 0, l = value.length; i < l; i++) {
                obj = value[i];
                if (obj && obj.__ob__)
                    obj.__ob__.dep.depend();
                if (Array.isArray(obj))
                    dependArray(obj);
            }
        }
        class  Dep1{
            constructor(){
                this.target = null;
                this.subs = {};
            }
            depend (deps, dep) {
                deps.add(this.target);
                this.subs[this.target].add(dep)
            }
            getValidDeps (deps, key) {
                return deps.filter(dep => this.subs[dep].includes(key))
            }
            notifyDeps (deps) {
                for (let i=0, l = deps.length; i<l; i++)
                    this.notify(deps[i]);
                this.render();
            }
        }
        class Dep{
            constructor(host){
                this.subs = [];
                this.host = host;
            }
            addSub (sub) {
                this.subs.add(sub);
            }
            removeSub (sub) {
                this.subs.remove(sub);
            }
            depend () {
                if (Dep.target)
                    Dep.target.addDep(this);
            }
            notify () {
                for (let i = 0, l=this.subs.length; i<l; i++)
                    this.subs[i].update();
                this.host.render(this.host);
            }
        }
        Dep.target = null;
        const targetStack = [];
        function pushTarget (_target) {
            if (Dep.target) {
                targetStack.push(Dep.target);
            }
            Dep.target = _target;
        }
        function popTarget () {
            Dep.target = targetStack.pop();
        }
        function  regComponent () {
            prototype.is = prototype.is || prototype.name || module && module.id;
            if (window.customElements.get(prototype.is) === undefined){
                try{
                    let template;
                    const parents = ((prototype.extends && prototype.extends.split(',')) || []).filter(i=>{
                        i = i.trim();
                        return i === 'this' || i.includes('-');
                    }).map(ext =>{
                        ext = ext.trim();
                        if (ext === 'this')
                            return ext;
                        const parent =  ODA.telemetry.components[ext];
                        if (!parent)
                            ODA.error(prototype.is,`not found inherit parent "${ext}"`);
                        return parent;
                    });

                    if (module) {
                        module.id = prototype.is;
                        prototype.module = module;

                        if (prototype.template) {
                            template = prototype.template;
                        }
                        else
                            template = Array.prototype.find.call(prototype.module.children, i => i.localName === 'template');
                        let style = Array.prototype.find.call((prototype.module).children, i => i.localName === 'style');
                        if (style)
                            ODA.warn(prototype.is, 'Tag <style> must be has in to tag <template>');

                        if (template){
                            style = Array.prototype.find.call((template.content || template).children, i => i.localName === 'style');
                            if (style){
                                style.setAttribute('scope', prototype.is);
                                style.textContent = style.textContent.replace(applyRegx, applyReplacer);
                            }
                        }

                        if (template && prototype.module && prototype.module.localName && prototype.module.localName !== 'oda-test' && prototype.module.localName !== 'oda-module') {
                            //ODA.error(prototype.is, `Please use module tag name as <oda-module id="${prototype.is}">.`);
                            ODA.error(prototype.is, `Valid ODA module names are <oda-module> or <oda-test>.`);
                        }

                        if (prototype.module.localName === 'oda-test' && (template.content || template).firstElementChild){
                            const id = (template.content || template).firstElementChild.localName;
                            prototype.is = id+'-test' + (prototype.is?'-'+prototype.is:'');
                            prototype.test = id;
                            prototype.module.id = prototype.is;
                            if (window.customElements.get(prototype.is)!== undefined)
                                return;
                        }

                        prototype.path = (decodeURI(prototype.module.baseURI)).split('/');

                        prototype.path.pop();
                        prototype.path = prototype.path.join('/') + '/';

                        prototype.classes = [];
                        prototype.slots = [];
                        if (template){
                            Array.prototype.forEach.call((template.content || template).querySelectorAll('*'), el=>{
                                if (el.localName === 'slot') {
                                    const name =  el.getAttribute('name');
                                    if (name)
                                        prototype.slots.push(name);
                                }
                                let cls = el.getAttribute('class');
                                if (cls)
                                    prototype.classes.push(...cls.split(' ').filter(v=> ODA.styles['--'+v]));
                                cls = el.getAttribute(':class');
                                // if (cls){ todo
                                //     try{
                                //         const func = new Function(`with (this) return ${cls}`);
                                //         cls = func.call(prototype.properties);
                                //         prototype.classes.push(...Object.keys(cls).filter(v=> ODA.styles['--'+v]));
                                //     }
                                //     catch (e) {
                                //         // el.removeAttribute(':class');
                                //         // ODA.error(prototype.is, `In expression :class="${cls}"`, e)
                                //     }
                                //
                                // }


                                Array.prototype.forEach.call(el.attributes, a=>{
                                    const name = a.name.substring(a.name.lastIndexOf(':')+1);
                                    const v = ODA.styles['--' + name];
                                    if (v)
                                        prototype.classes.push(name);
                                });
                            });
                        }
                        prototype.classes = prototype.classes.filter((item, pos) => {
                            return prototype.classes.indexOf(item) === pos;
                        });
                        const more = prototype.classes.map(v=>{
                            return `.${v}{\n\t@apply --${v};\n}\n`
                        }).join('\n').replace(applyRegx, applyReplacer);

                        if(more) {
                            if (style){
                                style.innerHTML += '\n'+more.replace(applyRegx, applyReplacer);
                            }
                            else{
                                const el = document.createElement('style');
                                el.setAttribute('scope', prototype.is);
                                el.innerHTML = more.replace(applyRegx, applyReplacer);
                                template.content.appendChild(el)
                            }
                        }
                        template = (template && template.innerHTML) || '';
                        let par_templates  = '';
                        parents.forEach((parent, i)=>{
                            if (parent === 'this'){
                                par_templates += template;
                                template = '';
                            }
                            else if (parent){
                                if (parent.template){
                                    par_templates += parent.template;
                                }
                                prototype.classes.push(...parent.prototype.classes);
                            }
                        });
                        while (parents.indexOf('this') > -1)
                            parents.splice(parents.indexOf('this'), 1);

                        template = par_templates + template;


                        prototype.template = template;
                    }

                    convertPrototype(parents);

                    if (prototype.path){
                        ODA.modules.push({path: prototype.path, id: prototype.is});
                    }

                    ODA.telemetry.components[prototype.is] = {prototype: prototype, template: template, count: 0, render: 0};

                    let options;
                    let el;
                    if (prototype.extends && !prototype.extends.includes(',') && !ODA.telemetry.components[prototype.extends]){
                        el = class extends Object.getPrototypeOf(document.createElement(prototype.extends)).constructor{
                            constructor(){
                                super();
                            }
                            connectedCallback(){
                                if (prototype.attached)
                                    prototype.attached.apply(this);
                            }
                            disconnectedCallback(){
                                if (prototype.detached)
                                    prototype.detached.apply(this);
                            }
                        };
                        options = {
                            extends: prototype.extends
                        }
                    }
                    else{
                        el = ComponentFactory();
                    }

                    window.customElements.define(prototype.is,  el , options);
                    ODA.success(prototype.is, 'registered');
                    if (prototype.test)
                        ODA.tests[prototype.test] = prototype.is;

                }
                catch (e) {
                    ODA.error(prototype.is, e);
                }
            }
            else{
                // ODA.warn(prototype.is, 'component has already been registered');
            }
        }

        function convertPrototype(parents){
            prototype.properties = prototype.properties || {};
            prototype.observers = prototype.observers || [];

            for(let key in prototype.properties){
                let prop = prototype.properties[key];
                let computed = prop && (prop.computed || prop.get || (typeof prop === 'function' && !prop.prototype && prop));
                if (computed){
                    if (typeof prop === 'function')
                        prototype.properties[key] = prop = {};
                    if (typeof computed === 'string')
                        computed = prototype[computed];
                    delete prop.get;
                    prop.computed = computed;
                }
                let watch = prop && (prop.watch || prop.set || prop.observe);
                if (watch){
                    if (typeof watch === 'string')
                        watch = prototype[watch];
                    delete prop.set;
                    delete prop.observe;
                    prop.watch = watch;
                }
                if (typeof prop === "function"){
                    prop = {type: prop};
                    prototype.properties[key] = prop;
                }
                else if (Array.isArray(prop)) {
                    const array =  [].concat(prop);
                    prop = prototype.properties[key] = {default(){
                            return [].concat(array);
                        }, type: Array};
                }
                else if(typeof prop !== "object"){
                    prop = prototype.properties[key] = {default: prop, type: prop.__proto__.constructor};
                }
                else if(prop === null){
                    prop = prototype.properties[key] = {type: Object, default: null};
                }
                else if(Object.keys(prop).length === 0 || (!computed && !watch && prop.default === undefined && !prop.type)){
                    const n = Object.assign({}, prop);
                    prop = prototype.properties[key] = {type: Object, default(){return n}};
                }


                if (prop.value !== undefined)
                    prop.default = prop.value;
                delete prop.value;
                if (prop.default !== undefined && typeof prop.default !== 'function') {
                    switch (prop.type) {
                        case undefined:{
                            if (Array.isArray(prop.default)){
                                const array = [].concat(prop.default);
                                prop.default = function(){return [].concat(array)};
                                prop.type = Array;
                            }
                            else if(typeof prop.default === 'object'){
                                const obj = Object.assign({}, prop.default);
                                prop.default = function(){return Object.assign({}, obj)};
                                prop.type = Object;
                            }
                            else{
                                prop.type = prop.default.__proto__.constructor;
                            }

                        } break;
                        case Object:{
                            if (prop.default){
                                const obj = Object.assign({}, prop.default);
                                prop.default = function(){return Object.assign({}, obj)};
                            }
                        } break;
                        case Array:{
                            const array = [].concat(prop.default);
                            prop.default = function(){return [].concat(array)};
                        } break;
                    }
                }
            }

            prototype.listeners = prototype.listeners || {};
            if (prototype.keyBindings){
                prototype.listeners.keydown = function (e) {
                    const key = Object.keys(prototype.keyBindings).find(key=>{
                        return key.toLowerCase().split(',').some(v=>{
                            return v.split('+').every(k=>{
                                switch (k.trim()) {
                                    case 'ctrl':
                                        return e.ctrlKey;
                                    case 'shift':
                                        return e.shiftKey;
                                    case 'alt':
                                        return e.altKey;
                                    default:
                                        return k === e.key.toLowerCase();
                                }
                            })
                        });
                    });
                    if (key){
                        e.preventDefault();
                        let handler = prototype.keyBindings[key];
                        if (typeof handler === 'string')
                            handler = prototype[handler];
                        handler.call(this, e);
                    }
                }
            }
            for (let event in prototype.listeners){
                const handler = prototype.listeners[event];
                prototype.listeners[event] = (typeof handler === 'string')?prototype[handler]:handler;
            }

            parents.forEach(parent=>{
                if (parent){
                    for(let key in parent.prototype.properties){
                        let p = parent.prototype.properties[key];
                        let me = prototype.properties[key];
                        if(!me){
                            p = Object.assign({}, p);
                            p.extends = parent.prototype.is;
                            prototype.properties[key] = p;
                        }
                        else{
                            for(let k in p){
                                if (!me[k]){
                                    me[k] = p[k];
                                }
                                else if(k === 'type' && p[k] && me[k] !== p[k]){
                                    const _types = new Set([...(Array.isArray(me[k]) ? me[k] : [me[k]]), ...(Array.isArray(p[k]) ? p[k] : [p[k]])]);
                                    me[k] = [..._types];
                                }
                            }
                            if (!me.extends)
                                me.extends = parent.prototype.is;
                            else
                                me.extends = me.extends + ', ' + parent.prototype.is;
                        }
                    }
                    for(let key in parent.prototype.listeners){
                        if(!Object.getOwnPropertyDescriptor(prototype.listeners, key)){
                            const par = Object.getOwnPropertyDescriptor(parent.prototype.listeners, key);
                            prototype.listeners[key] = par.value;
                        }
                    }
                    parent.prototype.observers.forEach(func =>{
                        let name;
                        if (typeof func === 'function'){
                            name = func.name;
                        }
                        else{
                            name = func.split(' ')[0]
                        }
                        const f = prototype.observers.find(func=>{
                            if (typeof func === 'function'){
                                return name === func.name;
                            }
                            else{
                                return func.startsWith(name);
                            }
                        });
                        if(!f){
                            prototype.observers.push(func);
                        }
                    });
                    for(let key in parent.prototype){
                        const p = Object.getOwnPropertyDescriptor(parent.prototype, key);
                        const self = Object.getOwnPropertyDescriptor(prototype, key);
                        if (typeof p.value === 'function'){
                            if (!self){
                                prototype[key] = function(...args){
                                    return p.value.call(this, ...args);
                                }
                            }
                            else if(hooks.includes(key)){
                                prototype[key] = function(){
                                    p.value.apply(this);
                                    if (self)
                                        self.value.apply(this);
                                }
                            }
                        }
                    }
                }
            });
        }


        if (document.frameworkIsReady || prototype.is === 'oda-style' || !module) {
            regComponent(prototype, module);
        }
        else {
            const handler = () => {
                document.removeEventListener('framework-ready', handler);
                requestAnimationFrame(()=>{
                    regComponent(prototype, module);
                })
            };
            document.addEventListener('framework-ready', handler)
        }
    };
    function funcToAttribute(name){
        const val = this[name];
        name = name.toKebabCase();
        if (val === false || val === undefined || val === null || val === '')
            this.removeAttribute(name);
        else
            this.setAttribute(name, val === true?'':val);
    }
    let sid = 0;
    class VNode{
        constructor(el, vars) {
            this.id = ++sid;
            this.vars = vars;
            el.__node__ = this;
            this.el = el;
            this.tag = el.nodeName;
            this.attrs = {};
            this.bind = {};
            this.dirs = [];
            this.tags = [];
            this.text = [];
            this.fn = {};
            this.children = [];
            this.cache = {[el.nodeName]:[]};
            if (el.nodeName === 'svg' || (el.parentNode && el.parentNode.__node__ && el.parentNode.__node__.svg))
                this.svg = true;
            this.listeners = {};
        }
        setCache(el){
            this.cache[el.nodeName] = this.cache[el.nodeName] || [];
            this.cache[el.nodeName].add(el);
        }
        getCache(tag){
            return (this.cache[tag] || []).shift()
        }
    }
    function parseJSX(prototype, el, vars = []){
        if (typeof el === 'string'){
            let tmp = document.createElement('template');
            tmp.innerHTML = el;
            tmp = tmp.content.childNodes;
            return Array.prototype.map.call(tmp, el=>parseJSX(prototype, el)).filter(i=>i);
        }
        let src = new VNode(el, vars);
        if (el.nodeType === 3){
            const value = el.textContent.trim();
            if (!value) return;
            if(/\{\{((?:.|\n)+?)\}\}/g.test(value)) {
                const expr = value.replace(/^|$/g, "'").replace(/{{/g, "'+(").replace(/}}/g, ")+'").replace(/\n/g, "\\n").replace(/\+\'\'/g, "").replace(/\'\'\+/g, "");
                const fn = func(vars.join(','), expr);
                src.text.push(function textContent($el, p){
                    $el.textContent = exec.call(this, fn, p) || '';
                });
            }
            else
                src.textContent = value;
        }
        else if (el.nodeType === 8){
            src.textContent = el.textContent;
        }
        else {
            let attr, name, modifiers, expr;
            for (let i=0,l=el.attributes.length; i<l;  i++){
                attr = el.attributes[i]
                name = attr.name;
                modifiers = parseModifiers(name);
                if (modifiers)
                    name = name.replace(modifierRE, '');
                expr = attr.value;
                if (prototype[expr])
                    expr+='()';
                if (/^:/.test(attr.name)){
                    name = name.replace(/:/g, '');
                    if (tags[name])
                        new Tags(src, name, expr, vars);
                    else if (directives[name])
                        new Directive(src, name, expr, vars);
                    else if (name === 'for')
                        return forDirective(prototype, src, name, expr, vars, attr.name);
                    else{
                        let fn = func(vars.join(','), expr);
                        if (/::/.test(attr.name)){
                            const params = ['$value', ...(vars || [])];
                            const func = new Function(params.join(','), `with (this) {${expr} = $value}`);
                            src.listeners[src.tag === 'INPUT'?'input':name+'-changed'] = function (e, d) {
                                if (e.target.__node__.vars){
                                    const idx = e.target.__node__.vars.indexOf(expr);
                                    if (idx%2 === 0){
                                        const array = e.target.__array[idx+2];
                                        const index = e.target.__array[idx+1];
                                        array.splice(index, 1, e.target[name]);
                                        return;
                                    }
                                }
                                exec.call(this, func, [e.target[name]]);
                                this.render();
                            }
                        }
                        const h = function(params){
                            return exec.call(this, fn, params);
                        };
                        h.modifiers = modifiers;
                        src.bind[name.toCamelCase()] = h;
                    }
                }
                else if (/^(oda|[a-z])?-/.test(name)){
                    name = name.replace(/^(oda|[a-z])?-/, '');
                    if (name === 'for')
                        return forDirective(prototype, src, name, expr, vars, attr.name);
                    else if (name === 'model'){
                        const fn = func(vars.join(','), expr);
                        const params = ['$value', ...(vars || [])];
                        const func1 = new Function(params.join(','), `with (this) {${expr} = $value}`);
                        src.listeners[src.tag === 'INPUT'?'input':name+'-changed'] = function (e, d) {
                            if (e.target.__node__.vars){
                                const idx = e.target.__node__.vars.indexOf(expr);
                                if (idx%2 === 0){
                                    const array = e.target.__array[idx+2];
                                    const index = e.target.__array[idx+1];
                                    array.splice(index, 1, e.target.value);
                                    return;
                                }
                            }
                            exec.call(this, func1, [e.target.value]);
                            this.render();
                        };
                        src.bind['value'] = function(params){
                            return exec.call(this, fn, params);
                        }
                    }
                    else if (tags[name])
                        new Tags(src, name, expr, vars);
                    else if (directives[name])
                        new Directive(src, name, expr, vars);
                    else
                        throw new Error('Unknown directive '+attr.name);
                }
                else if (/^@/.test(attr.name)){
                    if (prototype[attr.value])
                        expr = attr.value+'($event, $detail)';
                    name = name.replace(/^@/g, '');
                    const params = ['$event', '$detail', ...(vars || [])];
                    const fn = new Function(params.join(','), `with (this) {${expr}}`);
                    src.listeners = src.listeners || {};
                    const handler = prototype[expr];
                    src.listeners[name] = function (e){
                        modifiers && modifiers.stop && e.stopPropagation();
                        modifiers && modifiers.prevent && e.preventDefault();
                        if(typeof handler === 'function')
                            handler.call(this, e, e.detail);
                        else
                            exec.call(this, fn, [e]);
                    };
                }
                else if (name === 'is')
                    src.tag = expr.toUpperCase();
                else if (name === 'id' || name === 'ref')
                    src.ref = expr;
                else
                    src.attrs[name] =  expr;
            }
            src.children =  Array.from(el.childNodes).map(el=>{
                return parseJSX(prototype, el, vars)
            }).filter(i=>i);
        }
        return src;
    }
    const tags = {
        if(tag, fn, p, $el){
            return exec.call(this, fn, p)?tag:'#comment';
        },
        'else-if'(tag, fn, p, $el){
            if (!$el || ($el.previousElementSibling && $el.previousElementSibling.nodeType === 1))
                return '#comment';
            return exec.call(this, fn, p)?tag:'#comment';
        },
        else(tag, fn, p, $el){
            if (!$el || ($el.previousElementSibling && $el.previousElementSibling.nodeType === 1))
                return '#comment';
            return tag;
        },
        is(tag, fn, p){
            return ((exec.call(this, fn, p) || '').toUpperCase() || tag);
        }
    };
    const directives = {
        ref($el, fn, p){
            $el.__ref = exec.call(this, fn, p);
        },
        id($el, fn, p){
            $el.__ref = exec.call(this, fn, p);
        },
        show($el, fn, p){
            $el.style.display = exec.call(this, fn, p)?'':'none';
        },
        html($el, fn, p){
            $el.innerHTML = exec.call(this, fn, p) || '';
        },
        text($el, fn, p){
            $el.textContent = exec.call(this, fn, p) || '';
        },
        class($el, fn, p){
            let s = exec.call(this, fn, p) || '';
            if ($el.__class !== s/* !Object.equal($el.__class, s)*/){
                $el.__class = s;
                const src = $el.__node__;
                if (typeof s === 'string')
                    s = s.replace(/,/g, ' ').split(' ');
                else if (!Array.isArray(s))
                    s = Object.keys(s).filter(i => s[i]);
                if (src.attrs.class){
                    src.class = src.attrs.class.split(' ');
                    delete src.attrs.class;
                }
                if (src.class)
                    s.push(...src.class);
                s = s.join(' ');
                $el.setAttribute('class', s);
            }
        },
        style($el, fn, p){
            let s = exec.call(this, fn, p) || '';
            if ($el.__style !== s/* !Object.equal($el.__style, s)*/){
                $el.__style = s;
                const src = $el.__node__;
                if (typeof s === 'string')
                    s = styleToObj(s);
                else if (Array.isArray(s))
                    s = Object.assign({}, ...s);
                if (src.attrs.style){
                    src.style = styleToObj(src.attrs.style);
                    delete src.attrs.style;
                }
                if (src.style)
                    s = Object.assign(s, src.style);
                let style = '';
                for (let key in s)
                    style += key.toKebabCase()+': '+s[key] + '; ';
                $el.setAttribute('style', style);
            }
        }
    };
    class Directive {
        constructor(src, name, expr, vars){
            src.fn[name] = func(vars.join(','), expr);
            src.fn[name].expr = expr;
            src.dirs.push(directives[name])
        }
    }
    class Tags {
        constructor(src, name, expr, vars){
            src.fn[name] = expr?func(vars.join(','), expr):null;
            src.tags.push(tags[name])
        }
    }
    function  forDirective(prototype, src, name, expr, vars, attrName){
        const newVars = expr.replace(/\s(in|of)\s/, '\n').split('\n');
        expr = newVars.pop();
        const params = (newVars.shift() || '').replace('(', '').replace(')', '').split(',');
        forVars.forEach((varName, i) =>{
            let p = pp = (params[i] || forVars[i]).trim();
            let idx = 1;
            while (vars.find(v =>p === v)){
                p = pp + idx; ++idx;
            }
            newVars.push(p);
        });
        src.vars = [...vars];
        src.vars.push(...newVars);
        src.el.removeAttribute(attrName);
        const child = parseJSX(prototype, src.el, src.vars);
        const fn = func(src.vars.join(','), expr);
        const h =  function (p) {
            let items = exec.call(this, fn, p);
            if (items === undefined)
                items = [];
            else if(!Array.isArray(items)){
                items = new Array(+items);
                for (let i = 0; i < items.length; items[i++] = -1);
            }
            const res = []
            for (let item, i = 0, l = items.length; i<l; i++){
                item = items[i];
                res.push({src: child, params: [...(p || emptyArray), item, i, items]})
            }
            return res
        };
        h.src = child;
        return h;
    }

    function createElement(src, tag) {
        let $el = src.getCache(tag);
        if (!$el){
            if (tag === '#comment')
                $el = document.createComment(src.textContent || src.id);
            else if (tag === '#text')
                $el = document.createTextNode(src.textContent || '');
            else if (src.svg)
                $el = document.createElementNS(svgNS, tag);
            else
                $el = document.createElement(tag);
        }
        for (const e in src.listeners || {})
            $el.addEventListener(e, src.listeners[e].bind(this));
        $el.__node__ = src;
        return $el;
    }
    function render(){
        this.__core__.$refs = {};
        updateDom.call(this, this.__core__.root, this.__core__.shadowRoot);
        this.__core__.inRender = false;
    }
    function  updateDom(src, $el, $parent, pars){
        let tag = src.tag, h, i, l;
        if ($parent){
            for (i = 0, l = src.tags.length; i<l; i++){
                h = src.tags[i];
                tag = h.call(this, tag, src.fn[h.name], pars, $el);
            }
            if (!$el){
                $el = createElement.call(this, src, tag);
                $parent.appendChild($el);
            }
            else if ($el.__node && $el.__node__.id !== src.id || ($el.tagName || $el.nodeName) !== tag){
                const el = createElement.call(this, src, tag);
                $parent.replaceChild(el, $el);
                $el = el;
            }

            switch ($el.nodeType) {
                case 1: break;
                case 3:{
                    for (i = 0, l = src.text.length; i<l; i++){
                        h = src.text[i];
                        h.call(this, $el, pars);
                    }
                    // if (!$el.textContent && src.textContent)
                    //     $el.textContent = src.textContent;
                }
                default: return;
            }
            $el.__array = pars;
            let ref = $el.__ref || src.ref || src.fn.ref;
            if (ref){
                if (ref.call){
                    ref = ref.call(this, pars);
                }
                if (pars){
                    this.__core__.$refs[ref] = this.__core__.$refs[ref] || [];
                    this.__core__.$refs[ref].push($el)
                }
                else
                    this.__core__.$refs[ref] = $el;
            }
            for (const a in src.attrs)
                $el.setAttribute(a, src.attrs[a]);

            for (i = 0, l = src.dirs.length; i<l; i++){
                h = src.dirs[i];
                h.call(this, $el, src.fn[h.name], pars);
            }
            for (let p in src.bind){
                h = src.bind[p];
                $el.setProperty(p, h.call(this, pars), h.modifiers);
            };
        }
        let idx = 0;
        for (i = 0, l = src.children.length; i<l; i++){
            h = src.children[i];
            if (typeof h === "function"){
                const arr = h.call(this, pars);
                let node;
                for (let j=0, s = arr.length; j<s; j++){
                    node = arr[j];
                    updateDom.call(this, node.src, $el.childNodes[idx], $el, node.params);
                    idx++;
                }
                let el = $el.childNodes[idx];
                while(el && el.__node__.id === h.src.id){
                    el.remove();
                    el = $el.childNodes[idx];
                }
            }
            else{
                updateDom.call(this, h, $el.childNodes[idx], $el, pars);
                idx++;
            }
        }
    }
    let frArray = [];

    const renderQueue = [];
    let rafId = 0;
    ODA.render = function(renderer){
        renderQueue.push(renderer);
        // rafId && cancelAnimationFrame(rafId);
        rafId = requestAnimationFrame(raf)
    };
    function raf() {
        rafId = 0;
        if(!renderQueue.length) return;
        frArray.push(...renderQueue);
        renderQueue.length = 0;
        while (frArray.length){
            frArray.shift()();
        }
    }
    Object.__proto__.equal = function(a, b) {
        if (a !== b){
            if (!(a instanceof Object && b instanceof Object)) return;
            for(const key in Object.assign({}, a, b))
                if(!Object.equal(b[key], a[key])) return false;
        } return true;
    };
    console.log("%c ... Start to use new-oda.js", `color: magenta; font-weight: bold; font-size: 16px`);

    window.origin = new URL(document.currentScript.src).origin;
// заглушка для Safari
    try {
        new IntersectionObserver(() => {});
    } catch (e) {
        console.warn('IntersectionObserver missing');
        window.IntersectionObserver = class IntersectionObserver {
            constructor(callback) {}
            observe(callback) {
                callback({isIntersecting: true});
            }
        };
    }
    function parseModifiers (name) {
        if (name){
            const match = name.match(modifierRE);
            if (match) {
                const ret = {};
                match.forEach(function (m) { ret[m.slice(1)] = true; });
                return ret
            }
        }
    }
    function func (vars, expr) {
        try{
            return new Function(vars, `with (this) {return (${expr})}`);
        }
        catch (e) {
            ODA.error(this, `${e} - ${expr}"` );
            // console.error(e);
            return new Function(`return "${e}: ${expr}"`);
        }
    }
    function h(tag, props = {}, children = [], more = {}) {
        return {tag, props, children, ...more};
    }
    const emptyArray = [];
    function exec (fn, p){
        try{
            return fn.call(this, ...(p || emptyArray));
        }
        catch(e){
            return e;
        }
    }

    const forVars = ['item', 'index', 'array'];
    const svgNS = "http://www.w3.org/2000/svg";
    const modifierRE = /\.[^.]+/g;
    Object.defineProperty(Element.prototype, 'error',{
        set(v) {
            const target =  (this.nodeType === 3 && this.parentElement)?this.parentElement:this;
            if (target.nodeType === 1){
                if (v){
                    target.setAttribute('part', 'error');
                    target.setAttribute('oda-error', v);
                }
                else{
                    target.removeAttribute('part');
                    target.removeAttribute('oda-error');
                }
            }
        }
    });
    if (!Array.prototype.add) {
        Array.prototype.has = Array.prototype.includes;

        Array.prototype.clear = function () {
            this.splice(0);
        };
        Array.prototype.add = function (item) {
            // if (Array.isArray(item)){
            //     items.forEach(i =>{
            //         if (!this.includes(i))
            //             this.push(i);
            //     });
            // } else
            if (this.includes(item)) return;
                this.push(item);
        };
        Array.prototype.remove = function (...items) {
            for (const item of items){
                const idx = this.indexOf(item);
                if (idx <0) continue;
                this.splice(idx, 1);
            }
        };
    }

    function cached (fn) {
        const cache = Object.create(null);
        return (function cachedFn (str) {
            return cache[str] || (cache[str] = fn(str))
        })
    }
    const kebabGlossary = {};
    function toKebab(str){
        const res = kebabGlossary[str] = str.replace(/\B([A-Z])/g, '-$1').toLowerCase();
        return res
    }
    String.prototype.toKebabCase = function () {
        const s = this.toString();
        const str = kebabGlossary[s];
        return str?str:toKebab(s);
    };
    String.prototype.toCamelCase = function (){
        return this.replace(/-(\w)/g, function (_, c) { return c ? c.toUpperCase() : ''; })
    };
    String.prototype.replaceAll = function (search, replace) {
        return this.replace(new RegExp(search, 'g'), replace);
    };

    window.applyRegx  =  /@apply\s*\(?[^);]*\)?\s*(?:[;\n]|$)?/gim;
    window.rootRegx = /:root\s*{?[^};]}/gim;
    window.applyReplacer = (s)=>{
        const a = s.replace(/@apply|\(|\)|\s|;/g, '');
        return ODA.styles[a] || getComputedStyle(document.documentElement).getPropertyValue(a).replace(/{|}/g, '')
    };

    ODA.mainWindow = window;
    try{
        while(ODA.mainWindow.parent && ODA.mainWindow.parent !== ODA.mainWindow) {
            ODA.mainWindow = ODA.mainWindow.parent;
        }
    }
    catch(e){
        console.dir(e);
    }

    ODA.origin = origin;
    ODA.telemetry = {notify: 0, el: 0, exec: 0, render: 0, paint: 0, nodes: 0, draw:0,  components: {count: 0}, clear:()=>{
            for (const i of Object.keys(ODA.telemetry)){
                if (typeof ODA.telemetry[i] === 'number')
                    ODA.telemetry[i] = 0;
            }
        }};
    ODA.modules = [];
    ODA.tests = {};
    window.onerror = (...e) => {
        const module = ODA.modules.find(i=>i.path === e[1]);
        if (module){
            ODA.error(module.id, e[4].stack);
            return true;
        }
        else if (document.currentScript && e[0].includes('SyntaxError')){
            let s = document.currentScript.textContent;
            let idx = s.indexOf('is:');
            if (idx>0){
                s = s.substring(idx + 3);
                s = s.replace(/'/g, '"');
                s = s.substring(s.indexOf('"')+1);
                s = s.substring(0, s.indexOf('"'));
                if (s.includes('-')){
                    ODA({
                        is: s,
                        template: `<span class="error border" style="cursor: help; padding: 2px; background-color: yellow; margin: 2px" title="${e[0]}'\n'${e[1]} - (${e[2]},${e[3]})">error: &lt;${s}&gt;</span>`
                    })
                }
            }
        }
        return false;
    };
    ODA.error = (component, ...args)=>{
        ODA.console( component, console.error, 'red', ...args);
    };
    ODA.warn = (component, ...args)=>{
        ODA.console(component, console.warn, 'orange', ...args);
    };
    ODA.success = (component, ...args)=>{
        ODA.console(component, console.log, 'green', ...args);
    };
    ODA.log = (component, ...args)=>{
        ODA.console(component, console.log, 'gray', ...args);
    };
    ODA.console = (component = {}, method, color, ...args)=>{
        component = (component && component.localName) || component;
        method(`%c<${component}>`, `color: white; font-weight: bold; background-color: ${color}; padding: 1px 8px; border-radius: 8px`, ...args)
    };

    const hooks = ['created', 'ready', 'attached', 'detached', 'updated', 'destroyed'];
    ODA.getBool = (v, def = false) => {
        if (v === false || v === '' || !v)
            return def;
        switch (typeof v) {
            case 'object':
                return true;
            case 'string':
                return v.toLowerCase() === 'true';
            case 'boolean':
                return v;
            case 'number':
                return v !== 0;
        }
        return false;
    };
    ODA.loadScript = async function (url) {
        return ODA.cache('load-script:' + url, ()=>{
            return new Promise(function (resolve, reject) {
                let script = document.createElement("script");
                script.onload = function (e) {
                    globalThis.loader && globalThis.loader.off();
                    // script.remove();
                    resolve(script);
                };
                script.onerror = function (e) {
                    globalThis.loader && globalThis.loader.off();
                    script.remove();
                    script = null;
                    reject(new Error('error on load script', url));
                };
                script.async = true;
                script.type = "text/javascript";
                if (ODA.origin && ODA.origin !== document.location.origin && !url.startsWith(ODA.origin))
                    url = ODA.origin + url;
                script.src = encodeURI(url);
                globalThis.loader && globalThis.loader.on(100);
                document.head.appendChild(script);
            });
        });
    };
    ODA.loadLink = function (url){
        return ODA.cache('load-link: '+url, ()=>{
            return new Promise((resolve, reject) => {
                const link = document.createElement("link");
                link.addEventListener('load', e=>{
                    resolve(link);
                });
                link.onerror = e => {
                    console.error(e);
                    reject(e);
                };
                link.rel = "import";
                if (ODA.origin && ODA.origin !== document.location.origin && !url.startsWith(ODA.origin))
                    url = ODA.origin + url;
                link.href = url;
                document.head.appendChild(link);
            });
        });
    };
    function load (){
        document.body.hidden = true;
        const links = Array.prototype.map.call(document.head.querySelectorAll('link[rel=oda-import]'), i=>{
            return ODA.loadLink(i.href);
        });
        Promise.all(links).then(()=>{
            document.body.hidden = false;
        })
    }
    function noop (a, b, c) {}
    const computedWatcherOptions = {lazy:true};
    function styleToObj(style){
        const s = {};
        const arr = style.split(';');
        let r;
        for (let i=0, l=arr.length; i<l; i++){
            r = arr[i].split(':');
            if (r.length !== 2) continue;
            s[r[0].trim()] = r[1].trim();
        }
        return s;
    }
    const arrayMethods = Object.create(Array.prototype);
    const methodsToPatch = ['push', 'pop', 'shift', 'unshift', 'splice', 'sort', 'reverse'];
    methodsToPatch.forEach(function (method) {
        const original = Array.prototype[method];
        def(arrayMethods, method, function mutator () {
            const args = [];
            let len = arguments.length;
            while ( len-- )
                args[ len ] = arguments[ len ];
            const result = original.apply(this, args);
            let inserted;
            switch (method) {
                case 'push':
                case 'unshift':
                    inserted = args;
                    break;
                case 'splice':
                    inserted = args.slice(2);
                    break;
            }
            if (inserted)
                this.__ob__.observeArray.call( this.__ob__.dep.host,  inserted);
            this.__ob__.dep.notify();
            return result
        });
    });
    var arrayKeys = Object.getOwnPropertyNames(arrayMethods);
    function isObject(obj){
        return obj && typeof obj === 'object';
    }
    function isPlainObject (obj) {
        return obj && obj.constructor.name === 'Object';
    }
    function def (obj, key, val, enumerable) {
        Object.defineProperty(obj, key, {
            value: val,
            enumerable: !!enumerable,
            writable: true,
            configurable: true
        });
    }
    function deepCopy(obj) {
        if (Array.isArray(obj))
            return obj.map(item => deepCopy.call(this,  item));
        else if (isPlainObject(obj)){
            obj = Object.assign({}, obj);
            for (const key in obj)
                obj[key] = deepCopy.call(this, obj[key]);
        }
        return obj;
    }
    const emptyObj = {};
    Node.prototype.setProperty = function (name, v, modifiers = emptyObj) {
        const d = Object.getOwnPropertyDescriptor(this.__proto__, name);
        if ((d && d.set) || !this.setAttribute || typeof v === 'object' || modifiers.prop)
            this[name] = v;
        else {
            !d && (name = name.toKebabCase());
            if (v === false || v === undefined || v === null || v === '')
                this.removeAttribute(name);
            else
                this.setAttribute(name, v === true ? '' : v);
        }
        if (!this.assignedElements) return;
        const els = this.assignedElements();
        for (let i = 0, l=els.length; i<l;i++)
            els[i].setProperty(name, v)
    };
    const replaceChildElement = Element.prototype.replaceChild;
    Element.prototype.replaceChild = function (n, o) {
        o.__node__ && o.__node__.setCache(o);
        return replaceChildElement.call(this, n, o);
    };
    const removeElement = Node.prototype.remove;
    Node.prototype.remove = function () {
        this.__node__ && this.__node__.setCache(this);
        return removeElement.call(this);
    };

    ODA.styles = {};
    ODA({
        is: 'oda-view',
        properties:{
            focusedItem: Object,
            contextItem: {
                _isChanged: 0,
                type: Object,
                watch(item, old){
                    this.focusedItem = item;
                    if (old){
                        this.unlisten(old, 'changed', '_changed');
                    }
                    if (item){
                        this.listen(item, 'changed', '_changed');
                        this._changed();
                    }
                }
            },
            iconSize: 24
        },
        _changed(e){
            this._isChanged = this._isChanged+1;
        }
    });
    ODA({
        is: 'oda-style',
        extends: 'style',

        attached(){
            Array.prototype.forEach.call(this.sheet.cssRules, i=>{
                if (i.style){
                    Array.prototype.filter.call(i.style, s => s.startsWith('--')).forEach(s=>{
                        const css = getComputedStyle(document.documentElement).getPropertyValue(s);
                        ODA.styles[s] = css.replace(/{|}/g, '').replace(applyRegx, applyReplacer).trim();
                    }, {})
                }
            });
            ODA.log('oda-style','is ready', this.getAttribute('group'), this);
        }
    });
    if (document.body) {
        load();
    } else {
        document.addEventListener('DOMContentLoaded', load);
    }
    class odaEvent{
        constructor(target, handler, ...args){
            this.handler = handler;
            target.__listeners = target.__listeners || {};
            target.__listeners[this.event] = target.__listeners[this.event] || new Map();
            target.__listeners[this.event].set(handler, this);
            this._target = target;
            this._events = {};
        }
        static remove(name, target, handler){
            const event = target.__listeners && target.__listeners[name] && target.__listeners[name].get(handler);
            event && event.delete();
        }
        get event(){
            return 'event'
        }
        addSubEvent(name, handler, useCapture){
            this._events[name] = handler;
            this._target.addEventListener(name, handler, useCapture);
        }
        delete(){
            for(const name in this._events){
                if(this._events.hasOwnProperty(name)){
                    this._target.removeEventListener(name, this._events[name]);
                }
            }
        }
    }
    if (!("path" in Event.prototype))
        Object.defineProperty(Event.prototype, "path", {
            get: function () {
                var path = [];
                var currentElem = this.target;
                while (currentElem) {
                    path.push(currentElem);
                    currentElem = currentElem.parentElement;
                }
                if (path.indexOf(window) === -1 && path.indexOf(document) === -1)
                    path.push(document);
                if (path.indexOf(window) === -1)
                    path.push(window);
                return path;
            }
        });

    class  odaCustomEvent extends CustomEvent{
        constructor(name, params, source){
            super(name, params);
            if(source){
                const props = {
                    path:{
                        value: source.path
                    },
                    currentTarget:{
                        value: source.currentTarget
                    },
                    target:{
                        value: source.target
                    },
                    stopPropagation:{
                        value: () => source.stopPropagation()
                    },
                    preventDefault:{
                        value: () => source.preventDefault()
                    },
                    sourceEvent: {
                        value: source
                    }
                };
                Object.defineProperties(this, props);
            }
        }
    }
    class odaEventTap extends odaEvent{
        constructor(target, handler, ...args){
            super(target, handler, ...args);
            // if (!target.onclick) {
            //     target.onclick = () => void(0);
            // }
            this.addSubEvent('click', (e) => {
                const ce = new odaCustomEvent("tap", {detail: {sourceEvent: e}}, e);
                this.handler(ce, ce.detail);
            });
        }
        get event(){
            return 'tap'
        }
    }
    class odaEventDown extends odaEvent{
        constructor(target, handler, ...args){
            super(target, handler, ...args);
            this.addSubEvent('mousedown', (e) => {
                const ce = new odaCustomEvent("down", {detail: {sourceEvent: e}}, e);
                this.handler(ce, ce.detail);
            });
        }
        get event(){
            return 'down'
        }
    }
    class odaEventUp extends odaEvent{
        constructor(target, handler, ...args){
            super(target, handler, ...args);
            this.addSubEvent('mouseup', (e) => {
                const ce = new odaCustomEvent("up",{detail: {sourceEvent: e}}, e);
                this.handler(ce, ce.detail);
            });
        }
        get event(){
            return 'up'
        }
    }
    // class odaEventResize extends odaEvent{
    //     constructor(target, handler, ...args){
    //         super(target, handler, ...args);
    //         window.addEventListener('resize', (e) => {
    //             const ce = new odaCustomEvent("resize", {detail: {sourceEvent: e}}, e);
    //             this.handler(ce, ce.detail);
    //         });
    //     }
    //     get event(){
    //         return 'resize'
    //     }
    // }
    class odaEventTrack extends odaEvent {
        constructor(target, handler, ...args) {
            super(target, handler, ...args);
            this.addSubEvent('mousedown', (e) => {
                this.detail = {
                    state: 'start',
                    start: {
                        x: e.clientX,
                        y: e.clientY
                    }, ddx: 0, ddy: 0, dx: 0, dy: 0,
                };
                window.addEventListener('mousemove', moveHandler);
                window.addEventListener('mouseup', upHandler);
            }, true);
            const moveHandler = (e) => {
                // e.stopPropagation();
                this.detail.x = e.clientX;
                this.detail.y = e.clientY;
                this.detail.ddx = -(this.detail.dx - (e.clientX - this.detail.start.x));
                this.detail.ddy = -(this.detail.dy - (e.clientY - this.detail.start.y));
                this.detail.dx = e.clientX - this.detail.start.x;
                this.detail.dy = e.clientY - this.detail.start.y;
                if (this.detail.dx || this.detail.dy) {
                    const ce = new odaCustomEvent("track",  {detail: Object.assign({}, this.detail)}, e);
                    this.handler(ce, ce.detail);
                    this.detail.state = 'track';
                }
            };
            const upHandler = (e) => {
                // e.preventDefault();
                window.removeEventListener('mousemove', moveHandler);
                window.removeEventListener('mouseup', upHandler);
                this.detail.state = 'end';
                const ce = new odaCustomEvent("track", {detail: Object.assign({}, this.detail)}, e);
                this.handler(ce, ce.detail);
            };
        }

        get event() {
            return 'track'
        }
    }
    if (!Element.prototype.__addEventListener) {
        const func = Element.prototype.addEventListener;
        Element.prototype.addEventListener = function(name, handler, ...args){
            this.__events = this.__events || new Map();
            let array = this.__events.get(name);
            if (!array){
                array = [];
                this.__events.set(name, array);
            }
            const f = ()=>{
                switch (name){
                    case 'tap':
                        return new odaEventTap(this, handler, ...args);
                    case 'down':
                        return new odaEventDown(this, handler, ...args);
                    case 'up':
                        return new odaEventUp(this, handler, ...args);
                    case 'track':
                        return new odaEventTrack(this, handler, ...args);
                    // case 'resize':
                    //     return new odaEventResize(this, handler, ...args);
                    default:
                        return func.call(this, name, handler, ...args);
                }
            };
            array.push({handler, event: f()});
        };
    }
    if (!Element.prototype.__removeEventListener) {
        const func = Element.prototype.removeEventListener;
        Element.prototype.removeEventListener = function(name, handler, ...args){
            if (this.__events){
                const array = this.__events.get(name) || [];
                const idx = array.indexOf(handler);
                if (idx>-1){
                    array.splice(idx, 1);
                }
                if (!array.length)
                    this.__events.delete(name);
            }
            switch (name){
                case 'tap':
                case 'down':
                case 'up':
                case 'track':{
                    odaEvent.remove(name, this, handler);
                } break;
                default:
                    func.call(this, name, handler, ...args);
            }
        };
    }
    ODA._cache = {};
    ODA.cache = (key, callback) => {
        ODA._cache[key] = ODA._cache[key] || (typeof callback === 'function')?callback():callback;
        return ODA._cache[key];
    };
    ODA.createComponent = async (url, params, inner) => {
        const id = await ODA.loadComponent(url);
        let el = document.createElement(id);
        if (params) {
            for (let p in params) {
                el[p] = params[p];
            }
        }
        if (inner)
            el.textContent = inner;
        return el;
    };
    ODA.loadComponent = async (url) => {
        return ODA.cache('load-component: '+url, async ()=>{
            const link = await ODA.loadLink(url);
            const body = link.import.body ? link.import.body : link.import;
            const module = Array.prototype.find.call(body.children, (e) => e.localName === 'oda-module');
            const load = (link)=>{
                [...link.import.querySelectorAll('link')].forEach(l => {
                    if (l.import) {
                        load(l);
                        [...l.import.querySelectorAll('oda-module')].forEach(m => {
                            const t = m.querySelector('template');
                            if (t) {
                                [...t.content.children].forEach(s => {
                                    if (s.localName === 'script') {
                                        m.appendChild(s);
                                    }
                                });
                            }
                        });
                    }
                });
            };
            load(link);
            const t = module && module.querySelector('template');
            if (t) {
                [...t.content.children].forEach(s => {
                    if (s.localName === 'script') {
                        module.appendChild(s);
                    }
                });
            }
            return (module && module.id);
        })
    };
    ODA.createElement = (name = 'div', params = {}) =>{
        const el = document.createElement(name);
        for (let i in params) {
            el[i] = params[i];
        }
        return el;
    };
    ODA.showFileDialog = (accept = '*', multiple) => {
        return new Promise(resolve=>{
            if(!ODANT._fileDialog){
                ODANT._fileDialog = document.createElement('input');
                ODANT._fileDialog.setAttribute('type', 'file');
            }
            ODANT._fileDialog.setAttribute('accept', accept );
            ODANT._fileDialog.setAttribute('multiple', multiple);
            ODANT._fileDialog.onchange = (e)=>{
                resolve(e.target.files);
            };
            ODANT._fileDialog.click();
        })
    };
    ODA.showColorDialog = (value) => {
        return ODA.createComponent('/web/lib/colors/palette').then(ctrl=>{
            return ODA.showModal(ctrl, 'color')
        });
    };
    ODA.showContextMenu = async (param) => {
        const component = await ODA.createComponent('/web/lib/menus/context-menu/context-menu.html');
        return component.open(param);
    };
    ODA.showHint = async function(text, icon){
        ODA.loadComponent('/web/lib/hint/hint.html').then(id =>{
            if (!ODANT._hintControl){
                ODANT._hintControl = document.createElement(id);
            }
            ODANT._hintControl.show(text, icon);
        })
    };
    ODA.showDialog = async (control, property = {}) => {
        const form = await ODA.createComponent('/web/lib/dialogs/dialog/dialog.html');
        for (let p in property) {
            form[p] = property[p];
        }
        return form.show(control);
    };
    ODA.showDatePicker = async (value) => {
        const control = await ODA.createComponent('/web/lib/dialogs/calendar/calendar.html');
        control.value = (value && new Date(Date.parse(value))) || new Date();
        return control.show();
    };
    ODA.showCalculator = async(value)=>{
        const control = await ODA.createComponent('/web/lib/dialogs/calculator/calculator.html');
        control.value = value;
        return control.show();
    };
    ODA.showModal = async function (control, property = {}) {
        let modal = await ODA.createComponent('/web/lib/dialogs/modal/modal.html');
        for (let p in property) {
            modal[p] = property[p];
        }
        return modal.show(control);
    };
    ODA.confirm = function(text, title) {
        return ODA.createComponent('/web/lib/dialogs/confirm/confirm.html').then(e =>{
            return e.show(text, title);
        })
    };
    ODA.inputText = function(param = {title: 'Input text', value, type}){
        return ODA.createComponent('/web/lib/dialogs/input/input.html').then(e =>{
            return e.show(param);
        })
    };
    ODA.showDropDown = function(control, parent){
        ODA.createComponent('/web/lib/dropdown/odant-dropdown.html').then(dropdown =>{
            dropdown.parent = parent;
            return dropdown.show(control);
        })
    };
    ODA.showForm = function(url){
        ODA.createComponent('/web/lib/modal-form/odant-modal-form.html').then(control =>{
            return control.show(url);
        })
    };
    ODA.notify = function(text){
        ODA.push(text);
    };
    ODA.push = (name = 'Warning!', {tag = 'message', body, icon = '/web/res/icons/warning.png', image}={}) => {
        if (!body){
            body = name;
            name = 'Warning!'
        }
        let params = {tag, body, icon, image};
        switch ( Notification.permission.toLowerCase() ) {
            case "granted":
                new Notification(name, params);
                break;
            case "denied":
                break;
            case "default":
                Notification.requestPermission(state => {
                    if (state === "granted")
                        ODA.push(name, params);
                });
                break;
        }
    };
    ODA.pushMessage = ODA.push;
    ODA.pushError = (error, context)=>{
        if (error instanceof Error)
            error = error.stack;
        const tag = (context && context.displayLabel) || 'Error';
        ODA.push(tag,{
            tag : tag,
            body : error,
            icon : '/web/res/icons/error.png'
        })
    };
    ODA.getIconUrl = function(icon, item){
        let url = icon;
        if(!url.includes(':') && !url.includes('/web/')){
            url = '/web/res/icons/' + url;
            if(!url.includes('.png'))
                url += '.png';
        }
        url = encodeURI(url);
    };

    window.ODARect = window.ODARect || class ODARect{
        constructor(element){
            if (element && element.host)
                element = element.host;
            const pos = element?element.getBoundingClientRect():ODA.mousePos;
            this.x = pos.x;
            this.y = pos.y;
            this.top = pos.top;
            this.bottom = pos.bottom;
            this.left = pos.left;
            this.right = pos.right;
            this.width = pos.width;
            this.height = pos.height;
        }
    };
    if (!window.DOMRect){
        window.DOMRect = function  (x, y,  width, height){
            this.x = x;
            this.y = y;
            this.top = y;
            this.bottom = y + height;
            this.left = x;
            this.right = x + width;
            this.width = width;
            this.height = height;
        }
    }
    document.addEventListener('mousedown', e =>{
        ODA.mousePos = new DOMRect(e.pageX, e.pageY);
    });
    window.odaLocalStorage = window.odaLocalStorage ||  class odaLocalStorage{
        constructor(path, parent){
            this._path = path;
            this._parent = parent;
            try{
                if (this._parent){
                    this._storage = this._parent.getValue(path) || {};
                }
                else{
                    this._storage = JSON.parse(localStorage.getItem(path)) || {};
                }
                if(typeof this._storage !== 'object')
                    this._storage = {};
            }
            catch(err){
                this._storage = {};
            }

        }
        setValue(key, value){
            let path = key.split('/');
            let s = this._storage;
            while (typeof s === 'object' && path.length) {
                let v = path.shift();
                if (path.length){
                    s = s[v || '*'] || {};
                }
                else{
                    if (value)
                        s[v || '*'] = value;
                    else if (s[v || '*'])
                        delete s[v || '*'];
                    break;
                }
            }
            this.save();
        }
        getValue(key){
            let path = key.split('/');
            let s = this._storage;
            while (typeof  s === 'object' && path.length) {
                let v = path.shift();
                s = s[v || '*'];
            }
            return s;
        }
        clear(){
            this._storage = null;
            this.save();
            this._storage = {};

        }
        save(){
            if (this._parent)
                this._parent.setValue(this._path, this._storage);
            else if (this._storage)
                localStorage.setItem(this._path, JSON.stringify(this._storage));
            else
                localStorage.removeItem(this._path);
        }
    };

    window.addEventListener('load', async () => {
        document.oncontextmenu = (e) => {
            e.target.dispatchEvent(new MouseEvent('menu', e));
            return false;
        };
        document.addEventListener('HTMLImportsLoaded', async () => {
            const styles = await ODA.loadLink(origin+'/web/core/styles.html');
            if (!Object.keys(ODA.styles).length){
                Array.prototype.forEach.call(styles.import.querySelectorAll('style[is]'), style=>{
                    Array.prototype.forEach.call(style.sheet.cssRules, i=>{
                        if (i.style){
                            Array.prototype.filter.call(i.style, s => s.startsWith('--')).forEach(s => {
                                const css = getComputedStyle(document.documentElement).getPropertyValue(s);
                                ODA.styles[s] = css.replace(/{|}/g, '').replace(applyRegx, applyReplacer).trim();
                            }, {});
                        }
                    });
                });``
            }
            ODA({
                is: 'oda-module',
                properties:{
                    test: String,
                    context: String,
                    id: String
                },
                async attached() {
                    this.async( async ()=>{
                        if (document.body.firstElementChild === this) {
                            if (this.test) {
                                location.replace(this.test);
                            } else {
                                const component = document.createElement(this.id);
                                Array.prototype.forEach.call(this.attributes, a => {
                                    if (!(a.name in this)) {
                                        component[a.name] = a.value;
                                    }
                                });
                                const tester = await ODA.createComponent(origin + '/web/tools/component-test/component-test.html', {
                                    component: component,
                                    context: this.context
                                });
                                document.body.insertBefore(tester, this);
                            }
                        }
                        this.async(()=>{
                            this.remove();
                        }, 1000)
                    }, 50)
                }
            });
            ODA({
                is: 'oda-slot'
            });
            ODA({
                is: 'oda-test',
                properties:{
                    id: String
                },
                async attached() {
                    if (document.body.firstElementChild === this){
                        const tester = await ODA.createComponent(origin+'/web/tools/component-test/component-test.html', {context: this.context });
                        document.body.appendChild(tester);
                        this.async(()=>{
                            let component = this.querySelector('template');
                            if (component)
                                component = component.content.firstElementChild;
                            if (component){
                                this.id = component.localName + '-test';
                                component = document.createElement(this.id);
                                tester.component = component
                            }
                        })
                    }
                }
            });
            ODA.log('ODA', 'framework is ready');
            document.frameworkIsReady = true;
            document.dispatchEvent(new Event('framework-ready'));
        });
        await ODA.loadScript('/web/ext/html-imports/html-imports.min.js');
        document.body.style.display = 'flex';
    });
}