# [ODA Framework](https://odajs.org/)
 [![GitHub license](https://img.shields.io/badge/license-MIT-blue.svg)](https://github.com/odajs/blob/master/LICENSE) [![npm version](https://img.shields.io/npm/v/oda-framework.svg?style=flat)](https://www.npmjs.com/oda-framework) [![CircleCI Status](https://circleci.com/gh/facebook/react.svg?style=shield&circle-token=:circle-token)](https://circleci.com/gh/facebook/react) [![PRs Welcome](https://img.shields.io/badge/ODA-welcome-brightgreen.svg)](https://odajs.org/web/oda/learn/docs/how-to-contribute.html#your-first-pull-request)

It's a progressive ES framework based on the technology of Web Components and designed especially for rapid development of custom UI/UX for web applications.

* **Features** The ODA Framework allows its users to create  interactive user interfaces of any complexity rapidly and easily. Web application code becomes as simple and straightforward as it is even possible for debugging and further distribution. Effective updating and rendering of an interface are carried out automatically whenever there is any change in the data itself or in the state of web components.
* **Technologies** It is used a component-oriented approach based on all 4 basic elements of the Web Components technology: Custom Elements, Shadow DOM, HTML Templates, and Modules. It implements all the requirements of PWA and PWC technologies.
* **Advantages** Simplicity of coding and learning, code minimizaton with its functionality maximization, the substantial increase of the development speed and extensibility due to the re-use of ready-made web components, both self- and third-party-developed. High rendering efficiency for any changes occurring within an interface. Capability to develop cross-platform mobile applications.

[Learn how to use ODA Framework in your own project](https://odajs.org/docs/getting-started.html).

## Installation

ODA Framework has been designed for gradual adoption from the start, and **you can use as little or as much ODA Framework as you need**:

* Use [Online Playgrounds](https://odajs.org/docs/getting-started.html#online-playgrounds) to get a taste of ODA Framework.
* [Add ODA Framework to a Website](https://odajs.org/docs/add-react-to-a-website.html) as a `<script>` tag in one minute.
* [Create a New ODA Framework App](https://odajs.org/docs/create-a-new-react-app.html) if you're looking for a powerful JavaScript toolchain.

You can use ODA Framework as a `<script>` tag from a [CDN](https://odajs.org/docs/cdn-links.html), or as a `oda-framework` package on [npm](https://www.npmjs.com/).

## Browser Compatibility

ODA Framework supports all browsers that are [ES5-compliant](http://kangax.github.io/compat-table/es5/) (IE8 and below are not supported).

## Documentation

You can find the ODA Framework documentation [on the website](https://odajs.org/learn/docs). 

Check out the [Getting Started](https://odajs.org/learn/docs/getting-started.html) page for a quick overview.

The documentation is divided into several sections:

* [Tutorial](https://reactjs.org/tutorial/tutorial.html)
* [Main Concepts](https://reactjs.org/docs/hello-world.html)
* [Advanced Guides](https://reactjs.org/docs/jsx-in-depth.html)
* [API Reference](https://reactjs.org/docs/react-api.html)
* [Where to Get Support](https://reactjs.org/community/support.html)
* [Contributing Guide](https://reactjs.org/docs/how-to-contribute.html)

You can improve it by sending pull requests to [this repository](https://github.com/odajs/oda-framework.org).

## Questions

For questions and support please use [the official forum](http://forum.odajs.org) or [community chat](https://chat.odajs.org/). The issue list of this repo is **exclusively** for bug reports and feature requests.

## Issues

Please make sure to read the [Issue Reporting Checklist](https://github.com/odajs/oda-framework/blob/dev/.github/CONTRIBUTING.md#issue-reporting-guidelines) before opening an issue. Issues not conforming to the guidelines may be closed immediately.

## Good First Issues

To help you get your feet wet and get you familiar with our contribution process, we have a list of [good first issues](https://github.com/odajs/oda-framework/labels/good%20first%20issue) that contain bugs which have a relatively limited scope. This is a great place to get started.

## Changelog

Detailed changes for each release are documented in the [release notes](https://github.com/odajs/oda-framework/releases).

## Contribution

Please make sure to read the [Contributing Guide](https://github.com/odajs/oda-framework/blob/dev/.github/CONTRIBUTING.md) before making a pull request. If you have a ODA-related project/component/tool, add it with a pull request to [this curated list](https://github.com/odajs/awesome-vue)!

Thank you to all the people who already contributed to ODA Framework!

## License

ODA Framework is [MIT licensed](./LICENSE).
