import '../../../oda.js';
ODA({
    is: 'oda-3d-scene',
    template: `
        <style>
            :host{
                overflow: hidden;
                perspective: 1500px;
                background: linear-gradient(darkblue, black, black, black);
                @apply --flex;
            }
        </style>
        <oda-3d-cube ~for="screens" style="background-color: transparent" class="content flex" ~style="{transformOrigin: \`center center \${width}px\`,transform: \`translateZ(-\${width}px)  rotateY(\${item.angle}deg)\`}">{{\`angle = \${Math.round(item.angle)} deg\`}}</oda-3d-cube>
        <div style="top: 50%; left: 20%; right: 20%; bottom: 0px; position: absolute; transform: rotateX(75deg); transform-origin: bottom;" class="header">sdfsafasdf</div>
    `,
    props:{
        screenCount: {
            default: 0,
            set(n,o){
                const screens = [];
                for (let i = 0; i<n; i++){
                    screens.push({angle: i * this.angle})
                }
                this.screens = screens;
            }
        },
        screens:[],
        angle:{
            default: 0,
            get(){
                return 360/this.screenCount;
            }
        },
        width:{
            default: 0,
            get(){
                return window.innerWidth;
            }
        }
    },
    listeners:{
        track: function (e, d) {
            switch (d.state) {
                case 'track':{
                    for (let i = 0; i<this.screenCount; i++){
                        this.screens[i].angle -= d.ddx / this.width * 2 * 60;
                    }
                } break;
            }
        }
    }
});
ODA({
    is: 'oda-3d-cube',
    template: `
        <style>
            :host{
                overflow: visible;
                background-color: transparent;
                /*@apply --vertical;*/
                /*background:linear-gradient(darkblue, black, black);*/
                box-sizing: border-box;
                
                position: absolute;
                width: 100%;
                height: 100%;
                font-size: xx-large;
                text-align: center;
                transition: transform .3s;
                
                
            }
            .side{
               position: absolute;
               border: 1px solid gray;
               width: inherit;
               height: inherit;               
               text-align: center;
               /*line-height: 300px;*/
               font-size: xx-large;
               backface-visibility: hidden;
               @apply --content;
            }
            .cube{
                transition: transform 1s;
                width: inherit;
                height: inherit;
                transform-style: preserve-3d;
            }
            .container{
                width: 100%;
                height: 100%;
                background-color: transparent;
            }
        </style>
        <div class="container" ~style="{perspective: \`\${width*2}px\`}">
              <div class="cube" ~style="{transform: \`rotateX(\${rotateX}deg) rotateY(\${rotateY}deg) scale3d(\${scale}, \${scale}, \${scale})\`}">
                <div class="front side" ~style="{transform: \`translateZ(\${width/2}px)\`}">front</div>
                <div  class="back side" ~style="{transform: \`rotateY(180deg) translateZ(\${width/2}px)\`}">back</div>                
                <div class="top side" ~style="{transform: \`rotateX(90deg) translateZ(\${height/2}px)\`}">top</div>
                <div class="bottom side" ~style="{transform: \`rotateX(-90deg) translateZ(\${height/2}px)\`}">bottom</div>
                <div is="iframe" src="https://odajs.org" class="right side" ~style="{transform: \`rotateY(90deg) translateZ(\${width/2}px)\`}">right</div>
                <div class="left side" ~style="{transform: \`rotateY(-90deg) translateZ(\${width/2}px)\`}">left</div>
            </div>
        </div>`,
    props:{
        rotateX: 0,
        rotateY: 0,
        scale: .8,
        width: {
            get(){
                return window.innerWidth;
            }
        },
        height: {
            get(){
                return window.innerHeight;
            }
        }

    },
    listeners:{
        track (e,d) {
            e.stopPropagation();
            switch (d.state){
                case 'track': {
                    this.rotateY = d.dx / 500 * 90;
                    // this.rotateX = -d.dy / 100 * 90;

                    // else if (d.ddx > 0){
                    //     this.rotateY += 90;
                    // }
                    // if (d.ddy < 0){
                    //     this.rotateX = 90;
                    // }
                    // else if (d.ddy > 0){
                    //     this.rotateX -= 90;
                    // }
                } break;
                case 'end': {
                    // this.rotateY = 0;
                    // this.rotateX = 0;
                    // if (d.ddx < 0){
                    //     this.rotateY -= 90;
                    // }
                    // else if (d.ddx > 0){
                    //     this.rotateY += 90;
                    // }
                    // if (d.ddy < 0){
                    //     this.rotateX = 90;
                    // }
                    // else if (d.ddy > 0){
                    //     this.rotateX -= 90;
                    // }
                } break;
            }
        }
    }

});