import '../../oda.js';

ODA({
    is: 'oda-paas-conf', template: `
        <style>
            :host {
                overflow:auto;
            }
        </style>
        <div align="center" class="header" style="margin-top:8px;padding:8px"><b>ODA PAAS Configurator</b></div>
        <div  style="margin-top:8px">Create mashine</div>
        <hr>
        <div ~for="s in sets" style="display:flex; align-items:center;padding:2px;">
            <oda-icon :icon="s.icon" style="padding:2px;"></oda-icon>
            <div style="padding-left:16px;min-width:160px;">{{s.label}}</div>
            <input ~if="s.type!='radio' && s.type!='checkbox'" :type="s.type" ::value="s.value" :name="s.key"
                    :min="s.min" :max="s.max" :step="s.step" style="min-width:190px;"  @change="_changed">
            <div ~if="s.type==='radio' || s.type==='checkbox'" ~for="val in s.values" style="display:flex;align-items:center;">
                <input :name="s.key" :type="s.type" :value="val" @change="_changed"><label style="font-size:13px">{{val}}</label>
            </div>
        </div>
        <hr>
        <oda-button style="width:100px;border:1px solid gray;border-radius:2px;margin-left:4px;" @tap="_result">Submit</oda-button>
        <hr>
    `,
    props: {
        sets: [
            { icon: 'odant:base', label: 'Hostname', key: 'host', type: 'text', value: 'test' },
            { icon: 'enterprise:computer', label: 'CPU cores', key: 'cpu', type: 'number', min: 1, max: 64, step: 1, value: 1 },
            { icon: 'hardware:memory', label: 'Memory MB', key: 'mem', type: 'number', min: 1024, max: 32768, step: 1024, value: 1024 },
            { icon: 'device:storage', label: 'Disk GB', key: 'disk', type: 'number', min: 8, max: 4096, step: 8, value: 8 },
            { icon: 'enterprise:computer-user', label: 'User UIDs', key: 'uid', type: 'text', value: '' },
            { icon: 'icons:tree-structure', label: 'Branch', key: 'branch', type: 'radio', value: 'stable', values: ['stable', 'testing', 'develop'] },
            { icon: 'files:db', label: 'Example database', key: 'db', type: 'radio', value: 'none', values: ['none', 'eds-demo'] },
            { icon: 'icons:settings', label: 'Options', key: 'opt', type: 'checkbox', value: ['enable', 'start', 'update'], values: ['enable', 'start', 'update'] },
        ],
        _sets: {}
    },
    ready() {
        this.sets.forEach(o => this._sets[o.key] = o.value);
    },
    _changed(e) {
        this._sets[e.currentTarget.name] = e.currentTarget.value;
    },
    _result() {
        console.dir(this._sets);
    }
});
