
// https://simplemde.com/
// https://github.com/sparksuite/simplemde-markdown-editor

import '/web/oda/oda.js';
import "./dist/simplemde.min.js";
ODA({
    is: 'oda-simplemde', template: `
        <textarea ref="mde"></textarea>
        <link rel="stylesheet" href="./dist/simplemde.min.css">
        <link rel="stylesheet" type="text/css" href="./dist/font-awesome.min.css">
    `,
    properties: {
        mdSource: {
            type: String,
            default: '',
            watch(n) {
                if (this.simplemde) this.simplemde.value(n);
            }
        }
    },
    ready() {
        this.simplemde = new SimpleMDE({
            element: this.$refs.mde,
            spellChecker: false,
            toolbar: [
                'bold', 'italic', "heading", 'strikethrough', '|',
                'quote', 'unordered-list', 'ordered-list', 'horizontal-rule', '|',
                'code', 'table', 'link', 'image', '|',
                'preview', 'side-by-side'
            ],
            codeSyntaxHighlighting: true,
            
        });
        this.simplemde.value(this.mdSource);
    }
});