import '../icon/icon.js'
const Groups = {}
ODA({
    is: 'oda-button', extends: 'oda-icon', template: /*html*/`
    <style>
        :host{
            @apply --horizontal;
            opacity: 0.8;
            padding: 4px;
            cursor: pointer;
            min-width: 24px;
            min-height: 24px;
            align-items: center;
            justify-content: center;
            outline-offset: -1px;
            overflow: hidden;
            @apply --no-flex;
        }
        :host([icon-pos=right]){
            flex-direction: row-reverse !important;
        }
        :host([icon-pos=top]){
            flex-direction: column !important;
        }
        :host([icon-pos=bottom]){
            flex-direction: column-reverse !important;
        }
        :host(:hover){
            opacity: 0.999;
            outline: 1px dotted rgba(0,0,0,0.2);
           
            
        }
        span{
            display: block;
            align-self: center;
            white-space: nowrap;
            overflow-x: hidden;
            text-overflow: ellipsis;
            margin: 0px 4px;
        }
        :host(:active), :host([toggled]){
            @apply --active;
            opacity: 0.999;
            outline: 1px solid rgba(0,0,0,0.5) !important;
        }
    </style>
    <span class="label" ~if="label">{{label}}</span><slot></slot>`,
    props: {
        description: {
            component: 'Component button inherited from icon',
            author: 'R.A. Perepelkin',
        },
        iconPos: {
            description: 'Icon position relative to label',
            default: 'left',
            list: ['left', 'right', 'top', 'bottom'],
            reflectToAttribute: true
        },
        label: String,
        hideIcon: {
            get() {
                return !this.icon && !this.default;
            },
            notify: true
        },
        toggled: {
            default: false,
            notify: true,
            reflectToAttribute: true,
            set(n, o){
                if (n && this.toggleGroup){
                    for (let button of Groups[this.toggleGroup]){
                        if(button !== this && button.parentElement === this.parentElement)
                            button.toggled = false;
                    }
                }
            }
        },
        allowToggle: false,
        toggleGroup: {
            type: String,
            set(n, o){
                if (o){
                    (Groups[o] || []).remove(this);
                }
                if (n){
                    Groups[n] =  Groups[n] || [];
                    Groups[n].add(this);
                }
            }
        }
    },
    listeners: {
        tap(e) {
            if (this.allowToggle) {
                e.preventDefault();
                e.stopPropagation();
                this.toggled = !this.toggled;
            }
        }
    }
});