import '../../buttons/button/button.js';

ODA({
    is: 'oda-number-input', template: `<style>
    :host {
        @apply --horizontal;
    }
    input {
        border: none;
        background-color: transparent;
        text-align: right;
        overflow: hidden;
        text-overflow: ellipsis;
        width: 100%;
        padding: 4px;
        margin-left: 2px;
        margin-right: 2px;
    }
    :host([read-only])>input:focus {
        outline: none;
    }
    :host([read-only]) {
        pointer-events: none;
    }
    oda-button {
        padding: 0px;
    }
</style>
<input ref="input" :type="focused?'number':'text'" :value="focused?valueEdit:valueFormatted" :readonly="readOnly" :style="{color: _color}" @input.stop="_input" @focus="_focus" @blur="_blur" @keydown.stop="_keydown">
<oda-button icon="enterprise:calculator" ~if="!readOnly && showCalculator" @tap="_showCalculator"></oda-button>`,
    props: {
        focused: false,
        readOnly: false,
        showCalculator: false,
        value: {
            type: Number,
            notify: true
        },
        valueFormatted: String,
        valueEdit: {
            type: Number,
            get() { return this.value; }
        },
        format: String,
        min: 0,
        max: 0,
        useMinMax: false,
        places: String,
        locale: {
            type: String,
            default: 'ru-RU',
            //list: ['ru-RU', 'en-US', 'ua-UA', 'ar-EG', 'zh-Hans-CN-u-nu-hanidec', 'th-TH-u-nu-thai'],
        },
        _color: {
            type: String,
            get() {
                if (this.value === 0 && !this.focused) return this.zeroColor;
                if (this.value >= 0) return this.plusColor;
                if (this.value < 0) return this.minusColor;
            }
        },
        zeroColor: 'hsla(0, 0%, 50%, .4)',
        minusColor: 'red',
        plusColor: '',
    },
    listeners: {
        focus(e) {
            if (!this.readOnly) this.$refs.input.focus();
        }
    },
    _input(e) { },
    _keydown(e) { },
    _focus() {
        if (this.readOnly) return;
        this.focused = true;
    },
    _blur() {
        this.focused = false;
    },
    _checkValue(val) { return val },
    async _showCalculator() {
        try {
            const val = await ODA.showCalculator(this.value);
            this.value = this._checkValue(val);
        }
        catch (e) { }
    },
});