import '../../buttons/icon/icon.js';
ODA({
    is: 'oda-list', template: `
    <style>
        :host {
            overflow: auto;
        }
    </style>
    <ul ~is="tag" class="vertical shadow" :type="marker" style="overflow-x: hidden; margin: 0px;" ~style="{padding: (marker === 'none')?'4px':''}" >
        <li ~for="items" :item="item" :focused="item === focusedItem" ~class="marker==='none' && !numerable ? 'horizontal' : ''" @down.stop="_select($event, item)" style="text-overflow:ellipsis; overflow: hidden; box-sizing: border-box; border-bottom: 1px solid transparent" :type="item.marker" :title="item.label">
            <span ~is="item.template || 'span'" :item="item"><oda-icon ~if="item.icon" :icon="item.icon"></oda-icon>{{!item.template && (item instanceof Object && item.__proto__.__proto__ === null && item.label || item)}}</span>
        </li>
    </ul>`,
    props:{
        iconSize: {
            default: 24,
            shared: true
        },
        numerable: false,
        marker:{
            default: 'none',
            list: ('none|circle|disc|square').split('|')
        },
        tag:{
            get(){
                return this.numerable?'ol':'ul';
            }
        },
        focusedItem: {
            default: null,
            notify: true
        },
        items: [],
        selection: []
    },
    _select(e, item){
        this.focusedItem = item
    }
});