import '../table/table.js';
ODA({
    is: "oda-tree",
    extends: 'oda-table',
    props:{
        focusedNode:{
            type: Object,
            notify: true
        },
        cols:{
            type: Array,
            get(){
                return this.columns.length?this.columns:[{name: this.keyName, treeMode: true}]
            }
        },
        autoWidth: true,
        keyName: 'name'
    },
    observers:[
        function setFocusedNode(focusedRow){
            if(focusedRow !== this.focusedNode){
                this.focusedNode = focusedRow;
            }
        },
        function setFocusedRow(focusedNode) {
            if (focusedNode !== this.focusedRow) {
                this.focusedRow = focusedNode;
            }
        }
    ],
    async expandAll(){
        const expand = (items) => {
            if (items){
                items.forEach(async i=>{
                    if (i.items){
                        i.$expanded = true;
                        await expand(i.items);
                    }

                });
            }
        };
        await expand((this.items && (this.items.length > 0)) ? this.items : this.dataSet);
        this._refresh();
    },
    async collapseAll() {
        const collapse = (items) => {
            items.forEach(async i => {
                if (i.items) {
                    i.$expanded = false;
                    await collapse(i.items);
                }

            });
        };
        await collapse(this.items);
        this._refresh();
    },
});