import '../buttons/icon/icon.js';
ODA({is: 'oda-rating', template: `
     <style>
        :host {
            position: relative;
            @apply --horizontal;
                cursor: pointer;
        }
    </style>
    <oda-icon :fill="color" ~for="(icon, i) in items" class="star" :size="size" :icon="icon" :index="i" @tap="_tap"></oda-icon>`,
    props: {
        size: 32,
        count: 5,
        color: 'gold',
        items: {
            type: Array,
            get(){
                const stars = [];
                for (let i = 0; i < this.count; i++)
                    stars.push('icons:'+this.getIcon(i, this.value));
                return stars;
            }
        },
        value: {
            default: 0,
            notify: true,
        }
    },
    static:{

    },
    settings:{

    },
    getIcon(star, value) {
        const v = Math.floor((value * this.count) * 2) / 2;
        const int = Math.floor(v);
        if (star < int)
            return 'star';
        if (star >= v)
            return 'star-border';
        return 'star-half';
    },
    _tap(e) {
        const v = (e.target.index + 1) / this.count;
        if (e.target.index  === 0 && this.value === v)
            this.value = 0;
        else
            this.value = v;
    }
});