Команда **console** позволяет вывести необходимые сообщения в строку состояния.

Данная команда имеет следующий синтаксис:

```javascript
ODA.console.«модификатор»
```

В качестве модификатора можно использовать одно из следующих значений:

1. **log** — позволяет выводить сообщение в журнал сообщений.
1. **status** — позволяет выводить сообщение на поверхность статусной панели.
1. **error** — позволяет выводить сообщение в журнал ошибок.
1. **warn** — позволяет выводить сообщение в журнал предупреждений.
1. **success** — позволяет выводить сообщение в журнал успешных действий.

Если у команды используется модификатор **log**, то, при отправке сообщения, его можно увидеть в статусной строке, нажав на кнопку с изображением знака вопроса.

Например,

```javascript run_line_edit_loadoda_[my-component.js]
 ODA({
    is: 'my-component',
    template: `
        <label>Текст сообщения: <input ::value> </label>
    `,
    props: {
        value: {
            default: 'Введите текст',
            set (n) {
                ODA.console.log(n);
            }
        }
    }
});
```

В этом случае в нижней части окна, в котором выводится данный компонент, появится статусная строка, на которой будет располагаться кнопка с изображением консоли. При нажатии на нее появится список всех сообщений, которые были отправлены с консоли.
