Команда **createComponent** позволяет динамически создавать любой компонент.

Она имеет следующий синтаксис:

```javascript
ODA.createComponent(id, props = {})
```

Ей передаются 2 параметра:

1. **id** — имя компонента в виде строки. Например, **'oda-icon'**.
1. **props** — свойства компонента, который будет создан. Например, **{icon: 'icons:android', iconSize: 50}**.

В результате выполнения эта функция возвращает созданный компонент.

Например,

```javascript run_line_edit_loadoda_[my-component.js]_h=100_
import '/components/buttons/icon/icon.js';
 ODA({
    is: 'my-component',
    template: `
        <button @tap="onTap">Нажми на меня</button>
    `,
    onTap() {
        let el = ODA.createComponent('oda-icon', {icon: 'icons:android', iconSize: 50});
        this.$core.shadowRoot.append(el);
    }
});
```

После создания компонента он не будет автоматически удаляться, поэтому каждое нажатие на кнопку в этом примере будет приводить к созданию все новых и новых однотипных компонентов.
