Команда **ODA.loadHTML** позволяет загрузить ресурс с указанного URL-адреса в формате HTML.

Она имеет следующий синтаксис:

```javascript
ODA.loadHTML = async function(url){...}
```

Ей передается 1 параметр **url** — адрес загружаемого ресурса.

В результате выполнения этой команды возвращается промис с полученным результатом запроса, представленным в виде DOM-объекта с типом **HTMLDocument**.

Например,

```javascript run_line_edit_loadoda_[my-component.js]_h=100_

 ODA({
    is: 'my-component',
    template: `
        <label>URL-адрес: <input type="url" ::value style="width: 45%" ></input></label><br>
        <textarea ref="mytext" style="height: 100px; width: 25%" placeholder="Результат запроса"></textarea>
        <iframe ref="frame" width="25%" height="100"> </iframe><br>
        <button @tap="onTap">Загрузить</button>
    `,
    props: {
        value: 'https://odajs.org/learn/guide/api/commands/example.html'
    },
    async onTap() {
        let result = await ODA.loadHTML(this.value);
        this.$refs.mytext.value = '<!DOCTYPE html>' + result.documentElement.outerHTML;
        var doc = this.$refs.frame.contentWindow.document;
        doc.open();
        doc.write('<!DOCTYPE html>' + this.$refs.mytext.value);
        doc.close();
    }
});
```
