Команда **ODA.loadLink** позволяет динамически задать отношение между текущим HTML-документом и внешним ресурсом, расположенный по указанному URL-адресу.

Она имеет следующий синтаксис:

```javascript
ODA.loadLink = async function(url){...}
```

Ей передается 1 параметр **url** — адрес загружаемого файла скрипта.

В результате выполнения этой команды возвращается промис с полученным содержимым файла скрипта, представленным в виде HTML-узла с тегом **script**, который автоматически добавляется к заголовку HTML-страницы при первой загрузке.

Например,

```javascript run_line_edit_loadoda_[my-component.js]_h=100_

 ODA({
    is: 'my-component',
    template: `
        <label>URL-адрес: <input type="url" ::value style="width: 45%" ></input></label><br>
        <textarea ref="mytext" style="height: 100px; width: 50%" placeholder="Текст скрипта"></textarea><br>
        <span>Результат выполнения: {{result}}</span>
        <button @tap="onTap">Загрузить</button>
    `,
    props: {
        value: 'https://odajs.org/learn/guide/api/commands/example.js',
        result: 'Пока нет',
    },
    async onTap() {
        let script = await ODA.loadScript(this.value);
        this.$refs.mytext.value = script.outerHTML;
        this.result = my();
    }
});
```
