Команда **ODA.loadURL** позволяет загрузить любой ресурс c указанного URL-адреса.

Она имеет следующий синтаксис:

```javascript
ODA.loadURL = async function(url){...}
```

Ей передается 1 параметр **url** — адрес загружаемого ресурса.

В результате выполнения этой команды возвращается промис с полученным результатом запроса по указанному адресу.

Например,

```javascript run_line_edit_loadoda_[my-component.js]_h=100_
import '/components/buttons/icon/icon.js';
 ODA({
    is: 'my-component',
    template: `
        <label>URL-адрес: <input type="url" ::value></input></label><br>
        <textarea ref="mytext" style="height: 100px; width: 300px" placeholder="Результат запроса"></textarea><br>
        <button @tap="onTap">Загрузить</button>
    `,
    props: {
        value: 'https://odajs.org/oda.js'
    },
    async onTap() {
        let response = await ODA.loadURL(this.value);
        this.$refs.mytext.value = await response.text();
    }
});
```
