Команда **ODA.notify** позволяет отправлять предупреждающие уведомления.

Она объявлена как функция, которая вызывает команду **ODA.push**, передавая ей текст тела сообщения:

```javascript
    ODA.notify = function(text){ ODA.push(text);};
```

В отличие от команды **ODA.push**, здесь передается только один параметр, а остальные задаются по умолчанию:

1. name = **'Warning!'** — заголовок уведомления.
1. tag = **'message'** — уникальный идентификатор уведомления.
1. icon = **'/icons/png/warning.png'** — URL изображения иконки.

Как и при использовании команды **ODA.notify**, пользователь должен разрешить уведомления для данного сайта во время появления первого уведомления, нажав на соответствующую кнопку в диалогом окне.

![Разрешение отображать уведомления](learn/guide/api/commands/images/requestNotification.png "Разрешить уведомления")

Если диалоговое окно будет закрыто или будет нажата кнопка **«Блокировать»**, то механизм отображения уведомлений для данного сайта будет заблокирован. Снова включить этот механизм можно только в настройках параметров безопасности сайта в браузере.

![Отключение блокировки уведомлений](learn/guide/api/commands/images/SiteSetting.png "Отключение блокировки уведомлений").

Например,

```javascript run_line_edit_loadoda_[my-component.js]
 ODA({
    is: 'my-component',
    template: `
        <input ::value='body'> <br>
        <button @tap="onTap">Нажми на меня</button>
    `,
    props: {
        body: 'Тело сообщения'
    },
    onTap() {
        ODA.notify(this.body);
    }
});
```

Если при получении уведомления поместить его в центр уведомлений, то любые другие уведомления с тем же самым уникальным идентификатором **tag** также не будут отображаться для пользователя. Они будут помещаться в центр уведомлений под тем же самым номером, заменяя предыдущие уведомление.

Если закрыть уведомление без помещения его в центр уведомлений, то, при отправке другого уведомления с тем же самым идентификатором, оно будет отображаться пользователю как новое.
