**ODA.origin** — это свойство, которое возвращает источник загрузки URL-ресурса, сериализованный в виде строки.

Эта строка формируется на основе кортежа, состоящего из трех элементов:

1. Протокол (scheme).
1. Хост (host).
1. Порт (port).

Значения этих элементов берутся из URL-адреса загруженного ресурса и отделяются друг от друга спец.символами.

Например, https://odajs.org:80

Если в происхождении URL-ресурса не указан порт, то по умолчанию он не будет выводится в сериализованной строке.

Например,

```javascript run_line_edit_loadoda_[my-component.js]
import '/components/buttons/button/button.js';
 ODA({
    is: 'my-component',
    template: `
        <oda-button ref="btn" label="Нажми на меня" icon="icons:android" @tap="onTap"></oda-button>
    `,
    onTap() {
        this.$refs.btn.label = ODA.origin;
    }
});
```

Если в источнике загрузки используется URL-cхема **file** (указан протокол: **file://**), то свойство **origin** вернет строку со значением **"null"**.

Подробную информацию о объекте **origin** можно найти в [HTML Living Standard](https://html.spec.whatwg.org/multipage/origin.html#concept-origin).
