Мы уже создали наш первый компонент, который умеет отрисовывать простой HTML-шаблон.
Давайте расширим его функциональные возможности с помощью механизма декларативной прорисовки.
Для этого Вы можете воспользоваться заготовкой на [JSFiddle](https://jsfiddle.net/odajs/u8bohnsq/) или добавить к прототипу компонента свойство в разделе **props**. Для отображения этого свойства достаточно указать его имя в шаблоне компонента внутри двойных фигурных скобок.

```javascript
<oda-welcome></oda-welcome>
<script type="module">
    import "https://cdn.jsdelivr.net/gh/odajs/oda-framework/oda.js";
    ODA({is: 'oda-welcome', template: `
        <span>{{myProperty}}</span>`,
        props: {
            myProperty: 'Hello, property!'
        }
    });
</script>
```

 Двойные фигурные скобки определяют директиву декларативной рендеринга,  с помощью которой значение свойства автоматически подставляется в шаблон компонента вместо самой директивы. В результате этого пользователь увидит значение свойства компонента, а не текст самой директивы.

```javascript
Hello, property!
```

Вы может можете посмотреть, что произойдет, если изменить имя свойства или его значение с помощью этого урока на [Scrimba](https://scrimba.com/c/cMqJyGcv).
