Чтобы понять что из себя представляет код компонента, давайте посмотрим на простейший компонент **Hello, World!**, созданный на ODA-фреймворке:

```html run_line_edit
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <title>WELCOME</title>
        <script type="module" src="https://cdn.jsdelivr.net/gh/odajs/oda-framework/oda.js"></script>
    </head>
    <body>
        <welcome-component></welcome-component>
        <script type="module">
            ODA({
                is: 'welcome-component',
                template: `
                    <span>{{text}}</span>
                `,
                props:{
                    text: 'Hello, world!'
                }
            });
        </script>
    </body>
</html>
```

Давайте подробнее разберем код компонента:

1. В строке 6 кода с помощью механизма CDN и технологии JavaScript осуществляется подключение библиотеки ODA-фреймворка.
1. В строке 9 кода объявляется пользовательский компонент welcome-component.
1. В строке 11 кода вызывается функция ODA.

Функции ODA передается прототип будущего компонента, в котором достаточно указать только его имя в свойстве **is** и HTML-шаблон в свойстве **template**.

На основе этой информации функция ODA сама создаст и зарегистрирует пользовательский компонент на HTML-странице, а браузер получит возможность отображать кастомный тег компонента как нативный HTML-элемент.

```info_md
В данном примере был использован полный формат HTML5. В дальнейшем, для компактности будет использована сокращенная нотация.
```
