Самым простым способом начала работы с фреймворком ODA является использования примера [Hello, World!](https://jsfiddle.net/odajs/4ojaq7xp/). Однако Вы можете создать файл index.html и подключить к нему библиотеку oda.js как JavaScript-модуль.

```javascript
<script type="module">
    import "https://cdn.jsdelivr.net/gh/odajs/oda-framework/oda.js";
</script>
```

Сам ODA-компонент объявляется как кастомный HTML-элемент с использованием имени, записанного в шашлычной нотации. Использование в имени компонента хотя бы одного символа дефиса является обязательным требованием [стандарта HTML](https://html.spec.whatwg.org/multipage/custom-elements.html#valid-custom-element-name).

```javascript
<oda-welcome></oda-welcome>
```

Сам ODA-компонент создается с помощью специальной функцией ODA.

```javascript
    ODA({is: 'oda-welcome', template: `
        <span>Hello, world!</span>`
    });
```

В эту функцию передается прототип будущего компонента, в котором достаточно указать только его имя и HTML-шаблон.

На основе этой информации функция ODA выполнит за Вас всю необходимую работу по созданию и регистрации Вашего компонента на HTML-странице, а браузер получит возможность отображать кастомный тег компонента так, будто это был обычный нативный HTML-элемент.

В результате этого пользователь увидит контент компонента на месте кастомного тега, а вся магия будет скрыта внутри ODA-фреймворка.

```javascript
Hello, world!
```

Если Вы хотите большей интерактивности, то можете попробовать этот урок на [Scrimba](https://scrimba.com/c/cMqJyGcv), которая представляет собой сочетание видео-скринкастов и песочницы с более подробными пояснениями. Там Вы сможете вносить изменения в представленный код, и наблюдать получаемые результаты на лету с возможностью возобновления пояснений в любое время.
