﻿Атрибут **imports** используется для указания списка загружаемых модулей с JavaScript-кодом родительских и вложенных компонентов. С помощью этого атрибута реализуется асинхронная загрузка модулей средствами ODA-фреймворка.

За счет асинхронной загрузки JavaScript-кода повышается скорость загрузки HTML-страницы и отзывчивость визуального интерфейса, построенного на ODA-фреймворке.

Список модулей в атрибуте **imports** можно представить в двух форматах:
1. единая строка, в которой ссылки на модули разделены запятыми:
~~~html
imports:'./components/colors/palette/palette.js,./components/buttons/button/button.js'
~~~
2. массив строк, в котором ссылка на каждый модуль является отдельным элементом:
~~~html
imports:['./components/colors/palette/palette.js',
         './components/buttons/button/button.js']
~~~

Пример

```javascript _run_line_edit_[my-component.js]_h=50_
import "https://odajs.org/components/buttons/button/button.js";
ODA({
    is: 'my-component',
    imports: 'https://odajs.org/components/colors/palette/palette.js',
    template:`
        <oda-button label="Button" icon="icons:android" style="width:200px;background-color:lime"></oda-button>
        <oda-palette gradients="1"></oda-palette>
    `
});
```

В данном примере загрузка кодов компонентов **oda-button** и **oda-palette** осуществляется с использованием разных механизмов. Загрузка кода компонента **oda-button** осуществляется инструкцией **import** языка JavaScript. Для загрузки кода компонента **oda-palette** используется специальный механизм, реализованный в ODA-фреймворке. Ссылка на код указана в прототипе в атрибуте **imports**.


