Шаблон компонента задается в атрибуте с именем **template**, в котором указываются стили и JSX-содержимое самого компонента. Содержимое шаблона записывается в виде строкового литерала в обратных кавычках (backticks).

**Style** — раздел шаблона компонента, в котором задаются CSS-стили отображения его элементов.

```info_md
В разделе **style** можно использовать селектор псевдокласса **:host**. Указанные в нем CSS-стили будут применяться ко всему компоненту в целом, включая все его элементы.
```

Раздел **style** поддерживает классовую и селекторную стилизации. Кроме этого, в CSS-свойствах можно использовать предопределенные CSS-переменные, задаваемые директивой **var**, и миксины, подключаемые к CSS-правилам с помощью директивы **@apply**.

```like__md
ODA-framework поддерживает реактивную стилизацию.
```

**JSX** — раздел шаблона компонента, предназначенный для указания его HTML-содержимого.

```info_md
При парсинге, с помощью специальной функции ParseJSX, содержимое этого раздела автоматически преобразуется в HTML-формат отображения компонента в браузере, с учетом всех заданных реактивных особенностей его элементов.
```

В JSX-шаблоне можно:

1. Задавать нативные HTML-элементы.
1. Осуществлять биндинг свойств.
1. Указывать обработчики событий.
1. Использовать специальные директивы.
1. Указывать текстовые выражения.
