Директива **@** используется для создания подписчика на какое-либо событие компонента.

Имя события указывается непосредственно после директивы **@**, а сам подписчик записывается в выражении директивы в виде отдельного метода, inline-выражения или может полностью отсутствовать.

Например:

```javascript_run_line_edit_[my-component.js]
ODA({
    is: 'my-component',
    template: `
        <span>{{count}}</span>
        <button @tap="_onTap">Кнопка</button>
    `,
    props: {
        count: 0
    },
    _onTap() {
        this.count++;
    }
});
```

В этом пример задан обработчик **_onTap**, который срабатывает при возникновения события **tap**.

Вместо метода можно указывать inline-выражение. Например:

```javascript_run_line_edit_[my-component.js]
ODA({
    is: 'my-component',
    template: `
        <span>{{count}}</span>
        <button @tap="count++">Кнопка</button>
    `,
    props: {
        count: 0
    }
});

Данный пример будет работать аналогично предыдущему, но в нем будет выполняться inline-выражение при каждом возникновении указанного события.

Обработчик события можно не указывать, а записать только после имени события дополнительный модификатор через точку.

```javascript_run_line_edit_[my-component.js]
ODA({
    is: 'my-component',
    template: `
        <span>{{count}}</span>
        <button @tap.="count++">Кнопка</button>
    `,
    props: {
        count: 0
    }
});
