Директива ~else используется для рендеринга HTML-элемента, когда условие не выполняется.

```javascript_run_line_edit_[my-component.js]
ODA({
    is: 'my-component',
    template: `
        <span ~if="_show">Меня видно</span>
        <span ~else>Меня невидно</span>
        <button @tap="_onTap">Кнопка</button>
    `,
    props: {
        _show: true
    },
    _onTap() {
        this._show = !this._show;
     }
});
```

HTML-элемент, в котором указана директива **~else**, будет создаваться и рендериться только в том случае, когда значение директивы **~if** можно привести к значению **false**.

Если значение выражения директива **~if** будет **true**, то HTML-элемент с директивой **~else** будет автоматически удален из DOM.

```warning_md
Элемент с директивой **~else** обязательно должен непосредственно после директивы **~if**. В противном случае элемент с директивой **~else** будет создан в DOM в независимости от значения выражения директивы **~if**
```
