Директива ~else-if используется для условного рендеринга HTML-элемента, когда директива ~if у предыдущего элемента не выполняется.

```javascript_run_line_edit_[my-component.js]
ODA({
    is: 'my-component',
    template: `
        <span ~if="item === 'A'"><input placeholder="Введите имя пользователя"></span>
        <div ~else-if="item === 'B'">Элемент div
        input placeholder="Введите имя пользователя">
        </div>
        <p ~else>Элемент p
        <input placeholder="Введите email">
        </p>
        <button @tap="_onTap">Switch</button>
    `,
    props: {
        item: 'A'
    },
    _onTap() {
        switch (this.item) {
            case 'A':
                this.item = 'B';
                break;
            case 'B':
                this.item = 'C';
                break;
            case 'C':
                this.item = 'A';
                break;
        }
    }
});
```

HTML-элемент, в котором указана директива **~else-if**, будет создаваться и рендериться только в том случае, когда значение директивы **~if** у предыдущего элемента можно привести к значению **false**. При этом значение выражения у самой директивы **~else-if** должно быть **true**.

Если выражения у все директив ~if и ~else-if ложны, ты будет создан и прорисован HTML-элемент, указанный с директивой **~else**.

```warning_md
Элемент с директивой **~else-if** обязательно должен быть указан непосредственно только после элемента с директивой **~if** или **else-if**. В противном случае элемент с **~else-if** будет создан в DOM в независимости от значения выражения директив **~if** или **~else-if**, идущими до него.
```
