Директива :: используется для взаимного связывания двух свойств различных компонентов.

При ее использовании изменение значения свойства одного компонента будет автоматически приводить к изменению значение свойства другого компонента, и наоборот.

Например:

```javascript_run_line_edit_[second-component.js]
ODA({
    is: 'second-component',
    template: `
        <span>{{text2}}</span>
        <button @tap="_changeText">Второй компонент</button>
    `,
    props: {
        text2: {
            default: 'Второй компонент',
            notify: true,
        }
    },
    _changeText() {
        this.text2 = "Второй компонент2";
    }
});
```

Данный компонент содержит свойство **text2**, которое изменяется при нажатии на кнопку с надписью **Второй компонент**.

Это свойство связано со свойством **text1** первого компонента.

```javascript_run_line_edit_[first-component.js]_{second-component.js}
ODA({
    is: 'first-component',
    template: `
        <button @tap="_changeText">Первый компонент</button>
        <span>{{text1}}</span>
        <second-component ::text2="text1"></second-component>
    `,
    props: {
        text1: {
            default: "Первый компонент",
            notify: true
        }
    },
    _changeText() {
        this.text1 = "Первый компонент1";
    }
});
```

При изменение свойства **text1** первого компонента будет изменено свойство **text2** второго компонента, и наоборот, при изменение свойства **text2** второго компонента будет изменено свойство **text1** первого компонента.
