import '../../components/layouts/splitter/splitter.js'
ODA({
    is: "oda-console", template:`
        <style>
            :host{
                max-height: 50vh;
                @apply --vertical;
                @apply --no-flex;
            }
            div{
                padding-left: 8px;
            }
        </style>
        <oda-splitter align="horizontal"></oda-splitter>
        <div class="horizontal header" style="align-items: center;">
            <span class="flex">{{status}}</span>
            <oda-button allow-toggle :toggled="item === focusedGroup" @tap="focusedGroup = item" ~for="Object.values(data)" :icon="item.icon"></oda-button>
            <oda-button icon="icons:close" @tap="close"></oda-button>
        </div>
        <div class="vertical no-flex" ~if="focusedGroup" style="overflow-y: scroll;">
            <div class="vertical no-flex">
                <span ~for="focusedGroup.items" style="border: 1px solid">{{item}}</span>
            </div>
        </div>
    `,
    props:{
        status: {
            type: String,
            set(n){
                show();
            }
        },
        iconSize:{
            default: 24,
            shared: true
        },
        data:{
            messages: {icon: 'icons:message', items: 10},
            logs: {icon: 'icons:war', items: [1,2,3]},
            warn: {icon: 'icons:warning',  items: [1,2,3]},
            errors: {icon: 'icons:error', items: [1,2,3]},
            dirs: {icon: 'icons:message', items: [1,2,3]}
        },
        focusedGroup:{

        }
    },
    log(log){
        show()
    },
    close(){
        document.body.removeChild(ODA.console);
    }
});
function show(){
    document.body.appendChild(ODA.console)
}
