ODA({
    imports: [ '/web/oda/components/buttons/button/button.js' ],
    is: 'oda-console', template: /*html*/`
    <style>
        :host {
            bottom: 0;
            background-color: var(--content-background);
            font-size: small;
            border: 1px solid var(--dark-background);
        }
        :host div {
            bottom: 0;
            padding: 2px;
            border-bottom: 1px solid var(--dark-background);
        }
        :host .log {
            max-height: 300px;
            overflow-y: auto;
        }
    </style>
    <div class="horizontal">
        <oda-button :icon="expanded ? 'icons:arrow-drop-down' : 'icons:arrow-drop-up'" :disabled="!items?.length" @tap="expanded = !expanded" icon-size="18"> ({{items?.length || 0}})</oda-button>
        <oda-button icon="icons:clear" :disabled="!items?.length" @tap="items = null;expanded = false;" icon-size="18"></oda-button>
    </div>
    <div class="log" ~if="expanded && items?.length">
        <div ~for="items"><span :style="item?.style"><{{item?.component}}></span> {{item?.text || item}}</div>
    </div>
    `,
    props: {
        items: Array,
        expanded: false
    }
});